# Tenko parser test case

- Path: tests/testcases/async_keyword/async_can_not_have_line_terminator_after_it_arrow_expression_wont_be_async.md

> :: async keyword
>
> ::> async can not have line terminator after it arrow expression wont be async
>
> this is different from the `async (x) => x` case which would be a syntax error

## Input

`````js
let f = async
g => g
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:2,column:6},source:''},
  body: [
    {
      type: 'VariableDeclaration',
      loc:{start:{line:1,column:0},end:{line:1,column:13},source:''},
      kind: 'let',
      declarations: [
        {
          type: 'VariableDeclarator',
          loc:{start:{line:1,column:4},end:{line:1,column:13},source:''},
          id: {
            type: 'Identifier',
            loc:{start:{line:1,column:4},end:{line:1,column:5},source:''},
            name: 'f'
          },
          init: {
            type: 'Identifier',
            loc:{start:{line:1,column:8},end:{line:1,column:13},source:''},
            name: 'async'
          }
        }
      ]
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:2,column:0},end:{line:2,column:6},source:''},
      expression: {
        type: 'ArrowFunctionExpression',
        loc:{start:{line:2,column:0},end:{line:2,column:6},source:''},
        params: [
          {
            type: 'Identifier',
            loc:{start:{line:2,column:0},end:{line:2,column:1},source:''},
            name: 'g'
          }
        ],
        id: null,
        generator: false,
        async: false,
        expression: true,
        body: {
          type: 'Identifier',
          loc:{start:{line:2,column:5},end:{line:2,column:6},source:''},
          name: 'g'
        }
      }
    }
  ]
}

tokens (10x):
       ID_let IDENT PUNC_EQ ID_async ASI IDENT PUNC_EQ_GT IDENT ASI
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
let f = async;
g => (g);
````

Produces same AST
