# Tenko parser test case

- Path: tests/testcases/async_keyword/async_hack_should_not_consume_nested_args_when_it_has_no_args_itself.md

> :: async keyword
>
> ::> async hack should not consume nested args when it has no args itself

## Input

`````js
foo(async(), x)
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:15},source:''},
  body: [
    {
      type: 'ExpressionStatement',
      loc:{start:{line:1,column:0},end:{line:1,column:15},source:''},
      expression: {
        type: 'CallExpression',
        loc:{start:{line:1,column:0},end:{line:1,column:15},source:''},
        callee: {
          type: 'Identifier',
          loc:{start:{line:1,column:0},end:{line:1,column:3},source:''},
          name: 'foo'
        },
        arguments: [
          {
            type: 'CallExpression',
            loc:{start:{line:1,column:4},end:{line:1,column:11},source:''},
            callee: {
              type: 'Identifier',
              loc:{start:{line:1,column:4},end:{line:1,column:9},source:''},
              name: 'async'
            },
            arguments: []
          },
          {
            type: 'Identifier',
            loc:{start:{line:1,column:13},end:{line:1,column:14},source:''},
            name: 'x'
          }
        ]
      }
    }
  ]
}

tokens (10x):
       IDENT PUNC_PAREN_OPEN ID_async PUNC_PAREN_OPEN PUNC_PAREN_CLOSE
       PUNC_COMMA IDENT PUNC_PAREN_CLOSE ASI
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
((foo)(async(), x));
````

Produces same AST
