# Tenko parser test case

- Path: tests/testcases/async_keyword/async_testing_ast_without_newline.md

> :: async keyword
>
> ::> async testing ast without newline
>
> this also tests operator precedent with `async()`, it should be (((a+b)+async())+d) and NOT (a+b)+(async()+d)

## Input

`````js
let f = a + b + async() + d
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:27},source:''},
  body: [
    {
      type: 'VariableDeclaration',
      loc:{start:{line:1,column:0},end:{line:1,column:27},source:''},
      kind: 'let',
      declarations: [
        {
          type: 'VariableDeclarator',
          loc:{start:{line:1,column:4},end:{line:1,column:27},source:''},
          id: {
            type: 'Identifier',
            loc:{start:{line:1,column:4},end:{line:1,column:5},source:''},
            name: 'f'
          },
          init: {
            type: 'BinaryExpression',
            loc:{start:{line:1,column:8},end:{line:1,column:27},source:''},
            left: {
              type: 'BinaryExpression',
              loc:{start:{line:1,column:8},end:{line:1,column:23},source:''},
              left: {
                type: 'BinaryExpression',
                loc:{start:{line:1,column:8},end:{line:1,column:13},source:''},
                left: {
                  type: 'Identifier',
                  loc:{start:{line:1,column:8},end:{line:1,column:9},source:''},
                  name: 'a'
                },
                operator: '+',
                right: {
                  type: 'Identifier',
                  loc:{start:{line:1,column:12},end:{line:1,column:13},source:''},
                  name: 'b'
                }
              },
              operator: '+',
              right: {
                type: 'CallExpression',
                loc:{start:{line:1,column:16},end:{line:1,column:23},source:''},
                callee: {
                  type: 'Identifier',
                  loc:{start:{line:1,column:16},end:{line:1,column:21},source:''},
                  name: 'async'
                },
                arguments: []
              }
            },
            operator: '+',
            right: {
              type: 'Identifier',
              loc:{start:{line:1,column:26},end:{line:1,column:27},source:''},
              name: 'd'
            }
          }
        }
      ]
    }
  ]
}

tokens (14x):
       ID_let IDENT PUNC_EQ IDENT PUNC_PLUS IDENT PUNC_PLUS ID_async
       PUNC_PAREN_OPEN PUNC_PAREN_CLOSE PUNC_PLUS IDENT ASI
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
let f = ((((((a) + (b))) + (async()))) + (d));
````

Produces same AST
