# Tenko parser test case

- Path: tests/testcases/async_keyword/await_as_param_name_of_an_arrow_that_is_a_param_default_of_an_async_call.md

> :: async keyword
>
> ::> await as param name of an arrow that is a param default of an async call
>
> Should pass in non-module?

## Input

`````js
async(a = (await) => {});
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:25},source:''},
  body: [
    {
      type: 'ExpressionStatement',
      loc:{start:{line:1,column:0},end:{line:1,column:25},source:''},
      expression: {
        type: 'CallExpression',
        loc:{start:{line:1,column:0},end:{line:1,column:24},source:''},
        callee: {
          type: 'Identifier',
          loc:{start:{line:1,column:0},end:{line:1,column:5},source:''},
          name: 'async'
        },
        arguments: [
          {
            type: 'AssignmentExpression',
            loc:{start:{line:1,column:6},end:{line:1,column:23},source:''},
            left: {
              type: 'Identifier',
              loc:{start:{line:1,column:6},end:{line:1,column:7},source:''},
              name: 'a'
            },
            operator: '=',
            right: {
              type: 'ArrowFunctionExpression',
              loc:{start:{line:1,column:10},end:{line:1,column:23},source:''},
              params: [
                {
                  type: 'Identifier',
                  loc:{start:{line:1,column:11},end:{line:1,column:16},source:''},
                  name: 'await'
                }
              ],
              id: null,
              generator: false,
              async: false,
              expression: false,
              body: {
                type: 'BlockStatement',
                loc:{start:{line:1,column:21},end:{line:1,column:23},source:''},
                body: []
              }
            }
          }
        ]
      }
    }
  ]
}

tokens (13x):
       ID_async PUNC_PAREN_OPEN IDENT PUNC_EQ PUNC_PAREN_OPEN ID_await
       PUNC_PAREN_CLOSE PUNC_EQ_GT PUNC_CURLY_OPEN PUNC_CURLY_CLOSE
       PUNC_PAREN_CLOSE PUNC_SEMI
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

`````
throws: Parser error!
  Cannot use `await` as var when goal=module but found `await` outside an async function

async(a = (await) => {});
                ^------- error
`````


### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
(async((a = await => {})));
````

Produces same AST
