# Tenko parser test case

- Path: tests/testcases/async_keyword/export_an_async_arrow.md

> :: async keyword
>
> ::> export an async arrow

## Input

`````js
export default async (x) => y
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
throws: Parser error!
  The `export` keyword can only be used with the module goal

export default async (x) => y
^------- error
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:29},source:''},
  body: [
    {
      type: 'ExportDefaultDeclaration',
      loc:{start:{line:1,column:0},end:{line:1,column:29},source:''},
      declaration: {
        type: 'ArrowFunctionExpression',
        loc:{start:{line:1,column:15},end:{line:1,column:29},source:''},
        params: [
          {
            type: 'Identifier',
            loc:{start:{line:1,column:22},end:{line:1,column:23},source:''},
            name: 'x'
          }
        ],
        id: null,
        generator: false,
        async: true,
        expression: true,
        body: {
          type: 'Identifier',
          loc:{start:{line:1,column:28},end:{line:1,column:29},source:''},
          name: 'y'
        }
      }
    }
  ]
}

tokens (10x):
       ID_export ID_default ID_async PUNC_PAREN_OPEN IDENT
       PUNC_PAREN_CLOSE PUNC_EQ_GT IDENT ASI
`````


### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [module]:

````js
export default async x => (y);
````

Produces same AST
