# Tenko parser test case

- Path: tests/testcases/async_keyword/export_an_async_call.md

> :: async keyword
>
> ::> export an async call
>
> Despite being legacy an `async` call can be default exported

## Input

`````js
export default async (x);
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
throws: Parser error!
  The `export` keyword can only be used with the module goal

export default async (x);
^------- error
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:25},source:''},
  body: [
    {
      type: 'ExportDefaultDeclaration',
      loc:{start:{line:1,column:0},end:{line:1,column:25},source:''},
      declaration: {
        type: 'CallExpression',
        loc:{start:{line:1,column:15},end:{line:1,column:24},source:''},
        callee: {
          type: 'Identifier',
          loc:{start:{line:1,column:15},end:{line:1,column:20},source:''},
          name: 'async'
        },
        arguments: [
          {
            type: 'Identifier',
            loc:{start:{line:1,column:22},end:{line:1,column:23},source:''},
            name: 'x'
          }
        ]
      }
    }
  ]
}

tokens (8x):
       ID_export ID_default ID_async PUNC_PAREN_OPEN IDENT
       PUNC_PAREN_CLOSE PUNC_SEMI
`````


### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [module]:

````js
export default async(x);
````

Produces same AST
