# Tenko parser test case

- Path: tests/testcases/async_keyword/newline_behavior/statement/asi_cases/toplevel_async_arrow_with_trailing_comma.md

> :: async keyword : newline behavior : statement : asi cases
>
> ::> toplevel async arrow with trailing comma
>
> expression statement parses a sequence expression so the trailing comma is fine

## Input

`````js
async () => x, y
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:16},source:''},
  body: [
    {
      type: 'ExpressionStatement',
      loc:{start:{line:1,column:0},end:{line:1,column:16},source:''},
      expression: {
        type: 'SequenceExpression',
        loc:{start:{line:1,column:0},end:{line:1,column:16},source:''},
        expressions: [
          {
            type: 'ArrowFunctionExpression',
            loc:{start:{line:1,column:0},end:{line:1,column:13},source:''},
            params: [],
            id: null,
            generator: false,
            async: true,
            expression: true,
            body: {
              type: 'Identifier',
              loc:{start:{line:1,column:12},end:{line:1,column:13},source:''},
              name: 'x'
            }
          },
          {
            type: 'Identifier',
            loc:{start:{line:1,column:15},end:{line:1,column:16},source:''},
            name: 'y'
          }
        ]
      }
    }
  ]
}

tokens (9x):
       ID_async PUNC_PAREN_OPEN PUNC_PAREN_CLOSE PUNC_EQ_GT IDENT
       PUNC_COMMA IDENT ASI
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
((async () => (x), y));
````

Produces same AST
