# Tenko parser test case

- Path: tests/testcases/await/await_as_arg_default/class_dynamic_method_no_arg.md

> :: await : await as arg default
>
> ::> class dynamic method no arg
>
> Await is not valid inside method args with dynamic method name

## Input

`````js
class x{[x](a=await){}}
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:23},source:''},
  body: [
    {
      type: 'ClassDeclaration',
      loc:{start:{line:1,column:0},end:{line:1,column:23},source:''},
      id: {
        type: 'Identifier',
        loc:{start:{line:1,column:6},end:{line:1,column:7},source:''},
        name: 'x'
      },
      superClass: null,
      body: {
        type: 'ClassBody',
        loc:{start:{line:1,column:7},end:{line:1,column:23},source:''},
        body: [
          {
            type: 'MethodDefinition',
            loc:{start:{line:1,column:8},end:{line:1,column:22},source:''},
            key: {
              type: 'Identifier',
              loc:{start:{line:1,column:9},end:{line:1,column:10},source:''},
              name: 'x'
            },
            static: false,
            computed: true,
            kind: 'method',
            value: {
              type: 'FunctionExpression',
              loc:{start:{line:1,column:8},end:{line:1,column:22},source:''},
              generator: false,
              async: false,
              id: null,
              params: [
                {
                  type: 'AssignmentPattern',
                  loc:{start:{line:1,column:12},end:{line:1,column:19},source:''},
                  left: {
                    type: 'Identifier',
                    loc:{start:{line:1,column:12},end:{line:1,column:13},source:''},
                    name: 'a'
                  },
                  right: {
                    type: 'Identifier',
                    loc:{start:{line:1,column:14},end:{line:1,column:19},source:''},
                    name: 'await'
                  }
                }
              ],
              body: {
                type: 'BlockStatement',
                loc:{start:{line:1,column:20},end:{line:1,column:22},source:''},
                body: []
              }
            }
          }
        ]
      }
    }
  ]
}

tokens (15x):
       ID_class IDENT PUNC_CURLY_OPEN PUNC_BRACKET_OPEN IDENT
       PUNC_BRACKET_CLOSE PUNC_PAREN_OPEN IDENT PUNC_EQ ID_await
       PUNC_PAREN_CLOSE PUNC_CURLY_OPEN PUNC_CURLY_CLOSE
       PUNC_CURLY_CLOSE
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

`````
throws: Parser error!
  Cannot use `await` as var when goal=module but found `await` outside an async function

class x{[x](a=await){}}
                   ^------- error
`````


### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
class x{[x](a = await){};}
````

Produces same AST
