# Tenko parser test case

- Path: tests/testcases/await/await_as_func_id/plain_function_expr.md

> :: await : await as func id
>
> ::> plain function expr

## Input

`````js
let x = function await(){}
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:26},source:''},
  body: [
    {
      type: 'VariableDeclaration',
      loc:{start:{line:1,column:0},end:{line:1,column:26},source:''},
      kind: 'let',
      declarations: [
        {
          type: 'VariableDeclarator',
          loc:{start:{line:1,column:4},end:{line:1,column:26},source:''},
          id: {
            type: 'Identifier',
            loc:{start:{line:1,column:4},end:{line:1,column:5},source:''},
            name: 'x'
          },
          init: {
            type: 'FunctionExpression',
            loc:{start:{line:1,column:8},end:{line:1,column:26},source:''},
            generator: false,
            async: false,
            id: {
              type: 'Identifier',
              loc:{start:{line:1,column:17},end:{line:1,column:22},source:''},
              name: 'await'
            },
            params: [],
            body: {
              type: 'BlockStatement',
              loc:{start:{line:1,column:24},end:{line:1,column:26},source:''},
              body: []
            }
          }
        }
      ]
    }
  ]
}

tokens (11x):
       ID_let IDENT PUNC_EQ ID_function ID_await PUNC_PAREN_OPEN
       PUNC_PAREN_CLOSE PUNC_CURLY_OPEN PUNC_CURLY_CLOSE ASI
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

`````
throws: Parser error!
  Cannot use this name (await) as a variable name because: Await is illegal as var name with module goal

let x = function await(){}
                 ^------- error
`````


### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
let x = function await() {};
````

Produces same AST
