# Tenko parser test case

- Path: tests/testcases/await/await_expression_in_async.md

> :: await
>
> ::> await expression in async

## Input

`````js
async function f(){ async(await x); }
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:37},source:''},
  body: [
    {
      type: 'FunctionDeclaration',
      loc:{start:{line:1,column:0},end:{line:1,column:37},source:''},
      generator: false,
      async: true,
      id: {
        type: 'Identifier',
        loc:{start:{line:1,column:15},end:{line:1,column:16},source:''},
        name: 'f'
      },
      params: [],
      body: {
        type: 'BlockStatement',
        loc:{start:{line:1,column:18},end:{line:1,column:37},source:''},
        body: [
          {
            type: 'ExpressionStatement',
            loc:{start:{line:1,column:20},end:{line:1,column:35},source:''},
            expression: {
              type: 'CallExpression',
              loc:{start:{line:1,column:20},end:{line:1,column:34},source:''},
              callee: {
                type: 'Identifier',
                loc:{start:{line:1,column:20},end:{line:1,column:25},source:''},
                name: 'async'
              },
              arguments: [
                {
                  type: 'AwaitExpression',
                  loc:{start:{line:1,column:26},end:{line:1,column:33},source:''},
                  argument: {
                    type: 'Identifier',
                    loc:{start:{line:1,column:32},end:{line:1,column:33},source:''},
                    name: 'x'
                  }
                }
              ]
            }
          }
        ]
      }
    }
  ]
}

tokens (14x):
       ID_async ID_function IDENT PUNC_PAREN_OPEN PUNC_PAREN_CLOSE
       PUNC_CURLY_OPEN ID_async PUNC_PAREN_OPEN ID_await IDENT
       PUNC_PAREN_CLOSE PUNC_SEMI PUNC_CURLY_CLOSE
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
async function f() {(async(await (x)));}
````

Produces same AST
