# Tenko parser test case

- Path: tests/testcases/await/await_in_group_in_param_default/group_await_piggy_test_in_func_param_default_1.md

> :: await : await in group in param default
>
> ::> group await piggy test in func param default 1
>
> this is only an await expression in Module goal
>
> https://tc39.github.io/ecma262/#sec-arrow-function-definitions-static-semantics-early-errors
>
> > It is a Syntax Error if ArrowParameters Contains AwaitExpression is true.
>
> The arrow parens inherit the async state from the parent scope (unlike regular funcs, who reset it)

## Input

`````js
function f(x=(await)=y){}
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:25},source:''},
  body: [
    {
      type: 'FunctionDeclaration',
      loc:{start:{line:1,column:0},end:{line:1,column:25},source:''},
      generator: false,
      async: false,
      id: {
        type: 'Identifier',
        loc:{start:{line:1,column:9},end:{line:1,column:10},source:''},
        name: 'f'
      },
      params: [
        {
          type: 'AssignmentPattern',
          loc:{start:{line:1,column:11},end:{line:1,column:22},source:''},
          left: {
            type: 'Identifier',
            loc:{start:{line:1,column:11},end:{line:1,column:12},source:''},
            name: 'x'
          },
          right: {
            type: 'AssignmentExpression',
            loc:{start:{line:1,column:13},end:{line:1,column:22},source:''},
            left: {
              type: 'Identifier',
              loc:{start:{line:1,column:14},end:{line:1,column:19},source:''},
              name: 'await'
            },
            operator: '=',
            right: {
              type: 'Identifier',
              loc:{start:{line:1,column:21},end:{line:1,column:22},source:''},
              name: 'y'
            }
          }
        }
      ],
      body: {
        type: 'BlockStatement',
        loc:{start:{line:1,column:23},end:{line:1,column:25},source:''},
        body: []
      }
    }
  ]
}

tokens (14x):
       ID_function IDENT PUNC_PAREN_OPEN IDENT PUNC_EQ PUNC_PAREN_OPEN
       ID_await PUNC_PAREN_CLOSE PUNC_EQ IDENT PUNC_PAREN_CLOSE
       PUNC_CURLY_OPEN PUNC_CURLY_CLOSE
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

`````
throws: Parser error!
  Cannot use `await` as var when goal=module but found `await` outside an async function

function f(x=(await)=y){}
                   ^------- error
`````


### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
function f(x = (await = y)) {}
````

Produces same AST
