# Tenko parser test case

- Path: tests/testcases/await/await_is_a_valid_identifier_in_script_mode_9.md

> :: await
>
> ::> await is a valid identifier in script mode 9

## Input

`````js
call(await.foo)
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:15},source:''},
  body: [
    {
      type: 'ExpressionStatement',
      loc:{start:{line:1,column:0},end:{line:1,column:15},source:''},
      expression: {
        type: 'CallExpression',
        loc:{start:{line:1,column:0},end:{line:1,column:15},source:''},
        callee: {
          type: 'Identifier',
          loc:{start:{line:1,column:0},end:{line:1,column:4},source:''},
          name: 'call'
        },
        arguments: [
          {
            type: 'MemberExpression',
            loc:{start:{line:1,column:5},end:{line:1,column:14},source:''},
            object: {
              type: 'Identifier',
              loc:{start:{line:1,column:5},end:{line:1,column:10},source:''},
              name: 'await'
            },
            property: {
              type: 'Identifier',
              loc:{start:{line:1,column:11},end:{line:1,column:14},source:''},
              name: 'foo'
            },
            computed: false
          }
        ]
      }
    }
  ]
}

tokens (8x):
       IDENT PUNC_PAREN_OPEN ID_await PUNC_DOT IDENT PUNC_PAREN_CLOSE
       ASI
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

`````
throws: Parser error!
  Cannot use `await` as var when goal=module but found `await` outside an async function

call(await.foo)
          ^------- error
`````


### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
((call)((await).foo));
````

Produces same AST
