# Tenko parser test case

- Path: tests/testcases/await/make_failing_code_is_inside_async_function_should_still_fail_for_being_in_parameter_head.md

> :: await
>
> ::> make failing code is inside async function should still fail for being in parameter head
>
> it's by far too much effort to proc a nice message here

## Input

`````js
async function x(){ function y(s=await foo){}}
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
throws: Parser error!
  Missing function param definition closing parenthesis, found `foo` instead

async function x(){ function y(s=await foo){}}
                                       ^------- error
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

`````
throws: Parser error!
  Cannot use `await` as var when goal=module but found `await` outside an async function

async function x(){ function y(s=await foo){}}
                                       ^------- error
`````


### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._
