# Tenko parser test case

- Path: tests/testcases/break_statement/in_a_switch/break_with_label_inside_a_default.md

> :: break statement : in a switch
>
> ::> break with label inside a default

## Input

`````js
foo: switch (x) { default: break foo; }
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:39},source:''},
  body: [
    {
      type: 'LabeledStatement',
      loc:{start:{line:1,column:0},end:{line:1,column:39},source:''},
      label: {
        type: 'Identifier',
        loc:{start:{line:1,column:0},end:{line:1,column:3},source:''},
        name: 'foo'
      },
      body: {
        type: 'SwitchStatement',
        loc:{start:{line:1,column:5},end:{line:1,column:39},source:''},
        discriminant: {
          type: 'Identifier',
          loc:{start:{line:1,column:13},end:{line:1,column:14},source:''},
          name: 'x'
        },
        cases: [
          {
            type: 'SwitchCase',
            loc:{start:{line:1,column:18},end:{line:1,column:37},source:''},
            test: null,
            consequent: [
              {
                type: 'BreakStatement',
                loc:{start:{line:1,column:27},end:{line:1,column:37},source:''},
                label: {
                  type: 'Identifier',
                  loc:{start:{line:1,column:33},end:{line:1,column:36},source:''},
                  name: 'foo'
                }
              }
            ]
          }
        ]
      }
    }
  ]
}

tokens (14x):
       IDENT PUNC_COLON ID_switch PUNC_PAREN_OPEN IDENT
       PUNC_PAREN_CLOSE PUNC_CURLY_OPEN ID_default PUNC_COLON ID_break
       IDENT PUNC_SEMI PUNC_CURLY_CLOSE
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
foo: switch (x) {default:
break foo;}
````

Produces same AST
