# Tenko parser test case

- Path: tests/testcases/break_statement/in_a_switch/break_without_label_inside_a_switch_nested_block.md

> :: break statement : in a switch
>
> ::> break without label inside a switch nested block

## Input

`````js
switch (x) { case x: {break;} }
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:31},source:''},
  body: [
    {
      type: 'SwitchStatement',
      loc:{start:{line:1,column:0},end:{line:1,column:31},source:''},
      discriminant: {
        type: 'Identifier',
        loc:{start:{line:1,column:8},end:{line:1,column:9},source:''},
        name: 'x'
      },
      cases: [
        {
          type: 'SwitchCase',
          loc:{start:{line:1,column:13},end:{line:1,column:29},source:''},
          test: {
            type: 'Identifier',
            loc:{start:{line:1,column:18},end:{line:1,column:19},source:''},
            name: 'x'
          },
          consequent: [
            {
              type: 'BlockStatement',
              loc:{start:{line:1,column:21},end:{line:1,column:29},source:''},
              body: [
                {
                  type: 'BreakStatement',
                  loc:{start:{line:1,column:22},end:{line:1,column:28},source:''},
                  label: null
                }
              ]
            }
          ]
        }
      ]
    }
  ]
}

tokens (14x):
       ID_switch PUNC_PAREN_OPEN IDENT PUNC_PAREN_CLOSE
       PUNC_CURLY_OPEN ID_case IDENT PUNC_COLON PUNC_CURLY_OPEN
       ID_break PUNC_SEMI PUNC_CURLY_CLOSE PUNC_CURLY_CLOSE
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
switch (x) {case x:
{break;}}
````

Produces same AST
