# Tenko parser test case

- Path: tests/testcases/break_statement/labels/break_to_label_in_do.md

> :: break statement : labels
>
> ::> break to label in do

## Input

`````js
foo: do break foo; while(true)
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:30},source:''},
  body: [
    {
      type: 'LabeledStatement',
      loc:{start:{line:1,column:0},end:{line:1,column:30},source:''},
      label: {
        type: 'Identifier',
        loc:{start:{line:1,column:0},end:{line:1,column:3},source:''},
        name: 'foo'
      },
      body: {
        type: 'DoWhileStatement',
        loc:{start:{line:1,column:5},end:{line:1,column:30},source:''},
        body: {
          type: 'BreakStatement',
          loc:{start:{line:1,column:8},end:{line:1,column:18},source:''},
          label: {
            type: 'Identifier',
            loc:{start:{line:1,column:14},end:{line:1,column:17},source:''},
            name: 'foo'
          }
        },
        test: {
          type: 'Literal',
          loc:{start:{line:1,column:25},end:{line:1,column:29},source:''},
          value: true,
          raw: 'true'
        }
      }
    }
  ]
}

tokens (12x):
       IDENT PUNC_COLON ID_do ID_break IDENT PUNC_SEMI ID_while
       PUNC_PAREN_OPEN ID_true PUNC_PAREN_CLOSE ASI
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
foo: do break foo; while (true);
````

Produces same AST
