# Tenko parser test case

- Path: tests/testcases/break_statement/nesting/switch/function/nested.md

> :: break statement : nesting : switch : function
>
> ::> nested

## Input

`````js
function f(){ switch (x){ case z:       if (x) break   }}
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:57},source:''},
  body: [
    {
      type: 'FunctionDeclaration',
      loc:{start:{line:1,column:0},end:{line:1,column:57},source:''},
      generator: false,
      async: false,
      id: {
        type: 'Identifier',
        loc:{start:{line:1,column:9},end:{line:1,column:10},source:''},
        name: 'f'
      },
      params: [],
      body: {
        type: 'BlockStatement',
        loc:{start:{line:1,column:12},end:{line:1,column:57},source:''},
        body: [
          {
            type: 'SwitchStatement',
            loc:{start:{line:1,column:14},end:{line:1,column:56},source:''},
            discriminant: {
              type: 'Identifier',
              loc:{start:{line:1,column:22},end:{line:1,column:23},source:''},
              name: 'x'
            },
            cases: [
              {
                type: 'SwitchCase',
                loc:{start:{line:1,column:26},end:{line:1,column:52},source:''},
                test: {
                  type: 'Identifier',
                  loc:{start:{line:1,column:31},end:{line:1,column:32},source:''},
                  name: 'z'
                },
                consequent: [
                  {
                    type: 'IfStatement',
                    loc:{start:{line:1,column:40},end:{line:1,column:52},source:''},
                    test: {
                      type: 'Identifier',
                      loc:{start:{line:1,column:44},end:{line:1,column:45},source:''},
                      name: 'x'
                    },
                    consequent: {
                      type: 'BreakStatement',
                      loc:{start:{line:1,column:47},end:{line:1,column:52},source:''},
                      label: null
                    },
                    alternate: null
                  }
                ]
              }
            ]
          }
        ]
      }
    }
  ]
}

tokens (22x):
       ID_function IDENT PUNC_PAREN_OPEN PUNC_PAREN_CLOSE
       PUNC_CURLY_OPEN ID_switch PUNC_PAREN_OPEN IDENT
       PUNC_PAREN_CLOSE PUNC_CURLY_OPEN ID_case IDENT PUNC_COLON ID_if
       PUNC_PAREN_OPEN IDENT PUNC_PAREN_CLOSE ID_break ASI
       PUNC_CURLY_CLOSE PUNC_CURLY_CLOSE
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
function f() {switch (x) {case z:
if (x) break;}}
````

Produces same AST
