# Tenko parser test case

- Path: tests/testcases/call_expression/chained_calls_2.md

> :: call expression
>
> ::> chained calls 2

## Input

`````js
foo(a)(b)(c)(d)(e)
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:18},source:''},
  body: [
    {
      type: 'ExpressionStatement',
      loc:{start:{line:1,column:0},end:{line:1,column:18},source:''},
      expression: {
        type: 'CallExpression',
        loc:{start:{line:1,column:0},end:{line:1,column:18},source:''},
        callee: {
          type: 'CallExpression',
          loc:{start:{line:1,column:0},end:{line:1,column:15},source:''},
          callee: {
            type: 'CallExpression',
            loc:{start:{line:1,column:0},end:{line:1,column:12},source:''},
            callee: {
              type: 'CallExpression',
              loc:{start:{line:1,column:0},end:{line:1,column:9},source:''},
              callee: {
                type: 'CallExpression',
                loc:{start:{line:1,column:0},end:{line:1,column:6},source:''},
                callee: {
                  type: 'Identifier',
                  loc:{start:{line:1,column:0},end:{line:1,column:3},source:''},
                  name: 'foo'
                },
                arguments: [
                  {
                    type: 'Identifier',
                    loc:{start:{line:1,column:4},end:{line:1,column:5},source:''},
                    name: 'a'
                  }
                ]
              },
              arguments: [
                {
                  type: 'Identifier',
                  loc:{start:{line:1,column:7},end:{line:1,column:8},source:''},
                  name: 'b'
                }
              ]
            },
            arguments: [
              {
                type: 'Identifier',
                loc:{start:{line:1,column:10},end:{line:1,column:11},source:''},
                name: 'c'
              }
            ]
          },
          arguments: [
            {
              type: 'Identifier',
              loc:{start:{line:1,column:13},end:{line:1,column:14},source:''},
              name: 'd'
            }
          ]
        },
        arguments: [
          {
            type: 'Identifier',
            loc:{start:{line:1,column:16},end:{line:1,column:17},source:''},
            name: 'e'
          }
        ]
      }
    }
  ]
}

tokens (18x):
       IDENT PUNC_PAREN_OPEN IDENT PUNC_PAREN_CLOSE PUNC_PAREN_OPEN
       IDENT PUNC_PAREN_CLOSE PUNC_PAREN_OPEN IDENT PUNC_PAREN_CLOSE
       PUNC_PAREN_OPEN IDENT PUNC_PAREN_CLOSE PUNC_PAREN_OPEN IDENT
       PUNC_PAREN_CLOSE ASI
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
((((((foo)(a))(b))(c))(d))(e));
````

Produces same AST
