# Tenko parser test case

- Path: tests/testcases/classes/constructor_name_checks/as_ident/static_constructor_is_ok_and_just_a_method.md

> :: classes : constructor name checks : as ident
>
> ::> static constructor is ok and just a method
> 
> https://tc39.github.io/ecma262/#sec-identifier-names-static-semantics-stringvalue
> 
> Note: the "constructor" check is determined by the "StringValue", which canonizes the unicode escapes
> 
> https://tc39.github.io/ecma262/#sec-string-literals-static-semantics-stringvalue
> 
> And for strings it is the unquoted canonical value of the string (so "constructor" and 'constructor' + escapes)

## Input

`````js
class x { static constructor(){} }
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:34},source:''},
  body: [
    {
      type: 'ClassDeclaration',
      loc:{start:{line:1,column:0},end:{line:1,column:34},source:''},
      id: {
        type: 'Identifier',
        loc:{start:{line:1,column:6},end:{line:1,column:7},source:''},
        name: 'x'
      },
      superClass: null,
      body: {
        type: 'ClassBody',
        loc:{start:{line:1,column:8},end:{line:1,column:34},source:''},
        body: [
          {
            type: 'MethodDefinition',
            loc:{start:{line:1,column:10},end:{line:1,column:32},source:''},
            key: {
              type: 'Identifier',
              loc:{start:{line:1,column:17},end:{line:1,column:28},source:''},
              name: 'constructor'
            },
            static: true,
            computed: false,
            kind: 'method',
            value: {
              type: 'FunctionExpression',
              loc:{start:{line:1,column:10},end:{line:1,column:32},source:''},
              generator: false,
              async: false,
              id: null,
              params: [],
              body: {
                type: 'BlockStatement',
                loc:{start:{line:1,column:30},end:{line:1,column:32},source:''},
                body: []
              }
            }
          }
        ]
      }
    }
  ]
}

tokens (11x):
       ID_class IDENT PUNC_CURLY_OPEN ID_static IDENT PUNC_PAREN_OPEN
       PUNC_PAREN_CLOSE PUNC_CURLY_OPEN PUNC_CURLY_CLOSE
       PUNC_CURLY_CLOSE
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
class x{static constructor(){};}
````

Produces same AST
