# Tenko parser test case

- Path: tests/testcases/classes/duplicate_keys/constructor/static/a_static_constructor_does_not_disable_the_check.md

> :: classes : duplicate keys : constructor : static
>
> ::> a static constructor does not disable the check
> 
> https://tc39.github.io/ecma262/#sec-static-semantics-constructormethod
> 
> > It is a Syntax Error if PrototypePropertyNameList of ClassElementList contains more than one occurrence of "constructor".
> 
> static members do not end up on the prototype so should not get this treatment

## Input

`````js
class x {static constructor(){}; constructor(){}; constructor(){}}
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
throws: Parser error!
  Classes may only have one constructor

class x {static constructor(){}; constructor(){}; constructor(){}}
                                                                 ^------- error
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._
