# Tenko parser test case

- Path: tests/testcases/classes/extending/arrpattern.md

> :: classes : extending
>
> ::> arrpattern
>
> Regression that triggered an assertion error over the pattern assignment inside a group.

## Input

`````js
class n extends ([] = x) {}
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:27},source:''},
  body: [
    {
      type: 'ClassDeclaration',
      loc:{start:{line:1,column:0},end:{line:1,column:27},source:''},
      id: {
        type: 'Identifier',
        loc:{start:{line:1,column:6},end:{line:1,column:7},source:''},
        name: 'n'
      },
      superClass: {
        type: 'AssignmentExpression',
        loc:{start:{line:1,column:17},end:{line:1,column:23},source:''},
        left: {
          type: 'ArrayPattern',
          loc:{start:{line:1,column:17},end:{line:1,column:19},source:''},
          elements: []
        },
        operator: '=',
        right: {
          type: 'Identifier',
          loc:{start:{line:1,column:22},end:{line:1,column:23},source:''},
          name: 'x'
        }
      },
      body: {
        type: 'ClassBody',
        loc:{start:{line:1,column:25},end:{line:1,column:27},source:''},
        body: []
      }
    }
  ]
}

tokens (12x):
       ID_class IDENT ID_extends PUNC_PAREN_OPEN PUNC_BRACKET_OPEN
       PUNC_BRACKET_CLOSE PUNC_EQ IDENT PUNC_PAREN_CLOSE
       PUNC_CURLY_OPEN PUNC_CURLY_CLOSE
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
class n extends (([] = x)) {}
````

Produces same AST
