# Tenko parser test case

- Path: tests/testcases/classes/extending/extend_expression_also_inherits_the_strict_mode_from_class_1.md

> :: classes : extending
>
> ::> extend expression also inherits the strict mode from class 1
>
> anything from the class keyword onwards is strict mode regardless of goal/sloppy state

## Input

`````js
class X extends function(){ with(obj); } {}
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
throws: Parser error!
  The `with` statement is not allowed in strict mode

class X extends function(){ with(obj); } {}
                            ^------- error
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._
