# Tenko parser test case

- Path: tests/testcases/classes/generators/with_static/no_prefix/with_string_key.md

> :: classes : generators : with static : no prefix
>
> ::> with string key

## Input

`````js
class x{static *"foo"(){}}
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:26},source:''},
  body: [
    {
      type: 'ClassDeclaration',
      loc:{start:{line:1,column:0},end:{line:1,column:26},source:''},
      id: {
        type: 'Identifier',
        loc:{start:{line:1,column:6},end:{line:1,column:7},source:''},
        name: 'x'
      },
      superClass: null,
      body: {
        type: 'ClassBody',
        loc:{start:{line:1,column:7},end:{line:1,column:26},source:''},
        body: [
          {
            type: 'MethodDefinition',
            loc:{start:{line:1,column:8},end:{line:1,column:25},source:''},
            key: {
              type: 'Literal',
              loc:{start:{line:1,column:16},end:{line:1,column:21},source:''},
              value: 'foo',
              raw: '"foo"'
            },
            static: true,
            computed: false,
            kind: 'method',
            value: {
              type: 'FunctionExpression',
              loc:{start:{line:1,column:8},end:{line:1,column:25},source:''},
              generator: true,
              async: false,
              id: null,
              params: [],
              body: {
                type: 'BlockStatement',
                loc:{start:{line:1,column:23},end:{line:1,column:25},source:''},
                body: []
              }
            }
          }
        ]
      }
    }
  ]
}

tokens (12x):
       ID_class IDENT PUNC_CURLY_OPEN ID_static PUNC_STAR
       STRING_DOUBLE PUNC_PAREN_OPEN PUNC_PAREN_CLOSE PUNC_CURLY_OPEN
       PUNC_CURLY_CLOSE PUNC_CURLY_CLOSE
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
class x{static * "foo"(){};}
````

Produces same AST
