# Tenko parser test case

- Path: tests/testcases/comma/in_a_for-in_header_part_2.md

> :: comma
>
> ::> in a for-in header part 2

## Input

`````js
for (a in b,c) d;
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:17},source:''},
  body: [
    {
      type: 'ForInStatement',
      loc:{start:{line:1,column:0},end:{line:1,column:17},source:''},
      left: {
        type: 'Identifier',
        loc:{start:{line:1,column:5},end:{line:1,column:6},source:''},
        name: 'a'
      },
      right: {
        type: 'SequenceExpression',
        loc:{start:{line:1,column:10},end:{line:1,column:13},source:''},
        expressions: [
          {
            type: 'Identifier',
            loc:{start:{line:1,column:10},end:{line:1,column:11},source:''},
            name: 'b'
          },
          {
            type: 'Identifier',
            loc:{start:{line:1,column:12},end:{line:1,column:13},source:''},
            name: 'c'
          }
        ]
      },
      body: {
        type: 'ExpressionStatement',
        loc:{start:{line:1,column:15},end:{line:1,column:17},source:''},
        expression: {
          type: 'Identifier',
          loc:{start:{line:1,column:15},end:{line:1,column:16},source:''},
          name: 'd'
        }
      }
    }
  ]
}

tokens (11x):
       ID_for PUNC_PAREN_OPEN IDENT ID_in IDENT PUNC_COMMA IDENT
       PUNC_PAREN_CLOSE IDENT PUNC_SEMI
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
for ((a) in (b, c)) (d);
````

Produces same AST
