# Tenko parser test case

- Path: tests/testcases/comma/in_a_template_part_1.md

> :: comma
>
> ::> in a template part 1

## Input

`````js
`x${a,b}y`
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:10},source:''},
  body: [
    {
      type: 'ExpressionStatement',
      loc:{start:{line:1,column:0},end:{line:1,column:10},source:''},
      expression: {
        type: 'TemplateLiteral',
        loc:{start:{line:1,column:0},end:{line:1,column:10},source:''},
        expressions: [
          {
            type: 'SequenceExpression',
            loc:{start:{line:1,column:4},end:{line:1,column:7},source:''},
            expressions: [
              {
                type: 'Identifier',
                loc:{start:{line:1,column:4},end:{line:1,column:5},source:''},
                name: 'a'
              },
              {
                type: 'Identifier',
                loc:{start:{line:1,column:6},end:{line:1,column:7},source:''},
                name: 'b'
              }
            ]
          }
        ],
        quasis: [
          {
            type: 'TemplateElement',
            loc:{start:{line:1,column:1},end:{line:1,column:2},source:''},
            tail: false,
            value: { raw: 'x', cooked: 'x' }
          },
          {
            type: 'TemplateElement',
            loc:{start:{line:1,column:8},end:{line:1,column:9},source:''},
            tail: true,
            value: { raw: 'y', cooked: 'y' }
          }
        ]
      }
    }
  ]
}

tokens (7x):
       TICK_HEAD IDENT PUNC_COMMA IDENT TICK_TAIL ASI
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
`x${(a, b)}y`;
````

Produces same AST
