# Tenko parser test case

- Path: tests/testcases/comma/in_a_with.md

> :: comma
>
> ::> in a with
>
> comma is stronger than ternary

## Input

`````js
with (a,b) c;
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:13},source:''},
  body: [
    {
      type: 'WithStatement',
      loc:{start:{line:1,column:0},end:{line:1,column:13},source:''},
      object: {
        type: 'SequenceExpression',
        loc:{start:{line:1,column:6},end:{line:1,column:9},source:''},
        expressions: [
          {
            type: 'Identifier',
            loc:{start:{line:1,column:6},end:{line:1,column:7},source:''},
            name: 'a'
          },
          {
            type: 'Identifier',
            loc:{start:{line:1,column:8},end:{line:1,column:9},source:''},
            name: 'b'
          }
        ]
      },
      body: {
        type: 'ExpressionStatement',
        loc:{start:{line:1,column:11},end:{line:1,column:13},source:''},
        expression: {
          type: 'Identifier',
          loc:{start:{line:1,column:11},end:{line:1,column:12},source:''},
          name: 'c'
        }
      }
    }
  ]
}

tokens (9x):
       ID_with PUNC_PAREN_OPEN IDENT PUNC_COMMA IDENT PUNC_PAREN_CLOSE
       IDENT PUNC_SEMI
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

`````
throws: Parser error!
  The `with` statement is not allowed in strict mode

with (a,b) c;
^------- error
`````


### Module goal

Parsed with the module goal.

_Output same as strict mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
with ((a, b)) (c);
````

Produces same AST
