# Tenko parser test case

- Path: tests/testcases/const_statement/binding_generic/as_a_statement/destructuring/array/rest_operator/spread_vs_rest.md

> :: const statement : binding generic : as a statement : destructuring : array : rest operator
>
> ::> spread vs rest
>
> expecting both a rest and spread node in the ast

## Input

`````js
const [a=[...b], ...c] = obj;
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:29},source:''},
  body: [
    {
      type: 'VariableDeclaration',
      loc:{start:{line:1,column:0},end:{line:1,column:29},source:''},
      kind: 'const',
      declarations: [
        {
          type: 'VariableDeclarator',
          loc:{start:{line:1,column:6},end:{line:1,column:28},source:''},
          id: {
            type: 'ArrayPattern',
            loc:{start:{line:1,column:6},end:{line:1,column:22},source:''},
            elements: [
              {
                type: 'AssignmentPattern',
                loc:{start:{line:1,column:7},end:{line:1,column:15},source:''},
                left: {
                  type: 'Identifier',
                  loc:{start:{line:1,column:7},end:{line:1,column:8},source:''},
                  name: 'a'
                },
                right: {
                  type: 'ArrayExpression',
                  loc:{start:{line:1,column:9},end:{line:1,column:15},source:''},
                  elements: [
                    {
                      type: 'SpreadElement',
                      loc:{start:{line:1,column:10},end:{line:1,column:14},source:''},
                      argument: {
                        type: 'Identifier',
                        loc:{start:{line:1,column:13},end:{line:1,column:14},source:''},
                        name: 'b'
                      }
                    }
                  ]
                }
              },
              {
                type: 'RestElement',
                loc:{start:{line:1,column:17},end:{line:1,column:21},source:''},
                argument: {
                  type: 'Identifier',
                  loc:{start:{line:1,column:20},end:{line:1,column:21},source:''},
                  name: 'c'
                }
              }
            ]
          },
          init: {
            type: 'Identifier',
            loc:{start:{line:1,column:25},end:{line:1,column:28},source:''},
            name: 'obj'
          }
        }
      ]
    }
  ]
}

tokens (16x):
       ID_const PUNC_BRACKET_OPEN IDENT PUNC_EQ PUNC_BRACKET_OPEN
       PUNC_DOT_DOT_DOT IDENT PUNC_BRACKET_CLOSE PUNC_COMMA
       PUNC_DOT_DOT_DOT IDENT PUNC_BRACKET_CLOSE PUNC_EQ IDENT
       PUNC_SEMI
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
const [a = [...b,], ...c] = obj;
````

Produces same AST
