# Tenko parser test case

- Path: tests/testcases/const_statement/binding_generic/in_a_for-header/destructuring/for-of/array/rest_operator/spread_and_rest.md

> :: const statement : binding generic : in a for-header : destructuring : for-of : array : rest operator
>
> ::> spread and rest

## Input

`````js
for (const [a=[...b], ...c] of obj);
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:36},source:''},
  body: [
    {
      type: 'ForOfStatement',
      loc:{start:{line:1,column:0},end:{line:1,column:36},source:''},
      left: {
        type: 'VariableDeclaration',
        loc:{start:{line:1,column:5},end:{line:1,column:27},source:''},
        kind: 'const',
        declarations: [
          {
            type: 'VariableDeclarator',
            loc:{start:{line:1,column:11},end:{line:1,column:27},source:''},
            id: {
              type: 'ArrayPattern',
              loc:{start:{line:1,column:11},end:{line:1,column:27},source:''},
              elements: [
                {
                  type: 'AssignmentPattern',
                  loc:{start:{line:1,column:12},end:{line:1,column:20},source:''},
                  left: {
                    type: 'Identifier',
                    loc:{start:{line:1,column:12},end:{line:1,column:13},source:''},
                    name: 'a'
                  },
                  right: {
                    type: 'ArrayExpression',
                    loc:{start:{line:1,column:14},end:{line:1,column:20},source:''},
                    elements: [
                      {
                        type: 'SpreadElement',
                        loc:{start:{line:1,column:15},end:{line:1,column:19},source:''},
                        argument: {
                          type: 'Identifier',
                          loc:{start:{line:1,column:18},end:{line:1,column:19},source:''},
                          name: 'b'
                        }
                      }
                    ]
                  }
                },
                {
                  type: 'RestElement',
                  loc:{start:{line:1,column:22},end:{line:1,column:26},source:''},
                  argument: {
                    type: 'Identifier',
                    loc:{start:{line:1,column:25},end:{line:1,column:26},source:''},
                    name: 'c'
                  }
                }
              ]
            },
            init: null
          }
        ]
      },
      right: {
        type: 'Identifier',
        loc:{start:{line:1,column:31},end:{line:1,column:34},source:''},
        name: 'obj'
      },
      await: false,
      body: {
        type: 'EmptyStatement',
        loc:{start:{line:1,column:35},end:{line:1,column:36},source:''}
      }
    }
  ]
}

tokens (19x):
       ID_for PUNC_PAREN_OPEN ID_const PUNC_BRACKET_OPEN IDENT PUNC_EQ
       PUNC_BRACKET_OPEN PUNC_DOT_DOT_DOT IDENT PUNC_BRACKET_CLOSE
       PUNC_COMMA PUNC_DOT_DOT_DOT IDENT PUNC_BRACKET_CLOSE ID_of
       IDENT PUNC_PAREN_CLOSE PUNC_SEMI
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
for (const [a = [...b,], ...c] of obj) ;
````

Produces same AST
