# Tenko parser test case

- Path: tests/testcases/const_statement/binding_generic/in_a_for-header/destructuring/regular_for-loop/object/in_edge_case.md

> :: const statement : binding generic : in a for-header : destructuring : regular for-loop : object
>
> ::> in edge case
>
> `in` is illegal due to disambiguation, but an array/object resets that state

## Input

`````js
for (const {x = a in b} = obj;;);
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:33},source:''},
  body: [
    {
      type: 'ForStatement',
      loc:{start:{line:1,column:0},end:{line:1,column:33},source:''},
      init: {
        type: 'VariableDeclaration',
        loc:{start:{line:1,column:5},end:{line:1,column:29},source:''},
        kind: 'const',
        declarations: [
          {
            type: 'VariableDeclarator',
            loc:{start:{line:1,column:11},end:{line:1,column:29},source:''},
            id: {
              type: 'ObjectPattern',
              loc:{start:{line:1,column:11},end:{line:1,column:23},source:''},
              properties: [
                {
                  type: 'Property',
                  loc:{start:{line:1,column:12},end:{line:1,column:22},source:''},
                  key: {
                    type: 'Identifier',
                    loc:{start:{line:1,column:12},end:{line:1,column:13},source:''},
                    name: 'x'
                  },
                  kind: 'init',
                  method: false,
                  computed: false,
                  value: {
                    type: 'AssignmentPattern',
                    loc:{start:{line:1,column:12},end:{line:1,column:22},source:''},
                    left: {
                      type: 'Identifier',
                      loc:{start:{line:1,column:12},end:{line:1,column:13},source:''},
                      name: 'x'
                    },
                    right: {
                      type: 'BinaryExpression',
                      loc:{start:{line:1,column:16},end:{line:1,column:22},source:''},
                      left: {
                        type: 'Identifier',
                        loc:{start:{line:1,column:16},end:{line:1,column:17},source:''},
                        name: 'a'
                      },
                      operator: 'in',
                      right: {
                        type: 'Identifier',
                        loc:{start:{line:1,column:21},end:{line:1,column:22},source:''},
                        name: 'b'
                      }
                    }
                  },
                  shorthand: true
                }
              ]
            },
            init: {
              type: 'Identifier',
              loc:{start:{line:1,column:26},end:{line:1,column:29},source:''},
              name: 'obj'
            }
          }
        ]
      },
      test: null,
      update: null,
      body: {
        type: 'EmptyStatement',
        loc:{start:{line:1,column:32},end:{line:1,column:33},source:''}
      }
    }
  ]
}

tokens (17x):
       ID_for PUNC_PAREN_OPEN ID_const PUNC_CURLY_OPEN IDENT PUNC_EQ
       IDENT ID_in IDENT PUNC_CURLY_CLOSE PUNC_EQ IDENT PUNC_SEMI
       PUNC_SEMI PUNC_PAREN_CLOSE PUNC_SEMI
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
for (const {x = ((a) in (b))} = obj;;) ;
````

Produces same AST
