# Tenko parser test case

- Path: tests/testcases/const_statement/binding_generic/in_export_decl/destructuring/array/rest_operator/spread_and_rest.md

> :: const statement : binding generic : in export decl : destructuring : array : rest operator
>
> ::> spread and rest

## Input

`````js
export const [a=[...b], ...c] = obj;
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
throws: Parser error!
  The `export` keyword can only be used with the module goal

export const [a=[...b], ...c] = obj;
^------- error
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:36},source:''},
  body: [
    {
      type: 'ExportNamedDeclaration',
      loc:{start:{line:1,column:0},end:{line:1,column:36},source:''},
      specifiers: [],
      declaration: {
        type: 'VariableDeclaration',
        loc:{start:{line:1,column:7},end:{line:1,column:36},source:''},
        kind: 'const',
        declarations: [
          {
            type: 'VariableDeclarator',
            loc:{start:{line:1,column:13},end:{line:1,column:35},source:''},
            id: {
              type: 'ArrayPattern',
              loc:{start:{line:1,column:13},end:{line:1,column:29},source:''},
              elements: [
                {
                  type: 'AssignmentPattern',
                  loc:{start:{line:1,column:14},end:{line:1,column:22},source:''},
                  left: {
                    type: 'Identifier',
                    loc:{start:{line:1,column:14},end:{line:1,column:15},source:''},
                    name: 'a'
                  },
                  right: {
                    type: 'ArrayExpression',
                    loc:{start:{line:1,column:16},end:{line:1,column:22},source:''},
                    elements: [
                      {
                        type: 'SpreadElement',
                        loc:{start:{line:1,column:17},end:{line:1,column:21},source:''},
                        argument: {
                          type: 'Identifier',
                          loc:{start:{line:1,column:20},end:{line:1,column:21},source:''},
                          name: 'b'
                        }
                      }
                    ]
                  }
                },
                {
                  type: 'RestElement',
                  loc:{start:{line:1,column:24},end:{line:1,column:28},source:''},
                  argument: {
                    type: 'Identifier',
                    loc:{start:{line:1,column:27},end:{line:1,column:28},source:''},
                    name: 'c'
                  }
                }
              ]
            },
            init: {
              type: 'Identifier',
              loc:{start:{line:1,column:32},end:{line:1,column:35},source:''},
              name: 'obj'
            }
          }
        ]
      },
      source: null
    }
  ]
}

tokens (17x):
       ID_export ID_const PUNC_BRACKET_OPEN IDENT PUNC_EQ
       PUNC_BRACKET_OPEN PUNC_DOT_DOT_DOT IDENT PUNC_BRACKET_CLOSE
       PUNC_COMMA PUNC_DOT_DOT_DOT IDENT PUNC_BRACKET_CLOSE PUNC_EQ
       IDENT PUNC_SEMI
`````


### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [module]:

````js
export const [a = [...b,], ...c] = obj;
````

Produces same AST
