# Tenko parser test case

- Path: tests/testcases/const_statement/binding_generic/in_export_decl/destructuring/object/double_destruct_with_and_without_rename.md

> :: const statement : binding generic : in export decl : destructuring : object
>
> ::> double destruct with and without rename

## Input

`````js
export const {x : y, z} = obj;
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
throws: Parser error!
  The `export` keyword can only be used with the module goal

export const {x : y, z} = obj;
^------- error
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:30},source:''},
  body: [
    {
      type: 'ExportNamedDeclaration',
      loc:{start:{line:1,column:0},end:{line:1,column:30},source:''},
      specifiers: [],
      declaration: {
        type: 'VariableDeclaration',
        loc:{start:{line:1,column:7},end:{line:1,column:30},source:''},
        kind: 'const',
        declarations: [
          {
            type: 'VariableDeclarator',
            loc:{start:{line:1,column:13},end:{line:1,column:29},source:''},
            id: {
              type: 'ObjectPattern',
              loc:{start:{line:1,column:13},end:{line:1,column:23},source:''},
              properties: [
                {
                  type: 'Property',
                  loc:{start:{line:1,column:14},end:{line:1,column:19},source:''},
                  key: {
                    type: 'Identifier',
                    loc:{start:{line:1,column:14},end:{line:1,column:15},source:''},
                    name: 'x'
                  },
                  kind: 'init',
                  method: false,
                  computed: false,
                  value: {
                    type: 'Identifier',
                    loc:{start:{line:1,column:18},end:{line:1,column:19},source:''},
                    name: 'y'
                  },
                  shorthand: false
                },
                {
                  type: 'Property',
                  loc:{start:{line:1,column:21},end:{line:1,column:22},source:''},
                  key: {
                    type: 'Identifier',
                    loc:{start:{line:1,column:21},end:{line:1,column:22},source:''},
                    name: 'z'
                  },
                  kind: 'init',
                  method: false,
                  computed: false,
                  value: {
                    type: 'Identifier',
                    loc:{start:{line:1,column:21},end:{line:1,column:22},source:''},
                    name: 'z'
                  },
                  shorthand: true
                }
              ]
            },
            init: {
              type: 'Identifier',
              loc:{start:{line:1,column:26},end:{line:1,column:29},source:''},
              name: 'obj'
            }
          }
        ]
      },
      source: null
    }
  ]
}

tokens (13x):
       ID_export ID_const PUNC_CURLY_OPEN IDENT PUNC_COLON IDENT
       PUNC_COMMA IDENT PUNC_CURLY_CLOSE PUNC_EQ IDENT PUNC_SEMI
`````


### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [module]:

````js
export const {x:y, z} = obj;
````

Produces same AST
