# Tenko parser test case

- Path: tests/testcases/const_statement/binding_generic/in_export_decl/destructuring/object/single_destruct_with_init.md

> :: const statement : binding generic : in export decl : destructuring : object
>
> ::> single destruct with init
>
> note: value gets the assignment pattern! not the objectpattern:properties

## Input

`````js
export const {x = y} = obj;
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
throws: Parser error!
  The `export` keyword can only be used with the module goal

export const {x = y} = obj;
^------- error
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:27},source:''},
  body: [
    {
      type: 'ExportNamedDeclaration',
      loc:{start:{line:1,column:0},end:{line:1,column:27},source:''},
      specifiers: [],
      declaration: {
        type: 'VariableDeclaration',
        loc:{start:{line:1,column:7},end:{line:1,column:27},source:''},
        kind: 'const',
        declarations: [
          {
            type: 'VariableDeclarator',
            loc:{start:{line:1,column:13},end:{line:1,column:26},source:''},
            id: {
              type: 'ObjectPattern',
              loc:{start:{line:1,column:13},end:{line:1,column:20},source:''},
              properties: [
                {
                  type: 'Property',
                  loc:{start:{line:1,column:14},end:{line:1,column:19},source:''},
                  key: {
                    type: 'Identifier',
                    loc:{start:{line:1,column:14},end:{line:1,column:15},source:''},
                    name: 'x'
                  },
                  kind: 'init',
                  method: false,
                  computed: false,
                  value: {
                    type: 'AssignmentPattern',
                    loc:{start:{line:1,column:14},end:{line:1,column:19},source:''},
                    left: {
                      type: 'Identifier',
                      loc:{start:{line:1,column:14},end:{line:1,column:15},source:''},
                      name: 'x'
                    },
                    right: {
                      type: 'Identifier',
                      loc:{start:{line:1,column:18},end:{line:1,column:19},source:''},
                      name: 'y'
                    }
                  },
                  shorthand: true
                }
              ]
            },
            init: {
              type: 'Identifier',
              loc:{start:{line:1,column:23},end:{line:1,column:26},source:''},
              name: 'obj'
            }
          }
        ]
      },
      source: null
    }
  ]
}

tokens (11x):
       ID_export ID_const PUNC_CURLY_OPEN IDENT PUNC_EQ IDENT
       PUNC_CURLY_CLOSE PUNC_EQ IDENT PUNC_SEMI
`````


### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output was same as input [module]
