# Tenko parser test case

- Path: tests/testcases/const_statement/const_a_var_inside_for-statement_that_was_var_bound_in_for-header.md

> :: const statement
>
> ::> const a var inside for-statement that was var bound in for-header
>
> https://tc39.github.io/ecma262/#sec-for-statement-static-semantics-early-errors
>
> > It is a Syntax Error if any element of the BoundNames of LexicalDeclaration also occurs in the VarDeclaredNames of Statement.
>
> But none the other way around?

## Input

`````js
for (var x = 3;;) { const x = 1 }
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:33},source:''},
  body: [
    {
      type: 'ForStatement',
      loc:{start:{line:1,column:0},end:{line:1,column:33},source:''},
      init: {
        type: 'VariableDeclaration',
        loc:{start:{line:1,column:5},end:{line:1,column:14},source:''},
        kind: 'var',
        declarations: [
          {
            type: 'VariableDeclarator',
            loc:{start:{line:1,column:9},end:{line:1,column:14},source:''},
            id: {
              type: 'Identifier',
              loc:{start:{line:1,column:9},end:{line:1,column:10},source:''},
              name: 'x'
            },
            init: {
              type: 'Literal',
              loc:{start:{line:1,column:13},end:{line:1,column:14},source:''},
              value: 3,
              raw: '3'
            }
          }
        ]
      },
      test: null,
      update: null,
      body: {
        type: 'BlockStatement',
        loc:{start:{line:1,column:18},end:{line:1,column:33},source:''},
        body: [
          {
            type: 'VariableDeclaration',
            loc:{start:{line:1,column:20},end:{line:1,column:31},source:''},
            kind: 'const',
            declarations: [
              {
                type: 'VariableDeclarator',
                loc:{start:{line:1,column:26},end:{line:1,column:31},source:''},
                id: {
                  type: 'Identifier',
                  loc:{start:{line:1,column:26},end:{line:1,column:27},source:''},
                  name: 'x'
                },
                init: {
                  type: 'Literal',
                  loc:{start:{line:1,column:30},end:{line:1,column:31},source:''},
                  value: 1,
                  raw: '1'
                }
              }
            ]
          }
        ]
      }
    }
  ]
}

tokens (17x):
       ID_for PUNC_PAREN_OPEN ID_var IDENT PUNC_EQ NUMBER_DEC
       PUNC_SEMI PUNC_SEMI PUNC_PAREN_CLOSE PUNC_CURLY_OPEN ID_const
       IDENT PUNC_EQ NUMBER_DEC ASI PUNC_CURLY_CLOSE
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
for (var x = 3;;) {const x = 1;}
````

Produces same AST
