# Tenko parser test case

- Path: tests/testcases/const_statement/const_a_var_inside_for-statement_that_was_var_bound_in_for-in-header.md

> :: const statement
>
> ::> const a var inside for-statement that was var bound in for-in-header
>
> > It is a Syntax Error if any element of the BoundNames of LexicalDeclaration also occurs in
>
> > the VarDeclaredNames of Statement.
>
> Not the other way around

## Input

`````js
for (var x in obj) { const x = 1 }
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:34},source:''},
  body: [
    {
      type: 'ForInStatement',
      loc:{start:{line:1,column:0},end:{line:1,column:34},source:''},
      left: {
        type: 'VariableDeclaration',
        loc:{start:{line:1,column:5},end:{line:1,column:10},source:''},
        kind: 'var',
        declarations: [
          {
            type: 'VariableDeclarator',
            loc:{start:{line:1,column:9},end:{line:1,column:10},source:''},
            id: {
              type: 'Identifier',
              loc:{start:{line:1,column:9},end:{line:1,column:10},source:''},
              name: 'x'
            },
            init: null
          }
        ]
      },
      right: {
        type: 'Identifier',
        loc:{start:{line:1,column:14},end:{line:1,column:17},source:''},
        name: 'obj'
      },
      body: {
        type: 'BlockStatement',
        loc:{start:{line:1,column:19},end:{line:1,column:34},source:''},
        body: [
          {
            type: 'VariableDeclaration',
            loc:{start:{line:1,column:21},end:{line:1,column:32},source:''},
            kind: 'const',
            declarations: [
              {
                type: 'VariableDeclarator',
                loc:{start:{line:1,column:27},end:{line:1,column:32},source:''},
                id: {
                  type: 'Identifier',
                  loc:{start:{line:1,column:27},end:{line:1,column:28},source:''},
                  name: 'x'
                },
                init: {
                  type: 'Literal',
                  loc:{start:{line:1,column:31},end:{line:1,column:32},source:''},
                  value: 1,
                  raw: '1'
                }
              }
            ]
          }
        ]
      }
    }
  ]
}

tokens (15x):
       ID_for PUNC_PAREN_OPEN ID_var IDENT ID_in IDENT
       PUNC_PAREN_CLOSE PUNC_CURLY_OPEN ID_const IDENT PUNC_EQ
       NUMBER_DEC ASI PUNC_CURLY_CLOSE
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
for (var x in obj) {const x = 1;}
````

Produces same AST
