# Tenko parser test case

- Path: tests/testcases/continue_statement/label_validation/do-loop/label_label2_loop_block_loop_continue_label.md

> :: continue statement : label validation : do-loop
>
> ::> label label2 loop block loop continue label
>
> The `continue` label much match a label that is a direct parent of a loop node or a direct parent of such label recursively.

## PASS

## Input

`````js
foo: bar: do { do continue foo; while(z); } while(z)
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:52},source:''},
  body: [
    {
      type: 'LabeledStatement',
      loc:{start:{line:1,column:0},end:{line:1,column:52},source:''},
      label: {
        type: 'Identifier',
        loc:{start:{line:1,column:0},end:{line:1,column:3},source:''},
        name: 'foo'
      },
      body: {
        type: 'LabeledStatement',
        loc:{start:{line:1,column:5},end:{line:1,column:52},source:''},
        label: {
          type: 'Identifier',
          loc:{start:{line:1,column:5},end:{line:1,column:8},source:''},
          name: 'bar'
        },
        body: {
          type: 'DoWhileStatement',
          loc:{start:{line:1,column:10},end:{line:1,column:52},source:''},
          body: {
            type: 'BlockStatement',
            loc:{start:{line:1,column:13},end:{line:1,column:43},source:''},
            body: [
              {
                type: 'DoWhileStatement',
                loc:{start:{line:1,column:15},end:{line:1,column:41},source:''},
                body: {
                  type: 'ContinueStatement',
                  loc:{start:{line:1,column:18},end:{line:1,column:31},source:''},
                  label: {
                    type: 'Identifier',
                    loc:{start:{line:1,column:27},end:{line:1,column:30},source:''},
                    name: 'foo'
                  }
                },
                test: {
                  type: 'Identifier',
                  loc:{start:{line:1,column:38},end:{line:1,column:39},source:''},
                  name: 'z'
                }
              }
            ]
          },
          test: {
            type: 'Identifier',
            loc:{start:{line:1,column:50},end:{line:1,column:51},source:''},
            name: 'z'
          }
        }
      }
    }
  ]
}

tokens (22x):
       IDENT PUNC_COLON IDENT PUNC_COLON ID_do PUNC_CURLY_OPEN ID_do
       ID_continue IDENT PUNC_SEMI ID_while PUNC_PAREN_OPEN IDENT
       PUNC_PAREN_CLOSE PUNC_SEMI PUNC_CURLY_CLOSE ID_while
       PUNC_PAREN_OPEN IDENT PUNC_PAREN_CLOSE ASI
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
foo: bar: do {do continue foo; while (z);} while (z);
````

Produces same AST
