# Tenko parser test case

- Path: tests/testcases/continue_statement/label_validation/do-loop/label_loop_block_loop_continue.md

> :: continue statement : label validation : do-loop
>
> ::> label loop block loop continue
>
> The `continue` label much match a label that is a direct parent of a loop node or a direct parent of such label recursively.

## PASS

## Input

`````js
foo: do { do continue foo;while(z) } while(z)
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:45},source:''},
  body: [
    {
      type: 'LabeledStatement',
      loc:{start:{line:1,column:0},end:{line:1,column:45},source:''},
      label: {
        type: 'Identifier',
        loc:{start:{line:1,column:0},end:{line:1,column:3},source:''},
        name: 'foo'
      },
      body: {
        type: 'DoWhileStatement',
        loc:{start:{line:1,column:5},end:{line:1,column:45},source:''},
        body: {
          type: 'BlockStatement',
          loc:{start:{line:1,column:8},end:{line:1,column:36},source:''},
          body: [
            {
              type: 'DoWhileStatement',
              loc:{start:{line:1,column:10},end:{line:1,column:34},source:''},
              body: {
                type: 'ContinueStatement',
                loc:{start:{line:1,column:13},end:{line:1,column:26},source:''},
                label: {
                  type: 'Identifier',
                  loc:{start:{line:1,column:22},end:{line:1,column:25},source:''},
                  name: 'foo'
                }
              },
              test: {
                type: 'Identifier',
                loc:{start:{line:1,column:32},end:{line:1,column:33},source:''},
                name: 'z'
              }
            }
          ]
        },
        test: {
          type: 'Identifier',
          loc:{start:{line:1,column:43},end:{line:1,column:44},source:''},
          name: 'z'
        }
      }
    }
  ]
}

tokens (20x):
       IDENT PUNC_COLON ID_do PUNC_CURLY_OPEN ID_do ID_continue IDENT
       PUNC_SEMI ID_while PUNC_PAREN_OPEN IDENT PUNC_PAREN_CLOSE ASI
       PUNC_CURLY_CLOSE ID_while PUNC_PAREN_OPEN IDENT
       PUNC_PAREN_CLOSE ASI
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
foo: do {do continue foo; while (z);} while (z);
````

Produces same AST
