# Tenko parser test case

- Path: tests/testcases/continue_statement/label_validation/do-loop/loop_label_loop_continue.md

> :: continue statement : label validation : do-loop
>
> ::> loop label loop continue
>
> The `continue` label much match a label that is a direct parent of a loop node or a direct parent of such label recursively.

## PASS

## Input

`````js
do foo: do continue foo; while(z); while(z)
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:43},source:''},
  body: [
    {
      type: 'DoWhileStatement',
      loc:{start:{line:1,column:0},end:{line:1,column:43},source:''},
      body: {
        type: 'LabeledStatement',
        loc:{start:{line:1,column:3},end:{line:1,column:34},source:''},
        label: {
          type: 'Identifier',
          loc:{start:{line:1,column:3},end:{line:1,column:6},source:''},
          name: 'foo'
        },
        body: {
          type: 'DoWhileStatement',
          loc:{start:{line:1,column:8},end:{line:1,column:34},source:''},
          body: {
            type: 'ContinueStatement',
            loc:{start:{line:1,column:11},end:{line:1,column:24},source:''},
            label: {
              type: 'Identifier',
              loc:{start:{line:1,column:20},end:{line:1,column:23},source:''},
              name: 'foo'
            }
          },
          test: {
            type: 'Identifier',
            loc:{start:{line:1,column:31},end:{line:1,column:32},source:''},
            name: 'z'
          }
        }
      },
      test: {
        type: 'Identifier',
        loc:{start:{line:1,column:41},end:{line:1,column:42},source:''},
        name: 'z'
      }
    }
  ]
}

tokens (18x):
       ID_do IDENT PUNC_COLON ID_do ID_continue IDENT PUNC_SEMI
       ID_while PUNC_PAREN_OPEN IDENT PUNC_PAREN_CLOSE PUNC_SEMI
       ID_while PUNC_PAREN_OPEN IDENT PUNC_PAREN_CLOSE ASI
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
do foo: do continue foo; while (z); while (z);
````

Produces same AST
