# Tenko parser test case

- Path: tests/testcases/continue_statement/label_validation/while-loop/label_loop_block_label2_loop_continue_label.md

> :: continue statement : label validation : while-loop
>
> ::> label loop block label2 loop continue label
>
> The `continue` label much match a label that is a direct parent of a loop node or a direct parent of such label recursively.

## PASS

## Input

`````js
foo: while(z) { bar: while(z) continue foo }
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:44},source:''},
  body: [
    {
      type: 'LabeledStatement',
      loc:{start:{line:1,column:0},end:{line:1,column:44},source:''},
      label: {
        type: 'Identifier',
        loc:{start:{line:1,column:0},end:{line:1,column:3},source:''},
        name: 'foo'
      },
      body: {
        type: 'WhileStatement',
        loc:{start:{line:1,column:5},end:{line:1,column:44},source:''},
        test: {
          type: 'Identifier',
          loc:{start:{line:1,column:11},end:{line:1,column:12},source:''},
          name: 'z'
        },
        body: {
          type: 'BlockStatement',
          loc:{start:{line:1,column:14},end:{line:1,column:44},source:''},
          body: [
            {
              type: 'LabeledStatement',
              loc:{start:{line:1,column:16},end:{line:1,column:42},source:''},
              label: {
                type: 'Identifier',
                loc:{start:{line:1,column:16},end:{line:1,column:19},source:''},
                name: 'bar'
              },
              body: {
                type: 'WhileStatement',
                loc:{start:{line:1,column:21},end:{line:1,column:42},source:''},
                test: {
                  type: 'Identifier',
                  loc:{start:{line:1,column:27},end:{line:1,column:28},source:''},
                  name: 'z'
                },
                body: {
                  type: 'ContinueStatement',
                  loc:{start:{line:1,column:30},end:{line:1,column:42},source:''},
                  label: {
                    type: 'Identifier',
                    loc:{start:{line:1,column:39},end:{line:1,column:42},source:''},
                    name: 'foo'
                  }
                }
              }
            }
          ]
        }
      }
    }
  ]
}

tokens (18x):
       IDENT PUNC_COLON ID_while PUNC_PAREN_OPEN IDENT
       PUNC_PAREN_CLOSE PUNC_CURLY_OPEN IDENT PUNC_COLON ID_while
       PUNC_PAREN_OPEN IDENT PUNC_PAREN_CLOSE ID_continue IDENT ASI
       PUNC_CURLY_CLOSE
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
foo: while (z) {bar: while (z) continue foo;}
````

Produces same AST
