# Tenko parser test case

- Path: tests/testcases/continue_statement/labels/continue_to_label_in_nested_else.md

> :: continue statement : labels
>
> ::> continue to label in nested else

## Input

`````js
foo: while (true) if (x); else continue foo;
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:44},source:''},
  body: [
    {
      type: 'LabeledStatement',
      loc:{start:{line:1,column:0},end:{line:1,column:44},source:''},
      label: {
        type: 'Identifier',
        loc:{start:{line:1,column:0},end:{line:1,column:3},source:''},
        name: 'foo'
      },
      body: {
        type: 'WhileStatement',
        loc:{start:{line:1,column:5},end:{line:1,column:44},source:''},
        test: {
          type: 'Literal',
          loc:{start:{line:1,column:12},end:{line:1,column:16},source:''},
          value: true,
          raw: 'true'
        },
        body: {
          type: 'IfStatement',
          loc:{start:{line:1,column:18},end:{line:1,column:44},source:''},
          test: {
            type: 'Identifier',
            loc:{start:{line:1,column:22},end:{line:1,column:23},source:''},
            name: 'x'
          },
          consequent: {
            type: 'EmptyStatement',
            loc:{start:{line:1,column:24},end:{line:1,column:25},source:''}
          },
          alternate: {
            type: 'ContinueStatement',
            loc:{start:{line:1,column:31},end:{line:1,column:44},source:''},
            label: {
              type: 'Identifier',
              loc:{start:{line:1,column:40},end:{line:1,column:43},source:''},
              name: 'foo'
            }
          }
        }
      }
    }
  ]
}

tokens (16x):
       IDENT PUNC_COLON ID_while PUNC_PAREN_OPEN ID_true
       PUNC_PAREN_CLOSE ID_if PUNC_PAREN_OPEN IDENT PUNC_PAREN_CLOSE
       PUNC_SEMI ID_else ID_continue IDENT PUNC_SEMI
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
foo: while (true) if (x) ; else continue foo;
````

Produces same AST
