# Tenko parser test case

- Path: tests/testcases/continue_statement/labels/continue_to_label_in_nested_if_block.md

> :: continue statement : labels
>
> ::> continue to label in nested if block

## Input

`````js
foo: while (true) if (x) { continue foo; }
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:42},source:''},
  body: [
    {
      type: 'LabeledStatement',
      loc:{start:{line:1,column:0},end:{line:1,column:42},source:''},
      label: {
        type: 'Identifier',
        loc:{start:{line:1,column:0},end:{line:1,column:3},source:''},
        name: 'foo'
      },
      body: {
        type: 'WhileStatement',
        loc:{start:{line:1,column:5},end:{line:1,column:42},source:''},
        test: {
          type: 'Literal',
          loc:{start:{line:1,column:12},end:{line:1,column:16},source:''},
          value: true,
          raw: 'true'
        },
        body: {
          type: 'IfStatement',
          loc:{start:{line:1,column:18},end:{line:1,column:42},source:''},
          test: {
            type: 'Identifier',
            loc:{start:{line:1,column:22},end:{line:1,column:23},source:''},
            name: 'x'
          },
          consequent: {
            type: 'BlockStatement',
            loc:{start:{line:1,column:25},end:{line:1,column:42},source:''},
            body: [
              {
                type: 'ContinueStatement',
                loc:{start:{line:1,column:27},end:{line:1,column:40},source:''},
                label: {
                  type: 'Identifier',
                  loc:{start:{line:1,column:36},end:{line:1,column:39},source:''},
                  name: 'foo'
                }
              }
            ]
          },
          alternate: null
        }
      }
    }
  ]
}

tokens (16x):
       IDENT PUNC_COLON ID_while PUNC_PAREN_OPEN ID_true
       PUNC_PAREN_CLOSE ID_if PUNC_PAREN_OPEN IDENT PUNC_PAREN_CLOSE
       PUNC_CURLY_OPEN ID_continue IDENT PUNC_SEMI PUNC_CURLY_CLOSE
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
foo: while (true) if (x) {continue foo;}
````

Produces same AST
