# Tenko parser test case

- Path: tests/testcases/continue_statement/labels/label_defined_in_outer_loop_illegal.md

> :: continue statement : labels
>
> ::> label defined in outer loop illegal
>
> Labels are not allowed to be a direct child of a loop (like while/for)

## Input

`````js
while (true) x: while (true) continue x;
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:40},source:''},
  body: [
    {
      type: 'WhileStatement',
      loc:{start:{line:1,column:0},end:{line:1,column:40},source:''},
      test: {
        type: 'Literal',
        loc:{start:{line:1,column:7},end:{line:1,column:11},source:''},
        value: true,
        raw: 'true'
      },
      body: {
        type: 'LabeledStatement',
        loc:{start:{line:1,column:13},end:{line:1,column:40},source:''},
        label: {
          type: 'Identifier',
          loc:{start:{line:1,column:13},end:{line:1,column:14},source:''},
          name: 'x'
        },
        body: {
          type: 'WhileStatement',
          loc:{start:{line:1,column:16},end:{line:1,column:40},source:''},
          test: {
            type: 'Literal',
            loc:{start:{line:1,column:23},end:{line:1,column:27},source:''},
            value: true,
            raw: 'true'
          },
          body: {
            type: 'ContinueStatement',
            loc:{start:{line:1,column:29},end:{line:1,column:40},source:''},
            label: {
              type: 'Identifier',
              loc:{start:{line:1,column:38},end:{line:1,column:39},source:''},
              name: 'x'
            }
          }
        }
      }
    }
  ]
}

tokens (14x):
       ID_while PUNC_PAREN_OPEN ID_true PUNC_PAREN_CLOSE IDENT
       PUNC_COLON ID_while PUNC_PAREN_OPEN ID_true PUNC_PAREN_CLOSE
       ID_continue IDENT PUNC_SEMI
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output was same as input [sloppy]
