# Tenko parser test case

- Path: tests/testcases/continue_statement/nesting/do-while/global/nested.md

> :: continue statement : nesting : do-while : global
>
> ::> nested

## Input

`````js
do     if (x) continue   ; while(true);
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:39},source:''},
  body: [
    {
      type: 'DoWhileStatement',
      loc:{start:{line:1,column:0},end:{line:1,column:39},source:''},
      body: {
        type: 'IfStatement',
        loc:{start:{line:1,column:7},end:{line:1,column:26},source:''},
        test: {
          type: 'Identifier',
          loc:{start:{line:1,column:11},end:{line:1,column:12},source:''},
          name: 'x'
        },
        consequent: {
          type: 'ContinueStatement',
          loc:{start:{line:1,column:14},end:{line:1,column:26},source:''},
          label: null
        },
        alternate: null
      },
      test: {
        type: 'Literal',
        loc:{start:{line:1,column:33},end:{line:1,column:37},source:''},
        value: true,
        raw: 'true'
      }
    }
  ]
}

tokens (13x):
       ID_do ID_if PUNC_PAREN_OPEN IDENT PUNC_PAREN_CLOSE ID_continue
       PUNC_SEMI ID_while PUNC_PAREN_OPEN ID_true PUNC_PAREN_CLOSE
       PUNC_SEMI
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
do if (x) continue; while (true);
````

Produces same AST
