# Tenko parser test case

- Path: tests/testcases/continue_statement/nesting/for/global/nested.md

> :: continue statement : nesting : for : global
>
> ::> nested

## Input

`````js
for (;;)    if (x) continue
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:27},source:''},
  body: [
    {
      type: 'ForStatement',
      loc:{start:{line:1,column:0},end:{line:1,column:27},source:''},
      init: null,
      test: null,
      update: null,
      body: {
        type: 'IfStatement',
        loc:{start:{line:1,column:12},end:{line:1,column:27},source:''},
        test: {
          type: 'Identifier',
          loc:{start:{line:1,column:16},end:{line:1,column:17},source:''},
          name: 'x'
        },
        consequent: {
          type: 'ContinueStatement',
          loc:{start:{line:1,column:19},end:{line:1,column:27},source:''},
          label: null
        },
        alternate: null
      }
    }
  ]
}

tokens (12x):
       ID_for PUNC_PAREN_OPEN PUNC_SEMI PUNC_SEMI PUNC_PAREN_CLOSE
       ID_if PUNC_PAREN_OPEN IDENT PUNC_PAREN_CLOSE ID_continue ASI
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
for (;;) if (x) continue;
````

Produces same AST
