# Tenko parser test case

- Path: tests/testcases/debugger_statement/await/in_a_generator_1.md

> :: debugger statement : await
>
> ::> in a generator 1

## Input

`````js
function *f(){ await: x; }
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:26},source:''},
  body: [
    {
      type: 'FunctionDeclaration',
      loc:{start:{line:1,column:0},end:{line:1,column:26},source:''},
      generator: true,
      async: false,
      id: {
        type: 'Identifier',
        loc:{start:{line:1,column:10},end:{line:1,column:11},source:''},
        name: 'f'
      },
      params: [],
      body: {
        type: 'BlockStatement',
        loc:{start:{line:1,column:13},end:{line:1,column:26},source:''},
        body: [
          {
            type: 'LabeledStatement',
            loc:{start:{line:1,column:15},end:{line:1,column:24},source:''},
            label: {
              type: 'Identifier',
              loc:{start:{line:1,column:15},end:{line:1,column:20},source:''},
              name: 'await'
            },
            body: {
              type: 'ExpressionStatement',
              loc:{start:{line:1,column:22},end:{line:1,column:24},source:''},
              expression: {
                type: 'Identifier',
                loc:{start:{line:1,column:22},end:{line:1,column:23},source:''},
                name: 'x'
              }
            }
          }
        ]
      }
    }
  ]
}

tokens (12x):
       ID_function PUNC_STAR IDENT PUNC_PAREN_OPEN PUNC_PAREN_CLOSE
       PUNC_CURLY_OPEN ID_await PUNC_COLON IDENT PUNC_SEMI
       PUNC_CURLY_CLOSE
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

`````
throws: Parser error!
  Cannot use this name (await) as a variable name because: Await is illegal as var name with module goal

function *f(){ await: x; }
                    ^------- error
`````


### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
function* f() {await: (x);}
````

Produces same AST
