# Tenko parser test case

- Path: tests/testcases/debugger_statement/can_not_use_certain_reserved_keywords_as_label_name_in_strict_modex003a_keywordx003dx0060letx0060.md

> :: debugger statement
>
> ::> can not use certain reserved keywords as label name in strict modex003a keywordx003dx0060letx0060

## Input

`````js
let: x;
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:7},source:''},
  body: [
    {
      type: 'LabeledStatement',
      loc:{start:{line:1,column:0},end:{line:1,column:7},source:''},
      label: {
        type: 'Identifier',
        loc:{start:{line:1,column:0},end:{line:1,column:3},source:''},
        name: 'let'
      },
      body: {
        type: 'ExpressionStatement',
        loc:{start:{line:1,column:5},end:{line:1,column:7},source:''},
        expression: {
          type: 'Identifier',
          loc:{start:{line:1,column:5},end:{line:1,column:6},source:''},
          name: 'x'
        }
      }
    }
  ]
}

tokens (5x):
       ID_let PUNC_COLON IDENT PUNC_SEMI
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

`````
throws: Parser error!
  Let declaration missing binding names and `let` cannot be a regular var or label name in strict mode

let: x;
   ^------- error
`````


### Module goal

Parsed with the module goal.

_Output same as strict mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
let: (x);
````

Produces same AST
