# Tenko parser test case

- Path: tests/testcases/debugger_statement/unicode_escapes_at_the_start_of_labels_should_not_allow_keywords.md

> :: debugger statement
>
> ::> unicode escapes at the start of labels should not allow keywords

## Input

`````js
async () => { \u{61}wait: x }
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
throws: Parser error!
  Cannot use this name (\u{61}wait) as a variable name because: Await not allowed here

async () => { \u{61}wait: x }
                        ^------- error
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

`````
throws: Parser error!
  Cannot use this name (\u{61}wait) as a variable name because: Await is illegal as var name with module goal

async () => { \u{61}wait: x }
                        ^------- error
`````


### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._
