# Tenko parser test case

- Path: tests/testcases/debugger_statement/unicode_escapes_in_the_middle_of_labels_should_not_allow_keywords.md

> :: debugger statement
>
> ::> unicode escapes in the middle of labels should not allow keywords

## Input

`````js
async () => { aw\u{61}it: x }
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
throws: Parser error!
  Cannot use this name (aw\u{61}it) as a variable name because: Await not allowed here

async () => { aw\u{61}it: x }
                        ^------- error
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

`````
throws: Parser error!
  Cannot use this name (aw\u{61}it) as a variable name because: Await is illegal as var name with module goal

async () => { aw\u{61}it: x }
                        ^------- error
`````


### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._
