# Tenko parser test case

- Path: tests/testcases/delete/for_header_ternary_flag.md

> :: delete
>
> ::> for header ternary flag
>
> By fuzzer, zeparser only
>
> Error: Parser error! Next ord should be 41 (`)`) but was 105 (curc: `i`, token: `in`)

## Input

`````js
for(delete((1)?y:x in y);;)x
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:28},source:''},
  body: [
    {
      type: 'ForStatement',
      loc:{start:{line:1,column:0},end:{line:1,column:28},source:''},
      init: {
        type: 'UnaryExpression',
        loc:{start:{line:1,column:4},end:{line:1,column:24},source:''},
        operator: 'delete',
        prefix: true,
        argument: {
          type: 'ConditionalExpression',
          loc:{start:{line:1,column:11},end:{line:1,column:23},source:''},
          test: {
            type: 'Literal',
            loc:{start:{line:1,column:12},end:{line:1,column:13},source:''},
            value: 1,
            raw: '1'
          },
          consequent: {
            type: 'Identifier',
            loc:{start:{line:1,column:15},end:{line:1,column:16},source:''},
            name: 'y'
          },
          alternate: {
            type: 'BinaryExpression',
            loc:{start:{line:1,column:17},end:{line:1,column:23},source:''},
            left: {
              type: 'Identifier',
              loc:{start:{line:1,column:17},end:{line:1,column:18},source:''},
              name: 'x'
            },
            operator: 'in',
            right: {
              type: 'Identifier',
              loc:{start:{line:1,column:22},end:{line:1,column:23},source:''},
              name: 'y'
            }
          }
        }
      },
      test: null,
      update: null,
      body: {
        type: 'ExpressionStatement',
        loc:{start:{line:1,column:27},end:{line:1,column:28},source:''},
        expression: {
          type: 'Identifier',
          loc:{start:{line:1,column:27},end:{line:1,column:28},source:''},
          name: 'x'
        }
      }
    }
  ]
}

tokens (20x):
       ID_for PUNC_PAREN_OPEN ID_delete PUNC_PAREN_OPEN
       PUNC_PAREN_OPEN NUMBER_DEC PUNC_PAREN_CLOSE PUNC_QMARK IDENT
       PUNC_COLON IDENT ID_in IDENT PUNC_PAREN_CLOSE PUNC_SEMI
       PUNC_SEMI PUNC_PAREN_CLOSE IDENT ASI
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
for ((delete (((1)? (y) : (((x) in (y))))));;) (x);
````

Produces same AST
