# Tenko parser test case

- Path: tests/testcases/delete/should_work_as_sequence_expression_statement.md

> :: delete
>
> ::> should work as sequence expression statement

## Input

`````js
delete foo.bar, z;
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:18},source:''},
  body: [
    {
      type: 'ExpressionStatement',
      loc:{start:{line:1,column:0},end:{line:1,column:18},source:''},
      expression: {
        type: 'SequenceExpression',
        loc:{start:{line:1,column:0},end:{line:1,column:17},source:''},
        expressions: [
          {
            type: 'UnaryExpression',
            loc:{start:{line:1,column:0},end:{line:1,column:14},source:''},
            operator: 'delete',
            prefix: true,
            argument: {
              type: 'MemberExpression',
              loc:{start:{line:1,column:7},end:{line:1,column:14},source:''},
              object: {
                type: 'Identifier',
                loc:{start:{line:1,column:7},end:{line:1,column:10},source:''},
                name: 'foo'
              },
              property: {
                type: 'Identifier',
                loc:{start:{line:1,column:11},end:{line:1,column:14},source:''},
                name: 'bar'
              },
              computed: false
            }
          },
          {
            type: 'Identifier',
            loc:{start:{line:1,column:16},end:{line:1,column:17},source:''},
            name: 'z'
          }
        ]
      }
    }
  ]
}

tokens (8x):
       ID_delete IDENT PUNC_DOT IDENT PUNC_COMMA IDENT PUNC_SEMI
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
((delete ((foo).bar), z));
````

Produces same AST
