# Tenko parser test case

- Path: tests/testcases/delete/single_ident_cases/grouped_forward_slash_newline_should_parse_as_a_division.md

> :: delete : single ident cases
>
> ::> grouped forward slash newline should parse as a division
>
> and make sure the ast reads as (delete x)/f/g

## Input

`````js
delete (x)
/f/g
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:2,column:4},source:''},
  body: [
    {
      type: 'ExpressionStatement',
      loc:{start:{line:1,column:0},end:{line:2,column:4},source:''},
      expression: {
        type: 'BinaryExpression',
        loc:{start:{line:1,column:0},end:{line:2,column:4},source:''},
        left: {
          type: 'BinaryExpression',
          loc:{start:{line:1,column:0},end:{line:2,column:2},source:''},
          left: {
            type: 'UnaryExpression',
            loc:{start:{line:1,column:0},end:{line:1,column:10},source:''},
            operator: 'delete',
            prefix: true,
            argument: {
              type: 'Identifier',
              loc:{start:{line:1,column:8},end:{line:1,column:9},source:''},
              name: 'x'
            }
          },
          operator: '/',
          right: {
            type: 'Identifier',
            loc:{start:{line:2,column:1},end:{line:2,column:2},source:''},
            name: 'f'
          }
        },
        operator: '/',
        right: {
          type: 'Identifier',
          loc:{start:{line:2,column:3},end:{line:2,column:4},source:''},
          name: 'g'
        }
      }
    }
  ]
}

tokens (10x):
       ID_delete PUNC_PAREN_OPEN IDENT PUNC_PAREN_CLOSE PUNC_DIV IDENT
       PUNC_DIV IDENT ASI
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

`````
throws: Parser error!
  Bad delete case, can not delete an ident wrapped in parens

delete (x)
/f/g
^------- error
`````


### Module goal

Parsed with the module goal.

_Output same as strict mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
(((((delete (x)) / (f))) / (g)));
````

Produces same AST
