# Tenko parser test case

- Path: tests/testcases/delete/single_ident_cases/keywords/false_grouped.md

> :: delete : single ident cases : keywords
>
> ::> false grouped
>
> This tests the "can not delete an identifier without tail in strict mode" rule, which does not apply to keywords
>
> This rule should persist through (noop) paren wrappings

## PASS

## Input

`````js
delete (false);
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:15},source:''},
  body: [
    {
      type: 'ExpressionStatement',
      loc:{start:{line:1,column:0},end:{line:1,column:15},source:''},
      expression: {
        type: 'UnaryExpression',
        loc:{start:{line:1,column:0},end:{line:1,column:14},source:''},
        operator: 'delete',
        prefix: true,
        argument: {
          type: 'Literal',
          loc:{start:{line:1,column:8},end:{line:1,column:13},source:''},
          value: false,
          raw: 'false'
        }
      }
    }
  ]
}

tokens (6x):
       ID_delete PUNC_PAREN_OPEN ID_false PUNC_PAREN_CLOSE PUNC_SEMI
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
(delete (false));
````

Produces same AST
