# Tenko parser test case

- Path: tests/testcases/delete/single_ident_cases/keywords/super.md

> :: delete : single ident cases : keywords
>
> ::> super
>
> This tests the "can not delete an identifier without tail in strict mode" rule, which does not apply to keywords
>
> However, `super` can only ever be referenced as a call or property so this would always fail.

## FAIL

## Input

`````js
class X extends Y {
  constructor() {
    delete super;
  }
}
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
throws: Parser error!
  The `super` keyword can only be used as call or member expression

class X extends Y {
  constructor() {
    delete super;
                ^------- error

  }
}
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._
