# Tenko parser test case

- Path: tests/testcases/delete/throw_template_delete.md

> :: delete
>
> ::> throw template delete
>
> fuzzed
>
> The delete grouped arg is a little special edge case. There was a regression where it would parse the `}` not as a template continuation.

## Input

`````js
function f() {
  throw `${delete(y)}`;
}
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:3,column:1},source:''},
  body: [
    {
      type: 'FunctionDeclaration',
      loc:{start:{line:1,column:0},end:{line:3,column:1},source:''},
      generator: false,
      async: false,
      id: {
        type: 'Identifier',
        loc:{start:{line:1,column:9},end:{line:1,column:10},source:''},
        name: 'f'
      },
      params: [],
      body: {
        type: 'BlockStatement',
        loc:{start:{line:1,column:13},end:{line:3,column:1},source:''},
        body: [
          {
            type: 'ThrowStatement',
            loc:{start:{line:2,column:2},end:{line:2,column:23},source:''},
            argument: {
              type: 'TemplateLiteral',
              loc:{start:{line:2,column:8},end:{line:2,column:22},source:''},
              expressions: [
                {
                  type: 'UnaryExpression',
                  loc:{start:{line:2,column:11},end:{line:2,column:20},source:''},
                  operator: 'delete',
                  prefix: true,
                  argument: {
                    type: 'Identifier',
                    loc:{start:{line:2,column:18},end:{line:2,column:19},source:''},
                    name: 'y'
                  }
                }
              ],
              quasis: [
                {
                  type: 'TemplateElement',
                  loc:{start:{line:2,column:9},end:{line:2,column:9},source:''},
                  tail: false,
                  value: { raw: '', cooked: '' }
                },
                {
                  type: 'TemplateElement',
                  loc:{start:{line:2,column:21},end:{line:2,column:21},source:''},
                  tail: true,
                  value: { raw: '', cooked: '' }
                }
              ]
            }
          }
        ]
      }
    }
  ]
}

tokens (15x):
       ID_function IDENT PUNC_PAREN_OPEN PUNC_PAREN_CLOSE
       PUNC_CURLY_OPEN ID_throw TICK_HEAD ID_delete PUNC_PAREN_OPEN
       IDENT PUNC_PAREN_CLOSE TICK_TAIL PUNC_SEMI PUNC_CURLY_CLOSE
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

`````
throws: Parser error!
  Bad delete case, can not delete an ident wrapped in parens

function f() {
  throw `${delete(y)}`;
                    ^------- error

}
`````


### Module goal

Parsed with the module goal.

_Output same as strict mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
function f() {throw `${delete (y)}`;}
````

Produces same AST
