# Tenko parser test case

- Path: tests/testcases/delete/wrapping_in_empty_groups_should_not_matter_for_the_error.md

> :: delete
>
> ::> wrapping in empty groups should not matter for the error

## Input

`````js
delete (((foo)));
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:17},source:''},
  body: [
    {
      type: 'ExpressionStatement',
      loc:{start:{line:1,column:0},end:{line:1,column:17},source:''},
      expression: {
        type: 'UnaryExpression',
        loc:{start:{line:1,column:0},end:{line:1,column:16},source:''},
        operator: 'delete',
        prefix: true,
        argument: {
          type: 'Identifier',
          loc:{start:{line:1,column:10},end:{line:1,column:13},source:''},
          name: 'foo'
        }
      }
    }
  ]
}

tokens (10x):
       ID_delete PUNC_PAREN_OPEN PUNC_PAREN_OPEN PUNC_PAREN_OPEN IDENT
       PUNC_PAREN_CLOSE PUNC_PAREN_CLOSE PUNC_PAREN_CLOSE PUNC_SEMI
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

`````
throws: Parser error!
  Bad delete case, can not delete an ident wrapped in parens

delete (((foo)));
                ^------- error
`````


### Module goal

Parsed with the module goal.

_Output same as strict mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
(delete (foo));
````

Produces same AST
