# Tenko parser test case

- Path: tests/testcases/destructuring/destruct_in_call_arg2.md

> :: destructuring
>
> ::> destruct in call arg2
>
> Another case of destructuring that node rejects

## Input

`````js
y(y/=x,{}=x)
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:12},source:''},
  body: [
    {
      type: 'ExpressionStatement',
      loc:{start:{line:1,column:0},end:{line:1,column:12},source:''},
      expression: {
        type: 'CallExpression',
        loc:{start:{line:1,column:0},end:{line:1,column:12},source:''},
        callee: {
          type: 'Identifier',
          loc:{start:{line:1,column:0},end:{line:1,column:1},source:''},
          name: 'y'
        },
        arguments: [
          {
            type: 'AssignmentExpression',
            loc:{start:{line:1,column:2},end:{line:1,column:6},source:''},
            left: {
              type: 'Identifier',
              loc:{start:{line:1,column:2},end:{line:1,column:3},source:''},
              name: 'y'
            },
            operator: '/=',
            right: {
              type: 'Identifier',
              loc:{start:{line:1,column:5},end:{line:1,column:6},source:''},
              name: 'x'
            }
          },
          {
            type: 'AssignmentExpression',
            loc:{start:{line:1,column:7},end:{line:1,column:11},source:''},
            left: {
              type: 'ObjectPattern',
              loc:{start:{line:1,column:7},end:{line:1,column:9},source:''},
              properties: []
            },
            operator: '=',
            right: {
              type: 'Identifier',
              loc:{start:{line:1,column:10},end:{line:1,column:11},source:''},
              name: 'x'
            }
          }
        ]
      }
    }
  ]
}

tokens (13x):
       IDENT PUNC_PAREN_OPEN IDENT PUNC_DIV_EQ IDENT PUNC_COMMA
       PUNC_CURLY_OPEN PUNC_CURLY_CLOSE PUNC_EQ IDENT PUNC_PAREN_CLOSE
       ASI
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
((y)((y /= x), ({} = x)));
````

Produces same AST
