# Tenko parser test case

- Path: tests/testcases/directive_prologues/octals/function/can_be_ok.md

> :: directive prologues : octals : function
>
> ::> can be ok
>
> The octal escape is not disallowed in directives by definition
>
> This should pass in sloppy mode

## Input

`````js
function f() {
    "You \077 ok"
}
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
throws: Lexer error!
    Octal escapes are only allowed in sloppy mode with web compat enabled

function f() {
    "You \077 ok"
    ^------- error

}
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

`````
throws: Lexer error!
    Illegal legacy octal escape in strict mode

function f() {
    "You \077 ok"
    ^------- error

}
`````


### Module goal

Parsed with the module goal.

_Output same as strict mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:3,column:1},source:''},
  body: [
    {
      type: 'FunctionDeclaration',
      loc:{start:{line:1,column:0},end:{line:3,column:1},source:''},
      generator: false,
      async: false,
      id: {
        type: 'Identifier',
        loc:{start:{line:1,column:9},end:{line:1,column:10},source:''},
        name: 'f'
      },
      params: [],
      body: {
        type: 'BlockStatement',
        loc:{start:{line:1,column:13},end:{line:3,column:1},source:''},
        body: [
          {
            type: 'ExpressionStatement',
            loc:{start:{line:2,column:4},end:{line:2,column:17},source:''},
            expression: {
              type: 'Literal',
              loc:{start:{line:2,column:4},end:{line:2,column:17},source:''},
              value: 'You ? ok',
              raw: '"You \\077 ok"'
            },
            directive: 'You \\077 ok'
          }
        ]
      }
    }
  ]
}

tokens (9x):
       ID_function IDENT PUNC_PAREN_OPEN PUNC_PAREN_CLOSE
       PUNC_CURLY_OPEN STRING_DOUBLE ASI PUNC_CURLY_CLOSE
`````


## AST Printer

Printer output different from input [web]:

````js
function f() {"You \077 ok";}
````

Produces same AST
