# Tenko parser test case

- Path: tests/testcases/directive_prologues/octals/function/nested_already_strict.md

> :: directive prologues : octals : function
>
> ::> nested already strict
>
> Octal escapes are retroactively illegal in directives if they're followed by a "use strict" directive
>
> This tests the case where global is not strict but a local function is strict and another function is nested in it. Basically, testing that the parser is not treating global "use strict" as special in this context.

## FAIL

## Input

`````js
function f() {
    "use strict"
    function g() {
        "You \077 ok";
    }
}
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
throws: Lexer error!
    Illegal legacy octal escape in strict mode

function f() {
    "use strict"
    function g() {
        "You \077 ok";
        ^------- error

    }
}
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._
