# Tenko parser test case

- Path: tests/testcases/directive_prologues/regressionx003a_double_use_strict_in_arrow.md

> :: directive prologues
>
> ::> regressionx003a double use strict in arrow
>
> this was throwing at some point, complaining about non-simple args

## Input

`````js
(w, o, e, m) => { "use strict"; "use strict" }
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:46},source:''},
  body: [
    {
      type: 'ExpressionStatement',
      loc:{start:{line:1,column:0},end:{line:1,column:46},source:''},
      expression: {
        type: 'ArrowFunctionExpression',
        loc:{start:{line:1,column:0},end:{line:1,column:46},source:''},
        params: [
          {
            type: 'Identifier',
            loc:{start:{line:1,column:1},end:{line:1,column:2},source:''},
            name: 'w'
          },
          {
            type: 'Identifier',
            loc:{start:{line:1,column:4},end:{line:1,column:5},source:''},
            name: 'o'
          },
          {
            type: 'Identifier',
            loc:{start:{line:1,column:7},end:{line:1,column:8},source:''},
            name: 'e'
          },
          {
            type: 'Identifier',
            loc:{start:{line:1,column:10},end:{line:1,column:11},source:''},
            name: 'm'
          }
        ],
        id: null,
        generator: false,
        async: false,
        expression: false,
        body: {
          type: 'BlockStatement',
          loc:{start:{line:1,column:16},end:{line:1,column:46},source:''},
          body: [
            {
              type: 'ExpressionStatement',
              loc:{start:{line:1,column:18},end:{line:1,column:31},source:''},
              expression: {
                type: 'Literal',
                loc:{start:{line:1,column:18},end:{line:1,column:30},source:''},
                value: 'use strict',
                raw: '"use strict"'
              },
              directive: 'use strict'
            },
            {
              type: 'ExpressionStatement',
              loc:{start:{line:1,column:32},end:{line:1,column:44},source:''},
              expression: {
                type: 'Literal',
                loc:{start:{line:1,column:32},end:{line:1,column:44},source:''},
                value: 'use strict',
                raw: '"use strict"'
              },
              directive: 'use strict'
            }
          ]
        }
      }
    }
  ]
}

tokens (18x):
       PUNC_PAREN_OPEN IDENT PUNC_COMMA IDENT PUNC_COMMA IDENT
       PUNC_COMMA IDENT PUNC_PAREN_CLOSE PUNC_EQ_GT PUNC_CURLY_OPEN
       STRING_DOUBLE PUNC_SEMI STRING_DOUBLE ASI PUNC_CURLY_CLOSE ASI
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
(w, o, e, m) => {"use strict";
"use strict";};
````

Produces same AST
