# Tenko parser test case

- Path: tests/testcases/directive_prologues/string_div_ident_asi_string.md

> :: directive prologues
>
> ::> string div ident asi string
>
> Regression was adding an empty `directive` property to the AST.
>
> The loop was only asserting the statement started with a string, but not bailing if it had a tail.

## Input

`````js
""/x
""
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:2,column:2},source:''},
  body: [
    {
      type: 'ExpressionStatement',
      loc:{start:{line:1,column:0},end:{line:1,column:4},source:''},
      expression: {
        type: 'BinaryExpression',
        loc:{start:{line:1,column:0},end:{line:1,column:4},source:''},
        left: {
          type: 'Literal',
          loc:{start:{line:1,column:0},end:{line:1,column:2},source:''},
          value: '',
          raw: '""'
        },
        operator: '/',
        right: {
          type: 'Identifier',
          loc:{start:{line:1,column:3},end:{line:1,column:4},source:''},
          name: 'x'
        }
      }
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:2,column:0},end:{line:2,column:2},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:2,column:0},end:{line:2,column:2},source:''},
        value: '',
        raw: '""'
      }
    }
  ]
}

tokens (7x):
       STRING_DOUBLE PUNC_DIV IDENT ASI STRING_DOUBLE ASI
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
((("") / (x)));
("");
````

Produces same AST
