# Tenko parser test case

- Path: tests/testcases/directive_prologues/weird_string_case.md

> :: directive prologues
>
> ::> weird string case
>
> Bug in directive scanning was adding bad `directive` properties to the AST
>
> The loop was only asserting the statement started with a string, but not bailing if it had a tail.

## Input

`````js
((("") / (x)));
"";
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:2,column:3},source:''},
  body: [
    {
      type: 'ExpressionStatement',
      loc:{start:{line:1,column:0},end:{line:1,column:15},source:''},
      expression: {
        type: 'BinaryExpression',
        loc:{start:{line:1,column:2},end:{line:1,column:12},source:''},
        left: {
          type: 'Literal',
          loc:{start:{line:1,column:3},end:{line:1,column:5},source:''},
          value: '',
          raw: '""'
        },
        operator: '/',
        right: {
          type: 'Identifier',
          loc:{start:{line:1,column:10},end:{line:1,column:11},source:''},
          name: 'x'
        }
      }
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:2,column:0},end:{line:2,column:3},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:2,column:0},end:{line:2,column:2},source:''},
        value: '',
        raw: '""'
      }
    }
  ]
}

tokens (15x):
       PUNC_PAREN_OPEN PUNC_PAREN_OPEN PUNC_PAREN_OPEN STRING_DOUBLE
       PUNC_PAREN_CLOSE PUNC_DIV PUNC_PAREN_OPEN IDENT
       PUNC_PAREN_CLOSE PUNC_PAREN_CLOSE PUNC_PAREN_CLOSE PUNC_SEMI
       STRING_DOUBLE PUNC_SEMI
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
((("") / (x)));
("");
````

Produces same AST
