# Tenko parser test case

- Path: tests/testcases/dowhile_statement/asi_is_weird/debugger_without_semi.md

> :: dowhile statement : asi is weird
>
> ::> debugger without semi
>
> <3 fuzzing
> 
> This case is (currently) accepted by all parsers except traceur.
> 
> And only for sub-statements that don't require ASI (like block, switch, try). It's almost as if that's universally stopping ASI in its tracks..? Even v8 suffers from this at the time of writing.
> 
> I found it with a fuzzer.

## Input

`````js
do debugger while(x) x
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
throws: Parser error!
  Unable to ASI, token: {# ID_while : nl=N pos=12:17 loc=12:1 `while`#}

do debugger while(x) x
            ^------- error
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._
