# Tenko parser test case

- Path: tests/testcases/dowhile_statement/asi_is_weird/do_arrow_newline_while.md

> :: dowhile statement : asi is weird
>
> ::> do arrow newline while
>
> An arrow still requires a semi for the expression statement

## PASS

## Input

`````js
do
  ()=>x
while(c)
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:3,column:8},source:''},
  body: [
    {
      type: 'DoWhileStatement',
      loc:{start:{line:1,column:0},end:{line:3,column:8},source:''},
      body: {
        type: 'ExpressionStatement',
        loc:{start:{line:2,column:2},end:{line:2,column:7},source:''},
        expression: {
          type: 'ArrowFunctionExpression',
          loc:{start:{line:2,column:2},end:{line:2,column:7},source:''},
          params: [],
          id: null,
          generator: false,
          async: false,
          expression: true,
          body: {
            type: 'Identifier',
            loc:{start:{line:2,column:6},end:{line:2,column:7},source:''},
            name: 'x'
          }
        }
      },
      test: {
        type: 'Identifier',
        loc:{start:{line:3,column:6},end:{line:3,column:7},source:''},
        name: 'c'
      }
    }
  ]
}

tokens (12x):
       ID_do PUNC_PAREN_OPEN PUNC_PAREN_CLOSE PUNC_EQ_GT IDENT ASI
       ID_while PUNC_PAREN_OPEN IDENT PUNC_PAREN_CLOSE ASI
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
do () => (x); while (c);
````

Produces same AST
