# Tenko parser test case

- Path: tests/testcases/dowhile_statement/asi_is_weird/no_asi_error.md

> :: dowhile statement : asi is weird
>
> ::> no asi error
>
> the problem is that ASI is only applied after newlines or before } or EOF and that this satisfies neither

## Input

`````js
do foo; while (bar);
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:20},source:''},
  body: [
    {
      type: 'DoWhileStatement',
      loc:{start:{line:1,column:0},end:{line:1,column:20},source:''},
      body: {
        type: 'ExpressionStatement',
        loc:{start:{line:1,column:3},end:{line:1,column:7},source:''},
        expression: {
          type: 'Identifier',
          loc:{start:{line:1,column:3},end:{line:1,column:6},source:''},
          name: 'foo'
        }
      },
      test: {
        type: 'Identifier',
        loc:{start:{line:1,column:15},end:{line:1,column:18},source:''},
        name: 'bar'
      }
    }
  ]
}

tokens (9x):
       ID_do IDENT PUNC_SEMI ID_while PUNC_PAREN_OPEN IDENT
       PUNC_PAREN_CLOSE PUNC_SEMI
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
do (foo); while (bar);
````

Produces same AST
