# Tenko parser test case

- Path: tests/testcases/dowhile_statement/asi_is_weird/try_catch_finally.md

> :: dowhile statement : asi is weird
>
> ::> try catch finally
>
> The ASI for `do-while` does not require a newline since ES6

## PASS

## Input

`````js
do try {} catch {} while(x) x
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:29},source:''},
  body: [
    {
      type: 'DoWhileStatement',
      loc:{start:{line:1,column:0},end:{line:1,column:27},source:''},
      body: {
        type: 'TryStatement',
        loc:{start:{line:1,column:3},end:{line:1,column:18},source:''},
        block: {
          type: 'BlockStatement',
          loc:{start:{line:1,column:7},end:{line:1,column:9},source:''},
          body: []
        },
        handler: {
          type: 'CatchClause',
          loc:{start:{line:1,column:10},end:{line:1,column:18},source:''},
          param: null,
          body: {
            type: 'BlockStatement',
            loc:{start:{line:1,column:16},end:{line:1,column:18},source:''},
            body: []
          }
        },
        finalizer: null
      },
      test: {
        type: 'Identifier',
        loc:{start:{line:1,column:25},end:{line:1,column:26},source:''},
        name: 'x'
      }
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:1,column:28},end:{line:1,column:29},source:''},
      expression: {
        type: 'Identifier',
        loc:{start:{line:1,column:28},end:{line:1,column:29},source:''},
        name: 'x'
      }
    }
  ]
}

tokens (15x):
       ID_do ID_try PUNC_CURLY_OPEN PUNC_CURLY_CLOSE ID_catch
       PUNC_CURLY_OPEN PUNC_CURLY_CLOSE ID_while PUNC_PAREN_OPEN IDENT
       PUNC_PAREN_CLOSE ASI IDENT ASI
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
do try {} catch {} while (x);
(x);
````

Produces same AST
