# Tenko parser test case

- Path: tests/testcases/dowhile_statement/do_if_func_while_no_semi_with_newline.md

> :: dowhile statement
>
> ::> do if func while no semi with newline
>
> By fuzzer reduced
>
> There's no ASI after the do-while sub statement unless there's a newline.
>
> The sub-statement of `do` does not get an `ASI` unless there's a newline preceeding the `while`. However, in this case the sub-statement ends in a function declaration which does not require a semi AND there is a newline so it's fine either way.
>
> This should be legal in web compat mode (only). In other modes the func decl cannot be a child of `if`.


## Input

`````js
do if(8)function s(){}
while(y)
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
throws: Parser error!
  A function declaration can only be the child of an `if`/`else` in sloppy web compat mode

do if(8)function s(){}
                 ^------- error

while(y)
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:2,column:8},source:''},
  body: [
    {
      type: 'DoWhileStatement',
      loc:{start:{line:1,column:0},end:{line:2,column:8},source:''},
      body: {
        type: 'IfStatement',
        loc:{start:{line:1,column:3},end:{line:1,column:22},source:''},
        test: {
          type: 'Literal',
          loc:{start:{line:1,column:6},end:{line:1,column:7},source:''},
          value: 8,
          raw: '8'
        },
        consequent: {
          type: 'FunctionDeclaration',
          loc:{start:{line:1,column:8},end:{line:1,column:22},source:''},
          generator: false,
          async: false,
          id: {
            type: 'Identifier',
            loc:{start:{line:1,column:17},end:{line:1,column:18},source:''},
            name: 's'
          },
          params: [],
          body: {
            type: 'BlockStatement',
            loc:{start:{line:1,column:20},end:{line:1,column:22},source:''},
            body: []
          }
        },
        alternate: null
      },
      test: {
        type: 'Identifier',
        loc:{start:{line:2,column:6},end:{line:2,column:7},source:''},
        name: 'y'
      }
    }
  ]
}

tokens (17x):
       ID_do ID_if PUNC_PAREN_OPEN NUMBER_DEC PUNC_PAREN_CLOSE
       ID_function IDENT PUNC_PAREN_OPEN PUNC_PAREN_CLOSE
       PUNC_CURLY_OPEN PUNC_CURLY_CLOSE ID_while PUNC_PAREN_OPEN IDENT
       PUNC_PAREN_CLOSE ASI
`````


## AST Printer

Printer output different from input [web]:

````js
do if (8) function s() {} while (y);
````

Produces same AST
