# Tenko parser test case

- Path: tests/testcases/dowhile_statement/do_label_func_while_no_semi_no_newline.md

> :: dowhile statement
>
> ::> do label func while no semi no newline
>
> By fuzzer reduced
>
> The sub-statement of `do` does not get an `ASI` unless there's a newline preceeding the `while`. However, in this case the sub-statement ends in a function declaration which does not require a semi, so it's fine.
>
> This should be legal in web compat mode (only). In other modes the func decl cannot be a child of a label.

## Input

`````js
do x: function s(){}while(y)
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
throws: Parser error!
  A "labelled function declaration" is not allowed in this situation

do x: function s(){}while(y)
               ^------- error
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._
