# Tenko parser test case

- Path: tests/testcases/dowhile_statement/do_label_while_while_continue.md

> :: dowhile statement
>
> ::> do label while while continue
>
> Curious case of while disambiguation
>
> This shouldn't work as the first `while` will consume the second `while` as its sub-statement.
>
> The `do` will trigger a syntax error for not seeing its own `while`.

## FAIL

## Input

`````js
do wow: while (x) while (x) continue wow;
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
throws: Parser error!
  A `do` must be followed by a `while`, but found `` instead (at EOF)

do wow: while (x) while (x) continue wow;
                                        ^------- error
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._
