# Tenko parser test case

- Path: tests/testcases/dowhile_statement/do_missing_semi.md

> :: dowhile statement
>
> ::> do missing semi
>
> The semi after `do-while` can trigger an ASI even without newline

## PASS

## Input

`````js
do;while(j)try{}finally{}
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:25},source:''},
  body: [
    {
      type: 'DoWhileStatement',
      loc:{start:{line:1,column:0},end:{line:1,column:11},source:''},
      body: {
        type: 'EmptyStatement',
        loc:{start:{line:1,column:2},end:{line:1,column:3},source:''}
      },
      test: {
        type: 'Identifier',
        loc:{start:{line:1,column:9},end:{line:1,column:10},source:''},
        name: 'j'
      }
    },
    {
      type: 'TryStatement',
      loc:{start:{line:1,column:11},end:{line:1,column:25},source:''},
      block: {
        type: 'BlockStatement',
        loc:{start:{line:1,column:14},end:{line:1,column:16},source:''},
        body: []
      },
      handler: null,
      finalizer: {
        type: 'BlockStatement',
        loc:{start:{line:1,column:23},end:{line:1,column:25},source:''},
        body: []
      }
    }
  ]
}

tokens (14x):
       ID_do PUNC_SEMI ID_while PUNC_PAREN_OPEN IDENT PUNC_PAREN_CLOSE
       ASI ID_try PUNC_CURLY_OPEN PUNC_CURLY_CLOSE ID_finally
       PUNC_CURLY_OPEN PUNC_CURLY_CLOSE
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
do ; while (j);
try {} finally {}
````

Produces same AST
