# Tenko parser test case

- Path: tests/testcases/dowhile_statement/do_while_asi_no_nl.md

> :: dowhile statement
>
> ::> do while asi no nl
>
> The ASI after a `do-while` does not require a newline
>
> https://tc39.es/ecma262/#sec-rules-of-automatic-semicolon-insertion
>
> > The previous token is ) and the inserted semicolon would then be parsed as the terminating semicolon of a do-while statement (13.7.2).
>
> Similar to blocks and certain declarations

## Input

`````js
do;while(x)y
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:12},source:''},
  body: [
    {
      type: 'DoWhileStatement',
      loc:{start:{line:1,column:0},end:{line:1,column:11},source:''},
      body: {
        type: 'EmptyStatement',
        loc:{start:{line:1,column:2},end:{line:1,column:3},source:''}
      },
      test: {
        type: 'Identifier',
        loc:{start:{line:1,column:9},end:{line:1,column:10},source:''},
        name: 'x'
      }
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:1,column:11},end:{line:1,column:12},source:''},
      expression: {
        type: 'Identifier',
        loc:{start:{line:1,column:11},end:{line:1,column:12},source:''},
        name: 'y'
      }
    }
  ]
}

tokens (10x):
       ID_do PUNC_SEMI ID_while PUNC_PAREN_OPEN IDENT PUNC_PAREN_CLOSE
       ASI IDENT ASI
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
do ; while (x);
(y);
````

Produces same AST
