# Tenko parser test case

- Path: tests/testcases/dowhile_statement/do_while_asi_regex.md

> :: dowhile statement
>
> ::> do while asi regex
>
> By fuzzer, zeparser assertion failed while trimming the input
>
> Error: Parser error! Assertion fail: The next token starts with a forward slash but neither a division nor a regular expression is legal here. This should be handled elsewhere.; []

## Input

`````js
do; while(x)
/x/g
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:2,column:4},source:''},
  body: [
    {
      type: 'DoWhileStatement',
      loc:{start:{line:1,column:0},end:{line:1,column:12},source:''},
      body: {
        type: 'EmptyStatement',
        loc:{start:{line:1,column:2},end:{line:1,column:3},source:''}
      },
      test: {
        type: 'Identifier',
        loc:{start:{line:1,column:10},end:{line:1,column:11},source:''},
        name: 'x'
      }
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:2,column:0},end:{line:2,column:4},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:2,column:0},end:{line:2,column:4},source:''},
        value: null,
        regex: { pattern: 'x', flags: 'g' },
        raw: '/x/g'
      }
    }
  ]
}

tokens (10x):
       ID_do PUNC_SEMI ID_while PUNC_PAREN_OPEN IDENT PUNC_PAREN_CLOSE
       ASI REGEXN ASI
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
do ; while (x);
/x/g;
````

Produces same AST
