# Tenko parser test case

- Path: tests/testcases/dowhile_statement/do_while_throw_without_newline.md

> :: dowhile statement
>
> ::> do while throw without newline
>
> By fuzzer original
>
> It's an error because there's no newline after the statement (it doesn't matter that there's one "inside" it)

## Input

`````js
do throw function (v, h) {
  "use strict"
} while ((""))
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
throws: Parser error!
  Unable to ASI, token: {# ID_while : nl=N pos=44:49 loc=2:3 `while`#}

do throw function (v, h) {
  "use strict"
} while ((""))
  ^------- error
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._
