# Tenko parser test case

- Path: tests/testcases/dowhile_statement/dowhile_throw.md

> :: dowhile statement
>
> ::> dowhile throw
>
> By fuzzer reduced


## Input

`````js
do throw function(){};while(y);try{for(;;)if(8)switch(y){default:}}catch{}
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:74},source:''},
  body: [
    {
      type: 'DoWhileStatement',
      loc:{start:{line:1,column:0},end:{line:1,column:31},source:''},
      body: {
        type: 'ThrowStatement',
        loc:{start:{line:1,column:3},end:{line:1,column:22},source:''},
        argument: {
          type: 'FunctionExpression',
          loc:{start:{line:1,column:9},end:{line:1,column:21},source:''},
          generator: false,
          async: false,
          id: null,
          params: [],
          body: {
            type: 'BlockStatement',
            loc:{start:{line:1,column:19},end:{line:1,column:21},source:''},
            body: []
          }
        }
      },
      test: {
        type: 'Identifier',
        loc:{start:{line:1,column:28},end:{line:1,column:29},source:''},
        name: 'y'
      }
    },
    {
      type: 'TryStatement',
      loc:{start:{line:1,column:31},end:{line:1,column:74},source:''},
      block: {
        type: 'BlockStatement',
        loc:{start:{line:1,column:34},end:{line:1,column:67},source:''},
        body: [
          {
            type: 'ForStatement',
            loc:{start:{line:1,column:35},end:{line:1,column:66},source:''},
            init: null,
            test: null,
            update: null,
            body: {
              type: 'IfStatement',
              loc:{start:{line:1,column:42},end:{line:1,column:66},source:''},
              test: {
                type: 'Literal',
                loc:{start:{line:1,column:45},end:{line:1,column:46},source:''},
                value: 8,
                raw: '8'
              },
              consequent: {
                type: 'SwitchStatement',
                loc:{start:{line:1,column:47},end:{line:1,column:66},source:''},
                discriminant: {
                  type: 'Identifier',
                  loc:{start:{line:1,column:54},end:{line:1,column:55},source:''},
                  name: 'y'
                },
                cases: [
                  {
                    type: 'SwitchCase',
                    loc:{start:{line:1,column:57},end:{line:1,column:65},source:''},
                    test: null,
                    consequent: []
                  }
                ]
              },
              alternate: null
            }
          }
        ]
      },
      handler: {
        type: 'CatchClause',
        loc:{start:{line:1,column:67},end:{line:1,column:74},source:''},
        param: null,
        body: {
          type: 'BlockStatement',
          loc:{start:{line:1,column:72},end:{line:1,column:74},source:''},
          body: []
        }
      },
      finalizer: null
    }
  ]
}

tokens (37x):
       ID_do ID_throw ID_function PUNC_PAREN_OPEN PUNC_PAREN_CLOSE
       PUNC_CURLY_OPEN PUNC_CURLY_CLOSE PUNC_SEMI ID_while
       PUNC_PAREN_OPEN IDENT PUNC_PAREN_CLOSE PUNC_SEMI ID_try
       PUNC_CURLY_OPEN ID_for PUNC_PAREN_OPEN PUNC_SEMI PUNC_SEMI
       PUNC_PAREN_CLOSE ID_if PUNC_PAREN_OPEN NUMBER_DEC
       PUNC_PAREN_CLOSE ID_switch PUNC_PAREN_OPEN IDENT
       PUNC_PAREN_CLOSE PUNC_CURLY_OPEN ID_default PUNC_COLON
       PUNC_CURLY_CLOSE PUNC_CURLY_CLOSE ID_catch PUNC_CURLY_OPEN
       PUNC_CURLY_CLOSE
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
do throw function() {}; while (y);
try {for (;;) if (8) switch (y) {default:
}} catch {}
````

Produces same AST
