# Tenko parser test case

- Path: tests/testcases/dowhile_statement/throw_function.md

> :: dowhile statement
>
> ::> throw function
>
> By fuzzer reduced


## Input

`````js
do throw function(){}
while(y)
for(;;)x
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:3,column:8},source:''},
  body: [
    {
      type: 'DoWhileStatement',
      loc:{start:{line:1,column:0},end:{line:2,column:8},source:''},
      body: {
        type: 'ThrowStatement',
        loc:{start:{line:1,column:3},end:{line:1,column:21},source:''},
        argument: {
          type: 'FunctionExpression',
          loc:{start:{line:1,column:9},end:{line:1,column:21},source:''},
          generator: false,
          async: false,
          id: null,
          params: [],
          body: {
            type: 'BlockStatement',
            loc:{start:{line:1,column:19},end:{line:1,column:21},source:''},
            body: []
          }
        }
      },
      test: {
        type: 'Identifier',
        loc:{start:{line:2,column:6},end:{line:2,column:7},source:''},
        name: 'y'
      }
    },
    {
      type: 'ForStatement',
      loc:{start:{line:3,column:0},end:{line:3,column:8},source:''},
      init: null,
      test: null,
      update: null,
      body: {
        type: 'ExpressionStatement',
        loc:{start:{line:3,column:7},end:{line:3,column:8},source:''},
        expression: {
          type: 'Identifier',
          loc:{start:{line:3,column:7},end:{line:3,column:8},source:''},
          name: 'x'
        }
      }
    }
  ]
}

tokens (21x):
       ID_do ID_throw ID_function PUNC_PAREN_OPEN PUNC_PAREN_CLOSE
       PUNC_CURLY_OPEN PUNC_CURLY_CLOSE ASI ID_while PUNC_PAREN_OPEN
       IDENT PUNC_PAREN_CLOSE ASI ID_for PUNC_PAREN_OPEN PUNC_SEMI
       PUNC_SEMI PUNC_PAREN_CLOSE IDENT ASI
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
do throw function() {}; while (y);
for (;;) (x);
````

Produces same AST
