# Tenko parser test case

- Path: tests/testcases/exponentiation_op/expr/good_exmaple_of_nested_expression.md

> :: exponentiation op : expr
>
> ::> good exmaple of nested expression
>
> note that a**3 must be the inner-most node, then b**that then +c * that as the outer-most node

## Input

`````js
(+c * b ** a ** 3)
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:18},source:''},
  body: [
    {
      type: 'ExpressionStatement',
      loc:{start:{line:1,column:0},end:{line:1,column:18},source:''},
      expression: {
        type: 'BinaryExpression',
        loc:{start:{line:1,column:1},end:{line:1,column:17},source:''},
        left: {
          type: 'UnaryExpression',
          loc:{start:{line:1,column:1},end:{line:1,column:3},source:''},
          operator: '+',
          prefix: true,
          argument: {
            type: 'Identifier',
            loc:{start:{line:1,column:2},end:{line:1,column:3},source:''},
            name: 'c'
          }
        },
        operator: '*',
        right: {
          type: 'BinaryExpression',
          loc:{start:{line:1,column:6},end:{line:1,column:17},source:''},
          left: {
            type: 'Identifier',
            loc:{start:{line:1,column:6},end:{line:1,column:7},source:''},
            name: 'b'
          },
          operator: '**',
          right: {
            type: 'BinaryExpression',
            loc:{start:{line:1,column:11},end:{line:1,column:17},source:''},
            left: {
              type: 'Identifier',
              loc:{start:{line:1,column:11},end:{line:1,column:12},source:''},
              name: 'a'
            },
            operator: '**',
            right: {
              type: 'Literal',
              loc:{start:{line:1,column:16},end:{line:1,column:17},source:''},
              value: 3,
              raw: '3'
            }
          }
        }
      }
    }
  ]
}

tokens (12x):
       PUNC_PAREN_OPEN PUNC_PLUS IDENT PUNC_STAR IDENT PUNC_STAR_STAR
       IDENT PUNC_STAR_STAR NUMBER_DEC PUNC_PAREN_CLOSE ASI
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
(((+ (c)) * (((b) ** (((a) ** (3)))))));
````

Produces same AST
