# Tenko parser test case

- Path: tests/testcases/export_declaration/confirm_when_a_semi_is_not_needed/non-default/async_generator_func.md

> :: export declaration : confirm when a semi is not needed : non-default
>
> ::> async generator func

## Input

- `skip = true`

`````js
export async function *f(){} foo
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
throws: Parser error!
  The `export` keyword can only be used with the module goal

export async function *f(){} foo
^------- error
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:32},source:''},
  body: [
    {
      type: 'ExportNamedDeclaration',
      loc:{start:{line:1,column:0},end:{line:1,column:28},source:''},
      specifiers: [],
      declaration: {
        type: 'FunctionDeclaration',
        loc:{start:{line:1,column:7},end:{line:1,column:28},source:''},
        generator: true,
        async: true,
        id: {
          type: 'Identifier',
          loc:{start:{line:1,column:23},end:{line:1,column:24},source:''},
          name: 'f'
        },
        params: [],
        body: {
          type: 'BlockStatement',
          loc:{start:{line:1,column:26},end:{line:1,column:28},source:''},
          body: []
        }
      },
      source: null
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:1,column:29},end:{line:1,column:32},source:''},
      expression: {
        type: 'Identifier',
        loc:{start:{line:1,column:29},end:{line:1,column:32},source:''},
        name: 'foo'
      }
    }
  ]
}

tokens (12x):
       ID_export ID_async ID_function PUNC_STAR IDENT PUNC_PAREN_OPEN
       PUNC_PAREN_CLOSE PUNC_CURLY_OPEN PUNC_CURLY_CLOSE IDENT ASI
`````


### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [module]:

````js
export async function* f() {}
(foo);
````

Produces same AST
