# Tenko parser test case

- Path: tests/testcases/export_declaration/edge_case_regarding_x0060inx0060.md

> :: export declaration
>
> ::> edge case regarding x0060inx0060
>
> always allowed by cfg

## Input

`````js
export default a in b
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
throws: Parser error!
  The `export` keyword can only be used with the module goal

export default a in b
^------- error
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:21},source:''},
  body: [
    {
      type: 'ExportDefaultDeclaration',
      loc:{start:{line:1,column:0},end:{line:1,column:21},source:''},
      declaration: {
        type: 'BinaryExpression',
        loc:{start:{line:1,column:15},end:{line:1,column:21},source:''},
        left: {
          type: 'Identifier',
          loc:{start:{line:1,column:15},end:{line:1,column:16},source:''},
          name: 'a'
        },
        operator: 'in',
        right: {
          type: 'Identifier',
          loc:{start:{line:1,column:20},end:{line:1,column:21},source:''},
          name: 'b'
        }
      }
    }
  ]
}

tokens (7x):
       ID_export ID_default IDENT ID_in IDENT ASI
`````


### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [module]:

````js
export default ((a) in (b));
````

Produces same AST
