# Tenko parser test case

- Path: tests/testcases/export_declaration/export_default_ident_asi_div.md

> :: export declaration
>
> ::> export default ident asi div
>
> This is an edge case with a regex after ASI
>
> In this case the export is a value so the next line cannot be a regex, instead a division

## Input

`````js
export default x
/y
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
throws: Parser error!
  The `export` keyword can only be used with the module goal

export default x
^------- error

/y
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:2,column:2},source:''},
  body: [
    {
      type: 'ExportDefaultDeclaration',
      loc:{start:{line:1,column:0},end:{line:2,column:2},source:''},
      declaration: {
        type: 'BinaryExpression',
        loc:{start:{line:1,column:15},end:{line:2,column:2},source:''},
        left: {
          type: 'Identifier',
          loc:{start:{line:1,column:15},end:{line:1,column:16},source:''},
          name: 'x'
        },
        operator: '/',
        right: {
          type: 'Identifier',
          loc:{start:{line:2,column:1},end:{line:2,column:2},source:''},
          name: 'y'
        }
      }
    }
  ]
}

tokens (7x):
       ID_export ID_default IDENT PUNC_DIV IDENT ASI
`````


### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [module]:

````js
export default ((x) / (y));
````

Produces same AST
