# Tenko parser test case

- Path: tests/testcases/export_declaration/export_obj_asi_regex.md

> :: export declaration
>
> ::> export obj asi regex
>
> Edge case of regular expression following an export declaration and ASI was not covered by tests
>
> This should pass in module goal

## Input

`````js
export {}
/foo/
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
throws: Parser error!
  The `export` keyword can only be used with the module goal

export {}
^------- error

/foo/
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:2,column:5},source:''},
  body: [
    {
      type: 'ExportNamedDeclaration',
      loc:{start:{line:1,column:0},end:{line:1,column:9},source:''},
      specifiers: [],
      declaration: null,
      source: null
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:2,column:0},end:{line:2,column:5},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:2,column:0},end:{line:2,column:5},source:''},
        value: null,
        regex: { pattern: 'foo', flags: '' },
        raw: '/foo/'
      }
    }
  ]
}

tokens (7x):
       ID_export PUNC_CURLY_OPEN PUNC_CURLY_CLOSE ASI REGEXN ASI
`````


### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [module]:

````js
export {}
/foo/;
````

Produces same AST
