# Tenko parser test case

- Path: tests/testcases/export_declaration/export_object_is_not_generic/can_export_x0060newx0060_as_export_name.md

> :: export declaration : export object is not generic
>
> ::> can export x0060newx0060 as export name

## Input

`````js
var foo; export {foo as new}
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
throws: Parser error!
  The `export` keyword can only be used with the module goal

var foo; export {foo as new}
         ^------- error
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:28},source:''},
  body: [
    {
      type: 'VariableDeclaration',
      loc:{start:{line:1,column:0},end:{line:1,column:8},source:''},
      kind: 'var',
      declarations: [
        {
          type: 'VariableDeclarator',
          loc:{start:{line:1,column:4},end:{line:1,column:7},source:''},
          id: {
            type: 'Identifier',
            loc:{start:{line:1,column:4},end:{line:1,column:7},source:''},
            name: 'foo'
          },
          init: null
        }
      ]
    },
    {
      type: 'ExportNamedDeclaration',
      loc:{start:{line:1,column:9},end:{line:1,column:28},source:''},
      specifiers: [
        {
          type: 'ExportSpecifier',
          loc:{start:{line:1,column:17},end:{line:1,column:27},source:''},
          local: {
            type: 'Identifier',
            loc:{start:{line:1,column:17},end:{line:1,column:20},source:''},
            name: 'foo'
          },
          exported: {
            type: 'Identifier',
            loc:{start:{line:1,column:24},end:{line:1,column:27},source:''},
            name: 'new'
          }
        }
      ],
      declaration: null,
      source: null
    }
  ]
}

tokens (11x):
       ID_var IDENT PUNC_SEMI ID_export PUNC_CURLY_OPEN IDENT ID_as
       ID_new PUNC_CURLY_CLOSE ASI
`````


### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [module]:

````js
var foo;
export {foo as new}
````

Produces same AST
