# Tenko parser test case

- Path: tests/testcases/export_declaration/export_object_is_not_generic/exported_name_can_be_weird_keywords.md

> :: export declaration : export object is not generic
>
> ::> exported name can be weird keywords

## Input

`````js
let x; export {x as new}; import {new as foo} from "bar";
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
throws: Parser error!
  The `export` keyword can only be used with the module goal

let x; export {x as new}; import {new as foo} from "bar";
       ^------- error
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:57},source:''},
  body: [
    {
      type: 'VariableDeclaration',
      loc:{start:{line:1,column:0},end:{line:1,column:6},source:''},
      kind: 'let',
      declarations: [
        {
          type: 'VariableDeclarator',
          loc:{start:{line:1,column:4},end:{line:1,column:5},source:''},
          id: {
            type: 'Identifier',
            loc:{start:{line:1,column:4},end:{line:1,column:5},source:''},
            name: 'x'
          },
          init: null
        }
      ]
    },
    {
      type: 'ExportNamedDeclaration',
      loc:{start:{line:1,column:7},end:{line:1,column:25},source:''},
      specifiers: [
        {
          type: 'ExportSpecifier',
          loc:{start:{line:1,column:15},end:{line:1,column:23},source:''},
          local: {
            type: 'Identifier',
            loc:{start:{line:1,column:15},end:{line:1,column:16},source:''},
            name: 'x'
          },
          exported: {
            type: 'Identifier',
            loc:{start:{line:1,column:20},end:{line:1,column:23},source:''},
            name: 'new'
          }
        }
      ],
      declaration: null,
      source: null
    },
    {
      type: 'ImportDeclaration',
      loc:{start:{line:1,column:26},end:{line:1,column:57},source:''},
      specifiers: [
        {
          type: 'ImportSpecifier',
          loc:{start:{line:1,column:34},end:{line:1,column:44},source:''},
          imported: {
            type: 'Identifier',
            loc:{start:{line:1,column:34},end:{line:1,column:37},source:''},
            name: 'new'
          },
          local: {
            type: 'Identifier',
            loc:{start:{line:1,column:41},end:{line:1,column:44},source:''},
            name: 'foo'
          }
        }
      ],
      source: {
        type: 'Literal',
        loc:{start:{line:1,column:51},end:{line:1,column:56},source:''},
        value: 'bar',
        raw: '"bar"'
      }
    }
  ]
}

tokens (20x):
       ID_let IDENT PUNC_SEMI ID_export PUNC_CURLY_OPEN IDENT ID_as
       ID_new PUNC_CURLY_CLOSE PUNC_SEMI ID_import PUNC_CURLY_OPEN
       ID_new ID_as IDENT PUNC_CURLY_CLOSE ID_from STRING_DOUBLE
       PUNC_SEMI
`````


### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [module]:

````js
let x;
export {x as new}
import {new as foo} from "bar";
````

Produces same AST
