# Tenko parser test case

- Path: tests/testcases/export_declaration/export_star_from/star_as_from_es10.md

> :: export declaration : export star from
>
> ::> star as from es10
>
> As per https://github.com/tc39/ecma262/pull/1174
>
> Introduced in ES2020 / ES11 so throw an error if targeting lower

## FAIL

## Input

- `es = 10`

`````js
export * as woo from 'bar';
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
throws: Parser error!
  The `export` keyword can only be used with the module goal

export * as woo from 'bar';
^------- error
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

`````
throws: Parser error!
  The `export * as x from src`, syntax was introduced in ES2020 but currently targeted version is lower

export * as woo from 'bar';
         ^------- error
`````


### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._
