# Tenko parser test case

- Path: tests/testcases/export_declaration/export_star_from/star_as_from_es11.md

> :: export declaration : export star from
>
> ::> star as from es11
>
> As per https://github.com/tc39/ecma262/pull/1174
>
> Introduced in ES2020 / ES11

## Input

- `es = 11`

`````js
export * as boo from 'bar';
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
throws: Parser error!
  The `export` keyword can only be used with the module goal

export * as boo from 'bar';
^------- error
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:27},source:''},
  body: [
    {
      type: 'ExportNamedDeclaration',
      loc:{start:{line:1,column:0},end:{line:1,column:27},source:''},
      specifiers: [
        {
          type: 'ExportNamespaceSpecifier',
          loc:{start:{line:1,column:0},end:{line:1,column:27},source:''},
          exported: {
            type: 'Identifier',
            loc:{start:{line:1,column:12},end:{line:1,column:15},source:''},
            name: 'boo'
          }
        }
      ],
      declaration: null,
      source: {
        type: 'Literal',
        loc:{start:{line:1,column:21},end:{line:1,column:27},source:''},
        value: 'bar',
        raw: "'bar'"
      }
    }
  ]
}

tokens (8x):
       ID_export PUNC_STAR ID_as IDENT ID_from STRING_SINGLE PUNC_SEMI
`````


### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output was same as input [module]
