# Tenko parser test case

- Path: tests/testcases/export_declaration/export_star_from/star_from_es10.md

> :: export declaration : export star from
>
> ::> star from es10
>
> This (without the `as`) was available since ES6 so it should be fine
>
> (This test checks whether the version restriction does not apply to the syntax without `as`)

## Input

- `es = 10`

`````js
export * from 'bar';
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
throws: Parser error!
  The `export` keyword can only be used with the module goal

export * from 'bar';
^------- error
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:20},source:''},
  body: [
    {
      type: 'ExportAllDeclaration',
      loc:{start:{line:1,column:0},end:{line:1,column:20},source:''},
      source: {
        type: 'Literal',
        loc:{start:{line:1,column:14},end:{line:1,column:20},source:''},
        value: 'bar',
        raw: "'bar'"
      }
    }
  ]
}

tokens (6x):
       ID_export PUNC_STAR ID_from STRING_SINGLE PUNC_SEMI
`````


### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output was same as input [module]
