# Tenko parser test case

- Path: tests/testcases/export_declaration/export_two_keys.md

> :: export declaration
>
> ::> export two keys

## Input

`````js
var x,y; export {x, y}
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
throws: Parser error!
  The `export` keyword can only be used with the module goal

var x,y; export {x, y}
         ^------- error
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:22},source:''},
  body: [
    {
      type: 'VariableDeclaration',
      loc:{start:{line:1,column:0},end:{line:1,column:8},source:''},
      kind: 'var',
      declarations: [
        {
          type: 'VariableDeclarator',
          loc:{start:{line:1,column:4},end:{line:1,column:5},source:''},
          id: {
            type: 'Identifier',
            loc:{start:{line:1,column:4},end:{line:1,column:5},source:''},
            name: 'x'
          },
          init: null
        },
        {
          type: 'VariableDeclarator',
          loc:{start:{line:1,column:6},end:{line:1,column:7},source:''},
          id: {
            type: 'Identifier',
            loc:{start:{line:1,column:6},end:{line:1,column:7},source:''},
            name: 'y'
          },
          init: null
        }
      ]
    },
    {
      type: 'ExportNamedDeclaration',
      loc:{start:{line:1,column:9},end:{line:1,column:22},source:''},
      specifiers: [
        {
          type: 'ExportSpecifier',
          loc:{start:{line:1,column:17},end:{line:1,column:18},source:''},
          local: {
            type: 'Identifier',
            loc:{start:{line:1,column:17},end:{line:1,column:18},source:''},
            name: 'x'
          },
          exported: {
            type: 'Identifier',
            loc:{start:{line:1,column:17},end:{line:1,column:18},source:''},
            name: 'x'
          }
        },
        {
          type: 'ExportSpecifier',
          loc:{start:{line:1,column:20},end:{line:1,column:21},source:''},
          local: {
            type: 'Identifier',
            loc:{start:{line:1,column:20},end:{line:1,column:21},source:''},
            name: 'y'
          },
          exported: {
            type: 'Identifier',
            loc:{start:{line:1,column:20},end:{line:1,column:21},source:''},
            name: 'y'
          }
        }
      ],
      declaration: null,
      source: null
    }
  ]
}

tokens (13x):
       ID_var IDENT PUNC_COMMA IDENT PUNC_SEMI ID_export
       PUNC_CURLY_OPEN IDENT PUNC_COMMA IDENT PUNC_CURLY_CLOSE ASI
`````


### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [module]:

````js
var x, y;
export {x, y}
````

Produces same AST
