# Tenko parser test case

- Path: tests/testcases/export_declaration/rest/rest_obj.md

> :: export declaration : rest
>
> ::> rest obj

## Input

`````js
export let {...x} = y
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
throws: Parser error!
  The `export` keyword can only be used with the module goal

export let {...x} = y
^------- error
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:21},source:''},
  body: [
    {
      type: 'ExportNamedDeclaration',
      loc:{start:{line:1,column:0},end:{line:1,column:21},source:''},
      specifiers: [],
      declaration: {
        type: 'VariableDeclaration',
        loc:{start:{line:1,column:7},end:{line:1,column:21},source:''},
        kind: 'let',
        declarations: [
          {
            type: 'VariableDeclarator',
            loc:{start:{line:1,column:11},end:{line:1,column:21},source:''},
            id: {
              type: 'ObjectPattern',
              loc:{start:{line:1,column:11},end:{line:1,column:17},source:''},
              properties: [
                {
                  type: 'RestElement',
                  loc:{start:{line:1,column:12},end:{line:1,column:16},source:''},
                  argument: {
                    type: 'Identifier',
                    loc:{start:{line:1,column:15},end:{line:1,column:16},source:''},
                    name: 'x'
                  }
                }
              ]
            },
            init: {
              type: 'Identifier',
              loc:{start:{line:1,column:20},end:{line:1,column:21},source:''},
              name: 'y'
            }
          }
        ]
      },
      source: null
    }
  ]
}

tokens (10x):
       ID_export ID_let PUNC_CURLY_OPEN PUNC_DOT_DOT_DOT IDENT
       PUNC_CURLY_CLOSE PUNC_EQ IDENT ASI
`````


### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [module]:

````js
export let {...x} = y;
````

Produces same AST
