# Tenko parser test case

- Path: tests/testcases/export_declaration/rest/var_and_rest_arr.md

> :: export declaration : rest
>
> ::> var and rest arr

## Input

`````js
export let a, [...x] = y
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
throws: Parser error!
  The `export` keyword can only be used with the module goal

export let a, [...x] = y
^------- error
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:24},source:''},
  body: [
    {
      type: 'ExportNamedDeclaration',
      loc:{start:{line:1,column:0},end:{line:1,column:24},source:''},
      specifiers: [],
      declaration: {
        type: 'VariableDeclaration',
        loc:{start:{line:1,column:7},end:{line:1,column:24},source:''},
        kind: 'let',
        declarations: [
          {
            type: 'VariableDeclarator',
            loc:{start:{line:1,column:11},end:{line:1,column:12},source:''},
            id: {
              type: 'Identifier',
              loc:{start:{line:1,column:11},end:{line:1,column:12},source:''},
              name: 'a'
            },
            init: null
          },
          {
            type: 'VariableDeclarator',
            loc:{start:{line:1,column:14},end:{line:1,column:24},source:''},
            id: {
              type: 'ArrayPattern',
              loc:{start:{line:1,column:14},end:{line:1,column:20},source:''},
              elements: [
                {
                  type: 'RestElement',
                  loc:{start:{line:1,column:15},end:{line:1,column:19},source:''},
                  argument: {
                    type: 'Identifier',
                    loc:{start:{line:1,column:18},end:{line:1,column:19},source:''},
                    name: 'x'
                  }
                }
              ]
            },
            init: {
              type: 'Identifier',
              loc:{start:{line:1,column:23},end:{line:1,column:24},source:''},
              name: 'y'
            }
          }
        ]
      },
      source: null
    }
  ]
}

tokens (12x):
       ID_export ID_let IDENT PUNC_COMMA PUNC_BRACKET_OPEN
       PUNC_DOT_DOT_DOT IDENT PUNC_BRACKET_CLOSE PUNC_EQ IDENT ASI
`````


### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [module]:

````js
export let a, [...x] = y;
````

Produces same AST
