# Tenko parser test case

- Path: tests/testcases/export_declaration/the_x0060asx0060_keyword_cannot_contain_escape_sequence.md

> :: export declaration
>
> ::> the x0060asx0060 keyword cannot contain escape sequence
>
> https://tc39.es/ecma262/#prod-ReservedWord
>
> > Per 5.1.5, keywords in the grammar match literal sequences of specific SourceCharacter elements. A code point in a keyword cannot be expressed by a \ UnicodeEscapeSequence.

## Input

`````js
export {a \u0061s b} from "x";
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
throws: Parser error!
  The `export` keyword can only be used with the module goal

export {a \u0061s b} from "x";
^------- error
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

`````
throws: Parser error!
  Unexpected token while parsing export object

export {a \u0061s b} from "x";
          ^------- error
`````


### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._
