# Tenko parser test case

- Path: tests/testcases/for_statement/const_binding_should_not_leak_to_parent.md

> :: for statement
>
> ::> const binding should not leak to parent
> https://twitter.com/Ghost1240145716/status/1152488565697179648
>
> The lex binding of a for-header should be recorded in a special binding layer and not in the parent statement/scope.


## Input

`````js
for (const { x, } = { x: 23 }; a < 1; ) {}; for (const { x, } = { x: 23 }; a < 1; ) {};
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:87},source:''},
  body: [
    {
      type: 'ForStatement',
      loc:{start:{line:1,column:0},end:{line:1,column:42},source:''},
      init: {
        type: 'VariableDeclaration',
        loc:{start:{line:1,column:5},end:{line:1,column:29},source:''},
        kind: 'const',
        declarations: [
          {
            type: 'VariableDeclarator',
            loc:{start:{line:1,column:11},end:{line:1,column:29},source:''},
            id: {
              type: 'ObjectPattern',
              loc:{start:{line:1,column:11},end:{line:1,column:17},source:''},
              properties: [
                {
                  type: 'Property',
                  loc:{start:{line:1,column:13},end:{line:1,column:14},source:''},
                  key: {
                    type: 'Identifier',
                    loc:{start:{line:1,column:13},end:{line:1,column:14},source:''},
                    name: 'x'
                  },
                  kind: 'init',
                  method: false,
                  computed: false,
                  value: {
                    type: 'Identifier',
                    loc:{start:{line:1,column:13},end:{line:1,column:14},source:''},
                    name: 'x'
                  },
                  shorthand: true
                }
              ]
            },
            init: {
              type: 'ObjectExpression',
              loc:{start:{line:1,column:20},end:{line:1,column:29},source:''},
              properties: [
                {
                  type: 'Property',
                  loc:{start:{line:1,column:22},end:{line:1,column:27},source:''},
                  key: {
                    type: 'Identifier',
                    loc:{start:{line:1,column:22},end:{line:1,column:23},source:''},
                    name: 'x'
                  },
                  kind: 'init',
                  method: false,
                  computed: false,
                  value: {
                    type: 'Literal',
                    loc:{start:{line:1,column:25},end:{line:1,column:27},source:''},
                    value: 23,
                    raw: '23'
                  },
                  shorthand: false
                }
              ]
            }
          }
        ]
      },
      test: {
        type: 'BinaryExpression',
        loc:{start:{line:1,column:31},end:{line:1,column:36},source:''},
        left: {
          type: 'Identifier',
          loc:{start:{line:1,column:31},end:{line:1,column:32},source:''},
          name: 'a'
        },
        operator: '<',
        right: {
          type: 'Literal',
          loc:{start:{line:1,column:35},end:{line:1,column:36},source:''},
          value: 1,
          raw: '1'
        }
      },
      update: null,
      body: {
        type: 'BlockStatement',
        loc:{start:{line:1,column:40},end:{line:1,column:42},source:''},
        body: []
      }
    },
    {
      type: 'EmptyStatement',
      loc:{start:{line:1,column:42},end:{line:1,column:43},source:''}
    },
    {
      type: 'ForStatement',
      loc:{start:{line:1,column:44},end:{line:1,column:86},source:''},
      init: {
        type: 'VariableDeclaration',
        loc:{start:{line:1,column:49},end:{line:1,column:73},source:''},
        kind: 'const',
        declarations: [
          {
            type: 'VariableDeclarator',
            loc:{start:{line:1,column:55},end:{line:1,column:73},source:''},
            id: {
              type: 'ObjectPattern',
              loc:{start:{line:1,column:55},end:{line:1,column:61},source:''},
              properties: [
                {
                  type: 'Property',
                  loc:{start:{line:1,column:57},end:{line:1,column:58},source:''},
                  key: {
                    type: 'Identifier',
                    loc:{start:{line:1,column:57},end:{line:1,column:58},source:''},
                    name: 'x'
                  },
                  kind: 'init',
                  method: false,
                  computed: false,
                  value: {
                    type: 'Identifier',
                    loc:{start:{line:1,column:57},end:{line:1,column:58},source:''},
                    name: 'x'
                  },
                  shorthand: true
                }
              ]
            },
            init: {
              type: 'ObjectExpression',
              loc:{start:{line:1,column:64},end:{line:1,column:73},source:''},
              properties: [
                {
                  type: 'Property',
                  loc:{start:{line:1,column:66},end:{line:1,column:71},source:''},
                  key: {
                    type: 'Identifier',
                    loc:{start:{line:1,column:66},end:{line:1,column:67},source:''},
                    name: 'x'
                  },
                  kind: 'init',
                  method: false,
                  computed: false,
                  value: {
                    type: 'Literal',
                    loc:{start:{line:1,column:69},end:{line:1,column:71},source:''},
                    value: 23,
                    raw: '23'
                  },
                  shorthand: false
                }
              ]
            }
          }
        ]
      },
      test: {
        type: 'BinaryExpression',
        loc:{start:{line:1,column:75},end:{line:1,column:80},source:''},
        left: {
          type: 'Identifier',
          loc:{start:{line:1,column:75},end:{line:1,column:76},source:''},
          name: 'a'
        },
        operator: '<',
        right: {
          type: 'Literal',
          loc:{start:{line:1,column:79},end:{line:1,column:80},source:''},
          value: 1,
          raw: '1'
        }
      },
      update: null,
      body: {
        type: 'BlockStatement',
        loc:{start:{line:1,column:84},end:{line:1,column:86},source:''},
        body: []
      }
    },
    {
      type: 'EmptyStatement',
      loc:{start:{line:1,column:86},end:{line:1,column:87},source:''}
    }
  ]
}

tokens (45x):
       ID_for PUNC_PAREN_OPEN ID_const PUNC_CURLY_OPEN IDENT
       PUNC_COMMA PUNC_CURLY_CLOSE PUNC_EQ PUNC_CURLY_OPEN IDENT
       PUNC_COLON NUMBER_DEC PUNC_CURLY_CLOSE PUNC_SEMI IDENT PUNC_LT
       NUMBER_DEC PUNC_SEMI PUNC_PAREN_CLOSE PUNC_CURLY_OPEN
       PUNC_CURLY_CLOSE PUNC_SEMI ID_for PUNC_PAREN_OPEN ID_const
       PUNC_CURLY_OPEN IDENT PUNC_COMMA PUNC_CURLY_CLOSE PUNC_EQ
       PUNC_CURLY_OPEN IDENT PUNC_COLON NUMBER_DEC PUNC_CURLY_CLOSE
       PUNC_SEMI IDENT PUNC_LT NUMBER_DEC PUNC_SEMI PUNC_PAREN_CLOSE
       PUNC_CURLY_OPEN PUNC_CURLY_CLOSE PUNC_SEMI
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
for (const {x} = {x:23};((a) < (1));) {}
;
for (const {x} = {x:23};((a) < (1));) {}
;
````

Produces same AST
