# Tenko parser test case

- Path: tests/testcases/for_statement/double_let_arr_pattern_not_dupe.md

> :: for statement
>
> ::> double let arr pattern not dupe
>
> The bindings inside the for-header of a sibling for-statement should cause dupe binding errors
>
> https://twitter.com/Ghost1240145716/status/1153634608220528643
>
> The regression applied to patterns (object and arrays)

## Input

`````js
for (let [a]=x;;);
for (let [a]=x;;);
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:2,column:18},source:''},
  body: [
    {
      type: 'ForStatement',
      loc:{start:{line:1,column:0},end:{line:1,column:18},source:''},
      init: {
        type: 'VariableDeclaration',
        loc:{start:{line:1,column:5},end:{line:1,column:14},source:''},
        kind: 'let',
        declarations: [
          {
            type: 'VariableDeclarator',
            loc:{start:{line:1,column:9},end:{line:1,column:14},source:''},
            id: {
              type: 'ArrayPattern',
              loc:{start:{line:1,column:9},end:{line:1,column:12},source:''},
              elements: [
                {
                  type: 'Identifier',
                  loc:{start:{line:1,column:10},end:{line:1,column:11},source:''},
                  name: 'a'
                }
              ]
            },
            init: {
              type: 'Identifier',
              loc:{start:{line:1,column:13},end:{line:1,column:14},source:''},
              name: 'x'
            }
          }
        ]
      },
      test: null,
      update: null,
      body: {
        type: 'EmptyStatement',
        loc:{start:{line:1,column:17},end:{line:1,column:18},source:''}
      }
    },
    {
      type: 'ForStatement',
      loc:{start:{line:2,column:0},end:{line:2,column:18},source:''},
      init: {
        type: 'VariableDeclaration',
        loc:{start:{line:2,column:5},end:{line:2,column:14},source:''},
        kind: 'let',
        declarations: [
          {
            type: 'VariableDeclarator',
            loc:{start:{line:2,column:9},end:{line:2,column:14},source:''},
            id: {
              type: 'ArrayPattern',
              loc:{start:{line:2,column:9},end:{line:2,column:12},source:''},
              elements: [
                {
                  type: 'Identifier',
                  loc:{start:{line:2,column:10},end:{line:2,column:11},source:''},
                  name: 'a'
                }
              ]
            },
            init: {
              type: 'Identifier',
              loc:{start:{line:2,column:13},end:{line:2,column:14},source:''},
              name: 'x'
            }
          }
        ]
      },
      test: null,
      update: null,
      body: {
        type: 'EmptyStatement',
        loc:{start:{line:2,column:17},end:{line:2,column:18},source:''}
      }
    }
  ]
}

tokens (25x):
       ID_for PUNC_PAREN_OPEN ID_let PUNC_BRACKET_OPEN IDENT
       PUNC_BRACKET_CLOSE PUNC_EQ IDENT PUNC_SEMI PUNC_SEMI
       PUNC_PAREN_CLOSE PUNC_SEMI ID_for PUNC_PAREN_OPEN ID_let
       PUNC_BRACKET_OPEN IDENT PUNC_BRACKET_CLOSE PUNC_EQ IDENT
       PUNC_SEMI PUNC_SEMI PUNC_PAREN_CLOSE PUNC_SEMI
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
for (let [a,] = x;;) ;
for (let [a,] = x;;) ;
````

Produces same AST
