# Tenko parser test case

- Path: tests/testcases/for_statement/for-await/dynamic_property_inside_header.md

> :: for statement : for-await
>
> ::> dynamic property inside header
>
> The `in` keyword inside a dynamic property inside the lhs of for-in header


## Input

`````js
async function f() {
    for await (x[a in b] of y);
}
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:3,column:1},source:''},
  body: [
    {
      type: 'FunctionDeclaration',
      loc:{start:{line:1,column:0},end:{line:3,column:1},source:''},
      generator: false,
      async: true,
      id: {
        type: 'Identifier',
        loc:{start:{line:1,column:15},end:{line:1,column:16},source:''},
        name: 'f'
      },
      params: [],
      body: {
        type: 'BlockStatement',
        loc:{start:{line:1,column:19},end:{line:3,column:1},source:''},
        body: [
          {
            type: 'ForOfStatement',
            loc:{start:{line:2,column:4},end:{line:2,column:31},source:''},
            left: {
              type: 'MemberExpression',
              loc:{start:{line:2,column:15},end:{line:2,column:24},source:''},
              object: {
                type: 'Identifier',
                loc:{start:{line:2,column:15},end:{line:2,column:16},source:''},
                name: 'x'
              },
              property: {
                type: 'BinaryExpression',
                loc:{start:{line:2,column:17},end:{line:2,column:23},source:''},
                left: {
                  type: 'Identifier',
                  loc:{start:{line:2,column:17},end:{line:2,column:18},source:''},
                  name: 'a'
                },
                operator: 'in',
                right: {
                  type: 'Identifier',
                  loc:{start:{line:2,column:22},end:{line:2,column:23},source:''},
                  name: 'b'
                }
              },
              computed: true
            },
            right: {
              type: 'Identifier',
              loc:{start:{line:2,column:28},end:{line:2,column:29},source:''},
              name: 'y'
            },
            await: true,
            body: {
              type: 'EmptyStatement',
              loc:{start:{line:2,column:30},end:{line:2,column:31},source:''}
            }
          }
        ]
      }
    }
  ]
}

tokens (21x):
       ID_async ID_function IDENT PUNC_PAREN_OPEN PUNC_PAREN_CLOSE
       PUNC_CURLY_OPEN ID_for ID_await PUNC_PAREN_OPEN IDENT
       PUNC_BRACKET_OPEN IDENT ID_in IDENT PUNC_BRACKET_CLOSE ID_of
       IDENT PUNC_PAREN_CLOSE PUNC_SEMI PUNC_CURLY_CLOSE
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
async function f() {for await (((x)[((a) in (b))]) of y) ;}
````

Produces same AST
