# Tenko parser test case

- Path: tests/testcases/for_statement/for-await/lhs_edge_cases/number_dynprop.md

> :: for statement : for-await : lhs edge cases
>
> ::> number dynprop
>
> Any simple assignment target is fine

## Input

`````js
async function f(){
  for await (456[x] of c) d;
}
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:3,column:1},source:''},
  body: [
    {
      type: 'FunctionDeclaration',
      loc:{start:{line:1,column:0},end:{line:3,column:1},source:''},
      generator: false,
      async: true,
      id: {
        type: 'Identifier',
        loc:{start:{line:1,column:15},end:{line:1,column:16},source:''},
        name: 'f'
      },
      params: [],
      body: {
        type: 'BlockStatement',
        loc:{start:{line:1,column:18},end:{line:3,column:1},source:''},
        body: [
          {
            type: 'ForOfStatement',
            loc:{start:{line:2,column:2},end:{line:2,column:28},source:''},
            left: {
              type: 'MemberExpression',
              loc:{start:{line:2,column:13},end:{line:2,column:19},source:''},
              object: {
                type: 'Literal',
                loc:{start:{line:2,column:13},end:{line:2,column:16},source:''},
                value: 456,
                raw: '456'
              },
              property: {
                type: 'Identifier',
                loc:{start:{line:2,column:17},end:{line:2,column:18},source:''},
                name: 'x'
              },
              computed: true
            },
            right: {
              type: 'Identifier',
              loc:{start:{line:2,column:23},end:{line:2,column:24},source:''},
              name: 'c'
            },
            await: true,
            body: {
              type: 'ExpressionStatement',
              loc:{start:{line:2,column:26},end:{line:2,column:28},source:''},
              expression: {
                type: 'Identifier',
                loc:{start:{line:2,column:26},end:{line:2,column:27},source:''},
                name: 'd'
              }
            }
          }
        ]
      }
    }
  ]
}

tokens (20x):
       ID_async ID_function IDENT PUNC_PAREN_OPEN PUNC_PAREN_CLOSE
       PUNC_CURLY_OPEN ID_for ID_await PUNC_PAREN_OPEN NUMBER_DEC
       PUNC_BRACKET_OPEN IDENT PUNC_BRACKET_CLOSE ID_of IDENT
       PUNC_PAREN_CLOSE IDENT PUNC_SEMI PUNC_CURLY_CLOSE
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
async function f() {for await (((456)[x]) of c) (d);}
````

Produces same AST
