# Tenko parser test case

- Path: tests/testcases/for_statement/for-await/lhs_edge_cases/yield_no-arg_lhs_1.md

> :: for statement : for-await : lhs edge cases
>
> ::> yield no-arg lhs 1

## Input

`````js
async function f(){
  for await (yield of x);
}
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:3,column:1},source:''},
  body: [
    {
      type: 'FunctionDeclaration',
      loc:{start:{line:1,column:0},end:{line:3,column:1},source:''},
      generator: false,
      async: true,
      id: {
        type: 'Identifier',
        loc:{start:{line:1,column:15},end:{line:1,column:16},source:''},
        name: 'f'
      },
      params: [],
      body: {
        type: 'BlockStatement',
        loc:{start:{line:1,column:18},end:{line:3,column:1},source:''},
        body: [
          {
            type: 'ForOfStatement',
            loc:{start:{line:2,column:2},end:{line:2,column:25},source:''},
            left: {
              type: 'Identifier',
              loc:{start:{line:2,column:13},end:{line:2,column:18},source:''},
              name: 'yield'
            },
            right: {
              type: 'Identifier',
              loc:{start:{line:2,column:22},end:{line:2,column:23},source:''},
              name: 'x'
            },
            await: true,
            body: {
              type: 'EmptyStatement',
              loc:{start:{line:2,column:24},end:{line:2,column:25},source:''}
            }
          }
        ]
      }
    }
  ]
}

tokens (16x):
       ID_async ID_function IDENT PUNC_PAREN_OPEN PUNC_PAREN_CLOSE
       PUNC_CURLY_OPEN ID_for ID_await PUNC_PAREN_OPEN ID_yield ID_of
       IDENT PUNC_PAREN_CLOSE PUNC_SEMI PUNC_CURLY_CLOSE
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

`````
throws: Parser error!
  Cannot use `yield` outside of generator functions when in strict mode

async function f(){
  for await (yield of x);
                   ^------- error

}
`````


### Module goal

Parsed with the module goal.

_Output same as strict mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
async function f() {for await ((yield) of x) ;}
````

Produces same AST
