# Tenko parser test case

- Path: tests/testcases/for_statement/for-in/destructuring_edge_cases/object_that_would_be_valid_to_assign-destructure.md

> :: for statement : for-in : destructuring edge cases
>
> ::> object that would be valid to assign-destructure
> 
> https://tc39.github.io/ecma262/#sec-for-in-and-for-of-statements-static-semantics-early-errors
> 
> > It is a Syntax Error if LeftHandSideExpression is either an ObjectLiteral or an ArrayLiteral and if LeftHandSideExpression is not covering an AssignmentPattern.

## Input

`````js
for ({x: a.b} in obj);
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:22},source:''},
  body: [
    {
      type: 'ForInStatement',
      loc:{start:{line:1,column:0},end:{line:1,column:22},source:''},
      left: {
        type: 'ObjectPattern',
        loc:{start:{line:1,column:5},end:{line:1,column:13},source:''},
        properties: [
          {
            type: 'Property',
            loc:{start:{line:1,column:6},end:{line:1,column:12},source:''},
            key: {
              type: 'Identifier',
              loc:{start:{line:1,column:6},end:{line:1,column:7},source:''},
              name: 'x'
            },
            kind: 'init',
            method: false,
            computed: false,
            value: {
              type: 'MemberExpression',
              loc:{start:{line:1,column:9},end:{line:1,column:12},source:''},
              object: {
                type: 'Identifier',
                loc:{start:{line:1,column:9},end:{line:1,column:10},source:''},
                name: 'a'
              },
              property: {
                type: 'Identifier',
                loc:{start:{line:1,column:11},end:{line:1,column:12},source:''},
                name: 'b'
              },
              computed: false
            },
            shorthand: false
          }
        ]
      },
      right: {
        type: 'Identifier',
        loc:{start:{line:1,column:17},end:{line:1,column:20},source:''},
        name: 'obj'
      },
      body: {
        type: 'EmptyStatement',
        loc:{start:{line:1,column:21},end:{line:1,column:22},source:''}
      }
    }
  ]
}

tokens (14x):
       ID_for PUNC_PAREN_OPEN PUNC_CURLY_OPEN IDENT PUNC_COLON IDENT
       PUNC_DOT IDENT PUNC_CURLY_CLOSE ID_in IDENT PUNC_PAREN_CLOSE
       PUNC_SEMI
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
for ({x:(a).b} in obj) ;
````

Produces same AST
