# Tenko parser test case

- Path: tests/testcases/for_statement/for-in/destructuring_edge_cases/object_that_would_not_be_destructible.md

> :: for statement : for-in : destructuring edge cases
>
> ::> object that would not be destructible
> 
> https://tc39.github.io/ecma262/#sec-for-in-and-for-of-statements-static-semantics-early-errors
> 
> > It is a Syntax Error if LeftHandSideExpression is either an ObjectLiteral or an ArrayLiteral and if LeftHandSideExpression is not covering an AssignmentPattern.

## Input

`````js
for ({a: x + y} in obj);
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
throws: Parser error!
  The for-header lhs binding pattern is not destructible

for ({a: x + y} in obj);
                ^------- error
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._
