# Tenko parser test case

- Path: tests/testcases/for_statement/for-in/let_edge_case.md

> :: for statement : for-in
>
> ::> let edge case

## Input

`````js
for (let in x) y
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:16},source:''},
  body: [
    {
      type: 'ForInStatement',
      loc:{start:{line:1,column:0},end:{line:1,column:16},source:''},
      left: {
        type: 'Identifier',
        loc:{start:{line:1,column:5},end:{line:1,column:8},source:''},
        name: 'let'
      },
      right: {
        type: 'Identifier',
        loc:{start:{line:1,column:12},end:{line:1,column:13},source:''},
        name: 'x'
      },
      body: {
        type: 'ExpressionStatement',
        loc:{start:{line:1,column:15},end:{line:1,column:16},source:''},
        expression: {
          type: 'Identifier',
          loc:{start:{line:1,column:15},end:{line:1,column:16},source:''},
          name: 'y'
        }
      }
    }
  ]
}

tokens (9x):
       ID_for PUNC_PAREN_OPEN ID_let ID_in IDENT PUNC_PAREN_CLOSE
       IDENT ASI
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

`````
throws: Parser error!
  Let binding missing binding names as `let` cannot be a var name in strict mode

for (let in x) y
         ^------- error
`````


### Module goal

Parsed with the module goal.

_Output same as strict mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
for ((let) in x) (y);
````

Produces same AST
