# Tenko parser test case

- Path: tests/testcases/for_statement/for-in/lhs_edge_cases/call_member_expression.md

> :: for statement : for-in : lhs edge cases
>
> ::> call member expression
>
> Any simple assignment target is fine

## Input

`````js
for (a()[b] in c) d;
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:20},source:''},
  body: [
    {
      type: 'ForInStatement',
      loc:{start:{line:1,column:0},end:{line:1,column:20},source:''},
      left: {
        type: 'MemberExpression',
        loc:{start:{line:1,column:5},end:{line:1,column:11},source:''},
        object: {
          type: 'CallExpression',
          loc:{start:{line:1,column:5},end:{line:1,column:8},source:''},
          callee: {
            type: 'Identifier',
            loc:{start:{line:1,column:5},end:{line:1,column:6},source:''},
            name: 'a'
          },
          arguments: []
        },
        property: {
          type: 'Identifier',
          loc:{start:{line:1,column:9},end:{line:1,column:10},source:''},
          name: 'b'
        },
        computed: true
      },
      right: {
        type: 'Identifier',
        loc:{start:{line:1,column:15},end:{line:1,column:16},source:''},
        name: 'c'
      },
      body: {
        type: 'ExpressionStatement',
        loc:{start:{line:1,column:18},end:{line:1,column:20},source:''},
        expression: {
          type: 'Identifier',
          loc:{start:{line:1,column:18},end:{line:1,column:19},source:''},
          name: 'd'
        }
      }
    }
  ]
}

tokens (14x):
       ID_for PUNC_PAREN_OPEN IDENT PUNC_PAREN_OPEN PUNC_PAREN_CLOSE
       PUNC_BRACKET_OPEN IDENT PUNC_BRACKET_CLOSE ID_in IDENT
       PUNC_PAREN_CLOSE IDENT PUNC_SEMI
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
for ((((a)())[b]) in c) (d);
````

Produces same AST
