# Tenko parser test case

- Path: tests/testcases/for_statement/for-in/web_compat/destructuring_with_const_is_always_illegal_1.md

> :: for statement : for-in : web compat
>
> ::> destructuring with const is always illegal 1
> 
> https://tc39.github.io/ecma262/#sec-iteration-statements
> 
> - for ( var ForBinding[?Yield, ?Await] in Expression[+In, ?Yield, ?Await] ) Statement[?Yield, ?Await, ?Return]
> 
> https://tc39.github.io/ecma262/#sec-initializers-in-forin-statement-heads
> 
> The following augments the IterationStatement;
> 
> - IterationStatement[Yield, Await, Return]:
>   - for ( var BindingIdentifier[?Yield, ?Await] Initializer[~In, ?Yield, ?Await] in Expression[+In, ?Yield, ?Await] ) Statement[?Yield, ?Await, ?Return]
> 
> (note that Expression also has comma-expression, there is no "Expressions" production)

## Input

`````js
for (const x = 0 in {});
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
throws: Parser error!
  For-in and for-of binding can not have an init

for (const x = 0 in {});
                 ^------- error
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._
