# Tenko parser test case

- Path: tests/testcases/for_statement/for-in/web_compat/var_with_init_left_and_assignment_right_of_x0060inx0060.md

> :: for statement : for-in : web compat
>
> ::> var with init left and assignment right of x0060inx0060
>
> this is an annexB web compat thing
> 
> https://tc39.github.io/ecma262/#sec-iteration-statements
> 
> - for ( var ForBinding[?Yield, ?Await] in Expression[+In, ?Yield, ?Await] ) Statement[?Yield, ?Await, ?Return]
> 
> https://tc39.github.io/ecma262/#sec-initializers-in-forin-statement-heads
> 
> The following augments the IterationStatement;
> 
> - IterationStatement[Yield, Await, Return]:
>   - for ( var BindingIdentifier[?Yield, ?Await] Initializer[~In, ?Yield, ?Await] in Expression[+In, ?Yield, ?Await] ) Statement[?Yield, ?Await, ?Return]
> 
> (note that Expression also has comma-expression, there is no "Expressions" production)

## Input

`````js
for (var a = 0 in stored = a, {});
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
throws: Parser error!
  For-in and for-of binding can not have an init

for (var a = 0 in stored = a, {});
               ^------- error
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:34},source:''},
  body: [
    {
      type: 'ForInStatement',
      loc:{start:{line:1,column:0},end:{line:1,column:34},source:''},
      left: {
        type: 'VariableDeclaration',
        loc:{start:{line:1,column:5},end:{line:1,column:14},source:''},
        kind: 'var',
        declarations: [
          {
            type: 'VariableDeclarator',
            loc:{start:{line:1,column:9},end:{line:1,column:14},source:''},
            id: {
              type: 'Identifier',
              loc:{start:{line:1,column:9},end:{line:1,column:10},source:''},
              name: 'a'
            },
            init: {
              type: 'Literal',
              loc:{start:{line:1,column:13},end:{line:1,column:14},source:''},
              value: 0,
              raw: '0'
            }
          }
        ]
      },
      right: {
        type: 'SequenceExpression',
        loc:{start:{line:1,column:18},end:{line:1,column:32},source:''},
        expressions: [
          {
            type: 'AssignmentExpression',
            loc:{start:{line:1,column:18},end:{line:1,column:28},source:''},
            left: {
              type: 'Identifier',
              loc:{start:{line:1,column:18},end:{line:1,column:24},source:''},
              name: 'stored'
            },
            operator: '=',
            right: {
              type: 'Identifier',
              loc:{start:{line:1,column:27},end:{line:1,column:28},source:''},
              name: 'a'
            }
          },
          {
            type: 'ObjectExpression',
            loc:{start:{line:1,column:30},end:{line:1,column:32},source:''},
            properties: []
          }
        ]
      },
      body: {
        type: 'EmptyStatement',
        loc:{start:{line:1,column:33},end:{line:1,column:34},source:''}
      }
    }
  ]
}

tokens (16x):
       ID_for PUNC_PAREN_OPEN ID_var IDENT PUNC_EQ NUMBER_DEC ID_in
       IDENT PUNC_EQ IDENT PUNC_COMMA PUNC_CURLY_OPEN PUNC_CURLY_CLOSE
       PUNC_PAREN_CLOSE PUNC_SEMI
`````


## AST Printer

Printer output different from input [web]:

````js
for (var a = 0 in ((stored = a), {})) ;
````

Produces same AST
