# Tenko parser test case

- Path: tests/testcases/for_statement/for-loop/addities_in_lhs/for_function_in.md

> :: for statement : for-loop : addities in lhs
>
> ::> for function in
>
> By fuzzer, zeparser only
>
> Error: Parser error! Next ord should be 41 (`)`) but was 105 (curc: `i`, token: `in`)

## Input

`````js
for(function(){if(x in 3);};;)x
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:31},source:''},
  body: [
    {
      type: 'ForStatement',
      loc:{start:{line:1,column:0},end:{line:1,column:31},source:''},
      init: {
        type: 'FunctionExpression',
        loc:{start:{line:1,column:4},end:{line:1,column:27},source:''},
        generator: false,
        async: false,
        id: null,
        params: [],
        body: {
          type: 'BlockStatement',
          loc:{start:{line:1,column:14},end:{line:1,column:27},source:''},
          body: [
            {
              type: 'IfStatement',
              loc:{start:{line:1,column:15},end:{line:1,column:26},source:''},
              test: {
                type: 'BinaryExpression',
                loc:{start:{line:1,column:18},end:{line:1,column:24},source:''},
                left: {
                  type: 'Identifier',
                  loc:{start:{line:1,column:18},end:{line:1,column:19},source:''},
                  name: 'x'
                },
                operator: 'in',
                right: {
                  type: 'Literal',
                  loc:{start:{line:1,column:23},end:{line:1,column:24},source:''},
                  value: 3,
                  raw: '3'
                }
              },
              consequent: {
                type: 'EmptyStatement',
                loc:{start:{line:1,column:25},end:{line:1,column:26},source:''}
              },
              alternate: null
            }
          ]
        }
      },
      test: null,
      update: null,
      body: {
        type: 'ExpressionStatement',
        loc:{start:{line:1,column:30},end:{line:1,column:31},source:''},
        expression: {
          type: 'Identifier',
          loc:{start:{line:1,column:30},end:{line:1,column:31},source:''},
          name: 'x'
        }
      }
    }
  ]
}

tokens (20x):
       ID_for PUNC_PAREN_OPEN ID_function PUNC_PAREN_OPEN
       PUNC_PAREN_CLOSE PUNC_CURLY_OPEN ID_if PUNC_PAREN_OPEN IDENT
       ID_in NUMBER_DEC PUNC_PAREN_CLOSE PUNC_SEMI PUNC_CURLY_CLOSE
       PUNC_SEMI PUNC_SEMI PUNC_PAREN_CLOSE IDENT ASI
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
for ((function() {if (((x) in (3))) ;});;) (x);
````

Produces same AST
