# Tenko parser test case

- Path: tests/testcases/for_statement/for-loop/double_proto/double_proto_of_lhs_obj_no_web_compat.md

> :: for statement : for-loop : double proto
>
> ::> double proto of lhs obj no web compat

## Input

`````js
for ({__proto__: 1, __proto__: 2};;);
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:37},source:''},
  body: [
    {
      type: 'ForStatement',
      loc:{start:{line:1,column:0},end:{line:1,column:37},source:''},
      init: {
        type: 'ObjectExpression',
        loc:{start:{line:1,column:5},end:{line:1,column:33},source:''},
        properties: [
          {
            type: 'Property',
            loc:{start:{line:1,column:6},end:{line:1,column:18},source:''},
            key: {
              type: 'Identifier',
              loc:{start:{line:1,column:6},end:{line:1,column:15},source:''},
              name: '__proto__'
            },
            kind: 'init',
            method: false,
            computed: false,
            value: {
              type: 'Literal',
              loc:{start:{line:1,column:17},end:{line:1,column:18},source:''},
              value: 1,
              raw: '1'
            },
            shorthand: false
          },
          {
            type: 'Property',
            loc:{start:{line:1,column:20},end:{line:1,column:32},source:''},
            key: {
              type: 'Identifier',
              loc:{start:{line:1,column:20},end:{line:1,column:29},source:''},
              name: '__proto__'
            },
            kind: 'init',
            method: false,
            computed: false,
            value: {
              type: 'Literal',
              loc:{start:{line:1,column:31},end:{line:1,column:32},source:''},
              value: 2,
              raw: '2'
            },
            shorthand: false
          }
        ]
      },
      test: null,
      update: null,
      body: {
        type: 'EmptyStatement',
        loc:{start:{line:1,column:36},end:{line:1,column:37},source:''}
      }
    }
  ]
}

tokens (16x):
       ID_for PUNC_PAREN_OPEN PUNC_CURLY_OPEN IDENT PUNC_COLON
       NUMBER_DEC PUNC_COMMA IDENT PUNC_COLON NUMBER_DEC
       PUNC_CURLY_CLOSE PUNC_SEMI PUNC_SEMI PUNC_PAREN_CLOSE PUNC_SEMI
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

`````
throws: Parser error!
  Cannot use lhs as regular for-loop because it must destruct

for ({__proto__: 1, __proto__: 2};;);
                                 ^------- error
`````


## AST Printer

Printer output different from input [sloppy]:

````js
for (({__proto__:1, __proto__:2});;) ;
````

Produces same AST
