# Tenko parser test case

- Path: tests/testcases/for_statement/for-loop/lhs_assign_expr_edge_cases/arrow_expr_with_in_should_fail.md

> :: for statement : for-loop : lhs assign expr edge cases
>
> ::> arrow expr with in should fail
>
> because the parser should be greedy (otoh the arrow can only be valid in regular loop so theres no ambiguity once the arrow is seen...)
>
> https://tc39.github.io/ecma262/#sec-statements
>
> Note: +In means "is allowed", ~In means "not allowed", without prefix means "same as input"
>
> IterationStatement[Yield, Await, Return]:
>
> for([lookahead != `let [`]Expression[~In, ?Yield, ?Await]opt ; ; ) ;
>
> Expression[In, Yield, Await]:
>
> AssignmentExpression[?In, ?Yield, ?Await]
>
> AssignmentExpression[In, Yield, Await]:
>
> ArrowFunction[?In, ?Yield, ?Await]
>
> ArrowFunction[In, Yield, Await]:
>
> ArrowParameters[?Yield, ?Await][no LineTerminator here]=>ConciseBody[?In]
>
> ConciseBody[In]:
>
> [lookahead != `{`]AssignmentExpression[?In, ~Yield, ~Await]
>
> {FunctionBody[~Yield, ~Await]}
>
> So a block-arrow doesn't care but an expression arrow propagates the "in" flag and disallows it in the expression, just like a regular lhs would. So it's not allowed.
>
> There is a counter test for `for (x=>{x in y};;);`, which should pass.

## FAIL

## Input

`````js
for (x=>x in y;;);
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
throws: Parser error!
  Arrows cannot be lhs to for-in

for (x=>x in y;;);
          ^------- error
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._
