# Tenko parser test case

- Path: tests/testcases/for_statement/for-loop/lhs_assign_expr_edge_cases/ternary_in_lhs.md

> :: for statement : for-loop : lhs assign expr edge cases
>
> ::> ternary in lhs

## Input

`````js
for (a ? b : c;;);
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:18},source:''},
  body: [
    {
      type: 'ForStatement',
      loc:{start:{line:1,column:0},end:{line:1,column:18},source:''},
      init: {
        type: 'ConditionalExpression',
        loc:{start:{line:1,column:5},end:{line:1,column:14},source:''},
        test: {
          type: 'Identifier',
          loc:{start:{line:1,column:5},end:{line:1,column:6},source:''},
          name: 'a'
        },
        consequent: {
          type: 'Identifier',
          loc:{start:{line:1,column:9},end:{line:1,column:10},source:''},
          name: 'b'
        },
        alternate: {
          type: 'Identifier',
          loc:{start:{line:1,column:13},end:{line:1,column:14},source:''},
          name: 'c'
        }
      },
      test: null,
      update: null,
      body: {
        type: 'EmptyStatement',
        loc:{start:{line:1,column:17},end:{line:1,column:18},source:''}
      }
    }
  ]
}

tokens (12x):
       ID_for PUNC_PAREN_OPEN IDENT PUNC_QMARK IDENT PUNC_COLON IDENT
       PUNC_SEMI PUNC_SEMI PUNC_PAREN_CLOSE PUNC_SEMI
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
for ((((a)? (b) : (c)));;) ;
````

Produces same AST
