# Tenko parser test case

- Path: tests/testcases/for_statement/for-loop/lhs_edge_cases/arr_might_destruct.md

> :: for statement : for-loop : lhs edge cases
>
> ::> arr might destruct
>
> This is an array that might destruct because it contains an object rest that could also be a spread.

## PASS

## Input

`````js
for ([{x,...x}]=x ;;) ;
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:23},source:''},
  body: [
    {
      type: 'ForStatement',
      loc:{start:{line:1,column:0},end:{line:1,column:23},source:''},
      init: {
        type: 'AssignmentExpression',
        loc:{start:{line:1,column:5},end:{line:1,column:17},source:''},
        left: {
          type: 'ArrayPattern',
          loc:{start:{line:1,column:5},end:{line:1,column:15},source:''},
          elements: [
            {
              type: 'ObjectPattern',
              loc:{start:{line:1,column:6},end:{line:1,column:14},source:''},
              properties: [
                {
                  type: 'Property',
                  loc:{start:{line:1,column:7},end:{line:1,column:8},source:''},
                  key: {
                    type: 'Identifier',
                    loc:{start:{line:1,column:7},end:{line:1,column:8},source:''},
                    name: 'x'
                  },
                  kind: 'init',
                  method: false,
                  computed: false,
                  value: {
                    type: 'Identifier',
                    loc:{start:{line:1,column:7},end:{line:1,column:8},source:''},
                    name: 'x'
                  },
                  shorthand: true
                },
                {
                  type: 'RestElement',
                  loc:{start:{line:1,column:9},end:{line:1,column:13},source:''},
                  argument: {
                    type: 'Identifier',
                    loc:{start:{line:1,column:12},end:{line:1,column:13},source:''},
                    name: 'x'
                  }
                }
              ]
            }
          ]
        },
        operator: '=',
        right: {
          type: 'Identifier',
          loc:{start:{line:1,column:16},end:{line:1,column:17},source:''},
          name: 'x'
        }
      },
      test: null,
      update: null,
      body: {
        type: 'EmptyStatement',
        loc:{start:{line:1,column:22},end:{line:1,column:23},source:''}
      }
    }
  ]
}

tokens (17x):
       ID_for PUNC_PAREN_OPEN PUNC_BRACKET_OPEN PUNC_CURLY_OPEN IDENT
       PUNC_COMMA PUNC_DOT_DOT_DOT IDENT PUNC_CURLY_CLOSE
       PUNC_BRACKET_CLOSE PUNC_EQ IDENT PUNC_SEMI PUNC_SEMI
       PUNC_PAREN_CLOSE PUNC_SEMI
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
for ((([{x, ...x},] = x));;) ;
````

Produces same AST
