# Tenko parser test case

- Path: tests/testcases/for_statement/for-loop/lhs_edge_cases/arrlit_member_expression.md

> :: for statement : for-loop : lhs edge cases
>
> ::> arrlit member expression
>
> Any simple assignment target is fine

## Input

`````js
for ([].b in c) d;
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:18},source:''},
  body: [
    {
      type: 'ForInStatement',
      loc:{start:{line:1,column:0},end:{line:1,column:18},source:''},
      left: {
        type: 'MemberExpression',
        loc:{start:{line:1,column:5},end:{line:1,column:9},source:''},
        object: {
          type: 'ArrayExpression',
          loc:{start:{line:1,column:5},end:{line:1,column:7},source:''},
          elements: []
        },
        property: {
          type: 'Identifier',
          loc:{start:{line:1,column:8},end:{line:1,column:9},source:''},
          name: 'b'
        },
        computed: false
      },
      right: {
        type: 'Identifier',
        loc:{start:{line:1,column:13},end:{line:1,column:14},source:''},
        name: 'c'
      },
      body: {
        type: 'ExpressionStatement',
        loc:{start:{line:1,column:16},end:{line:1,column:18},source:''},
        expression: {
          type: 'Identifier',
          loc:{start:{line:1,column:16},end:{line:1,column:17},source:''},
          name: 'd'
        }
      }
    }
  ]
}

tokens (12x):
       ID_for PUNC_PAREN_OPEN PUNC_BRACKET_OPEN PUNC_BRACKET_CLOSE
       PUNC_DOT IDENT ID_in IDENT PUNC_PAREN_CLOSE IDENT PUNC_SEMI
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
for (([].b) in c) (d);
````

Produces same AST
