# Tenko parser test case

- Path: tests/testcases/for_statement/for-loop/lhs_edge_cases/func_prop.md

> :: for statement : for-loop : lhs edge cases
>
> ::> func prop
>
> The for-in flag should be reset inside a function

## PASS

## Input

`````js
for (function(){ a in b; }.foo;;);
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:34},source:''},
  body: [
    {
      type: 'ForStatement',
      loc:{start:{line:1,column:0},end:{line:1,column:34},source:''},
      init: {
        type: 'MemberExpression',
        loc:{start:{line:1,column:5},end:{line:1,column:30},source:''},
        object: {
          type: 'FunctionExpression',
          loc:{start:{line:1,column:5},end:{line:1,column:26},source:''},
          generator: false,
          async: false,
          id: null,
          params: [],
          body: {
            type: 'BlockStatement',
            loc:{start:{line:1,column:15},end:{line:1,column:26},source:''},
            body: [
              {
                type: 'ExpressionStatement',
                loc:{start:{line:1,column:17},end:{line:1,column:24},source:''},
                expression: {
                  type: 'BinaryExpression',
                  loc:{start:{line:1,column:17},end:{line:1,column:23},source:''},
                  left: {
                    type: 'Identifier',
                    loc:{start:{line:1,column:17},end:{line:1,column:18},source:''},
                    name: 'a'
                  },
                  operator: 'in',
                  right: {
                    type: 'Identifier',
                    loc:{start:{line:1,column:22},end:{line:1,column:23},source:''},
                    name: 'b'
                  }
                }
              }
            ]
          }
        },
        property: {
          type: 'Identifier',
          loc:{start:{line:1,column:27},end:{line:1,column:30},source:''},
          name: 'foo'
        },
        computed: false
      },
      test: null,
      update: null,
      body: {
        type: 'EmptyStatement',
        loc:{start:{line:1,column:33},end:{line:1,column:34},source:''}
      }
    }
  ]
}

tokens (18x):
       ID_for PUNC_PAREN_OPEN ID_function PUNC_PAREN_OPEN
       PUNC_PAREN_CLOSE PUNC_CURLY_OPEN IDENT ID_in IDENT PUNC_SEMI
       PUNC_CURLY_CLOSE PUNC_DOT IDENT PUNC_SEMI PUNC_SEMI
       PUNC_PAREN_CLOSE PUNC_SEMI
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
for (((function() {(((a) in (b)));}).foo);;) ;
````

Produces same AST
