# Tenko parser test case

- Path: tests/testcases/for_statement/for-loop/lhs_edge_cases/pattern_eval_shorthand.md

> :: for statement : for-loop : lhs edge cases
>
> ::> pattern eval shorthand
>
> Regression with `eval` as a shorthand in the lhs of a `for`.
>
> The `eval` would be a read and write and a write to `eval` is illegal in strict mode.

## Input

`````js
for ({ eval = 0 } ;;) ;
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
throws: Parser error!
  Cannot use lhs as regular for-loop because it must destruct

for ({ eval = 0 } ;;) ;
                  ^------- error
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._
