# Tenko parser test case

- Path: tests/testcases/for_statement/for-loop/postfix_on_yield_in_for-header.md

> :: for statement : for-loop
>
> ::> postfix on yield in for-header

## Input

`````js
for (yield[g]--;;);
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:19},source:''},
  body: [
    {
      type: 'ForStatement',
      loc:{start:{line:1,column:0},end:{line:1,column:19},source:''},
      init: {
        type: 'UpdateExpression',
        loc:{start:{line:1,column:5},end:{line:1,column:15},source:''},
        argument: {
          type: 'MemberExpression',
          loc:{start:{line:1,column:5},end:{line:1,column:13},source:''},
          object: {
            type: 'Identifier',
            loc:{start:{line:1,column:5},end:{line:1,column:10},source:''},
            name: 'yield'
          },
          property: {
            type: 'Identifier',
            loc:{start:{line:1,column:11},end:{line:1,column:12},source:''},
            name: 'g'
          },
          computed: true
        },
        operator: '--',
        prefix: false
      },
      test: null,
      update: null,
      body: {
        type: 'EmptyStatement',
        loc:{start:{line:1,column:18},end:{line:1,column:19},source:''}
      }
    }
  ]
}

tokens (12x):
       ID_for PUNC_PAREN_OPEN ID_yield PUNC_BRACKET_OPEN IDENT
       PUNC_BRACKET_CLOSE PUNC_MIN_MIN PUNC_SEMI PUNC_SEMI
       PUNC_PAREN_CLOSE PUNC_SEMI
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

`````
throws: Parser error!
  Cannot use `yield` outside of generator functions when in strict mode

for (yield[g]--;;);
          ^------- error
`````


### Module goal

Parsed with the module goal.

_Output same as strict mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
for (((yield)[g]--);;) ;
````

Produces same AST
