# Tenko parser test case

- Path: tests/testcases/for_statement/for-of/for_let_call_of.md

> :: for statement : for-of
>
> ::> for let call of
>
> By fuzzer, zeparser only
>
> Error: Parser error! Cannot use `let` as a var name on the left side in a `for-of` header

## Input

`````js
for(let()of t)x
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
throws: Parser error!
  Cannot use `let` as a var name on the left side in a `for-of` header

for(let()of t)x
         ^------- error
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

`````
throws: Parser error!
  Let binding missing binding names

for(let()of t)x
       ^------- error
`````


### Module goal

Parsed with the module goal.

_Output same as strict mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._
