# Tenko parser test case

- Path: tests/testcases/for_statement/for-of/lhs_edge_cases/func_if_in.md

> :: for statement : for-of : lhs edge cases
>
> ::> func if in
>
> The for-in flag should be reset inside a function
>
> (The prop prevents different syntax error)

## PASS

## Input

`````js
for (function(){ if (a in b); }.prop of x);
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:43},source:''},
  body: [
    {
      type: 'ForOfStatement',
      loc:{start:{line:1,column:0},end:{line:1,column:43},source:''},
      left: {
        type: 'MemberExpression',
        loc:{start:{line:1,column:5},end:{line:1,column:36},source:''},
        object: {
          type: 'FunctionExpression',
          loc:{start:{line:1,column:5},end:{line:1,column:31},source:''},
          generator: false,
          async: false,
          id: null,
          params: [],
          body: {
            type: 'BlockStatement',
            loc:{start:{line:1,column:15},end:{line:1,column:31},source:''},
            body: [
              {
                type: 'IfStatement',
                loc:{start:{line:1,column:17},end:{line:1,column:29},source:''},
                test: {
                  type: 'BinaryExpression',
                  loc:{start:{line:1,column:21},end:{line:1,column:27},source:''},
                  left: {
                    type: 'Identifier',
                    loc:{start:{line:1,column:21},end:{line:1,column:22},source:''},
                    name: 'a'
                  },
                  operator: 'in',
                  right: {
                    type: 'Identifier',
                    loc:{start:{line:1,column:26},end:{line:1,column:27},source:''},
                    name: 'b'
                  }
                },
                consequent: {
                  type: 'EmptyStatement',
                  loc:{start:{line:1,column:28},end:{line:1,column:29},source:''}
                },
                alternate: null
              }
            ]
          }
        },
        property: {
          type: 'Identifier',
          loc:{start:{line:1,column:32},end:{line:1,column:36},source:''},
          name: 'prop'
        },
        computed: false
      },
      right: {
        type: 'Identifier',
        loc:{start:{line:1,column:40},end:{line:1,column:41},source:''},
        name: 'x'
      },
      await: false,
      body: {
        type: 'EmptyStatement',
        loc:{start:{line:1,column:42},end:{line:1,column:43},source:''}
      }
    }
  ]
}

tokens (21x):
       ID_for PUNC_PAREN_OPEN ID_function PUNC_PAREN_OPEN
       PUNC_PAREN_CLOSE PUNC_CURLY_OPEN ID_if PUNC_PAREN_OPEN IDENT
       ID_in IDENT PUNC_PAREN_CLOSE PUNC_SEMI PUNC_CURLY_CLOSE
       PUNC_DOT IDENT ID_of IDENT PUNC_PAREN_CLOSE PUNC_SEMI
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
for (((function() {if (((a) in (b))) ;}).prop) of x) ;
````

Produces same AST
