# Tenko parser test case

- Path: tests/testcases/for_statement/let_binding_should_not_leak_to_parent.md

> :: for statement
>
> ::> let binding should not leak to parent
> https://twitter.com/Ghost1240145716/status/1152488565697179648
>
> The lex binding of a for-header should be recorded in a special binding layer and not in the parent statement/scope.


## Input

`````js
for (let { x, } = { x: 23 }; a < 1; ) {}; for (let { x, } = { x: 23 }; a < 1; ) {};
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:83},source:''},
  body: [
    {
      type: 'ForStatement',
      loc:{start:{line:1,column:0},end:{line:1,column:40},source:''},
      init: {
        type: 'VariableDeclaration',
        loc:{start:{line:1,column:5},end:{line:1,column:27},source:''},
        kind: 'let',
        declarations: [
          {
            type: 'VariableDeclarator',
            loc:{start:{line:1,column:9},end:{line:1,column:27},source:''},
            id: {
              type: 'ObjectPattern',
              loc:{start:{line:1,column:9},end:{line:1,column:15},source:''},
              properties: [
                {
                  type: 'Property',
                  loc:{start:{line:1,column:11},end:{line:1,column:12},source:''},
                  key: {
                    type: 'Identifier',
                    loc:{start:{line:1,column:11},end:{line:1,column:12},source:''},
                    name: 'x'
                  },
                  kind: 'init',
                  method: false,
                  computed: false,
                  value: {
                    type: 'Identifier',
                    loc:{start:{line:1,column:11},end:{line:1,column:12},source:''},
                    name: 'x'
                  },
                  shorthand: true
                }
              ]
            },
            init: {
              type: 'ObjectExpression',
              loc:{start:{line:1,column:18},end:{line:1,column:27},source:''},
              properties: [
                {
                  type: 'Property',
                  loc:{start:{line:1,column:20},end:{line:1,column:25},source:''},
                  key: {
                    type: 'Identifier',
                    loc:{start:{line:1,column:20},end:{line:1,column:21},source:''},
                    name: 'x'
                  },
                  kind: 'init',
                  method: false,
                  computed: false,
                  value: {
                    type: 'Literal',
                    loc:{start:{line:1,column:23},end:{line:1,column:25},source:''},
                    value: 23,
                    raw: '23'
                  },
                  shorthand: false
                }
              ]
            }
          }
        ]
      },
      test: {
        type: 'BinaryExpression',
        loc:{start:{line:1,column:29},end:{line:1,column:34},source:''},
        left: {
          type: 'Identifier',
          loc:{start:{line:1,column:29},end:{line:1,column:30},source:''},
          name: 'a'
        },
        operator: '<',
        right: {
          type: 'Literal',
          loc:{start:{line:1,column:33},end:{line:1,column:34},source:''},
          value: 1,
          raw: '1'
        }
      },
      update: null,
      body: {
        type: 'BlockStatement',
        loc:{start:{line:1,column:38},end:{line:1,column:40},source:''},
        body: []
      }
    },
    {
      type: 'EmptyStatement',
      loc:{start:{line:1,column:40},end:{line:1,column:41},source:''}
    },
    {
      type: 'ForStatement',
      loc:{start:{line:1,column:42},end:{line:1,column:82},source:''},
      init: {
        type: 'VariableDeclaration',
        loc:{start:{line:1,column:47},end:{line:1,column:69},source:''},
        kind: 'let',
        declarations: [
          {
            type: 'VariableDeclarator',
            loc:{start:{line:1,column:51},end:{line:1,column:69},source:''},
            id: {
              type: 'ObjectPattern',
              loc:{start:{line:1,column:51},end:{line:1,column:57},source:''},
              properties: [
                {
                  type: 'Property',
                  loc:{start:{line:1,column:53},end:{line:1,column:54},source:''},
                  key: {
                    type: 'Identifier',
                    loc:{start:{line:1,column:53},end:{line:1,column:54},source:''},
                    name: 'x'
                  },
                  kind: 'init',
                  method: false,
                  computed: false,
                  value: {
                    type: 'Identifier',
                    loc:{start:{line:1,column:53},end:{line:1,column:54},source:''},
                    name: 'x'
                  },
                  shorthand: true
                }
              ]
            },
            init: {
              type: 'ObjectExpression',
              loc:{start:{line:1,column:60},end:{line:1,column:69},source:''},
              properties: [
                {
                  type: 'Property',
                  loc:{start:{line:1,column:62},end:{line:1,column:67},source:''},
                  key: {
                    type: 'Identifier',
                    loc:{start:{line:1,column:62},end:{line:1,column:63},source:''},
                    name: 'x'
                  },
                  kind: 'init',
                  method: false,
                  computed: false,
                  value: {
                    type: 'Literal',
                    loc:{start:{line:1,column:65},end:{line:1,column:67},source:''},
                    value: 23,
                    raw: '23'
                  },
                  shorthand: false
                }
              ]
            }
          }
        ]
      },
      test: {
        type: 'BinaryExpression',
        loc:{start:{line:1,column:71},end:{line:1,column:76},source:''},
        left: {
          type: 'Identifier',
          loc:{start:{line:1,column:71},end:{line:1,column:72},source:''},
          name: 'a'
        },
        operator: '<',
        right: {
          type: 'Literal',
          loc:{start:{line:1,column:75},end:{line:1,column:76},source:''},
          value: 1,
          raw: '1'
        }
      },
      update: null,
      body: {
        type: 'BlockStatement',
        loc:{start:{line:1,column:80},end:{line:1,column:82},source:''},
        body: []
      }
    },
    {
      type: 'EmptyStatement',
      loc:{start:{line:1,column:82},end:{line:1,column:83},source:''}
    }
  ]
}

tokens (45x):
       ID_for PUNC_PAREN_OPEN ID_let PUNC_CURLY_OPEN IDENT PUNC_COMMA
       PUNC_CURLY_CLOSE PUNC_EQ PUNC_CURLY_OPEN IDENT PUNC_COLON
       NUMBER_DEC PUNC_CURLY_CLOSE PUNC_SEMI IDENT PUNC_LT NUMBER_DEC
       PUNC_SEMI PUNC_PAREN_CLOSE PUNC_CURLY_OPEN PUNC_CURLY_CLOSE
       PUNC_SEMI ID_for PUNC_PAREN_OPEN ID_let PUNC_CURLY_OPEN IDENT
       PUNC_COMMA PUNC_CURLY_CLOSE PUNC_EQ PUNC_CURLY_OPEN IDENT
       PUNC_COLON NUMBER_DEC PUNC_CURLY_CLOSE PUNC_SEMI IDENT PUNC_LT
       NUMBER_DEC PUNC_SEMI PUNC_PAREN_CLOSE PUNC_CURLY_OPEN
       PUNC_CURLY_CLOSE PUNC_SEMI
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
for (let {x} = {x:23};((a) < (1));) {}
;
for (let {x} = {x:23};((a) < (1));) {}
;
````

Produces same AST
