# Tenko parser test case

- Path: tests/testcases/functions/evalx002fargs_name/decl/eval_when_function_contains_strict_mode.md

> :: functions : evalx002fargs name : decl
>
> ::> eval when function contains strict mode

## Input

`````js
function eval(){ "use strict"; }
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
throws: Parser error!
  Can not use reserved keyword `eval` in strict mode as id for function that has a use strict directive

function eval(){ "use strict"; }
                               ^------- error
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

`````
throws: Parser error!
  Cannot use this name (eval) as a variable name because: Cannot create a binding named `eval` in strict mode

function eval(){ "use strict"; }
         ^------- error
`````


### Module goal

Parsed with the module goal.

_Output same as strict mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._
