# Tenko parser test case

- Path: tests/testcases/functions/func_statements/switch_with_double_decl_same_name.md

> :: functions : func statements
>
> ::> switch with double decl same name
>
> This should reject because the name is bound twice and "function statements" bindings
> are considered lexical bindings.

## Input

`````js
switch (0) { 
  case 1: 
    function f() {} 
  default: 
    function f() {} 
}
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
throws: Parser error!
  Attempted to create a lexical binding for `f` but another binding already existed on the same level

switch (0) {
  case 1:
    function f() {}
  default:
    function f() {}
             ^------- error

}
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:6,column:1},source:''},
  body: [
    {
      type: 'SwitchStatement',
      loc:{start:{line:1,column:0},end:{line:6,column:1},source:''},
      discriminant: {
        type: 'Literal',
        loc:{start:{line:1,column:8},end:{line:1,column:9},source:''},
        value: 0,
        raw: '0'
      },
      cases: [
        {
          type: 'SwitchCase',
          loc:{start:{line:2,column:2},end:{line:3,column:19},source:''},
          test: {
            type: 'Literal',
            loc:{start:{line:2,column:7},end:{line:2,column:8},source:''},
            value: 1,
            raw: '1'
          },
          consequent: [
            {
              type: 'FunctionDeclaration',
              loc:{start:{line:3,column:4},end:{line:3,column:19},source:''},
              generator: false,
              async: false,
              id: {
                type: 'Identifier',
                loc:{start:{line:3,column:13},end:{line:3,column:14},source:''},
                name: 'f'
              },
              params: [],
              body: {
                type: 'BlockStatement',
                loc:{start:{line:3,column:17},end:{line:3,column:19},source:''},
                body: []
              }
            }
          ]
        },
        {
          type: 'SwitchCase',
          loc:{start:{line:4,column:2},end:{line:5,column:19},source:''},
          test: null,
          consequent: [
            {
              type: 'FunctionDeclaration',
              loc:{start:{line:5,column:4},end:{line:5,column:19},source:''},
              generator: false,
              async: false,
              id: {
                type: 'Identifier',
                loc:{start:{line:5,column:13},end:{line:5,column:14},source:''},
                name: 'f'
              },
              params: [],
              body: {
                type: 'BlockStatement',
                loc:{start:{line:5,column:17},end:{line:5,column:19},source:''},
                body: []
              }
            }
          ]
        }
      ]
    }
  ]
}

tokens (24x):
       ID_switch PUNC_PAREN_OPEN NUMBER_DEC PUNC_PAREN_CLOSE
       PUNC_CURLY_OPEN ID_case NUMBER_DEC PUNC_COLON ID_function IDENT
       PUNC_PAREN_OPEN PUNC_PAREN_CLOSE PUNC_CURLY_OPEN
       PUNC_CURLY_CLOSE ID_default PUNC_COLON ID_function IDENT
       PUNC_PAREN_OPEN PUNC_PAREN_CLOSE PUNC_CURLY_OPEN
       PUNC_CURLY_CLOSE PUNC_CURLY_CLOSE
`````


## AST Printer

Printer output different from input [web]:

````js
switch (0) {case 1:
function f() {}
default:
function f() {}}
````

Produces same AST
