# Tenko parser test case

- Path: tests/testcases/functions/function_args/destructuring/array/rest_operator/spread_on_array_with_default_on_array.md

> :: functions : function args : destructuring : array : rest operator
>
> ::> spread on array with default on array
>
> Counter test to `f = ([...[ x ] = []]) => x;`, which is an error. 
>
> Where the rest is more restrictive towards its arg, spread is okay with this.

## Input

`````js
f = ([...[ x ] = []]);
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:22},source:''},
  body: [
    {
      type: 'ExpressionStatement',
      loc:{start:{line:1,column:0},end:{line:1,column:22},source:''},
      expression: {
        type: 'AssignmentExpression',
        loc:{start:{line:1,column:0},end:{line:1,column:21},source:''},
        left: {
          type: 'Identifier',
          loc:{start:{line:1,column:0},end:{line:1,column:1},source:''},
          name: 'f'
        },
        operator: '=',
        right: {
          type: 'ArrayExpression',
          loc:{start:{line:1,column:5},end:{line:1,column:20},source:''},
          elements: [
            {
              type: 'SpreadElement',
              loc:{start:{line:1,column:6},end:{line:1,column:19},source:''},
              argument: {
                type: 'AssignmentExpression',
                loc:{start:{line:1,column:9},end:{line:1,column:19},source:''},
                left: {
                  type: 'ArrayPattern',
                  loc:{start:{line:1,column:9},end:{line:1,column:14},source:''},
                  elements: [
                    {
                      type: 'Identifier',
                      loc:{start:{line:1,column:11},end:{line:1,column:12},source:''},
                      name: 'x'
                    }
                  ]
                },
                operator: '=',
                right: {
                  type: 'ArrayExpression',
                  loc:{start:{line:1,column:17},end:{line:1,column:19},source:''},
                  elements: []
                }
              }
            }
          ]
        }
      }
    }
  ]
}

tokens (15x):
       IDENT PUNC_EQ PUNC_PAREN_OPEN PUNC_BRACKET_OPEN
       PUNC_DOT_DOT_DOT PUNC_BRACKET_OPEN IDENT PUNC_BRACKET_CLOSE
       PUNC_EQ PUNC_BRACKET_OPEN PUNC_BRACKET_CLOSE PUNC_BRACKET_CLOSE
       PUNC_PAREN_CLOSE PUNC_SEMI
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
((f = [...([x,] = []),]));
````

Produces same AST
