# Tenko parser test case

- Path: tests/testcases/functions/yield_and_await_keyword_cases/generator/arg-name/global_x_x003cyield_awaitx003e_x_x003cregular_async_generator_async_genx003e_x_arg-name_x_obj_method/obj_method_arg_called_yield.md

> :: functions : yield and await keyword cases : generator : arg-name : global x x003cyield awaitx003e x x003cregular async generator async genx003e x arg-name x obj method
>
> ::> obj method arg called yield
>
> barring exceptions -- for all functions and methods goes:
>
> - name of the func keeps outer scope await/yield state. exception: function expressions clear it.
> - args and body explicitly set it according to the type of this function (so async sets await clears yield, etc)
>
> This means you can use `await` as a function name as long as you are not in strict mode and not already inside an async function and it's okay if the function whose name is being defined is actually async itself.
>
> the cases to test are a cross product of:
>
> - `<global, inside async, inside generator>` 
> - `x` 
> - `<yield, await>`
> - `x` 
> - `<regular, async, generator, async gen>`
> - `x` 
> - `<name, arg-name, arg-default, body>`
> - `x`
> - `<class method, obj method, decl, expr, default>`

## Input

`````js
function *as(){ o = {f(yield) {}} }
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:35},source:''},
  body: [
    {
      type: 'FunctionDeclaration',
      loc:{start:{line:1,column:0},end:{line:1,column:35},source:''},
      generator: true,
      async: false,
      id: {
        type: 'Identifier',
        loc:{start:{line:1,column:10},end:{line:1,column:12},source:''},
        name: 'as'
      },
      params: [],
      body: {
        type: 'BlockStatement',
        loc:{start:{line:1,column:14},end:{line:1,column:35},source:''},
        body: [
          {
            type: 'ExpressionStatement',
            loc:{start:{line:1,column:16},end:{line:1,column:33},source:''},
            expression: {
              type: 'AssignmentExpression',
              loc:{start:{line:1,column:16},end:{line:1,column:33},source:''},
              left: {
                type: 'Identifier',
                loc:{start:{line:1,column:16},end:{line:1,column:17},source:''},
                name: 'o'
              },
              operator: '=',
              right: {
                type: 'ObjectExpression',
                loc:{start:{line:1,column:20},end:{line:1,column:33},source:''},
                properties: [
                  {
                    type: 'Property',
                    loc:{start:{line:1,column:21},end:{line:1,column:32},source:''},
                    key: {
                      type: 'Identifier',
                      loc:{start:{line:1,column:21},end:{line:1,column:22},source:''},
                      name: 'f'
                    },
                    kind: 'init',
                    method: true,
                    computed: false,
                    value: {
                      type: 'FunctionExpression',
                      loc:{start:{line:1,column:21},end:{line:1,column:32},source:''},
                      generator: false,
                      async: false,
                      id: null,
                      params: [
                        {
                          type: 'Identifier',
                          loc:{start:{line:1,column:23},end:{line:1,column:28},source:''},
                          name: 'yield'
                        }
                      ],
                      body: {
                        type: 'BlockStatement',
                        loc:{start:{line:1,column:30},end:{line:1,column:32},source:''},
                        body: []
                      }
                    },
                    shorthand: false
                  }
                ]
              }
            }
          }
        ]
      }
    }
  ]
}

tokens (19x):
       ID_function PUNC_STAR ID_as PUNC_PAREN_OPEN PUNC_PAREN_CLOSE
       PUNC_CURLY_OPEN IDENT PUNC_EQ PUNC_CURLY_OPEN IDENT
       PUNC_PAREN_OPEN ID_yield PUNC_PAREN_CLOSE PUNC_CURLY_OPEN
       PUNC_CURLY_CLOSE PUNC_CURLY_CLOSE ASI PUNC_CURLY_CLOSE
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

`````
throws: Parser error!
  Cannot use this name (yield) as a variable name because: Cannot use this reserved word as a variable name in strict mode

function *as(){ o = {f(yield) {}} }
                       ^------- error
`````


### Module goal

Parsed with the module goal.

_Output same as strict mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
function* as() {((o = {f(yield){}}));}
````

Produces same AST
