# Tenko parser test case

- Path: tests/testcases/functions/yield_and_await_keyword_cases/generator/name/global_x_x003cyield_awaitx003e_x_x003cregular_async_generator_async_genx003e_x_name_x_class_method/class_method_can_be_called_await.md

> :: functions : yield and await keyword cases : generator : name : global x x003cyield awaitx003e x x003cregular async generator async genx003e x name x class method
>
> ::> class method can be called await
>
> barring exceptions -- for all functions and methods goes:
>
> - name of the func keeps outer scope await/yield state. exception: function expressions clear it.
> - args and body explicitly set it according to the type of this function (so async sets await clears yield, etc)
>
> This means you can use `await` as a function name as long as you are not in strict mode and not already inside an async function and it's okay if the function whose name is being defined is actually async itself.
>
> the cases to test are a cross product of:
>
> - `<global, inside async, inside generator>` 
> - `x` 
> - `<yield, await>`
> - `x` 
> - `<regular, async, generator, async gen>`
> - `x` 
> - `<name, arg-name, arg-default, body>`
> - `x`
> - `<class method, obj method, decl, expr, default>`

## Input

`````js
function *as(){ class A {await() {}} }
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:38},source:''},
  body: [
    {
      type: 'FunctionDeclaration',
      loc:{start:{line:1,column:0},end:{line:1,column:38},source:''},
      generator: true,
      async: false,
      id: {
        type: 'Identifier',
        loc:{start:{line:1,column:10},end:{line:1,column:12},source:''},
        name: 'as'
      },
      params: [],
      body: {
        type: 'BlockStatement',
        loc:{start:{line:1,column:14},end:{line:1,column:38},source:''},
        body: [
          {
            type: 'ClassDeclaration',
            loc:{start:{line:1,column:16},end:{line:1,column:36},source:''},
            id: {
              type: 'Identifier',
              loc:{start:{line:1,column:22},end:{line:1,column:23},source:''},
              name: 'A'
            },
            superClass: null,
            body: {
              type: 'ClassBody',
              loc:{start:{line:1,column:24},end:{line:1,column:36},source:''},
              body: [
                {
                  type: 'MethodDefinition',
                  loc:{start:{line:1,column:25},end:{line:1,column:35},source:''},
                  key: {
                    type: 'Identifier',
                    loc:{start:{line:1,column:25},end:{line:1,column:30},source:''},
                    name: 'await'
                  },
                  static: false,
                  computed: false,
                  kind: 'method',
                  value: {
                    type: 'FunctionExpression',
                    loc:{start:{line:1,column:25},end:{line:1,column:35},source:''},
                    generator: false,
                    async: false,
                    id: null,
                    params: [],
                    body: {
                      type: 'BlockStatement',
                      loc:{start:{line:1,column:33},end:{line:1,column:35},source:''},
                      body: []
                    }
                  }
                }
              ]
            }
          }
        ]
      }
    }
  ]
}

tokens (17x):
       ID_function PUNC_STAR ID_as PUNC_PAREN_OPEN PUNC_PAREN_CLOSE
       PUNC_CURLY_OPEN ID_class IDENT PUNC_CURLY_OPEN ID_await
       PUNC_PAREN_OPEN PUNC_PAREN_CLOSE PUNC_CURLY_OPEN
       PUNC_CURLY_CLOSE PUNC_CURLY_CLOSE PUNC_CURLY_CLOSE
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
function* as() {class A{await(){};}}
````

Produces same AST
