# Tenko parser test case

- Path: tests/testcases/functions/yield_and_await_keyword_cases/normal_async/arg-name/global_x_x003cyield_awaitx003e_x_x003cregular_async_generator_async_genx003e_x_arg-name_x_expr/generator_func_expr_arg_called_await.md

> :: functions : yield and await keyword cases : normal async : arg-name : global x x003cyield awaitx003e x x003cregular async generator async genx003e x arg-name x expr
>
> ::> generator func expr arg called await
>
> barring exceptions -- for all functions and methods goes:
>
> - name of the func keeps outer scope await/yield state. exception: function expressions clear it.
> - args and body explicitly set it according to the type of this function (so async sets await clears yield, etc)
>
> This means you can use `await` as a function name as long as you are not in strict mode and not already inside an async function and it's okay if the function whose name is being defined is actually async itself.
>
> the cases to test are a cross product of:
>
> - `<global, inside async, inside generator>` 
> - `x` 
> - `<yield, await>`
> - `x` 
> - `<regular, async, generator, async gen>`
> - `x` 
> - `<name, arg-name, arg-default, body>`
> - `x`
> - `<class method, obj method, decl, expr, default>`

## Input

`````js
async function as(){ let f = function *f(await) {} }
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:52},source:''},
  body: [
    {
      type: 'FunctionDeclaration',
      loc:{start:{line:1,column:0},end:{line:1,column:52},source:''},
      generator: false,
      async: true,
      id: {
        type: 'Identifier',
        loc:{start:{line:1,column:15},end:{line:1,column:17},source:''},
        name: 'as'
      },
      params: [],
      body: {
        type: 'BlockStatement',
        loc:{start:{line:1,column:19},end:{line:1,column:52},source:''},
        body: [
          {
            type: 'VariableDeclaration',
            loc:{start:{line:1,column:21},end:{line:1,column:50},source:''},
            kind: 'let',
            declarations: [
              {
                type: 'VariableDeclarator',
                loc:{start:{line:1,column:25},end:{line:1,column:50},source:''},
                id: {
                  type: 'Identifier',
                  loc:{start:{line:1,column:25},end:{line:1,column:26},source:''},
                  name: 'f'
                },
                init: {
                  type: 'FunctionExpression',
                  loc:{start:{line:1,column:29},end:{line:1,column:50},source:''},
                  generator: true,
                  async: false,
                  id: {
                    type: 'Identifier',
                    loc:{start:{line:1,column:39},end:{line:1,column:40},source:''},
                    name: 'f'
                  },
                  params: [
                    {
                      type: 'Identifier',
                      loc:{start:{line:1,column:41},end:{line:1,column:46},source:''},
                      name: 'await'
                    }
                  ],
                  body: {
                    type: 'BlockStatement',
                    loc:{start:{line:1,column:48},end:{line:1,column:50},source:''},
                    body: []
                  }
                }
              }
            ]
          }
        ]
      }
    }
  ]
}

tokens (20x):
       ID_async ID_function ID_as PUNC_PAREN_OPEN PUNC_PAREN_CLOSE
       PUNC_CURLY_OPEN ID_let IDENT PUNC_EQ ID_function PUNC_STAR
       IDENT PUNC_PAREN_OPEN ID_await PUNC_PAREN_CLOSE PUNC_CURLY_OPEN
       PUNC_CURLY_CLOSE ASI PUNC_CURLY_CLOSE
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

`````
throws: Parser error!
  Cannot use this name (await) as a variable name because: Await is illegal as var name with module goal

async function as(){ let f = function *f(await) {} }
                                         ^------- error
`````


### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
async function as() {let f = function* f(await) {};}
````

Produces same AST
