# Tenko parser test case

- Path: tests/testcases/functions/yield_and_await_keyword_cases/normal_async/name/global_x_x003cyield_awaitx003e_x_x003cregular_async_generator_async_genx003e_x_name_x_decl/async_func_decl_can_be_called_yield.md

> :: functions : yield and await keyword cases : normal async : name : global x x003cyield awaitx003e x x003cregular async generator async genx003e x name x decl
>
> ::> async func decl can be called yield
>
> only illegal in strict mode
>
> barring exceptions -- for all functions and methods goes:
>
> - name of the func keeps outer scope await/yield state. exception: function expressions clear it.
> - args and body explicitly set it according to the type of this function (so async sets await clears yield, etc)
>
> This means you can use `await` as a function name as long as you are not in strict mode and not already inside an async function and it's okay if the function whose name is being defined is actually async itself.
>
> the cases to test are a cross product of:
>
> - `<global, inside async, inside generator>` 
> - `x` 
> - `<yield, await>`
> - `x` 
> - `<regular, async, generator, async gen>`
> - `x` 
> - `<name, arg-name, arg-default, body>`
> - `x`
> - `<class method, obj method, decl, expr, default>`

## Input

`````js
async function as(){ async function yield() {} }
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:48},source:''},
  body: [
    {
      type: 'FunctionDeclaration',
      loc:{start:{line:1,column:0},end:{line:1,column:48},source:''},
      generator: false,
      async: true,
      id: {
        type: 'Identifier',
        loc:{start:{line:1,column:15},end:{line:1,column:17},source:''},
        name: 'as'
      },
      params: [],
      body: {
        type: 'BlockStatement',
        loc:{start:{line:1,column:19},end:{line:1,column:48},source:''},
        body: [
          {
            type: 'FunctionDeclaration',
            loc:{start:{line:1,column:21},end:{line:1,column:46},source:''},
            generator: false,
            async: true,
            id: {
              type: 'Identifier',
              loc:{start:{line:1,column:36},end:{line:1,column:41},source:''},
              name: 'yield'
            },
            params: [],
            body: {
              type: 'BlockStatement',
              loc:{start:{line:1,column:44},end:{line:1,column:46},source:''},
              body: []
            }
          }
        ]
      }
    }
  ]
}

tokens (15x):
       ID_async ID_function ID_as PUNC_PAREN_OPEN PUNC_PAREN_CLOSE
       PUNC_CURLY_OPEN ID_async ID_function ID_yield PUNC_PAREN_OPEN
       PUNC_PAREN_CLOSE PUNC_CURLY_OPEN PUNC_CURLY_CLOSE
       PUNC_CURLY_CLOSE
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

`````
throws: Parser error!
  Cannot use this name (yield) as a variable name because: Cannot use this reserved word as a variable name in strict mode

async function as(){ async function yield() {} }
                                    ^------- error
`````


### Module goal

Parsed with the module goal.

_Output same as strict mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
async function as() {async function yield() {}}
````

Produces same AST
