# Tenko parser test case

- Path: tests/testcases/group_or_arrow/arrow/MUST_DESTRUCT_cases/array_without_nesting/in_a_for-of.md

> :: group or arrow : arrow : MUST DESTRUCT cases : array without nesting
>
> ::> in a for-of
>
> I believe the fail cases fail because https://tc39.github.io/ecma262/#prod-DestructuringAssignmentTarget
>
> (The object is treated as an expression, not a pattern, and so the {a=b} is an error as per CoverInitializedName in https://tc39.github.io/ecma262/#sec-object-initializer-static-semantics-early-errors )

## Input

`````js
for ([{x = y}] of y);
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:21},source:''},
  body: [
    {
      type: 'ForOfStatement',
      loc:{start:{line:1,column:0},end:{line:1,column:21},source:''},
      left: {
        type: 'ArrayPattern',
        loc:{start:{line:1,column:5},end:{line:1,column:14},source:''},
        elements: [
          {
            type: 'ObjectPattern',
            loc:{start:{line:1,column:6},end:{line:1,column:13},source:''},
            properties: [
              {
                type: 'Property',
                loc:{start:{line:1,column:7},end:{line:1,column:12},source:''},
                key: {
                  type: 'Identifier',
                  loc:{start:{line:1,column:7},end:{line:1,column:8},source:''},
                  name: 'x'
                },
                kind: 'init',
                method: false,
                computed: false,
                value: {
                  type: 'AssignmentPattern',
                  loc:{start:{line:1,column:7},end:{line:1,column:12},source:''},
                  left: {
                    type: 'Identifier',
                    loc:{start:{line:1,column:7},end:{line:1,column:8},source:''},
                    name: 'x'
                  },
                  right: {
                    type: 'Identifier',
                    loc:{start:{line:1,column:11},end:{line:1,column:12},source:''},
                    name: 'y'
                  }
                },
                shorthand: true
              }
            ]
          }
        ]
      },
      right: {
        type: 'Identifier',
        loc:{start:{line:1,column:18},end:{line:1,column:19},source:''},
        name: 'y'
      },
      await: false,
      body: {
        type: 'EmptyStatement',
        loc:{start:{line:1,column:20},end:{line:1,column:21},source:''}
      }
    }
  ]
}

tokens (14x):
       ID_for PUNC_PAREN_OPEN PUNC_BRACKET_OPEN PUNC_CURLY_OPEN IDENT
       PUNC_EQ IDENT PUNC_CURLY_CLOSE PUNC_BRACKET_CLOSE ID_of IDENT
       PUNC_PAREN_CLOSE PUNC_SEMI
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
for ([{x = y},] of y) ;
````

Produces same AST
