# Tenko parser test case

- Path: tests/testcases/group_or_arrow/arrow/MUST_DESTRUCT_cases/group_toplevel/something_that_MUST_be_a_pattern_as_arrow_head.md

> :: group or arrow : arrow : MUST DESTRUCT cases : group toplevel
>
> ::> something that MUST be a pattern as arrow head
>
> I believe the fail cases fail because https://tc39.github.io/ecma262/#prod-DestructuringAssignmentTarget
>
> (The object is treated as an expression, not a pattern, and so the {a=b} is an error as per CoverInitializedName in https://tc39.github.io/ecma262/#sec-object-initializer-static-semantics-early-errors )

## Input

`````js
({x = y}) => z
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:14},source:''},
  body: [
    {
      type: 'ExpressionStatement',
      loc:{start:{line:1,column:0},end:{line:1,column:14},source:''},
      expression: {
        type: 'ArrowFunctionExpression',
        loc:{start:{line:1,column:0},end:{line:1,column:14},source:''},
        params: [
          {
            type: 'ObjectPattern',
            loc:{start:{line:1,column:1},end:{line:1,column:8},source:''},
            properties: [
              {
                type: 'Property',
                loc:{start:{line:1,column:2},end:{line:1,column:7},source:''},
                key: {
                  type: 'Identifier',
                  loc:{start:{line:1,column:2},end:{line:1,column:3},source:''},
                  name: 'x'
                },
                kind: 'init',
                method: false,
                computed: false,
                value: {
                  type: 'AssignmentPattern',
                  loc:{start:{line:1,column:2},end:{line:1,column:7},source:''},
                  left: {
                    type: 'Identifier',
                    loc:{start:{line:1,column:2},end:{line:1,column:3},source:''},
                    name: 'x'
                  },
                  right: {
                    type: 'Identifier',
                    loc:{start:{line:1,column:6},end:{line:1,column:7},source:''},
                    name: 'y'
                  }
                },
                shorthand: true
              }
            ]
          }
        ],
        id: null,
        generator: false,
        async: false,
        expression: true,
        body: {
          type: 'Identifier',
          loc:{start:{line:1,column:13},end:{line:1,column:14},source:''},
          name: 'z'
        }
      }
    }
  ]
}

tokens (11x):
       PUNC_PAREN_OPEN PUNC_CURLY_OPEN IDENT PUNC_EQ IDENT
       PUNC_CURLY_CLOSE PUNC_PAREN_CLOSE PUNC_EQ_GT IDENT ASI
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
({x = y}) => (z);
````

Produces same AST
