# Tenko parser test case

- Path: tests/testcases/html_comments/close_comment/html_close_comment_should_cause_asi.md

> :: html comments : close comment
>
> ::> html close comment should cause asi
>
> https://tc39.github.io/ecma262/#sec-html-like-comments
>
> Similar to a MultiLineComment that contains a line terminator code point, a SingleLineHTMLCloseComment is considered to be a LineTerminator for purposes of parsing by the syntactic grammar.
>
> note: the SingleLineHTMLCloseComment is not "just" `-->` and so arbitrary occurrences of that token do not yield a pseudo-newline (in particular, I don't think it closes an html open...)

## Input

`````js
a
-->foo bar baz
b
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
throws: Parser error!
  Expected to parse a value

a
-->foo bar baz
  ^------- error

b
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:3,column:1},source:''},
  body: [
    {
      type: 'ExpressionStatement',
      loc:{start:{line:1,column:0},end:{line:1,column:1},source:''},
      expression: {
        type: 'Identifier',
        loc:{start:{line:1,column:0},end:{line:1,column:1},source:''},
        name: 'a'
      }
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:3,column:0},end:{line:3,column:1},source:''},
      expression: {
        type: 'Identifier',
        loc:{start:{line:3,column:0},end:{line:3,column:1},source:''},
        name: 'b'
      }
    }
  ]
}

tokens (5x):
       IDENT ASI IDENT ASI
`````


## AST Printer

Printer output different from input [web]:

````js
(a);
(b);
````

Produces same AST
