# Tenko parser test case

- Path: tests/testcases/html_comments/open_comment/html_open_actually_has_no_close.md

> :: html comments : open comment
>
> ::> html open actually has no close
>
> but only because you cant decl pre and postfix dec the same var (well and the rest)
>
> https://tc39.github.io/ecma262/#sec-html-like-comments
>
> Similar to a MultiLineComment that contains a line terminator code point, a SingleLineHTMLCloseComment is considered to be a LineTerminator for purposes of parsing by the syntactic grammar.
>
> note: the SingleLineHTMLCloseComment is not "just" `-->` and so arbitrary occurrences of that token do not yield a pseudo-newline (in particular, I don't think it closes an html open...)

## Input

`````js
call(); <!-- foo --> a b c
f()
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
throws: Parser error!
  Expected to parse a value

call(); <!-- foo --> a b c
        ^------- error

f()
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:2,column:3},source:''},
  body: [
    {
      type: 'ExpressionStatement',
      loc:{start:{line:1,column:0},end:{line:1,column:7},source:''},
      expression: {
        type: 'CallExpression',
        loc:{start:{line:1,column:0},end:{line:1,column:6},source:''},
        callee: {
          type: 'Identifier',
          loc:{start:{line:1,column:0},end:{line:1,column:4},source:''},
          name: 'call'
        },
        arguments: []
      }
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:2,column:0},end:{line:2,column:3},source:''},
      expression: {
        type: 'CallExpression',
        loc:{start:{line:2,column:0},end:{line:2,column:3},source:''},
        callee: {
          type: 'Identifier',
          loc:{start:{line:2,column:0},end:{line:2,column:1},source:''},
          name: 'f'
        },
        arguments: []
      }
    }
  ]
}

tokens (9x):
       IDENT PUNC_PAREN_OPEN PUNC_PAREN_CLOSE PUNC_SEMI IDENT
       PUNC_PAREN_OPEN PUNC_PAREN_CLOSE ASI
`````


## AST Printer

Printer output different from input [web]:

````js
((call)());
((f)());
````

Produces same AST
