# Tenko parser test case

- Path: tests/testcases/if_statement/simple_if_without_else_2.md

> :: if statement
>
> ::> simple if without else 2

## Input

`````js
if (foo) bar; else doo;
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:23},source:''},
  body: [
    {
      type: 'IfStatement',
      loc:{start:{line:1,column:0},end:{line:1,column:23},source:''},
      test: {
        type: 'Identifier',
        loc:{start:{line:1,column:4},end:{line:1,column:7},source:''},
        name: 'foo'
      },
      consequent: {
        type: 'ExpressionStatement',
        loc:{start:{line:1,column:9},end:{line:1,column:13},source:''},
        expression: {
          type: 'Identifier',
          loc:{start:{line:1,column:9},end:{line:1,column:12},source:''},
          name: 'bar'
        }
      },
      alternate: {
        type: 'ExpressionStatement',
        loc:{start:{line:1,column:19},end:{line:1,column:23},source:''},
        expression: {
          type: 'Identifier',
          loc:{start:{line:1,column:19},end:{line:1,column:22},source:''},
          name: 'doo'
        }
      }
    }
  ]
}

tokens (10x):
       ID_if PUNC_PAREN_OPEN IDENT PUNC_PAREN_CLOSE IDENT PUNC_SEMI
       ID_else IDENT PUNC_SEMI
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
if (foo) (bar); else (doo);
````

Produces same AST
