# Tenko parser test case

- Path: tests/testcases/import_declaration/simple_import_of_an_aliased_default_2.md

> :: import declaration
>
> ::> simple import of an aliased default 2

## Input

`````js
import x, * as a from "y"
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
throws: Parser error!
  The `import` keyword can only be used with the module goal

import x, * as a from "y"
       ^------- error
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:25},source:''},
  body: [
    {
      type: 'ImportDeclaration',
      loc:{start:{line:1,column:0},end:{line:1,column:25},source:''},
      specifiers: [
        {
          type: 'ImportDefaultSpecifier',
          loc:{start:{line:1,column:7},end:{line:1,column:8},source:''},
          local: {
            type: 'Identifier',
            loc:{start:{line:1,column:7},end:{line:1,column:8},source:''},
            name: 'x'
          }
        },
        {
          type: 'ImportNamespaceSpecifier',
          loc:{start:{line:1,column:10},end:{line:1,column:16},source:''},
          local: {
            type: 'Identifier',
            loc:{start:{line:1,column:15},end:{line:1,column:16},source:''},
            name: 'a'
          }
        }
      ],
      source: {
        type: 'Literal',
        loc:{start:{line:1,column:22},end:{line:1,column:25},source:''},
        value: 'y',
        raw: '"y"'
      }
    }
  ]
}

tokens (10x):
       ID_import IDENT PUNC_COMMA PUNC_STAR ID_as IDENT ID_from
       STRING_DOUBLE ASI
`````


### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [module]:

````js
import x, * as a from "y";
````

Produces same AST
