# Tenko parser test case

- Path: tests/testcases/import_dynamic/piggy_yield_var.md

> :: import dynamic
>
> ::> piggy yield var
>
> Make sure `yield` in the arg is detected when `import()` is used in a parameter default
>
> (Note Whether `await` and `yield` are a keyword or var inside the arg defaults is determined by the type of function that is being declared, not the parent function)

## Input

`````js
function f(x = import(yield)) {}
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:32},source:''},
  body: [
    {
      type: 'FunctionDeclaration',
      loc:{start:{line:1,column:0},end:{line:1,column:32},source:''},
      generator: false,
      async: false,
      id: {
        type: 'Identifier',
        loc:{start:{line:1,column:9},end:{line:1,column:10},source:''},
        name: 'f'
      },
      params: [
        {
          type: 'AssignmentPattern',
          loc:{start:{line:1,column:11},end:{line:1,column:28},source:''},
          left: {
            type: 'Identifier',
            loc:{start:{line:1,column:11},end:{line:1,column:12},source:''},
            name: 'x'
          },
          right: {
            type: 'CallExpression',
            loc:{start:{line:1,column:15},end:{line:1,column:28},source:''},
            callee: {
              type: 'Import',
              loc:{start:{line:1,column:15},end:{line:1,column:21},source:''}
            },
            arguments: [
              {
                type: 'Identifier',
                loc:{start:{line:1,column:22},end:{line:1,column:27},source:''},
                name: 'yield'
              }
            ]
          }
        }
      ],
      body: {
        type: 'BlockStatement',
        loc:{start:{line:1,column:30},end:{line:1,column:32},source:''},
        body: []
      }
    }
  ]
}

tokens (13x):
       ID_function IDENT PUNC_PAREN_OPEN IDENT PUNC_EQ ID_import
       PUNC_PAREN_OPEN ID_yield PUNC_PAREN_CLOSE PUNC_PAREN_CLOSE
       PUNC_CURLY_OPEN PUNC_CURLY_CLOSE
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

`````
throws: Parser error!
  Cannot use `yield` outside of generator functions when in strict mode

function f(x = import(yield)) {}
                           ^------- error
`````


### Module goal

Parsed with the module goal.

_Output same as strict mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output was same as input [sloppy]
