# Tenko parser test case

- Path: tests/testcases/labels/await/defined_outside_of_async_as_break_label_inside_async.md

> :: labels : await
>
> ::> defined outside of async as break label inside async
>
> red herring; label sets do not cross function boundaries ;) so label is undefined and the break crashes

## Input

`````js
await: { async function f(){ break await; } }
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
throws: Parser error!
  The label (`await`) for this `break` was not defined in the current label set, which is illegal

await: { async function f(){ break await; } }
                                   ^------- error
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

`````
throws: Parser error!
  Cannot use this name (await) as a variable name because: Await is illegal as var name with module goal

await: { async function f(){ break await; } }
     ^------- error
`````


### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._
