# Tenko parser test case

- Path: tests/testcases/labels/duplicate_reserved_strict_mode_keyword.md

> :: labels
>
> ::> duplicate reserved strict mode keyword
>
> Regression found by fuzzer
>
> The label set is not block scoped, it is statement-tree scoped

## Input

`````js
try{}catch{}finally{package:;package:for(;;);}
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:46},source:''},
  body: [
    {
      type: 'TryStatement',
      loc:{start:{line:1,column:0},end:{line:1,column:46},source:''},
      block: {
        type: 'BlockStatement',
        loc:{start:{line:1,column:3},end:{line:1,column:5},source:''},
        body: []
      },
      handler: {
        type: 'CatchClause',
        loc:{start:{line:1,column:5},end:{line:1,column:12},source:''},
        param: null,
        body: {
          type: 'BlockStatement',
          loc:{start:{line:1,column:10},end:{line:1,column:12},source:''},
          body: []
        }
      },
      finalizer: {
        type: 'BlockStatement',
        loc:{start:{line:1,column:19},end:{line:1,column:46},source:''},
        body: [
          {
            type: 'LabeledStatement',
            loc:{start:{line:1,column:20},end:{line:1,column:29},source:''},
            label: {
              type: 'Identifier',
              loc:{start:{line:1,column:20},end:{line:1,column:27},source:''},
              name: 'package'
            },
            body: {
              type: 'EmptyStatement',
              loc:{start:{line:1,column:28},end:{line:1,column:29},source:''}
            }
          },
          {
            type: 'LabeledStatement',
            loc:{start:{line:1,column:29},end:{line:1,column:45},source:''},
            label: {
              type: 'Identifier',
              loc:{start:{line:1,column:29},end:{line:1,column:36},source:''},
              name: 'package'
            },
            body: {
              type: 'ForStatement',
              loc:{start:{line:1,column:37},end:{line:1,column:45},source:''},
              init: null,
              test: null,
              update: null,
              body: {
                type: 'EmptyStatement',
                loc:{start:{line:1,column:44},end:{line:1,column:45},source:''}
              }
            }
          }
        ]
      }
    }
  ]
}

tokens (21x):
       ID_try PUNC_CURLY_OPEN PUNC_CURLY_CLOSE ID_catch
       PUNC_CURLY_OPEN PUNC_CURLY_CLOSE ID_finally PUNC_CURLY_OPEN
       ID_package PUNC_COLON PUNC_SEMI ID_package PUNC_COLON ID_for
       PUNC_PAREN_OPEN PUNC_SEMI PUNC_SEMI PUNC_PAREN_CLOSE PUNC_SEMI
       PUNC_CURLY_CLOSE
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

`````
throws: Parser error!
  Cannot use this name (package) as a variable name because: Cannot use this reserved word as a variable name in strict mode

try{}catch{}finally{package:;package:for(;;);}
                           ^------- error
`````


### Module goal

Parsed with the module goal.

_Output same as strict mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
try {} catch {} finally {package: ;
package: for (;;) ;}
````

Produces same AST
