# Tenko parser test case

- Path: tests/testcases/let_declaration/binding_generic/as_a_statement/regular_vars/asi_can_not_trigger_if_next_token_is_ident.md

> :: let declaration : binding generic : as a statement : regular vars
>
> ::> asi can not trigger if next token is ident
>
> ASI should not trigger because the next token after `let` does not trigger a syntax error. That only happens at the parenthesis, but the spec does not tell/allow the parser to backtrack to correct for the mistake.
>
> Instead a syntax error is triggered when the parenthesis are seen and the possible valid `let;foo();` is never considered.

## Input

`````js
let
foo()
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
throws: Parser error!
  Unable to ASI, token: {# PUNC_PAREN_OPEN : nl=N pos=7:8 loc=3:2 `(`#}

let
foo()
   ^------- error
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._
