# Tenko parser test case

- Path: tests/testcases/let_declaration/binding_generic/in_a_for-header/destructuring/regular_for-loop/array/two_vars_with_eliding_comma.md

> :: let declaration : binding generic : in a for-header : destructuring : regular for-loop : array
>
> ::> two vars with eliding comma

## Input

`````js
for (let [foo,,bar] = arr;;);
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:29},source:''},
  body: [
    {
      type: 'ForStatement',
      loc:{start:{line:1,column:0},end:{line:1,column:29},source:''},
      init: {
        type: 'VariableDeclaration',
        loc:{start:{line:1,column:5},end:{line:1,column:25},source:''},
        kind: 'let',
        declarations: [
          {
            type: 'VariableDeclarator',
            loc:{start:{line:1,column:9},end:{line:1,column:25},source:''},
            id: {
              type: 'ArrayPattern',
              loc:{start:{line:1,column:9},end:{line:1,column:19},source:''},
              elements: [
                {
                  type: 'Identifier',
                  loc:{start:{line:1,column:10},end:{line:1,column:13},source:''},
                  name: 'foo'
                },
                null,
                {
                  type: 'Identifier',
                  loc:{start:{line:1,column:15},end:{line:1,column:18},source:''},
                  name: 'bar'
                }
              ]
            },
            init: {
              type: 'Identifier',
              loc:{start:{line:1,column:22},end:{line:1,column:25},source:''},
              name: 'arr'
            }
          }
        ]
      },
      test: null,
      update: null,
      body: {
        type: 'EmptyStatement',
        loc:{start:{line:1,column:28},end:{line:1,column:29},source:''}
      }
    }
  ]
}

tokens (16x):
       ID_for PUNC_PAREN_OPEN ID_let PUNC_BRACKET_OPEN IDENT
       PUNC_COMMA PUNC_COMMA IDENT PUNC_BRACKET_CLOSE PUNC_EQ IDENT
       PUNC_SEMI PUNC_SEMI PUNC_PAREN_CLOSE PUNC_SEMI
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
for (let [foo, , bar,] = arr;;) ;
````

Produces same AST
