# Tenko parser test case

- Path: tests/testcases/let_declaration/binding_generic/in_export_decl/destructuring/array/rest_operator/second_param_rest_on_a_nested_destruct.md

> :: let declaration : binding generic : in export decl : destructuring : array : rest operator
>
> ::> second param rest on a nested destruct

## Input

`````js
export let [x, ...[foo, bar]] = obj;
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
throws: Parser error!
  The `export` keyword can only be used with the module goal

export let [x, ...[foo, bar]] = obj;
^------- error
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:36},source:''},
  body: [
    {
      type: 'ExportNamedDeclaration',
      loc:{start:{line:1,column:0},end:{line:1,column:36},source:''},
      specifiers: [],
      declaration: {
        type: 'VariableDeclaration',
        loc:{start:{line:1,column:7},end:{line:1,column:36},source:''},
        kind: 'let',
        declarations: [
          {
            type: 'VariableDeclarator',
            loc:{start:{line:1,column:11},end:{line:1,column:35},source:''},
            id: {
              type: 'ArrayPattern',
              loc:{start:{line:1,column:11},end:{line:1,column:29},source:''},
              elements: [
                {
                  type: 'Identifier',
                  loc:{start:{line:1,column:12},end:{line:1,column:13},source:''},
                  name: 'x'
                },
                {
                  type: 'RestElement',
                  loc:{start:{line:1,column:15},end:{line:1,column:28},source:''},
                  argument: {
                    type: 'ArrayPattern',
                    loc:{start:{line:1,column:18},end:{line:1,column:28},source:''},
                    elements: [
                      {
                        type: 'Identifier',
                        loc:{start:{line:1,column:19},end:{line:1,column:22},source:''},
                        name: 'foo'
                      },
                      {
                        type: 'Identifier',
                        loc:{start:{line:1,column:24},end:{line:1,column:27},source:''},
                        name: 'bar'
                      }
                    ]
                  }
                }
              ]
            },
            init: {
              type: 'Identifier',
              loc:{start:{line:1,column:32},end:{line:1,column:35},source:''},
              name: 'obj'
            }
          }
        ]
      },
      source: null
    }
  ]
}

tokens (16x):
       ID_export ID_let PUNC_BRACKET_OPEN IDENT PUNC_COMMA
       PUNC_DOT_DOT_DOT PUNC_BRACKET_OPEN IDENT PUNC_COMMA IDENT
       PUNC_BRACKET_CLOSE PUNC_BRACKET_CLOSE PUNC_EQ IDENT PUNC_SEMI
`````


### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [module]:

````js
export let [x, ...[foo, bar,]] = obj;
````

Produces same AST
