# Tenko parser test case

- Path: tests/testcases/let_declaration/binding_generic/in_export_decl/destructuring/object/double_destruct_both_with_rename.md

> :: let declaration : binding generic : in export decl : destructuring : object
>
> ::> double destruct both with rename

## Input

`````js
export let {x : y, z : a} = obj;
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
throws: Parser error!
  The `export` keyword can only be used with the module goal

export let {x : y, z : a} = obj;
^------- error
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:32},source:''},
  body: [
    {
      type: 'ExportNamedDeclaration',
      loc:{start:{line:1,column:0},end:{line:1,column:32},source:''},
      specifiers: [],
      declaration: {
        type: 'VariableDeclaration',
        loc:{start:{line:1,column:7},end:{line:1,column:32},source:''},
        kind: 'let',
        declarations: [
          {
            type: 'VariableDeclarator',
            loc:{start:{line:1,column:11},end:{line:1,column:31},source:''},
            id: {
              type: 'ObjectPattern',
              loc:{start:{line:1,column:11},end:{line:1,column:25},source:''},
              properties: [
                {
                  type: 'Property',
                  loc:{start:{line:1,column:12},end:{line:1,column:17},source:''},
                  key: {
                    type: 'Identifier',
                    loc:{start:{line:1,column:12},end:{line:1,column:13},source:''},
                    name: 'x'
                  },
                  kind: 'init',
                  method: false,
                  computed: false,
                  value: {
                    type: 'Identifier',
                    loc:{start:{line:1,column:16},end:{line:1,column:17},source:''},
                    name: 'y'
                  },
                  shorthand: false
                },
                {
                  type: 'Property',
                  loc:{start:{line:1,column:19},end:{line:1,column:24},source:''},
                  key: {
                    type: 'Identifier',
                    loc:{start:{line:1,column:19},end:{line:1,column:20},source:''},
                    name: 'z'
                  },
                  kind: 'init',
                  method: false,
                  computed: false,
                  value: {
                    type: 'Identifier',
                    loc:{start:{line:1,column:23},end:{line:1,column:24},source:''},
                    name: 'a'
                  },
                  shorthand: false
                }
              ]
            },
            init: {
              type: 'Identifier',
              loc:{start:{line:1,column:28},end:{line:1,column:31},source:''},
              name: 'obj'
            }
          }
        ]
      },
      source: null
    }
  ]
}

tokens (15x):
       ID_export ID_let PUNC_CURLY_OPEN IDENT PUNC_COLON IDENT
       PUNC_COMMA IDENT PUNC_COLON IDENT PUNC_CURLY_CLOSE PUNC_EQ
       IDENT PUNC_SEMI
`````


### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [module]:

````js
export let {x:y, z:a} = obj;
````

Produces same AST
