# Tenko parser test case

- Path: tests/testcases/let_declaration/let_as_identifier_in_sloppy_mode/let_as_var_name/do_let_while.md

> :: let declaration : let as identifier in sloppy mode : let as var name
>
> ::> do let while
>
> By fuzzer, zeparser only
>
> The newline after `let` should trigger ASI in sloppy mode and not bind the next ident if that was illegal.
>
> In strict mode this is always an error regardless.
>
> In do-while the sub-statement (in sloppy mode in this case the expression `let`) would require either a newline or an explicit semi-colon.
>
> So this is still an error due to ASI not applying.

## Input

`````js
do let while(x)
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
throws: Parser error!
  Unable to ASI, token: {# ID_while : nl=N pos=7:12 loc=7:1 `while`#}

do let while(x)
       ^------- error
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

`````
throws: Parser error!
  `let` declaration not allowed here and `let` cannot be a regular var or label name in strict mode

do let while(x)
       ^------- error
`````


### Module goal

Parsed with the module goal.

_Output same as strict mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._
