# Tenko parser test case

- Path: tests/testcases/let_declaration/let_as_identifier_in_sloppy_mode/let_as_var_name/let_throw.md

> :: let declaration : let as identifier in sloppy mode : let as var name
>
> ::> let throw
>
> By fuzzer, zeparser only
>
> The newline after `let` should trigger ASI in sloppy mode and not bind a var named `throw`. It will try this in strict/module so it'll be an error there. 

## Input

`````js
let
throw y
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
throws: Parser error!
  `let` must be a declaration in strict mode but the next ident is a reserved keyword (`throw`)

let
throw y
^------- error
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._
