# Tenko parser test case

- Path: tests/testcases/let_declaration/let_as_identifier_in_sloppy_mode/x0060letx0060_is_a_decl_and_in_sub_statement_should_result_in_x0060letx0060_variable_expression/base_case.md

> :: let declaration : let as identifier in sloppy mode : x0060letx0060 is a decl and in sub statement should result in x0060letx0060 variable expression
>
> ::> base case
>
> See section E: https://tc39.github.io/ecma262/#sec-additions-and-changes-that-introduce-incompatibilities-with-prior-editions
>
> > 13.2: In ECMAScript 2015, a StatementList beginning with the token let followed by the input elements LineTerminator then Identifier is the start of a LexicalDeclaration. In previous editions, automatic semicolon insertion would always insert a semicolon before the Identifier input element.
>
> > 13.5: In ECMAScript 2015, a StatementListItem beginning with the token let followed by the token [ is the start of a LexicalDeclaration. In previous editions such a sequence would be the start of an ExpressionStatement.
>
> > 13.7: In ECMAScript 2015, if the ( token of a for statement is immediately followed by the token sequence let [ then the let is treated as the start of a LexicalDeclaration. In previous editions such a token sequence would be the start of an Expression.
>
> > 13.7: In ECMAScript 2015, if the ( token of a for-in statement is immediately followed by the token sequence let [ then the let is treated as the start of a ForDeclaration. In previous editions such a token sequence would be the start of an LeftHandSideExpression.
>
> (note: the spec doesn't explicitly allow `let` as a var name but rather forbids it under certain situations. For example: in strict mode and as let/const names)

## Input

`````js
if (x) let;
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:11},source:''},
  body: [
    {
      type: 'IfStatement',
      loc:{start:{line:1,column:0},end:{line:1,column:11},source:''},
      test: {
        type: 'Identifier',
        loc:{start:{line:1,column:4},end:{line:1,column:5},source:''},
        name: 'x'
      },
      consequent: {
        type: 'ExpressionStatement',
        loc:{start:{line:1,column:7},end:{line:1,column:11},source:''},
        expression: {
          type: 'Identifier',
          loc:{start:{line:1,column:7},end:{line:1,column:10},source:''},
          name: 'let'
        }
      },
      alternate: null
    }
  ]
}

tokens (7x):
       ID_if PUNC_PAREN_OPEN IDENT PUNC_PAREN_CLOSE ID_let PUNC_SEMI
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

`````
throws: Parser error!
  `let` declaration not allowed here and `let` cannot be a regular var or label name in strict mode

if (x) let;
          ^------- error
`````


### Module goal

Parsed with the module goal.

_Output same as strict mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
if (x) (let);
````

Produces same AST
