# Tenko parser test case

- Path: tests/testcases/lexer_cases/numbers/legacy_octal/silly_prop.md

> :: lexer cases : numbers : legacy octal
>
> ::> silly prop
>
> Dot fraction is only supported for decimals
>
> Exponentials is only valid for decimals as well
>
> So `013.e013` is actually the octal `013` followed by a dot punctuator which starts a property access and then the property name identifier `e013`. In web.

## Input

`````js
034.e034
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:8},source:''},
  body: [
    {
      type: 'ExpressionStatement',
      loc:{start:{line:1,column:0},end:{line:1,column:8},source:''},
      expression: {
        type: 'MemberExpression',
        loc:{start:{line:1,column:0},end:{line:1,column:8},source:''},
        object: {
          type: 'Literal',
          loc:{start:{line:1,column:0},end:{line:1,column:3},source:''},
          value: 28,
          raw: '034'
        },
        property: {
          type: 'Identifier',
          loc:{start:{line:1,column:4},end:{line:1,column:8},source:''},
          name: 'e034'
        },
        computed: false
      }
    }
  ]
}

tokens (5x):
       NUMBER_OLD PUNC_DOT IDENT ASI
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

`````
throws: Lexer error!
    "Illegal" octal escape in strict mode

034.e034
^------- error
`````


### Module goal

Parsed with the module goal.

_Output same as strict mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
((034).e034);
````

Produces same AST
