# Tenko parser test case

- Path: tests/testcases/lexer_cases/regexesn/atom_back_reference/1.pass.md

> :: lexer cases : regexesn : atom back reference
>
> ::> 1.pass
>
> Imported lexer test
>
> backreference anywhere with 1 capturing group

## PASS

## Input

`````js
/\1(a)/
;
/(a)\1/
;
/(\1)/
;
/\1x(a)/
;
/(a)x\1/
;
/(a\1b)/
;
/0\1(a)/
;
/4\1(a)/
;
/(a)|\1/
;
/\1|(a)/
;
/(\1|a)/
;
/(a|\1)/
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:23,column:8},source:''},
  body: [
    {
      type: 'ExpressionStatement',
      loc:{start:{line:1,column:0},end:{line:2,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:1,column:0},end:{line:1,column:7},source:''},
        value: null,
        regex: { pattern: '\\1(a)', flags: '' },
        raw: '/\\1(a)/'
      }
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:3,column:0},end:{line:4,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:3,column:0},end:{line:3,column:7},source:''},
        value: null,
        regex: { pattern: '(a)\\1', flags: '' },
        raw: '/(a)\\1/'
      }
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:5,column:0},end:{line:6,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:5,column:0},end:{line:5,column:6},source:''},
        value: null,
        regex: { pattern: '(\\1)', flags: '' },
        raw: '/(\\1)/'
      }
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:7,column:0},end:{line:8,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:7,column:0},end:{line:7,column:8},source:''},
        value: null,
        regex: { pattern: '\\1x(a)', flags: '' },
        raw: '/\\1x(a)/'
      }
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:9,column:0},end:{line:10,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:9,column:0},end:{line:9,column:8},source:''},
        value: null,
        regex: { pattern: '(a)x\\1', flags: '' },
        raw: '/(a)x\\1/'
      }
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:11,column:0},end:{line:12,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:11,column:0},end:{line:11,column:8},source:''},
        value: null,
        regex: { pattern: '(a\\1b)', flags: '' },
        raw: '/(a\\1b)/'
      }
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:13,column:0},end:{line:14,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:13,column:0},end:{line:13,column:8},source:''},
        value: null,
        regex: { pattern: '0\\1(a)', flags: '' },
        raw: '/0\\1(a)/'
      }
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:15,column:0},end:{line:16,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:15,column:0},end:{line:15,column:8},source:''},
        value: null,
        regex: { pattern: '4\\1(a)', flags: '' },
        raw: '/4\\1(a)/'
      }
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:17,column:0},end:{line:18,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:17,column:0},end:{line:17,column:8},source:''},
        value: null,
        regex: { pattern: '(a)|\\1', flags: '' },
        raw: '/(a)|\\1/'
      }
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:19,column:0},end:{line:20,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:19,column:0},end:{line:19,column:8},source:''},
        value: null,
        regex: { pattern: '\\1|(a)', flags: '' },
        raw: '/\\1|(a)/'
      }
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:21,column:0},end:{line:22,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:21,column:0},end:{line:21,column:8},source:''},
        value: null,
        regex: { pattern: '(\\1|a)', flags: '' },
        raw: '/(\\1|a)/'
      }
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:23,column:0},end:{line:23,column:8},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:23,column:0},end:{line:23,column:8},source:''},
        value: null,
        regex: { pattern: '(a|\\1)', flags: '' },
        raw: '/(a|\\1)/'
      }
    }
  ]
}

tokens (25x):
       REGEXN PUNC_SEMI REGEXN PUNC_SEMI REGEXN PUNC_SEMI REGEXN
       PUNC_SEMI REGEXN PUNC_SEMI REGEXN PUNC_SEMI REGEXN PUNC_SEMI
       REGEXN PUNC_SEMI REGEXN PUNC_SEMI REGEXN PUNC_SEMI REGEXN
       PUNC_SEMI REGEXN ASI
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
/\1(a)/;
/(a)\1/;
/(\1)/;
/\1x(a)/;
/(a)x\1/;
/(a\1b)/;
/0\1(a)/;
/4\1(a)/;
/(a)|\1/;
/\1|(a)/;
/(\1|a)/;
/(a|\1)/;
````

Produces same AST
