# Tenko parser test case

- Path: tests/testcases/lexer_cases/regexesn/atom_digit_escape/1.pass.md

> :: lexer cases : regexesn : atom digit escape
>
> ::> 1.pass
>
> Imported lexer test
>
> escaped zero is a NUL and not a back reference

## PASS

## Input

`````js
/\0/
;
/a\0/
;
/\0b/
;
/a\0b/
;
/(a)\0/
;
/\0(b)/
;
/(\0)/
;
/(0\0)/
;
/(1\0)/
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:17,column:7},source:''},
  body: [
    {
      type: 'ExpressionStatement',
      loc:{start:{line:1,column:0},end:{line:2,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:1,column:0},end:{line:1,column:4},source:''},
        value: null,
        regex: { pattern: '\\0', flags: '' },
        raw: '/\\0/'
      }
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:3,column:0},end:{line:4,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:3,column:0},end:{line:3,column:5},source:''},
        value: null,
        regex: { pattern: 'a\\0', flags: '' },
        raw: '/a\\0/'
      }
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:5,column:0},end:{line:6,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:5,column:0},end:{line:5,column:5},source:''},
        value: null,
        regex: { pattern: '\\0b', flags: '' },
        raw: '/\\0b/'
      }
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:7,column:0},end:{line:8,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:7,column:0},end:{line:7,column:6},source:''},
        value: null,
        regex: { pattern: 'a\\0b', flags: '' },
        raw: '/a\\0b/'
      }
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:9,column:0},end:{line:10,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:9,column:0},end:{line:9,column:7},source:''},
        value: null,
        regex: { pattern: '(a)\\0', flags: '' },
        raw: '/(a)\\0/'
      }
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:11,column:0},end:{line:12,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:11,column:0},end:{line:11,column:7},source:''},
        value: null,
        regex: { pattern: '\\0(b)', flags: '' },
        raw: '/\\0(b)/'
      }
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:13,column:0},end:{line:14,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:13,column:0},end:{line:13,column:6},source:''},
        value: null,
        regex: { pattern: '(\\0)', flags: '' },
        raw: '/(\\0)/'
      }
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:15,column:0},end:{line:16,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:15,column:0},end:{line:15,column:7},source:''},
        value: null,
        regex: { pattern: '(0\\0)', flags: '' },
        raw: '/(0\\0)/'
      }
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:17,column:0},end:{line:17,column:7},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:17,column:0},end:{line:17,column:7},source:''},
        value: null,
        regex: { pattern: '(1\\0)', flags: '' },
        raw: '/(1\\0)/'
      }
    }
  ]
}

tokens (19x):
       REGEXN PUNC_SEMI REGEXN PUNC_SEMI REGEXN PUNC_SEMI REGEXN
       PUNC_SEMI REGEXN PUNC_SEMI REGEXN PUNC_SEMI REGEXN PUNC_SEMI
       REGEXN PUNC_SEMI REGEXN ASI
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
/\0/;
/a\0/;
/\0b/;
/a\0b/;
/(a)\0/;
/\0(b)/;
/(\0)/;
/(0\0)/;
/(1\0)/;
````

Produces same AST
