# Tenko parser test case

- Path: tests/testcases/lexer_cases/regexesn/charclass_escapes/6.pass.md

> :: lexer cases : regexesn : charclass escapes
>
> ::> 6.pass
>
> Imported lexer test
>
> escaped dash in char class is only valid with u flag or in web-compat mode

## Input

`````js
/[\-]/
;
/[a\-c]/
;
/[\-c]/
;
/[a\-b]/
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
throws: Lexer error!
    Regex: Escaping a dash in a char class is not allowed; Regex body had an escape that is only valid with an u-flag, but it had no u-flag

/[\-]/
^------- error

;
/[a\-c]/
;
/[\-c]/
;
/[a\-b]/
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:7,column:8},source:''},
  body: [
    {
      type: 'ExpressionStatement',
      loc:{start:{line:1,column:0},end:{line:2,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:1,column:0},end:{line:1,column:6},source:''},
        value: null,
        regex: { pattern: '[\\-]', flags: '' },
        raw: '/[\\-]/'
      }
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:3,column:0},end:{line:4,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:3,column:0},end:{line:3,column:8},source:''},
        value: null,
        regex: { pattern: '[a\\-c]', flags: '' },
        raw: '/[a\\-c]/'
      }
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:5,column:0},end:{line:6,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:5,column:0},end:{line:5,column:7},source:''},
        value: null,
        regex: { pattern: '[\\-c]', flags: '' },
        raw: '/[\\-c]/'
      }
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:7,column:0},end:{line:7,column:8},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:7,column:0},end:{line:7,column:8},source:''},
        value: null,
        regex: { pattern: '[a\\-b]', flags: '' },
        raw: '/[a\\-b]/'
      }
    }
  ]
}

tokens (9x):
       REGEXN PUNC_SEMI REGEXN PUNC_SEMI REGEXN PUNC_SEMI REGEXN ASI
`````


## AST Printer

Printer output different from input [web]:

````js
/[\-]/;
/[a\-c]/;
/[\-c]/;
/[a\-b]/;
````

Produces same AST
