# Tenko parser test case

- Path: tests/testcases/lexer_cases/strings_double/hex_escapes/1.pass.md

> :: lexer cases : strings double : hex escapes
>
> ::> 1.pass
>
> Imported lexer test

## PASS

## Input

`````js
"\x00"
;
"\x12"
;
"\x34"
;
"\x56"
;
"\x78"
;
"\x9a"
;
"\xAb"
;
"\xBc"
;
"\xCd"
;
"\xDe"
;
"\xEf"
;
"\xF0"
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:23,column:6},source:''},
  body: [
    {
      type: 'ExpressionStatement',
      loc:{start:{line:1,column:0},end:{line:2,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:1,column:0},end:{line:1,column:6},source:''},
        value: '\u0000',
        raw: '"\\x00"'
      },
      directive: '\\x00'
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:3,column:0},end:{line:4,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:3,column:0},end:{line:3,column:6},source:''},
        value: '\u0012',
        raw: '"\\x12"'
      },
      directive: '\\x12'
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:5,column:0},end:{line:6,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:5,column:0},end:{line:5,column:6},source:''},
        value: '4',
        raw: '"\\x34"'
      },
      directive: '\\x34'
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:7,column:0},end:{line:8,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:7,column:0},end:{line:7,column:6},source:''},
        value: 'V',
        raw: '"\\x56"'
      },
      directive: '\\x56'
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:9,column:0},end:{line:10,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:9,column:0},end:{line:9,column:6},source:''},
        value: 'x',
        raw: '"\\x78"'
      },
      directive: '\\x78'
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:11,column:0},end:{line:12,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:11,column:0},end:{line:11,column:6},source:''},
        value: '@{x9a}@',
        raw: '"\\x9a"'
      },
      directive: '\\x9a'
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:13,column:0},end:{line:14,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:13,column:0},end:{line:13,column:6},source:''},
        value: '@{xab}@',
        raw: '"\\xAb"'
      },
      directive: '\\xAb'
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:15,column:0},end:{line:16,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:15,column:0},end:{line:15,column:6},source:''},
        value: '@{xbc}@',
        raw: '"\\xBc"'
      },
      directive: '\\xBc'
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:17,column:0},end:{line:18,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:17,column:0},end:{line:17,column:6},source:''},
        value: '@{xcd}@',
        raw: '"\\xCd"'
      },
      directive: '\\xCd'
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:19,column:0},end:{line:20,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:19,column:0},end:{line:19,column:6},source:''},
        value: '@{xde}@',
        raw: '"\\xDe"'
      },
      directive: '\\xDe'
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:21,column:0},end:{line:22,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:21,column:0},end:{line:21,column:6},source:''},
        value: '@{xef}@',
        raw: '"\\xEf"'
      },
      directive: '\\xEf'
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:23,column:0},end:{line:23,column:6},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:23,column:0},end:{line:23,column:6},source:''},
        value: '@{xf0}@',
        raw: '"\\xF0"'
      },
      directive: '\\xF0'
    }
  ]
}

tokens (25x):
       STRING_DOUBLE PUNC_SEMI STRING_DOUBLE PUNC_SEMI STRING_DOUBLE
       PUNC_SEMI STRING_DOUBLE PUNC_SEMI STRING_DOUBLE PUNC_SEMI
       STRING_DOUBLE PUNC_SEMI STRING_DOUBLE PUNC_SEMI STRING_DOUBLE
       PUNC_SEMI STRING_DOUBLE PUNC_SEMI STRING_DOUBLE PUNC_SEMI
       STRING_DOUBLE PUNC_SEMI STRING_DOUBLE ASI
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
"\x00";
"\x12";
"\x34";
"\x56";
"\x78";
"\x9a";
"\xAb";
"\xBc";
"\xCd";
"\xDe";
"\xEf";
"\xF0";
````

Produces same AST
