# Tenko parser test case

- Path: tests/testcases/lexer_cases/strings_double/hex_escapes/2.pass.md

> :: lexer cases : strings double : hex escapes
>
> ::> 2.pass
>
> Imported lexer test
>
> followed by something else

## PASS

## Input

`````js
"\x000"
;
"\x128"
;
"\x34a"
;
"\x56X"
;
"\x78{"
;
"\x9a\
"
;
"\xAb@{x9}@"
;
"\xBc "
;
"\xCd#"
;
"\xDe\x00"
;
"\xEfok"
;
"pre\xF0"
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:24,column:9},source:''},
  body: [
    {
      type: 'ExpressionStatement',
      loc:{start:{line:1,column:0},end:{line:2,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:1,column:0},end:{line:1,column:7},source:''},
        value: '\u00000',
        raw: '"\\x000"'
      },
      directive: '\\x000'
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:3,column:0},end:{line:4,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:3,column:0},end:{line:3,column:7},source:''},
        value: '\u00128',
        raw: '"\\x128"'
      },
      directive: '\\x128'
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:5,column:0},end:{line:6,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:5,column:0},end:{line:5,column:7},source:''},
        value: '4a',
        raw: '"\\x34a"'
      },
      directive: '\\x34a'
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:7,column:0},end:{line:8,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:7,column:0},end:{line:7,column:7},source:''},
        value: 'VX',
        raw: '"\\x56X"'
      },
      directive: '\\x56X'
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:9,column:0},end:{line:10,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:9,column:0},end:{line:9,column:7},source:''},
        value: 'x{',
        raw: '"\\x78{"'
      },
      directive: '\\x78{'
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:11,column:0},end:{line:13,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:11,column:0},end:{line:12,column:1},source:''},
        value: '@{x9a}@',
        raw: '"\\x9a\\\n"'
      },
      directive: '\\x9a\\\n'
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:14,column:0},end:{line:15,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:14,column:0},end:{line:14,column:7},source:''},
        value: '@{xab}@\t',
        raw: '"\\xAb\t"'
      },
      directive: '\\xAb\t'
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:16,column:0},end:{line:17,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:16,column:0},end:{line:16,column:7},source:''},
        value: '@{xbc}@ ',
        raw: '"\\xBc "'
      },
      directive: '\\xBc '
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:18,column:0},end:{line:19,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:18,column:0},end:{line:18,column:7},source:''},
        value: '@{xcd}@#',
        raw: '"\\xCd#"'
      },
      directive: '\\xCd#'
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:20,column:0},end:{line:21,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:20,column:0},end:{line:20,column:10},source:''},
        value: '@{xde}@\u0000',
        raw: '"\\xDe\\x00"'
      },
      directive: '\\xDe\\x00'
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:22,column:0},end:{line:23,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:22,column:0},end:{line:22,column:8},source:''},
        value: '@{xef}@ok',
        raw: '"\\xEfok"'
      },
      directive: '\\xEfok'
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:24,column:0},end:{line:24,column:9},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:24,column:0},end:{line:24,column:9},source:''},
        value: 'pre@{xf0}@',
        raw: '"pre\\xF0"'
      },
      directive: 'pre\\xF0'
    }
  ]
}

tokens (25x):
       STRING_DOUBLE PUNC_SEMI STRING_DOUBLE PUNC_SEMI STRING_DOUBLE
       PUNC_SEMI STRING_DOUBLE PUNC_SEMI STRING_DOUBLE PUNC_SEMI
       STRING_DOUBLE PUNC_SEMI STRING_DOUBLE PUNC_SEMI STRING_DOUBLE
       PUNC_SEMI STRING_DOUBLE PUNC_SEMI STRING_DOUBLE PUNC_SEMI
       STRING_DOUBLE PUNC_SEMI STRING_DOUBLE ASI
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
"\x000";
"\x128";
"\x34a";
"\x56X";
"\x78{";
"\x9a\
";
"\xAb@{x9}@";
"\xBc ";
"\xCd#";
"\xDe\x00";
"\xEfok";
"pre\xF0";
````

Produces same AST
