# Tenko parser test case

- Path: tests/testcases/lexer_cases/strings_double/line_continuation/1.pass.md

> :: lexer cases : strings double : line continuation
>
> ::> 1.pass
>
> Imported lexer test
>
> line continuations are okay

## PASS

## Input

`````js
"\
"
;
"pre\
"
;
"\
post"
;
"pre\
post"
;
"\@{xd}@"
;
"pre\@{xd}@"
;
"\@{xd}@post"
;
"pre\@{xd}@post"
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:23,column:5},source:''},
  body: [
    {
      type: 'ExpressionStatement',
      loc:{start:{line:1,column:0},end:{line:3,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:1,column:0},end:{line:2,column:1},source:''},
        value: '',
        raw: '"\\\n"'
      },
      directive: '\\\n'
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:4,column:0},end:{line:6,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:4,column:0},end:{line:5,column:1},source:''},
        value: 'pre',
        raw: '"pre\\\n"'
      },
      directive: 'pre\\\n'
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:7,column:0},end:{line:9,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:7,column:0},end:{line:8,column:5},source:''},
        value: 'post',
        raw: '"\\\npost"'
      },
      directive: '\\\npost'
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:10,column:0},end:{line:12,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:10,column:0},end:{line:11,column:5},source:''},
        value: 'prepost',
        raw: '"pre\\\npost"'
      },
      directive: 'pre\\\npost'
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:13,column:0},end:{line:15,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:13,column:0},end:{line:14,column:1},source:''},
        value: '',
        raw: '"\\\r"'
      },
      directive: '\\\r'
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:16,column:0},end:{line:18,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:16,column:0},end:{line:17,column:1},source:''},
        value: 'pre',
        raw: '"pre\\\r"'
      },
      directive: 'pre\\\r'
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:19,column:0},end:{line:21,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:19,column:0},end:{line:20,column:5},source:''},
        value: 'post',
        raw: '"\\\rpost"'
      },
      directive: '\\\rpost'
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:22,column:0},end:{line:23,column:5},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:22,column:0},end:{line:23,column:5},source:''},
        value: 'prepost',
        raw: '"pre\\\rpost"'
      },
      directive: 'pre\\\rpost'
    }
  ]
}

tokens (17x):
       STRING_DOUBLE PUNC_SEMI STRING_DOUBLE PUNC_SEMI STRING_DOUBLE
       PUNC_SEMI STRING_DOUBLE PUNC_SEMI STRING_DOUBLE PUNC_SEMI
       STRING_DOUBLE PUNC_SEMI STRING_DOUBLE PUNC_SEMI STRING_DOUBLE
       ASI
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
"\
";
"pre\
";
"\
post";
"pre\
post";
"\@{xd}@";
"pre\@{xd}@";
"\@{xd}@post";
"pre\@{xd}@post";
````

Produces same AST
