# Tenko parser test case

- Path: tests/testcases/lexer_cases/strings_double/octal_escapes/50.md

> :: lexer cases : strings double : octal escapes
>
> ::> 50
>
> Imported lexer test
>
> ZeroToThreeOctalDigit [lookahead @{x2209}@ OctalDigit] (other character/high digit)

## Input

`````js
"\20\n"
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
throws: Lexer error!
    Octal escapes are only allowed in sloppy mode with web compat enabled

"\20\n"
^------- error
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

`````
throws: Lexer error!
    Illegal legacy octal escape in strict mode

"\20\n"
^------- error
`````


### Module goal

Parsed with the module goal.

_Output same as strict mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:7},source:''},
  body: [
    {
      type: 'ExpressionStatement',
      loc:{start:{line:1,column:0},end:{line:1,column:7},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:1,column:0},end:{line:1,column:7},source:''},
        value: '\u0010\n',
        raw: '"\\20\\n"'
      },
      directive: '\\20\\n'
    }
  ]
}

tokens (3x):
       STRING_DOUBLE ASI
`````


## AST Printer

Printer output different from input [web]:

````js
"\20\n";
````

Produces same AST
