# Tenko parser test case

- Path: tests/testcases/lexer_cases/strings_double/unicode_escape_variable/1.pass.md

> :: lexer cases : strings double : unicode escape variable
>
> ::> 1.pass
>
> Imported lexer test

## PASS

## Input

`````js
"\u{0123}"
;
"\u{4567}"
;
"\u{89abc}"
;
"\u{defAB}"
;
"\u{CDEF}"
;
"prefix \u{012345}"
;
"\u{012345} postfix"
;
"\u{012345}\u{6789a}"
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:15,column:21},source:''},
  body: [
    {
      type: 'ExpressionStatement',
      loc:{start:{line:1,column:0},end:{line:2,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:1,column:0},end:{line:1,column:10},source:''},
        value: '@{x123}@',
        raw: '"\\u{0123}"'
      },
      directive: '\\u{0123}'
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:3,column:0},end:{line:4,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:3,column:0},end:{line:3,column:10},source:''},
        value: '@{x4567}@',
        raw: '"\\u{4567}"'
      },
      directive: '\\u{4567}'
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:5,column:0},end:{line:6,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:5,column:0},end:{line:5,column:11},source:''},
        value: '@{x89abc}@',
        raw: '"\\u{89abc}"'
      },
      directive: '\\u{89abc}'
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:7,column:0},end:{line:8,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:7,column:0},end:{line:7,column:11},source:''},
        value: '@{xdefab}@',
        raw: '"\\u{defAB}"'
      },
      directive: '\\u{defAB}'
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:9,column:0},end:{line:10,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:9,column:0},end:{line:9,column:10},source:''},
        value: '@{xcdef}@',
        raw: '"\\u{CDEF}"'
      },
      directive: '\\u{CDEF}'
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:11,column:0},end:{line:12,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:11,column:0},end:{line:11,column:19},source:''},
        value: 'prefix @{x12345}@',
        raw: '"prefix \\u{012345}"'
      },
      directive: 'prefix \\u{012345}'
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:13,column:0},end:{line:14,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:13,column:0},end:{line:13,column:20},source:''},
        value: '@{x12345}@ postfix',
        raw: '"\\u{012345} postfix"'
      },
      directive: '\\u{012345} postfix'
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:15,column:0},end:{line:15,column:21},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:15,column:0},end:{line:15,column:21},source:''},
        value: '@{x12345}@@{x6789a}@',
        raw: '"\\u{012345}\\u{6789a}"'
      },
      directive: '\\u{012345}\\u{6789a}'
    }
  ]
}

tokens (17x):
       STRING_DOUBLE PUNC_SEMI STRING_DOUBLE PUNC_SEMI STRING_DOUBLE
       PUNC_SEMI STRING_DOUBLE PUNC_SEMI STRING_DOUBLE PUNC_SEMI
       STRING_DOUBLE PUNC_SEMI STRING_DOUBLE PUNC_SEMI STRING_DOUBLE
       ASI
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
"\u{0123}";
"\u{4567}";
"\u{89abc}";
"\u{defAB}";
"\u{CDEF}";
"prefix \u{012345}";
"\u{012345} postfix";
"\u{012345}\u{6789a}";
````

Produces same AST
