# Tenko parser test case

- Path: tests/testcases/lexer_cases/strings_single/octal_escapes/3.md

> :: lexer cases : strings single : octal escapes
>
> ::> 3
>
> Imported lexer test
>
> octal escape illegal in strict mode

## Input

`````js
'\2'
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
throws: Lexer error!
    Octal escapes are only allowed in sloppy mode with web compat enabled

'\2'
^------- error
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

`````
throws: Lexer error!
    Illegal legacy octal escape in strict mode

'\2'
^------- error
`````


### Module goal

Parsed with the module goal.

_Output same as strict mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:4},source:''},
  body: [
    {
      type: 'ExpressionStatement',
      loc:{start:{line:1,column:0},end:{line:1,column:4},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:1,column:0},end:{line:1,column:4},source:''},
        value: '\u0002',
        raw: "'\\2'"
      },
      directive: '\\2'
    }
  ]
}

tokens (3x):
       STRING_SINGLE ASI
`````


## AST Printer

Printer output different from input [web]:

````js
'\2';
````

Produces same AST
