# Tenko parser test case

- Path: tests/testcases/lexer_cases/strings_single/octal_escapes/79.md

> :: lexer cases : strings single : octal escapes
>
> ::> 79
>
> Imported lexer test
>
> FourToSeven OctalDigit other char

## Input

`````js
'\62a'
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
throws: Lexer error!
    Octal escapes are only allowed in sloppy mode with web compat enabled

'\62a'
^------- error
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

`````
throws: Lexer error!
    Illegal legacy octal escape in strict mode

'\62a'
^------- error
`````


### Module goal

Parsed with the module goal.

_Output same as strict mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:6},source:''},
  body: [
    {
      type: 'ExpressionStatement',
      loc:{start:{line:1,column:0},end:{line:1,column:6},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:1,column:0},end:{line:1,column:6},source:''},
        value: '2a',
        raw: "'\\62a'"
      },
      directive: '\\62a'
    }
  ]
}

tokens (3x):
       STRING_SINGLE ASI
`````


## AST Printer

Printer output different from input [web]:

````js
'\62a';
````

Produces same AST
