# Tenko parser test case

- Path: tests/testcases/lexer_cases/strings_single/unicode_escapes_quad/1.pass.md

> :: lexer cases : strings single : unicode escapes quad
>
> ::> 1.pass
>
> Imported lexer test

## PASS

## Input

`````js
'\u0123'
;
'\u4567'
;
'\u89ab'
;
'\ucdef'
;
'\uABCD'
;
'\uDE00'
;
'prefix \u0123'
;
'\u0123 postfix'
;
'\u0123\u4567'
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:17,column:14},source:''},
  body: [
    {
      type: 'ExpressionStatement',
      loc:{start:{line:1,column:0},end:{line:2,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:1,column:0},end:{line:1,column:8},source:''},
        value: '@{x123}@',
        raw: "'\\u0123'"
      },
      directive: '\\u0123'
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:3,column:0},end:{line:4,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:3,column:0},end:{line:3,column:8},source:''},
        value: '@{x4567}@',
        raw: "'\\u4567'"
      },
      directive: '\\u4567'
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:5,column:0},end:{line:6,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:5,column:0},end:{line:5,column:8},source:''},
        value: '@{x89ab}@',
        raw: "'\\u89ab'"
      },
      directive: '\\u89ab'
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:7,column:0},end:{line:8,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:7,column:0},end:{line:7,column:8},source:''},
        value: '@{xcdef}@',
        raw: "'\\ucdef'"
      },
      directive: '\\ucdef'
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:9,column:0},end:{line:10,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:9,column:0},end:{line:9,column:8},source:''},
        value: '@{xabcd}@',
        raw: "'\\uABCD'"
      },
      directive: '\\uABCD'
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:11,column:0},end:{line:12,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:11,column:0},end:{line:11,column:8},source:''},
        value: '@{xde00}@',
        raw: "'\\uDE00'"
      },
      directive: '\\uDE00'
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:13,column:0},end:{line:14,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:13,column:0},end:{line:13,column:15},source:''},
        value: 'prefix @{x123}@',
        raw: "'prefix \\u0123'"
      },
      directive: 'prefix \\u0123'
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:15,column:0},end:{line:16,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:15,column:0},end:{line:15,column:16},source:''},
        value: '@{x123}@ postfix',
        raw: "'\\u0123 postfix'"
      },
      directive: '\\u0123 postfix'
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:17,column:0},end:{line:17,column:14},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:17,column:0},end:{line:17,column:14},source:''},
        value: '@{x123}@@{x4567}@',
        raw: "'\\u0123\\u4567'"
      },
      directive: '\\u0123\\u4567'
    }
  ]
}

tokens (19x):
       STRING_SINGLE PUNC_SEMI STRING_SINGLE PUNC_SEMI STRING_SINGLE
       PUNC_SEMI STRING_SINGLE PUNC_SEMI STRING_SINGLE PUNC_SEMI
       STRING_SINGLE PUNC_SEMI STRING_SINGLE PUNC_SEMI STRING_SINGLE
       PUNC_SEMI STRING_SINGLE ASI
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
'\u0123';
'\u4567';
'\u89ab';
'\ucdef';
'\uABCD';
'\uDE00';
'prefix \u0123';
'\u0123 postfix';
'\u0123\u4567';
````

Produces same AST
