# Tenko parser test case

- Path: tests/testcases/member_expression/property_on_call.md

> :: member expression
>
> ::> property on call

## Input

`````js
a().b
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:5},source:''},
  body: [
    {
      type: 'ExpressionStatement',
      loc:{start:{line:1,column:0},end:{line:1,column:5},source:''},
      expression: {
        type: 'MemberExpression',
        loc:{start:{line:1,column:0},end:{line:1,column:5},source:''},
        object: {
          type: 'CallExpression',
          loc:{start:{line:1,column:0},end:{line:1,column:3},source:''},
          callee: {
            type: 'Identifier',
            loc:{start:{line:1,column:0},end:{line:1,column:1},source:''},
            name: 'a'
          },
          arguments: []
        },
        property: {
          type: 'Identifier',
          loc:{start:{line:1,column:4},end:{line:1,column:5},source:''},
          name: 'b'
        },
        computed: false
      }
    }
  ]
}

tokens (7x):
       IDENT PUNC_PAREN_OPEN PUNC_PAREN_CLOSE PUNC_DOT IDENT ASI
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
(((a)()).b);
````

Produces same AST
