# Tenko parser test case

- Path: tests/testcases/new/new_operator/argument_special_cases/new_async/new_async_empty_parens.md

> :: new : new operator : argument special cases : new async
>
> ::> new async empty parens
>
> make sure the async does not end up as a callexpression in the ast

## Input

`````js
new async ()
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:12},source:''},
  body: [
    {
      type: 'ExpressionStatement',
      loc:{start:{line:1,column:0},end:{line:1,column:12},source:''},
      expression: {
        type: 'NewExpression',
        loc:{start:{line:1,column:0},end:{line:1,column:12},source:''},
        arguments: [],
        callee: {
          type: 'Identifier',
          loc:{start:{line:1,column:4},end:{line:1,column:9},source:''},
          name: 'async'
        }
      }
    }
  ]
}

tokens (6x):
       ID_new ID_async PUNC_PAREN_OPEN PUNC_PAREN_CLOSE ASI
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
new (async)();
````

Produces same AST
