# Tenko parser test case

- Path: tests/testcases/objects/destructuring/in_comma_expr.md

> :: objects : destructuring
>
> ::> in comma expr

## Input

`````js
x, {foo, bar} = doo
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:19},source:''},
  body: [
    {
      type: 'ExpressionStatement',
      loc:{start:{line:1,column:0},end:{line:1,column:19},source:''},
      expression: {
        type: 'SequenceExpression',
        loc:{start:{line:1,column:0},end:{line:1,column:19},source:''},
        expressions: [
          {
            type: 'Identifier',
            loc:{start:{line:1,column:0},end:{line:1,column:1},source:''},
            name: 'x'
          },
          {
            type: 'AssignmentExpression',
            loc:{start:{line:1,column:3},end:{line:1,column:19},source:''},
            left: {
              type: 'ObjectPattern',
              loc:{start:{line:1,column:3},end:{line:1,column:13},source:''},
              properties: [
                {
                  type: 'Property',
                  loc:{start:{line:1,column:4},end:{line:1,column:7},source:''},
                  key: {
                    type: 'Identifier',
                    loc:{start:{line:1,column:4},end:{line:1,column:7},source:''},
                    name: 'foo'
                  },
                  kind: 'init',
                  method: false,
                  computed: false,
                  value: {
                    type: 'Identifier',
                    loc:{start:{line:1,column:4},end:{line:1,column:7},source:''},
                    name: 'foo'
                  },
                  shorthand: true
                },
                {
                  type: 'Property',
                  loc:{start:{line:1,column:9},end:{line:1,column:12},source:''},
                  key: {
                    type: 'Identifier',
                    loc:{start:{line:1,column:9},end:{line:1,column:12},source:''},
                    name: 'bar'
                  },
                  kind: 'init',
                  method: false,
                  computed: false,
                  value: {
                    type: 'Identifier',
                    loc:{start:{line:1,column:9},end:{line:1,column:12},source:''},
                    name: 'bar'
                  },
                  shorthand: true
                }
              ]
            },
            operator: '=',
            right: {
              type: 'Identifier',
              loc:{start:{line:1,column:16},end:{line:1,column:19},source:''},
              name: 'doo'
            }
          }
        ]
      }
    }
  ]
}

tokens (11x):
       IDENT PUNC_COMMA PUNC_CURLY_OPEN IDENT PUNC_COMMA IDENT
       PUNC_CURLY_CLOSE PUNC_EQ IDENT ASI
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
((x, ({foo, bar} = doo)));
````

Produces same AST
