# Tenko parser test case

- Path: tests/testcases/objects/duplicate_keys/obj_expr/dunderproto___proto__/exceptions/not_async/arr_plain_group.md

> :: objects : duplicate keys : obj expr : dunderproto proto : exceptions : not async
>
> ::> arr plain group
>
> Should fail in web compat because double __proto__ is not allowed in obj expression

## Input

`````js
([{web: false, __proto__: a, __proto__: b}]);
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:45},source:''},
  body: [
    {
      type: 'ExpressionStatement',
      loc:{start:{line:1,column:0},end:{line:1,column:45},source:''},
      expression: {
        type: 'ArrayExpression',
        loc:{start:{line:1,column:1},end:{line:1,column:43},source:''},
        elements: [
          {
            type: 'ObjectExpression',
            loc:{start:{line:1,column:2},end:{line:1,column:42},source:''},
            properties: [
              {
                type: 'Property',
                loc:{start:{line:1,column:3},end:{line:1,column:13},source:''},
                key: {
                  type: 'Identifier',
                  loc:{start:{line:1,column:3},end:{line:1,column:6},source:''},
                  name: 'web'
                },
                kind: 'init',
                method: false,
                computed: false,
                value: {
                  type: 'Literal',
                  loc:{start:{line:1,column:8},end:{line:1,column:13},source:''},
                  value: false,
                  raw: 'false'
                },
                shorthand: false
              },
              {
                type: 'Property',
                loc:{start:{line:1,column:15},end:{line:1,column:27},source:''},
                key: {
                  type: 'Identifier',
                  loc:{start:{line:1,column:15},end:{line:1,column:24},source:''},
                  name: '__proto__'
                },
                kind: 'init',
                method: false,
                computed: false,
                value: {
                  type: 'Identifier',
                  loc:{start:{line:1,column:26},end:{line:1,column:27},source:''},
                  name: 'a'
                },
                shorthand: false
              },
              {
                type: 'Property',
                loc:{start:{line:1,column:29},end:{line:1,column:41},source:''},
                key: {
                  type: 'Identifier',
                  loc:{start:{line:1,column:29},end:{line:1,column:38},source:''},
                  name: '__proto__'
                },
                kind: 'init',
                method: false,
                computed: false,
                value: {
                  type: 'Identifier',
                  loc:{start:{line:1,column:40},end:{line:1,column:41},source:''},
                  name: 'b'
                },
                shorthand: false
              }
            ]
          }
        ]
      }
    }
  ]
}

tokens (19x):
       PUNC_PAREN_OPEN PUNC_BRACKET_OPEN PUNC_CURLY_OPEN IDENT
       PUNC_COLON ID_false PUNC_COMMA IDENT PUNC_COLON IDENT
       PUNC_COMMA IDENT PUNC_COLON IDENT PUNC_CURLY_CLOSE
       PUNC_BRACKET_CLOSE PUNC_PAREN_CLOSE PUNC_SEMI
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

`````
throws: Parser error!
  Found a part that cant destruct and a part that must destruct so it is not destructible

([{web: false, __proto__: a, __proto__: b}]);
                                          ^------- error
`````


## AST Printer

Printer output different from input [sloppy]:

````js
([{web:false, __proto__:a, __proto__:b},]);
````

Produces same AST
