# Tenko parser test case

- Path: tests/testcases/objects/duplicate_keys/obj_expr/dunderproto___proto__/exceptions/not_async/as_a_function_with_obvious_pattern.md

> :: objects : duplicate keys : obj expr : dunderproto proto : exceptions : not async
>
> ::> as a function with obvious pattern
>
> https://tc39.github.io/ecma262/#sec-__proto__-property-names-in-object-initializers
>
> When ObjectLiteral appears in a context where ObjectAssignmentPattern is required the Early Error rule is not applied.
>
> In addition, it is not applied when initially parsing a CoverParenthesizedExpressionAndArrowParameterList or a CoverCallExpressionAndAsyncArrowHead.
>
> However, that doesn't prevent the error if the cover grammar does not end in a pattern
>
> In this case it's an assignment pattern, so no error expected.

## PASS

## Input

`````js
function f({__proto__: a, __proto__: b}) {}
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:43},source:''},
  body: [
    {
      type: 'FunctionDeclaration',
      loc:{start:{line:1,column:0},end:{line:1,column:43},source:''},
      generator: false,
      async: false,
      id: {
        type: 'Identifier',
        loc:{start:{line:1,column:9},end:{line:1,column:10},source:''},
        name: 'f'
      },
      params: [
        {
          type: 'ObjectPattern',
          loc:{start:{line:1,column:11},end:{line:1,column:39},source:''},
          properties: [
            {
              type: 'Property',
              loc:{start:{line:1,column:12},end:{line:1,column:24},source:''},
              key: {
                type: 'Identifier',
                loc:{start:{line:1,column:12},end:{line:1,column:21},source:''},
                name: '__proto__'
              },
              kind: 'init',
              method: false,
              computed: false,
              value: {
                type: 'Identifier',
                loc:{start:{line:1,column:23},end:{line:1,column:24},source:''},
                name: 'a'
              },
              shorthand: false
            },
            {
              type: 'Property',
              loc:{start:{line:1,column:26},end:{line:1,column:38},source:''},
              key: {
                type: 'Identifier',
                loc:{start:{line:1,column:26},end:{line:1,column:35},source:''},
                name: '__proto__'
              },
              kind: 'init',
              method: false,
              computed: false,
              value: {
                type: 'Identifier',
                loc:{start:{line:1,column:37},end:{line:1,column:38},source:''},
                name: 'b'
              },
              shorthand: false
            }
          ]
        }
      ],
      body: {
        type: 'BlockStatement',
        loc:{start:{line:1,column:41},end:{line:1,column:43},source:''},
        body: []
      }
    }
  ]
}

tokens (16x):
       ID_function IDENT PUNC_PAREN_OPEN PUNC_CURLY_OPEN IDENT
       PUNC_COLON IDENT PUNC_COMMA IDENT PUNC_COLON IDENT
       PUNC_CURLY_CLOSE PUNC_PAREN_CLOSE PUNC_CURLY_OPEN
       PUNC_CURLY_CLOSE
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
function f({__proto__:a, __proto__:b}) {}
````

Produces same AST
