# Tenko parser test case

- Path: tests/testcases/objects/duplicate_keys/obj_expr/dunderproto___proto__/exceptions/not_async/destructuring_assignment.md

> :: objects : duplicate keys : obj expr : dunderproto proto : exceptions : not async
>
> ::> destructuring assignment
>
> https://tc39.github.io/ecma262/#sec-__proto__-property-names-in-object-initializers
>
> When ObjectLiteral appears in a context where ObjectAssignmentPattern is required the Early Error rule is not applied.
>
> In addition, it is not applied when initially parsing a CoverParenthesizedExpressionAndArrowParameterList or a CoverCallExpressionAndAsyncArrowHead.
>
> However, that doesn't prevent the error if the cover grammar does not end in a pattern
>
> In this case it's an assignment pattern, so no error expected.

## PASS

## Input

`````js
x = {__proto__: a, __proto__: b} = y
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:36},source:''},
  body: [
    {
      type: 'ExpressionStatement',
      loc:{start:{line:1,column:0},end:{line:1,column:36},source:''},
      expression: {
        type: 'AssignmentExpression',
        loc:{start:{line:1,column:0},end:{line:1,column:36},source:''},
        left: {
          type: 'Identifier',
          loc:{start:{line:1,column:0},end:{line:1,column:1},source:''},
          name: 'x'
        },
        operator: '=',
        right: {
          type: 'AssignmentExpression',
          loc:{start:{line:1,column:4},end:{line:1,column:36},source:''},
          left: {
            type: 'ObjectPattern',
            loc:{start:{line:1,column:4},end:{line:1,column:32},source:''},
            properties: [
              {
                type: 'Property',
                loc:{start:{line:1,column:5},end:{line:1,column:17},source:''},
                key: {
                  type: 'Identifier',
                  loc:{start:{line:1,column:5},end:{line:1,column:14},source:''},
                  name: '__proto__'
                },
                kind: 'init',
                method: false,
                computed: false,
                value: {
                  type: 'Identifier',
                  loc:{start:{line:1,column:16},end:{line:1,column:17},source:''},
                  name: 'a'
                },
                shorthand: false
              },
              {
                type: 'Property',
                loc:{start:{line:1,column:19},end:{line:1,column:31},source:''},
                key: {
                  type: 'Identifier',
                  loc:{start:{line:1,column:19},end:{line:1,column:28},source:''},
                  name: '__proto__'
                },
                kind: 'init',
                method: false,
                computed: false,
                value: {
                  type: 'Identifier',
                  loc:{start:{line:1,column:30},end:{line:1,column:31},source:''},
                  name: 'b'
                },
                shorthand: false
              }
            ]
          },
          operator: '=',
          right: {
            type: 'Identifier',
            loc:{start:{line:1,column:35},end:{line:1,column:36},source:''},
            name: 'y'
          }
        }
      }
    }
  ]
}

tokens (15x):
       IDENT PUNC_EQ PUNC_CURLY_OPEN IDENT PUNC_COLON IDENT PUNC_COMMA
       IDENT PUNC_COLON IDENT PUNC_CURLY_CLOSE PUNC_EQ IDENT ASI
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
((x = ({__proto__:a, __proto__:b} = y)));
````

Produces same AST
