# Tenko parser test case

- Path: tests/testcases/objects/duplicate_keys/obj_expr/dunderproto___proto__/exceptions/not_async/inside_a_complex_destruct_in_an_arrow_1.md

> :: objects : duplicate keys : obj expr : dunderproto proto : exceptions : not async
>
> ::> inside a complex destruct in an arrow 1
>
> https://tc39.github.io/ecma262/#sec-__proto__-property-names-in-object-initializers
>
> When ObjectLiteral appears in a context where ObjectAssignmentPattern is required the Early Error rule is not applied.
>
> In addition, it is not applied when initially parsing a CoverParenthesizedExpressionAndArrowParameterList or a CoverCallExpressionAndAsyncArrowHead.
>
> However, that doesn't prevent the error if the cover grammar does not end in a pattern
>
> In this case it's a destructuring pattern, so no error expected.

## PASS

## Input

`````js
(a, [b, [c, {__proto__: d, __proto__: e}]], f) => x;
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:52},source:''},
  body: [
    {
      type: 'ExpressionStatement',
      loc:{start:{line:1,column:0},end:{line:1,column:52},source:''},
      expression: {
        type: 'ArrowFunctionExpression',
        loc:{start:{line:1,column:0},end:{line:1,column:51},source:''},
        params: [
          {
            type: 'Identifier',
            loc:{start:{line:1,column:1},end:{line:1,column:2},source:''},
            name: 'a'
          },
          {
            type: 'ArrayPattern',
            loc:{start:{line:1,column:4},end:{line:1,column:42},source:''},
            elements: [
              {
                type: 'Identifier',
                loc:{start:{line:1,column:5},end:{line:1,column:6},source:''},
                name: 'b'
              },
              {
                type: 'ArrayPattern',
                loc:{start:{line:1,column:8},end:{line:1,column:41},source:''},
                elements: [
                  {
                    type: 'Identifier',
                    loc:{start:{line:1,column:9},end:{line:1,column:10},source:''},
                    name: 'c'
                  },
                  {
                    type: 'ObjectPattern',
                    loc:{start:{line:1,column:12},end:{line:1,column:40},source:''},
                    properties: [
                      {
                        type: 'Property',
                        loc:{start:{line:1,column:13},end:{line:1,column:25},source:''},
                        key: {
                          type: 'Identifier',
                          loc:{start:{line:1,column:13},end:{line:1,column:22},source:''},
                          name: '__proto__'
                        },
                        kind: 'init',
                        method: false,
                        computed: false,
                        value: {
                          type: 'Identifier',
                          loc:{start:{line:1,column:24},end:{line:1,column:25},source:''},
                          name: 'd'
                        },
                        shorthand: false
                      },
                      {
                        type: 'Property',
                        loc:{start:{line:1,column:27},end:{line:1,column:39},source:''},
                        key: {
                          type: 'Identifier',
                          loc:{start:{line:1,column:27},end:{line:1,column:36},source:''},
                          name: '__proto__'
                        },
                        kind: 'init',
                        method: false,
                        computed: false,
                        value: {
                          type: 'Identifier',
                          loc:{start:{line:1,column:38},end:{line:1,column:39},source:''},
                          name: 'e'
                        },
                        shorthand: false
                      }
                    ]
                  }
                ]
              }
            ]
          },
          {
            type: 'Identifier',
            loc:{start:{line:1,column:44},end:{line:1,column:45},source:''},
            name: 'f'
          }
        ],
        id: null,
        generator: false,
        async: false,
        expression: true,
        body: {
          type: 'Identifier',
          loc:{start:{line:1,column:50},end:{line:1,column:51},source:''},
          name: 'x'
        }
      }
    }
  ]
}

tokens (27x):
       PUNC_PAREN_OPEN IDENT PUNC_COMMA PUNC_BRACKET_OPEN IDENT
       PUNC_COMMA PUNC_BRACKET_OPEN IDENT PUNC_COMMA PUNC_CURLY_OPEN
       IDENT PUNC_COLON IDENT PUNC_COMMA IDENT PUNC_COLON IDENT
       PUNC_CURLY_CLOSE PUNC_BRACKET_CLOSE PUNC_BRACKET_CLOSE
       PUNC_COMMA IDENT PUNC_PAREN_CLOSE PUNC_EQ_GT IDENT PUNC_SEMI
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
(a, [b, [c, {__proto__:d, __proto__:e},],], f) => (x);
````

Produces same AST
