# Tenko parser test case

- Path: tests/testcases/objects/duplicate_keys/obj_expr/dunderproto___proto__/exceptions/not_async/inside_a_complex_destruct_in_an_arrow_2.md

> :: objects : duplicate keys : obj expr : dunderproto proto : exceptions : not async
>
> ::> inside a complex destruct in an arrow 2
>
> https://tc39.github.io/ecma262/#sec-__proto__-property-names-in-object-initializers
>
> When ObjectLiteral appears in a context where ObjectAssignmentPattern is required the Early Error rule is not applied.
>
> In addition, it is not applied when initially parsing a CoverParenthesizedExpressionAndArrowParameterList or a CoverCallExpressionAndAsyncArrowHead.
>
> However, that doesn't prevent the error if the cover grammar does not end in a pattern
>
> In this case it's a destructuring pattern, so no error expected.

## PASS

## Input

`````js
function f(a, [b, [c, {__proto__: d, __proto__: e}]], f) {}
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:59},source:''},
  body: [
    {
      type: 'FunctionDeclaration',
      loc:{start:{line:1,column:0},end:{line:1,column:59},source:''},
      generator: false,
      async: false,
      id: {
        type: 'Identifier',
        loc:{start:{line:1,column:9},end:{line:1,column:10},source:''},
        name: 'f'
      },
      params: [
        {
          type: 'Identifier',
          loc:{start:{line:1,column:11},end:{line:1,column:12},source:''},
          name: 'a'
        },
        {
          type: 'ArrayPattern',
          loc:{start:{line:1,column:14},end:{line:1,column:52},source:''},
          elements: [
            {
              type: 'Identifier',
              loc:{start:{line:1,column:15},end:{line:1,column:16},source:''},
              name: 'b'
            },
            {
              type: 'ArrayPattern',
              loc:{start:{line:1,column:18},end:{line:1,column:51},source:''},
              elements: [
                {
                  type: 'Identifier',
                  loc:{start:{line:1,column:19},end:{line:1,column:20},source:''},
                  name: 'c'
                },
                {
                  type: 'ObjectPattern',
                  loc:{start:{line:1,column:22},end:{line:1,column:50},source:''},
                  properties: [
                    {
                      type: 'Property',
                      loc:{start:{line:1,column:23},end:{line:1,column:35},source:''},
                      key: {
                        type: 'Identifier',
                        loc:{start:{line:1,column:23},end:{line:1,column:32},source:''},
                        name: '__proto__'
                      },
                      kind: 'init',
                      method: false,
                      computed: false,
                      value: {
                        type: 'Identifier',
                        loc:{start:{line:1,column:34},end:{line:1,column:35},source:''},
                        name: 'd'
                      },
                      shorthand: false
                    },
                    {
                      type: 'Property',
                      loc:{start:{line:1,column:37},end:{line:1,column:49},source:''},
                      key: {
                        type: 'Identifier',
                        loc:{start:{line:1,column:37},end:{line:1,column:46},source:''},
                        name: '__proto__'
                      },
                      kind: 'init',
                      method: false,
                      computed: false,
                      value: {
                        type: 'Identifier',
                        loc:{start:{line:1,column:48},end:{line:1,column:49},source:''},
                        name: 'e'
                      },
                      shorthand: false
                    }
                  ]
                }
              ]
            }
          ]
        },
        {
          type: 'Identifier',
          loc:{start:{line:1,column:54},end:{line:1,column:55},source:''},
          name: 'f'
        }
      ],
      body: {
        type: 'BlockStatement',
        loc:{start:{line:1,column:57},end:{line:1,column:59},source:''},
        body: []
      }
    }
  ]
}

tokens (28x):
       ID_function IDENT PUNC_PAREN_OPEN IDENT PUNC_COMMA
       PUNC_BRACKET_OPEN IDENT PUNC_COMMA PUNC_BRACKET_OPEN IDENT
       PUNC_COMMA PUNC_CURLY_OPEN IDENT PUNC_COLON IDENT PUNC_COMMA
       IDENT PUNC_COLON IDENT PUNC_CURLY_CLOSE PUNC_BRACKET_CLOSE
       PUNC_BRACKET_CLOSE PUNC_COMMA IDENT PUNC_PAREN_CLOSE
       PUNC_CURLY_OPEN PUNC_CURLY_CLOSE
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
function f(a, [b, [c, {__proto__:d, __proto__:e},],], f) {}
````

Produces same AST
