# Tenko parser test case

- Path: tests/testcases/objects/duplicate_keys/obj_expr/dunderproto___proto__/exceptions/not_async/obj_plain_group.md

> :: objects : duplicate keys : obj expr : dunderproto proto : exceptions : not async
>
> ::> obj plain group
>
> Should fail in web compat
>
> https://github.com/tc39/test262/issues/2344

## Input

`````js
({web: false, __proto__: a, __proto__: b});
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:43},source:''},
  body: [
    {
      type: 'ExpressionStatement',
      loc:{start:{line:1,column:0},end:{line:1,column:43},source:''},
      expression: {
        type: 'ObjectExpression',
        loc:{start:{line:1,column:1},end:{line:1,column:41},source:''},
        properties: [
          {
            type: 'Property',
            loc:{start:{line:1,column:2},end:{line:1,column:12},source:''},
            key: {
              type: 'Identifier',
              loc:{start:{line:1,column:2},end:{line:1,column:5},source:''},
              name: 'web'
            },
            kind: 'init',
            method: false,
            computed: false,
            value: {
              type: 'Literal',
              loc:{start:{line:1,column:7},end:{line:1,column:12},source:''},
              value: false,
              raw: 'false'
            },
            shorthand: false
          },
          {
            type: 'Property',
            loc:{start:{line:1,column:14},end:{line:1,column:26},source:''},
            key: {
              type: 'Identifier',
              loc:{start:{line:1,column:14},end:{line:1,column:23},source:''},
              name: '__proto__'
            },
            kind: 'init',
            method: false,
            computed: false,
            value: {
              type: 'Identifier',
              loc:{start:{line:1,column:25},end:{line:1,column:26},source:''},
              name: 'a'
            },
            shorthand: false
          },
          {
            type: 'Property',
            loc:{start:{line:1,column:28},end:{line:1,column:40},source:''},
            key: {
              type: 'Identifier',
              loc:{start:{line:1,column:28},end:{line:1,column:37},source:''},
              name: '__proto__'
            },
            kind: 'init',
            method: false,
            computed: false,
            value: {
              type: 'Identifier',
              loc:{start:{line:1,column:39},end:{line:1,column:40},source:''},
              name: 'b'
            },
            shorthand: false
          }
        ]
      }
    }
  ]
}

tokens (17x):
       PUNC_PAREN_OPEN PUNC_CURLY_OPEN IDENT PUNC_COLON ID_false
       PUNC_COMMA IDENT PUNC_COLON IDENT PUNC_COMMA IDENT PUNC_COLON
       IDENT PUNC_CURLY_CLOSE PUNC_PAREN_CLOSE PUNC_SEMI
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

`````
throws: Parser error!
  Found a part that cant destruct and a part that must destruct so it is not destructible

({web: false, __proto__: a, __proto__: b});
                                         ^------- error
`````


## AST Printer

Printer output different from input [sloppy]:

````js
({web:false, __proto__:a, __proto__:b});
````

Produces same AST
