# Tenko parser test case

- Path: tests/testcases/objects/duplicate_keys/obj_expr/dunderproto___proto__/ident_string.md

> :: objects : duplicate keys : obj expr : dunderproto proto
>
> ::> ident string
>
> Regression caught by test262/test/annexB/language/expressions/object/__proto__-duplicate.js
>
> https://github.com/tc39/test262/issues/2344
>
> The cover rule exception does not prevent the error if the end result is not a pattern.
>
> So this is an error in web compat mode.

## Input

`````js
({
  __proto__: null,
  other: null,
  '__proto__': null
});
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:5,column:3},source:''},
  body: [
    {
      type: 'ExpressionStatement',
      loc:{start:{line:1,column:0},end:{line:5,column:3},source:''},
      expression: {
        type: 'ObjectExpression',
        loc:{start:{line:1,column:1},end:{line:5,column:1},source:''},
        properties: [
          {
            type: 'Property',
            loc:{start:{line:2,column:2},end:{line:2,column:17},source:''},
            key: {
              type: 'Identifier',
              loc:{start:{line:2,column:2},end:{line:2,column:11},source:''},
              name: '__proto__'
            },
            kind: 'init',
            method: false,
            computed: false,
            value: {
              type: 'Literal',
              loc:{start:{line:2,column:13},end:{line:2,column:17},source:''},
              value: null,
              raw: 'null'
            },
            shorthand: false
          },
          {
            type: 'Property',
            loc:{start:{line:3,column:2},end:{line:3,column:13},source:''},
            key: {
              type: 'Identifier',
              loc:{start:{line:3,column:2},end:{line:3,column:7},source:''},
              name: 'other'
            },
            kind: 'init',
            method: false,
            computed: false,
            value: {
              type: 'Literal',
              loc:{start:{line:3,column:9},end:{line:3,column:13},source:''},
              value: null,
              raw: 'null'
            },
            shorthand: false
          },
          {
            type: 'Property',
            loc:{start:{line:4,column:2},end:{line:4,column:19},source:''},
            key: {
              type: 'Literal',
              loc:{start:{line:4,column:2},end:{line:4,column:13},source:''},
              value: '__proto__',
              raw: "'__proto__'"
            },
            kind: 'init',
            method: false,
            computed: false,
            value: {
              type: 'Literal',
              loc:{start:{line:4,column:15},end:{line:4,column:19},source:''},
              value: null,
              raw: 'null'
            },
            shorthand: false
          }
        ]
      }
    }
  ]
}

tokens (17x):
       PUNC_PAREN_OPEN PUNC_CURLY_OPEN IDENT PUNC_COLON ID_null
       PUNC_COMMA IDENT PUNC_COLON ID_null PUNC_COMMA STRING_SINGLE
       PUNC_COLON ID_null PUNC_CURLY_CLOSE PUNC_PAREN_CLOSE PUNC_SEMI
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

`````
throws: Parser error!
  Found a part that cant destruct and a part that must destruct so it is not destructible

({
  __proto__: null,
  other: null,
  '__proto__': null
});
 ^------- error
`````


## AST Printer

Printer output different from input [sloppy]:

````js
({__proto__:null, other:null, '__proto__':null});
````

Produces same AST
