# Tenko parser test case

- Path: tests/testcases/objects/duplicate_keys/obj_expr/dunderproto___proto__/okay_with_shorthand_right.md

> :: objects : duplicate keys : obj expr : dunderproto proto
>
> ::> okay with shorthand right
> 
> https://tc39.github.io/ecma262/#sec-__proto__-property-names-in-object-initializers
> 
> > It is a Syntax Error if PropertyNameList of PropertyDefinitionList contains any duplicate entries for "__proto__" and at least two of those entries were obtained from productions of the form PropertyDefinition:PropertyName:AssignmentExpression .
> 
> This restriction only applies to webcompat mode (annex B)

## Input

`````js
x = {__proto__: 1, __proto__}
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:29},source:''},
  body: [
    {
      type: 'ExpressionStatement',
      loc:{start:{line:1,column:0},end:{line:1,column:29},source:''},
      expression: {
        type: 'AssignmentExpression',
        loc:{start:{line:1,column:0},end:{line:1,column:29},source:''},
        left: {
          type: 'Identifier',
          loc:{start:{line:1,column:0},end:{line:1,column:1},source:''},
          name: 'x'
        },
        operator: '=',
        right: {
          type: 'ObjectExpression',
          loc:{start:{line:1,column:4},end:{line:1,column:29},source:''},
          properties: [
            {
              type: 'Property',
              loc:{start:{line:1,column:5},end:{line:1,column:17},source:''},
              key: {
                type: 'Identifier',
                loc:{start:{line:1,column:5},end:{line:1,column:14},source:''},
                name: '__proto__'
              },
              kind: 'init',
              method: false,
              computed: false,
              value: {
                type: 'Literal',
                loc:{start:{line:1,column:16},end:{line:1,column:17},source:''},
                value: 1,
                raw: '1'
              },
              shorthand: false
            },
            {
              type: 'Property',
              loc:{start:{line:1,column:19},end:{line:1,column:28},source:''},
              key: {
                type: 'Identifier',
                loc:{start:{line:1,column:19},end:{line:1,column:28},source:''},
                name: '__proto__'
              },
              kind: 'init',
              method: false,
              computed: false,
              value: {
                type: 'Identifier',
                loc:{start:{line:1,column:19},end:{line:1,column:28},source:''},
                name: '__proto__'
              },
              shorthand: true
            }
          ]
        }
      }
    }
  ]
}

tokens (11x):
       IDENT PUNC_EQ PUNC_CURLY_OPEN IDENT PUNC_COLON NUMBER_DEC
       PUNC_COMMA IDENT PUNC_CURLY_CLOSE ASI
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
((x = {__proto__:1, __proto__}));
````

Produces same AST
