# Tenko parser test case

- Path: tests/testcases/objects/duplicate_keys/obj_expr/first_and_last.md

> :: objects : duplicate keys : obj expr
>
> ::> first and last
> 
> https://tc39.github.io/ecma262/#sec-additions-and-changes-that-introduce-incompatibilities-with-prior-editions
> 
> 12.2.6.1: In ECMAScript 2015, it is no longer an early error to have duplicate property names in Object Initializers.

## Input

`````js
({a: 1, b: 3, a: 2})
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:20},source:''},
  body: [
    {
      type: 'ExpressionStatement',
      loc:{start:{line:1,column:0},end:{line:1,column:20},source:''},
      expression: {
        type: 'ObjectExpression',
        loc:{start:{line:1,column:1},end:{line:1,column:19},source:''},
        properties: [
          {
            type: 'Property',
            loc:{start:{line:1,column:2},end:{line:1,column:6},source:''},
            key: {
              type: 'Identifier',
              loc:{start:{line:1,column:2},end:{line:1,column:3},source:''},
              name: 'a'
            },
            kind: 'init',
            method: false,
            computed: false,
            value: {
              type: 'Literal',
              loc:{start:{line:1,column:5},end:{line:1,column:6},source:''},
              value: 1,
              raw: '1'
            },
            shorthand: false
          },
          {
            type: 'Property',
            loc:{start:{line:1,column:8},end:{line:1,column:12},source:''},
            key: {
              type: 'Identifier',
              loc:{start:{line:1,column:8},end:{line:1,column:9},source:''},
              name: 'b'
            },
            kind: 'init',
            method: false,
            computed: false,
            value: {
              type: 'Literal',
              loc:{start:{line:1,column:11},end:{line:1,column:12},source:''},
              value: 3,
              raw: '3'
            },
            shorthand: false
          },
          {
            type: 'Property',
            loc:{start:{line:1,column:14},end:{line:1,column:18},source:''},
            key: {
              type: 'Identifier',
              loc:{start:{line:1,column:14},end:{line:1,column:15},source:''},
              name: 'a'
            },
            kind: 'init',
            method: false,
            computed: false,
            value: {
              type: 'Literal',
              loc:{start:{line:1,column:17},end:{line:1,column:18},source:''},
              value: 2,
              raw: '2'
            },
            shorthand: false
          }
        ]
      }
    }
  ]
}

tokens (17x):
       PUNC_PAREN_OPEN PUNC_CURLY_OPEN IDENT PUNC_COLON NUMBER_DEC
       PUNC_COMMA IDENT PUNC_COLON NUMBER_DEC PUNC_COMMA IDENT
       PUNC_COLON NUMBER_DEC PUNC_CURLY_CLOSE PUNC_PAREN_CLOSE ASI
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
({a:1, b:3, a:2});
````

Produces same AST
