# Tenko parser test case

- Path: tests/testcases/objects/ellipsis/can_be_addition.md

> :: objects : ellipsis
>
> ::> can be addition
>
> https://tc39.es/ecma262/#prod-DestructuringAssignmentTarget
>
> https://tc39.es/ecma262/#prod-BindingRestProperty
>
> The arg of object rest must at best be a valid lhs. Addition is neither so addition is not destructible, either way.
>
> https://tc39.es/ecma262/#prod-PropertyDefinition
>
> The arg of object spread must be an assignment expression. Addition falls in that category so it should be valid as object spread arg.

## Input

`````js
x = {...a + b}
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:14},source:''},
  body: [
    {
      type: 'ExpressionStatement',
      loc:{start:{line:1,column:0},end:{line:1,column:14},source:''},
      expression: {
        type: 'AssignmentExpression',
        loc:{start:{line:1,column:0},end:{line:1,column:14},source:''},
        left: {
          type: 'Identifier',
          loc:{start:{line:1,column:0},end:{line:1,column:1},source:''},
          name: 'x'
        },
        operator: '=',
        right: {
          type: 'ObjectExpression',
          loc:{start:{line:1,column:4},end:{line:1,column:14},source:''},
          properties: [
            {
              type: 'SpreadElement',
              loc:{start:{line:1,column:5},end:{line:1,column:13},source:''},
              argument: {
                type: 'BinaryExpression',
                loc:{start:{line:1,column:8},end:{line:1,column:13},source:''},
                left: {
                  type: 'Identifier',
                  loc:{start:{line:1,column:8},end:{line:1,column:9},source:''},
                  name: 'a'
                },
                operator: '+',
                right: {
                  type: 'Identifier',
                  loc:{start:{line:1,column:12},end:{line:1,column:13},source:''},
                  name: 'b'
                }
              }
            }
          ]
        }
      }
    }
  ]
}

tokens (10x):
       IDENT PUNC_EQ PUNC_CURLY_OPEN PUNC_DOT_DOT_DOT IDENT PUNC_PLUS
       IDENT PUNC_CURLY_CLOSE ASI
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
((x = {...((a) + (b))}));
````

Produces same AST
