# Tenko parser test case

- Path: tests/testcases/objects/literals/identifier_properties/shorthand_can_have_default_without_init_when_lhs_of_for-of.md

> :: objects : literals : identifier properties
>
> ::> shorthand can have default without init when lhs of for-of

## Input

`````js
for ({x=y} of a) b
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:18},source:''},
  body: [
    {
      type: 'ForOfStatement',
      loc:{start:{line:1,column:0},end:{line:1,column:18},source:''},
      left: {
        type: 'ObjectPattern',
        loc:{start:{line:1,column:5},end:{line:1,column:10},source:''},
        properties: [
          {
            type: 'Property',
            loc:{start:{line:1,column:6},end:{line:1,column:9},source:''},
            key: {
              type: 'Identifier',
              loc:{start:{line:1,column:6},end:{line:1,column:7},source:''},
              name: 'x'
            },
            kind: 'init',
            method: false,
            computed: false,
            value: {
              type: 'AssignmentPattern',
              loc:{start:{line:1,column:6},end:{line:1,column:9},source:''},
              left: {
                type: 'Identifier',
                loc:{start:{line:1,column:6},end:{line:1,column:7},source:''},
                name: 'x'
              },
              right: {
                type: 'Identifier',
                loc:{start:{line:1,column:8},end:{line:1,column:9},source:''},
                name: 'y'
              }
            },
            shorthand: true
          }
        ]
      },
      right: {
        type: 'Identifier',
        loc:{start:{line:1,column:14},end:{line:1,column:15},source:''},
        name: 'a'
      },
      await: false,
      body: {
        type: 'ExpressionStatement',
        loc:{start:{line:1,column:17},end:{line:1,column:18},source:''},
        expression: {
          type: 'Identifier',
          loc:{start:{line:1,column:17},end:{line:1,column:18},source:''},
          name: 'b'
        }
      }
    }
  ]
}

tokens (13x):
       ID_for PUNC_PAREN_OPEN PUNC_CURLY_OPEN IDENT PUNC_EQ IDENT
       PUNC_CURLY_CLOSE ID_of IDENT PUNC_PAREN_CLOSE IDENT ASI
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
for ({x = y} of a) (b);
````

Produces same AST
