# Tenko parser test case

- Path: tests/testcases/other_unclassified_cases/reading_from_arguments.md

> :: other unclassified cases
>
> ::> reading from arguments

## Input

`````js
arguments; log(arguments); arguments.foo; arguments[foo]; arguments.foo = bar; arguments[foo] = bar;
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:100},source:''},
  body: [
    {
      type: 'ExpressionStatement',
      loc:{start:{line:1,column:0},end:{line:1,column:10},source:''},
      expression: {
        type: 'Identifier',
        loc:{start:{line:1,column:0},end:{line:1,column:9},source:''},
        name: 'arguments'
      }
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:1,column:11},end:{line:1,column:26},source:''},
      expression: {
        type: 'CallExpression',
        loc:{start:{line:1,column:11},end:{line:1,column:25},source:''},
        callee: {
          type: 'Identifier',
          loc:{start:{line:1,column:11},end:{line:1,column:14},source:''},
          name: 'log'
        },
        arguments: [
          {
            type: 'Identifier',
            loc:{start:{line:1,column:15},end:{line:1,column:24},source:''},
            name: 'arguments'
          }
        ]
      }
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:1,column:27},end:{line:1,column:41},source:''},
      expression: {
        type: 'MemberExpression',
        loc:{start:{line:1,column:27},end:{line:1,column:40},source:''},
        object: {
          type: 'Identifier',
          loc:{start:{line:1,column:27},end:{line:1,column:36},source:''},
          name: 'arguments'
        },
        property: {
          type: 'Identifier',
          loc:{start:{line:1,column:37},end:{line:1,column:40},source:''},
          name: 'foo'
        },
        computed: false
      }
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:1,column:42},end:{line:1,column:57},source:''},
      expression: {
        type: 'MemberExpression',
        loc:{start:{line:1,column:42},end:{line:1,column:56},source:''},
        object: {
          type: 'Identifier',
          loc:{start:{line:1,column:42},end:{line:1,column:51},source:''},
          name: 'arguments'
        },
        property: {
          type: 'Identifier',
          loc:{start:{line:1,column:52},end:{line:1,column:55},source:''},
          name: 'foo'
        },
        computed: true
      }
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:1,column:58},end:{line:1,column:78},source:''},
      expression: {
        type: 'AssignmentExpression',
        loc:{start:{line:1,column:58},end:{line:1,column:77},source:''},
        left: {
          type: 'MemberExpression',
          loc:{start:{line:1,column:58},end:{line:1,column:71},source:''},
          object: {
            type: 'Identifier',
            loc:{start:{line:1,column:58},end:{line:1,column:67},source:''},
            name: 'arguments'
          },
          property: {
            type: 'Identifier',
            loc:{start:{line:1,column:68},end:{line:1,column:71},source:''},
            name: 'foo'
          },
          computed: false
        },
        operator: '=',
        right: {
          type: 'Identifier',
          loc:{start:{line:1,column:74},end:{line:1,column:77},source:''},
          name: 'bar'
        }
      }
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:1,column:79},end:{line:1,column:100},source:''},
      expression: {
        type: 'AssignmentExpression',
        loc:{start:{line:1,column:79},end:{line:1,column:99},source:''},
        left: {
          type: 'MemberExpression',
          loc:{start:{line:1,column:79},end:{line:1,column:93},source:''},
          object: {
            type: 'Identifier',
            loc:{start:{line:1,column:79},end:{line:1,column:88},source:''},
            name: 'arguments'
          },
          property: {
            type: 'Identifier',
            loc:{start:{line:1,column:89},end:{line:1,column:92},source:''},
            name: 'foo'
          },
          computed: true
        },
        operator: '=',
        right: {
          type: 'Identifier',
          loc:{start:{line:1,column:96},end:{line:1,column:99},source:''},
          name: 'bar'
        }
      }
    }
  ]
}

tokens (30x):
       ID_arguments PUNC_SEMI IDENT PUNC_PAREN_OPEN ID_arguments
       PUNC_PAREN_CLOSE PUNC_SEMI ID_arguments PUNC_DOT IDENT
       PUNC_SEMI ID_arguments PUNC_BRACKET_OPEN IDENT
       PUNC_BRACKET_CLOSE PUNC_SEMI ID_arguments PUNC_DOT IDENT
       PUNC_EQ IDENT PUNC_SEMI ID_arguments PUNC_BRACKET_OPEN IDENT
       PUNC_BRACKET_CLOSE PUNC_EQ IDENT PUNC_SEMI
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
(arguments);
((log)(arguments));
((arguments).foo);
((arguments)[foo]);
(((arguments).foo = bar));
(((arguments)[foo] = bar));
````

Produces same AST
