# Tenko parser test case

- Path: tests/testcases/random_stuff/x002318/ax002f0.md

> :: random stuff : x002318
>
> ::> ax002f0
>
> Note: Babel was incorrectly throwing an error for assigning to `eval` in strict mode. But that's not happening here because the assignment is to a property of a fresh object with one key that is the name and value of `eval`, which is fine in strict mode.
>
> Simpler put; the code is essentially doing this, which is more obviously legal in strict mode:
>
> ```
> let obj = {};
> obj.eval = eval;
> obj.x = {};
> ```

## Input

`````js
({...{eval}.x} = {});
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:21},source:''},
  body: [
    {
      type: 'ExpressionStatement',
      loc:{start:{line:1,column:0},end:{line:1,column:21},source:''},
      expression: {
        type: 'AssignmentExpression',
        loc:{start:{line:1,column:1},end:{line:1,column:19},source:''},
        left: {
          type: 'ObjectPattern',
          loc:{start:{line:1,column:1},end:{line:1,column:14},source:''},
          properties: [
            {
              type: 'RestElement',
              loc:{start:{line:1,column:2},end:{line:1,column:13},source:''},
              argument: {
                type: 'MemberExpression',
                loc:{start:{line:1,column:5},end:{line:1,column:13},source:''},
                object: {
                  type: 'ObjectExpression',
                  loc:{start:{line:1,column:5},end:{line:1,column:11},source:''},
                  properties: [
                    {
                      type: 'Property',
                      loc:{start:{line:1,column:6},end:{line:1,column:10},source:''},
                      key: {
                        type: 'Identifier',
                        loc:{start:{line:1,column:6},end:{line:1,column:10},source:''},
                        name: 'eval'
                      },
                      kind: 'init',
                      method: false,
                      computed: false,
                      value: {
                        type: 'Identifier',
                        loc:{start:{line:1,column:6},end:{line:1,column:10},source:''},
                        name: 'eval'
                      },
                      shorthand: true
                    }
                  ]
                },
                property: {
                  type: 'Identifier',
                  loc:{start:{line:1,column:12},end:{line:1,column:13},source:''},
                  name: 'x'
                },
                computed: false
              }
            }
          ]
        },
        operator: '=',
        right: {
          type: 'ObjectExpression',
          loc:{start:{line:1,column:17},end:{line:1,column:19},source:''},
          properties: []
        }
      }
    }
  ]
}

tokens (15x):
       PUNC_PAREN_OPEN PUNC_CURLY_OPEN PUNC_DOT_DOT_DOT
       PUNC_CURLY_OPEN ID_eval PUNC_CURLY_CLOSE PUNC_DOT IDENT
       PUNC_CURLY_CLOSE PUNC_EQ PUNC_CURLY_OPEN PUNC_CURLY_CLOSE
       PUNC_PAREN_CLOSE PUNC_SEMI
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
(({...({eval}).x} = {}));
````

Produces same AST
