# Tenko parser test case

- Path: tests/testcases/regexes/named_capturing_groups/bad_syntax_cases/k_arg_also_partial_match_second.md

> :: regexes : named capturing groups : bad syntax cases
>
> ::> k arg also partial match second
>
> This catches a regression where the first char of the group was omitted and so the original test case would still pass since it would record `ab` as `b` and then check group `a`. So this test checks group `b` for `ab` and if the first char is still omitted then it would pass, where it should fail.
>
> This should fail, I think in webcompat as well...

## Input

`````js
/(?<ab>a)\k<b>/
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
throws: Lexer error!
    Named back reference \k<b> was not defined in this regex: {#ab:true}

/(?<ab>a)\k<b>/
^------- error
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:15},source:''},
  body: [
    {
      type: 'ExpressionStatement',
      loc:{start:{line:1,column:0},end:{line:1,column:15},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:1,column:0},end:{line:1,column:15},source:''},
        value: null,
        regex: { pattern: '(?<ab>a)\\k<b>', flags: '' },
        raw: '/(?<ab>a)\\k<b>/'
      }
    }
  ]
}

tokens (3x):
       REGEXN ASI
`````


## AST Printer

Printer output different from input [web]:

````js
/(?<ab>a)\k<b>/;
````

Produces same AST
