# Tenko parser test case

- Path: tests/testcases/regexes/named_capturing_groups/non_bmp_unicode/idrest_as_start_of_groupname.md

> :: regexes : named capturing groups : non bmp unicode
>
> ::> idrest as start of groupname
>
> This checks whether `\u{1D7D0}` / `\uD835\uDFD0` is accepted as the start of a valid group name start
>
> I think that because RegExpIdentifierName is syntactically not parse-able (because the first character is a number), the whole thing is never "again" parsed as a groupname in webcompat mode. In other words, it never traverses the +N route.
>
> Since it won't trigger +N, it won't parse a group in webcompat, so it passes as an extended atom.

## Input

`````js
/(?<@{x1d7d0}@rest>foo)/
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
throws: Lexer error!
    Regex: Wanted to parse an unescaped group name specifier but it had a bad start: [`@{xd835}@`, 55349]

/(?<@{x1d7d0}@rest>foo)/
^------- error
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:16},source:''},
  body: [
    {
      type: 'ExpressionStatement',
      loc:{start:{line:1,column:0},end:{line:1,column:16},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:1,column:0},end:{line:1,column:16},source:''},
        value: null,
        regex: { pattern: '(?<@{x1d7d0}@rest>foo)', flags: '' },
        raw: '/(?<@{x1d7d0}@rest>foo)/'
      }
    }
  ]
}

tokens (3x):
       REGEXN ASI
`````


## AST Printer

Printer output different from input [web]:

````js
/(?<@{x1d7d0}@rest>foo)/;
````

Produces same AST
