# Tenko parser test case

- Path: tests/testcases/regexes/named_capturing_groups/non_bmp_unicode/idrest_group_name_dupe_check_lhs.u.md

> :: regexes : named capturing groups : non bmp unicode
>
> ::> idrest group name dupe check lhs.u
>
> This checks whether `\u{1D7D0}` / `\uD835\uDFD0` is accepted inside a valid group
>
> The backreference should fail to match the group because it's only half of the surrogate pair
>
> I think that because RegExpIdentifierName is syntactically not parse-able (because the the surrogate head cannot be validly parsed at all without a tail) it is never "again" parsed as a groupname in webcompat mode. In other words, it never traverses the +N route.
>
> Since it won't trigger +N, it won't parse a group in webcompat, so it passes as an extended atom.

## FAIL

## Input

`````js
/(?<abc@{x1d7d0}@def>foo\k<abc@{xfffd}@def>)/u
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
throws: Lexer error!
    Regex: name contained a character that is only a valid identifier with u-flag; Missing closing angle bracket of name of capturing group

/(?<abc@{x1d7d0}@def>foo\k<abc@{xfffd}@def>)/u
^------- error
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._
