# Tenko parser test case

- Path: tests/testcases/regexes/named_capturing_groups/non_bmp_unicode_double_escaped/idstart_start_dupe_check_rhs.md

> :: regexes : named capturing groups : non bmp unicode double escaped
>
> ::> idstart start dupe check rhs
>
> Capturing group name starts with a non-bmp unicode ID_START
>
> This confirms whether the right hand of surrogate pair `\u{2F9DF}` / `\ud87e\udddf`, which is `\udddf`, is correctly reported as not being declared as a group name
>
> The backreference should fail to match the group because it's only half of the surrogate pair
>
> I think that because RegExpIdentifierName is syntactically not parse-able (because the the surrogate head cannot be validly parsed at all without a tail) it is never "again" parsed as a groupname in webcompat mode. In other words, it never traverses the +N route.
>
> Since it won't trigger +N, it won't parse a group in webcompat, so it passes as an extended atom.

## FAIL

## Input

`````js
/(?<\ud87e\udddfxyz>foo)met\k<\udddfxyz>/
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
throws: Lexer error!
    Regex: A double unicode quad escape that represents a surrogate pair in char class or group name is only valid with u-flag; Found a quad that was a surrogate pair which created a valid identifier character and that will only work with u-flag; Named capturing group named contained an invalid unicode escaped char: [`@{xdddf}@`, 56799]

/(?<\ud87e\udddfxyz>foo)met\k<\udddfxyz>/
^------- error
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._
