# Tenko parser test case

- Path: tests/testcases/regexes/named_capturing_groups/non_bmp_unicode_long_escaped/idrest_as_start_of_groupname.md

> :: regexes : named capturing groups : non bmp unicode long escaped
>
> ::> idrest as start of groupname
>
> This checks whether `\u{1D7D0}` / `\uD835\uDFD0` is accepted as the start of a valid group name start
>
> Note that this is an ID_REST char, that is not an ID_START char, so it should fail regardless.
>
> This must fail because the `\u{...}` unicode escape is only valid with u-flag in regular expressions, and the flag is missing in this test case.

## FAIL

## Input

`````js
/(?<\u{1D7D0}rest>foo)/
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
throws: Lexer error!
    Regex: The es6 long unicode escape is only valid with u-flag; Encountered extended unicode escape (`\u{}`) or surrogate pair unicode quads (`\uxxxx\uxxxx`) which is only valid with u-flag; Named capturing group named contained an invalid unicode escaped char: [`@{x1d7d0}@`, 120784]

/(?<\u{1D7D0}rest>foo)/
^------- error
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._
