# Tenko parser test case

- Path: tests/testcases/regexes/named_capturing_groups/non_bmp_unicode_long_escaped/idstart_start_dupe_check_rhs.md

> :: regexes : named capturing groups : non bmp unicode long escaped
>
> ::> idstart start dupe check rhs
>
> Capturing group name starts with a non-bmp unicode ID_START
>
> This confirms whether the right hand of surrogate pair `\u{2F9DF}` / `\ud87e\udddf`, which is `\udddf`, is correctly reported as not being declared as a group name
>
> The backreference should fail to match the group because it's only half of the surrogate pair
>
> This must fail because the `\u{...}` unicode escape is only valid with u-flag in regular expressions, and the flag is missing in this test case.

## FAIL

## Input

`````js
/(?<\u{2F9DF}xyz>foo)met\k<\udddfxyz>/
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
throws: Lexer error!
    Regex: The es6 long unicode escape is only valid with u-flag; Encountered extended unicode escape (`\u{}`) or surrogate pair unicode quads (`\uxxxx\uxxxx`) which is only valid with u-flag; Named capturing group named contained an invalid unicode escaped char: [`@{xdddf}@`, 56799]

/(?<\u{2F9DF}xyz>foo)met\k<\udddfxyz>/
^------- error
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._
