# Tenko parser test case

- Path: tests/testcases/regexes/ranges/charclass_escaped_dash.md

> :: regexes : ranges
>
> ::> charclass escaped dash
>
> Regression was causing this to throw a range error, even in web compat mode
>
> This should pass with web compat because the dash can be escaped there.

## Input

`````js
/[b\-a]/
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
throws: Lexer error!
    Regex: Escaping a dash in a char class is not allowed; Regex body had an escape that is only valid with an u-flag, but it had no u-flag

/[b\-a]/
^------- error
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:8},source:''},
  body: [
    {
      type: 'ExpressionStatement',
      loc:{start:{line:1,column:0},end:{line:1,column:8},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:1,column:0},end:{line:1,column:8},source:''},
        value: null,
        regex: { pattern: '[b\\-a]', flags: '' },
        raw: '/[b\\-a]/'
      }
    }
  ]
}

tokens (3x):
       REGEXN ASI
`````


## AST Printer

Printer output different from input [web]:

````js
/[b\-a]/;
````

Produces same AST
