# Tenko parser test case

- Path: tests/testcases/regexes/ranges/charclass_escaped_dash.u.md

> :: regexes : ranges
>
> ::> charclass escaped dash.u
>
> Regression was causing this to throw a range error, even in web compat mode
>
> This should pass because the dash can be escaped with u-flag.

## PASS

## Input

`````js
/[b\-a]/u
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:9},source:''},
  body: [
    {
      type: 'ExpressionStatement',
      loc:{start:{line:1,column:0},end:{line:1,column:9},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:1,column:0},end:{line:1,column:9},source:''},
        value: null,
        regex: { pattern: '[b\\-a]', flags: 'u' },
        raw: '/[b\\-a]/u'
      }
    }
  ]
}

tokens (3x):
       REGEXU ASI
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
/[b\-a]/u;
````

Produces same AST
