# Tenko parser test case

- Path: tests/testcases/regexes/some_annexb_stuff/char_class_in_a_range/both_with_web_without_u-flag.md

> :: regexes : some annexb stuff : char class in a range
>
> ::> both with web without u-flag
>
> https://tc39.es/ecma262/#sec-patterns-static-semantics-early-errors
>
> NonemptyClassRangesNoDash :: ClassAtomNoDash `-` ClassAtomClassRanges
>
> > It is a Syntax Error if IsCharacterClass of ClassAtomNoDash is true or IsCharacterClass of ClassAtom is true.
>
> So this is illegal outside of webcompat mode.
>
> https://tc39.es/ecma262/#sec-patterns-static-semantics-early-errors-annexb
>
> This says that under webcompat mode, this rule only applies with u-flag
>
> So this should pass in webcompat and fail all other cases

## Input

`````js
/[\s-\d]+/
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
throws: Lexer error!
    Regex: Character class escapes `\d \D \s \S \w \W \p \P` are only ok as a range with webcompat, without uflag

/[\s-\d]+/
^------- error
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:10},source:''},
  body: [
    {
      type: 'ExpressionStatement',
      loc:{start:{line:1,column:0},end:{line:1,column:10},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:1,column:0},end:{line:1,column:10},source:''},
        value: null,
        regex: { pattern: '[\\s-\\d]+', flags: '' },
        raw: '/[\\s-\\d]+/'
      }
    }
  ]
}

tokens (3x):
       REGEXN ASI
`````


## AST Printer

Printer output different from input [web]:

````js
/[\s-\d]+/;
````

Produces same AST
