# Tenko parser test case

- Path: tests/testcases/regexes/some_annexb_stuff/invalid_escape_char/A_backslash_c.md

> :: regexes : some annexb stuff : invalid escape char
>
> ::> A backslash c
>
> The character value of an unqualified \c (with no param) is the backslash! Not the `c`
>
> So a-\c is bad where A-\c is good (backslash sits between lower and upper case)

## Input

`````js
/[A-\c]/
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
throws: Lexer error!
    Regex: The `\c` escape is only legal in a char class without uflag and in webcompat mode

/[A-\c]/
^------- error
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:8},source:''},
  body: [
    {
      type: 'ExpressionStatement',
      loc:{start:{line:1,column:0},end:{line:1,column:8},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:1,column:0},end:{line:1,column:8},source:''},
        value: null,
        regex: { pattern: '[A-\\c]', flags: '' },
        raw: '/[A-\\c]/'
      }
    }
  ]
}

tokens (3x):
       REGEXN ASI
`````


## AST Printer

Printer output different from input [web]:

````js
/[A-\c]/;
````

Produces same AST
