# Tenko parser test case

- Path: tests/testcases/regexes/some_annexb_stuff/octal_escape_in_char_class/without_web_compat.md

> :: regexes : some annexb stuff : octal escape in char class
>
> ::> without web compat
> 
> https://tc39.github.io/ecma262/#prod-CharacterClass
> 
> https://tc39.github.io/ecma262/#prod-ClassRanges
> 
> https://tc39.github.io/ecma262/#prod-NonemptyClassRanges
> 
> NonemptyClassRanges is extended by annex B:
> 
>   https://tc39.github.io/ecma262/#sec-patterns-static-semantics-early-errors-annexb
> 
>   NonemptyClassRangesNoDash :: ClassAtomNoDash - ClassAtom ClassRanges
> 
> https://tc39.github.io/ecma262/#prod-annexB-ClassAtomNoDash
> 
> https://tc39.github.io/ecma262/#prod-annexB-ClassEscape
> 
> https://tc39.github.io/ecma262/#prod-annexB-CharacterEscape
> 
> https://tc39.github.io/ecma262/#prod-annexB-LegacyOctalEscapeSequence
> 
> note:
> 
> https://tc39.github.io/ecma262/#sec-literals-string-literals
> 
> A conforming implementation, when processing strict mode code, must not extend the syntax of EscapeSequence to include LegacyOctalEscapeSequence as described in B.1.2.

## Input

`````js
/[\12-\14]/
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
throws: Lexer error!
    Regex: Back reference is only one digit and cannot be followed by another digit

/[\12-\14]/
^------- error
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:11},source:''},
  body: [
    {
      type: 'ExpressionStatement',
      loc:{start:{line:1,column:0},end:{line:1,column:11},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:1,column:0},end:{line:1,column:11},source:''},
        value: null,
        regex: { pattern: '[\\12-\\14]', flags: '' },
        raw: '/[\\12-\\14]/'
      }
    }
  ]
}

tokens (3x):
       REGEXN ASI
`````


## AST Printer

Printer output different from input [web]:

````js
/[\12-\14]/;
````

Produces same AST
