# Tenko parser test case

- Path: tests/testcases/regexes/some_annexb_stuff/property-escape-without-uflag.md

> :: regexes : some annexb stuff
>
> ::> property-escape-without-uflag
>
> Property escape without u-flag
>
> Should only pass in webcompat mode

## Input

`````js
/[\p{Hex}]/;
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
throws: Lexer error!
    Regex: The `\p` property escape is only legal with a u-flag, or as a webcompat edge case; Regex body had an escape that is only valid with an u-flag, but it had no u-flag

/[\p{Hex}]/;
^------- error
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:12},source:''},
  body: [
    {
      type: 'ExpressionStatement',
      loc:{start:{line:1,column:0},end:{line:1,column:12},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:1,column:0},end:{line:1,column:11},source:''},
        value: null,
        regex: { pattern: '[\\p{Hex}]', flags: '' },
        raw: '/[\\p{Hex}]/'
      }
    }
  ]
}

tokens (3x):
       REGEXN PUNC_SEMI
`````


## AST Printer

Printer output was same as input [web]
