# Tenko parser test case

- Path: tests/testcases/restricted_productions/update_expression/after_await_1.md

> :: restricted productions : update expression
>
> ::> after await 1
>
> this may throw off the restricted production check for ++ since the newline is fine here
>
> note: await is not restricted so the newline is fine here. the await arg is mandatory.

## Input

`````js
async function f(){ await
++c; }
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:2,column:6},source:''},
  body: [
    {
      type: 'FunctionDeclaration',
      loc:{start:{line:1,column:0},end:{line:2,column:6},source:''},
      generator: false,
      async: true,
      id: {
        type: 'Identifier',
        loc:{start:{line:1,column:15},end:{line:1,column:16},source:''},
        name: 'f'
      },
      params: [],
      body: {
        type: 'BlockStatement',
        loc:{start:{line:1,column:18},end:{line:2,column:6},source:''},
        body: [
          {
            type: 'ExpressionStatement',
            loc:{start:{line:1,column:20},end:{line:2,column:4},source:''},
            expression: {
              type: 'AwaitExpression',
              loc:{start:{line:1,column:20},end:{line:2,column:3},source:''},
              argument: {
                type: 'UpdateExpression',
                loc:{start:{line:2,column:0},end:{line:2,column:3},source:''},
                argument: {
                  type: 'Identifier',
                  loc:{start:{line:2,column:2},end:{line:2,column:3},source:''},
                  name: 'c'
                },
                operator: '++',
                prefix: true
              }
            }
          }
        ]
      }
    }
  ]
}

tokens (12x):
       ID_async ID_function IDENT PUNC_PAREN_OPEN PUNC_PAREN_CLOSE
       PUNC_CURLY_OPEN ID_await PUNC_PLUS_PLUS IDENT PUNC_SEMI
       PUNC_CURLY_CLOSE
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
async function f() {await (++c);}
````

Produces same AST
