# Tenko parser test case

- Path: tests/testcases/restricted_productions/update_expression/after_typeof.md

> :: restricted productions : update expression
>
> ::> after typeof

## Input

`````js
typeof b
++c;
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:2,column:4},source:''},
  body: [
    {
      type: 'ExpressionStatement',
      loc:{start:{line:1,column:0},end:{line:1,column:8},source:''},
      expression: {
        type: 'UnaryExpression',
        loc:{start:{line:1,column:0},end:{line:1,column:8},source:''},
        operator: 'typeof',
        prefix: true,
        argument: {
          type: 'Identifier',
          loc:{start:{line:1,column:7},end:{line:1,column:8},source:''},
          name: 'b'
        }
      }
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:2,column:0},end:{line:2,column:4},source:''},
      expression: {
        type: 'UpdateExpression',
        loc:{start:{line:2,column:0},end:{line:2,column:3},source:''},
        argument: {
          type: 'Identifier',
          loc:{start:{line:2,column:2},end:{line:2,column:3},source:''},
          name: 'c'
        },
        operator: '++',
        prefix: true
      }
    }
  ]
}

tokens (7x):
       ID_typeof IDENT ASI PUNC_PLUS_PLUS IDENT PUNC_SEMI
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
(typeof (b));
++c;
````

Produces same AST
