# Tenko parser test case

- Path: tests/testcases/return_statement/return_fwd_regex_noflag.md

> :: return statement
>
> ::> return fwd regex noflag
>
> The `return` keyword is "restricted", meaning it will proc ASI if a newline follows it.
>
> The forward slash cannot form a division so ASI applies and the forward slash is a regex.

## PASS

## Input

`````js
function f(){
  return
  /x/
}
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:4,column:1},source:''},
  body: [
    {
      type: 'FunctionDeclaration',
      loc:{start:{line:1,column:0},end:{line:4,column:1},source:''},
      generator: false,
      async: false,
      id: {
        type: 'Identifier',
        loc:{start:{line:1,column:9},end:{line:1,column:10},source:''},
        name: 'f'
      },
      params: [],
      body: {
        type: 'BlockStatement',
        loc:{start:{line:1,column:12},end:{line:4,column:1},source:''},
        body: [
          {
            type: 'ReturnStatement',
            loc:{start:{line:2,column:2},end:{line:2,column:8},source:''},
            argument: null
          },
          {
            type: 'ExpressionStatement',
            loc:{start:{line:3,column:2},end:{line:3,column:5},source:''},
            expression: {
              type: 'Literal',
              loc:{start:{line:3,column:2},end:{line:3,column:5},source:''},
              value: null,
              regex: { pattern: 'x', flags: '' },
              raw: '/x/'
            }
          }
        ]
      }
    }
  ]
}

tokens (11x):
       ID_function IDENT PUNC_PAREN_OPEN PUNC_PAREN_CLOSE
       PUNC_CURLY_OPEN ID_return ASI REGEXN ASI PUNC_CURLY_CLOSE
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
function f() {return;
/x/;}
````

Produces same AST
