# Tenko parser test case

- Path: tests/testcases/return_statement/should_work_in_arrow_C.md

> :: return statement
>
> ::> should work in arrow C

## Input

`````js
(a, b) => {return}
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:18},source:''},
  body: [
    {
      type: 'ExpressionStatement',
      loc:{start:{line:1,column:0},end:{line:1,column:18},source:''},
      expression: {
        type: 'ArrowFunctionExpression',
        loc:{start:{line:1,column:0},end:{line:1,column:18},source:''},
        params: [
          {
            type: 'Identifier',
            loc:{start:{line:1,column:1},end:{line:1,column:2},source:''},
            name: 'a'
          },
          {
            type: 'Identifier',
            loc:{start:{line:1,column:4},end:{line:1,column:5},source:''},
            name: 'b'
          }
        ],
        id: null,
        generator: false,
        async: false,
        expression: false,
        body: {
          type: 'BlockStatement',
          loc:{start:{line:1,column:10},end:{line:1,column:18},source:''},
          body: [
            {
              type: 'ReturnStatement',
              loc:{start:{line:1,column:11},end:{line:1,column:17},source:''},
              argument: null
            }
          ]
        }
      }
    }
  ]
}

tokens (12x):
       PUNC_PAREN_OPEN IDENT PUNC_COMMA IDENT PUNC_PAREN_CLOSE
       PUNC_EQ_GT PUNC_CURLY_OPEN ID_return ASI PUNC_CURLY_CLOSE ASI
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
(a, b) => {return;};
````

Produces same AST
