# Tenko parser test case

- Path: tests/testcases/return_statement/should_work_in_func_expr.md

> :: return statement
>
> ::> should work in func expr

## Input

`````js
(function(){ return })
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:22},source:''},
  body: [
    {
      type: 'ExpressionStatement',
      loc:{start:{line:1,column:0},end:{line:1,column:22},source:''},
      expression: {
        type: 'FunctionExpression',
        loc:{start:{line:1,column:1},end:{line:1,column:21},source:''},
        generator: false,
        async: false,
        id: null,
        params: [],
        body: {
          type: 'BlockStatement',
          loc:{start:{line:1,column:11},end:{line:1,column:21},source:''},
          body: [
            {
              type: 'ReturnStatement',
              loc:{start:{line:1,column:13},end:{line:1,column:19},source:''},
              argument: null
            }
          ]
        }
      }
    }
  ]
}

tokens (11x):
       PUNC_PAREN_OPEN ID_function PUNC_PAREN_OPEN PUNC_PAREN_CLOSE
       PUNC_CURLY_OPEN ID_return ASI PUNC_CURLY_CLOSE PUNC_PAREN_CLOSE
       ASI
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
(function() {return;});
````

Produces same AST
