# Tenko parser test case

- Path: tests/testcases/return_statement/switch_with_a_simple_default_and_case.md

> :: return statement
>
> ::> switch with a simple default and case

## Input

`````js
switch (A) {default: D; case B: C; }
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:36},source:''},
  body: [
    {
      type: 'SwitchStatement',
      loc:{start:{line:1,column:0},end:{line:1,column:36},source:''},
      discriminant: {
        type: 'Identifier',
        loc:{start:{line:1,column:8},end:{line:1,column:9},source:''},
        name: 'A'
      },
      cases: [
        {
          type: 'SwitchCase',
          loc:{start:{line:1,column:12},end:{line:1,column:23},source:''},
          test: null,
          consequent: [
            {
              type: 'ExpressionStatement',
              loc:{start:{line:1,column:21},end:{line:1,column:23},source:''},
              expression: {
                type: 'Identifier',
                loc:{start:{line:1,column:21},end:{line:1,column:22},source:''},
                name: 'D'
              }
            }
          ]
        },
        {
          type: 'SwitchCase',
          loc:{start:{line:1,column:24},end:{line:1,column:34},source:''},
          test: {
            type: 'Identifier',
            loc:{start:{line:1,column:29},end:{line:1,column:30},source:''},
            name: 'B'
          },
          consequent: [
            {
              type: 'ExpressionStatement',
              loc:{start:{line:1,column:32},end:{line:1,column:34},source:''},
              expression: {
                type: 'Identifier',
                loc:{start:{line:1,column:32},end:{line:1,column:33},source:''},
                name: 'C'
              }
            }
          ]
        }
      ]
    }
  ]
}

tokens (16x):
       ID_switch PUNC_PAREN_OPEN IDENT PUNC_PAREN_CLOSE
       PUNC_CURLY_OPEN ID_default PUNC_COLON IDENT PUNC_SEMI ID_case
       IDENT PUNC_COLON IDENT PUNC_SEMI PUNC_CURLY_CLOSE
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
switch (A) {default:
(D);
case B:
(C);}
````

Produces same AST
