# Tenko parser test case

- Path: tests/testcases/statements_and_declarations/cannot_nest_a_declaration_inside_a_non-block_statement/class/default.md

> :: statements and declarations : cannot nest a declaration inside a non-block statement : class
>
> ::> default

## Input

`````js
switch (x) { default: class X {} }
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:34},source:''},
  body: [
    {
      type: 'SwitchStatement',
      loc:{start:{line:1,column:0},end:{line:1,column:34},source:''},
      discriminant: {
        type: 'Identifier',
        loc:{start:{line:1,column:8},end:{line:1,column:9},source:''},
        name: 'x'
      },
      cases: [
        {
          type: 'SwitchCase',
          loc:{start:{line:1,column:13},end:{line:1,column:32},source:''},
          test: null,
          consequent: [
            {
              type: 'ClassDeclaration',
              loc:{start:{line:1,column:22},end:{line:1,column:32},source:''},
              id: {
                type: 'Identifier',
                loc:{start:{line:1,column:28},end:{line:1,column:29},source:''},
                name: 'X'
              },
              superClass: null,
              body: {
                type: 'ClassBody',
                loc:{start:{line:1,column:30},end:{line:1,column:32},source:''},
                body: []
              }
            }
          ]
        }
      ]
    }
  ]
}

tokens (13x):
       ID_switch PUNC_PAREN_OPEN IDENT PUNC_PAREN_CLOSE
       PUNC_CURLY_OPEN ID_default PUNC_COLON ID_class IDENT
       PUNC_CURLY_OPEN PUNC_CURLY_CLOSE PUNC_CURLY_CLOSE
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
switch (x) {default:
class X{}}
````

Produces same AST
