# Tenko parser test case

- Path: tests/testcases/statements_and_declarations/cannot_nest_a_declaration_inside_a_non-block_statement/const/catch.md

> :: statements and declarations : cannot nest a declaration inside a non-block statement : const
>
> ::> catch

## Input

`````js
try { } catch (e) { const y = x }
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:33},source:''},
  body: [
    {
      type: 'TryStatement',
      loc:{start:{line:1,column:0},end:{line:1,column:33},source:''},
      block: {
        type: 'BlockStatement',
        loc:{start:{line:1,column:4},end:{line:1,column:7},source:''},
        body: []
      },
      handler: {
        type: 'CatchClause',
        loc:{start:{line:1,column:8},end:{line:1,column:33},source:''},
        param: {
          type: 'Identifier',
          loc:{start:{line:1,column:15},end:{line:1,column:16},source:''},
          name: 'e'
        },
        body: {
          type: 'BlockStatement',
          loc:{start:{line:1,column:18},end:{line:1,column:33},source:''},
          body: [
            {
              type: 'VariableDeclaration',
              loc:{start:{line:1,column:20},end:{line:1,column:31},source:''},
              kind: 'const',
              declarations: [
                {
                  type: 'VariableDeclarator',
                  loc:{start:{line:1,column:26},end:{line:1,column:31},source:''},
                  id: {
                    type: 'Identifier',
                    loc:{start:{line:1,column:26},end:{line:1,column:27},source:''},
                    name: 'y'
                  },
                  init: {
                    type: 'Identifier',
                    loc:{start:{line:1,column:30},end:{line:1,column:31},source:''},
                    name: 'x'
                  }
                }
              ]
            }
          ]
        }
      },
      finalizer: null
    }
  ]
}

tokens (15x):
       ID_try PUNC_CURLY_OPEN PUNC_CURLY_CLOSE ID_catch
       PUNC_PAREN_OPEN IDENT PUNC_PAREN_CLOSE PUNC_CURLY_OPEN ID_const
       IDENT PUNC_EQ IDENT ASI PUNC_CURLY_CLOSE
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
try {} catch (e) {const y = x;}
````

Produces same AST
