# Tenko parser test case

- Path: tests/testcases/statements_and_declarations/cannot_nest_a_declaration_inside_a_non-block_statement/function/regular/else.md

> :: statements and declarations : cannot nest a declaration inside a non-block statement : function : regular
>
> ::> else

## Input

`````js
if (x); else function f() {}
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
throws: Parser error!
  A function declaration can only be the child of an `if`/`else` in sloppy web compat mode

if (x); else function f() {}
                      ^------- error
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:28},source:''},
  body: [
    {
      type: 'IfStatement',
      loc:{start:{line:1,column:0},end:{line:1,column:28},source:''},
      test: {
        type: 'Identifier',
        loc:{start:{line:1,column:4},end:{line:1,column:5},source:''},
        name: 'x'
      },
      consequent: {
        type: 'EmptyStatement',
        loc:{start:{line:1,column:6},end:{line:1,column:7},source:''}
      },
      alternate: {
        type: 'FunctionDeclaration',
        loc:{start:{line:1,column:13},end:{line:1,column:28},source:''},
        generator: false,
        async: false,
        id: {
          type: 'Identifier',
          loc:{start:{line:1,column:22},end:{line:1,column:23},source:''},
          name: 'f'
        },
        params: [],
        body: {
          type: 'BlockStatement',
          loc:{start:{line:1,column:26},end:{line:1,column:28},source:''},
          body: []
        }
      }
    }
  ]
}

tokens (13x):
       ID_if PUNC_PAREN_OPEN IDENT PUNC_PAREN_CLOSE PUNC_SEMI ID_else
       ID_function IDENT PUNC_PAREN_OPEN PUNC_PAREN_CLOSE
       PUNC_CURLY_OPEN PUNC_CURLY_CLOSE
`````


## AST Printer

Printer output different from input [web]:

````js
if (x) ; else function f() {}
````

Produces same AST
