# Tenko parser test case

- Path: tests/testcases/strict_mode/ast/ast_hex.md

> :: strict mode : ast
>
> ::> ast hex
>
> This test checks how an invalid directive "but only because a space was added through escape sequence instead of actual character" ends up in the AST
>
> See Babel for prior art: https://github.com/babel/babel/pull/1852

## Input

`````js
"use\u0020strict";
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:18},source:''},
  body: [
    {
      type: 'ExpressionStatement',
      loc:{start:{line:1,column:0},end:{line:1,column:18},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:1,column:0},end:{line:1,column:17},source:''},
        value: 'use strict',
        raw: '"use\\u0020strict"'
      },
      directive: 'use\\u0020strict'
    }
  ]
}

tokens (3x):
       STRING_DOUBLE PUNC_SEMI
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output was same as input [sloppy]
