# Tenko parser test case

- Path: tests/testcases/strict_mode/base_test_confirm_x0060withx0060_is_fine_without_strict_mode.md

> :: strict mode
>
> ::> base test confirm x0060withx0060 is fine without strict mode
>
> The idea is that strict mode should throw for using `with` but fine in sloppy mode
>
> https://tc39.github.io/ecma262/#sec-strict-mode-code
>
> Global code is strict mode code if it starts with use strict
>
> Module code is always strict mode code.
>
> All parts of a ClassDeclaration or a ClassExpression are strict mode code.
>
> Eval code is strict mode code if
>
> - it begins with use strict
> - the call to eval is a direct eval that is contained in strict mode code.
>
> Function code is strict mode code if
>
> - it's contained in strict mode code
> - it starts with use strict
>
> Dynamic functions (like Function) with a body that starts with use strict
>
> Base case: with is not allowed in strict mode

## Input

`````js
; with (x) y;
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:13},source:''},
  body: [
    {
      type: 'EmptyStatement',
      loc:{start:{line:1,column:0},end:{line:1,column:1},source:''}
    },
    {
      type: 'WithStatement',
      loc:{start:{line:1,column:2},end:{line:1,column:13},source:''},
      object: {
        type: 'Identifier',
        loc:{start:{line:1,column:8},end:{line:1,column:9},source:''},
        name: 'x'
      },
      body: {
        type: 'ExpressionStatement',
        loc:{start:{line:1,column:11},end:{line:1,column:13},source:''},
        expression: {
          type: 'Identifier',
          loc:{start:{line:1,column:11},end:{line:1,column:12},source:''},
          name: 'y'
        }
      }
    }
  ]
}

tokens (8x):
       PUNC_SEMI ID_with PUNC_PAREN_OPEN IDENT PUNC_PAREN_CLOSE IDENT
       PUNC_SEMI
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

`````
throws: Parser error!
  The `with` statement is not allowed in strict mode

; with (x) y;
  ^------- error
`````


### Module goal

Parsed with the module goal.

_Output same as strict mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
;
with (x) (y);
````

Produces same AST
