# Tenko parser test case

- Path: tests/testcases/strict_mode/eval/cannot_assign_to_multi_grouped_eval.md

> :: strict mode : eval
>
> ::> cannot assign to multi grouped eval

## Input

`````js
((((eval)))) = x;
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:17},source:''},
  body: [
    {
      type: 'ExpressionStatement',
      loc:{start:{line:1,column:0},end:{line:1,column:17},source:''},
      expression: {
        type: 'AssignmentExpression',
        loc:{start:{line:1,column:0},end:{line:1,column:16},source:''},
        left: {
          type: 'Identifier',
          loc:{start:{line:1,column:4},end:{line:1,column:8},source:''},
          name: 'eval'
        },
        operator: '=',
        right: {
          type: 'Identifier',
          loc:{start:{line:1,column:15},end:{line:1,column:16},source:''},
          name: 'x'
        }
      }
    }
  ]
}

tokens (13x):
       PUNC_PAREN_OPEN PUNC_PAREN_OPEN PUNC_PAREN_OPEN PUNC_PAREN_OPEN
       ID_eval PUNC_PAREN_CLOSE PUNC_PAREN_CLOSE PUNC_PAREN_CLOSE
       PUNC_PAREN_CLOSE PUNC_EQ IDENT PUNC_SEMI
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

`````
throws: Parser error!
  Cannot assign to lhs (starting with `(`) because it is not a valid assignment target

((((eval)))) = x;
             ^------- error
`````


### Module goal

Parsed with the module goal.

_Output same as strict mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
((eval = x));
````

Produces same AST
