# Tenko parser test case

- Path: tests/testcases/strict_mode/eval/cannot_postinc_eval.md

> :: strict mode : eval
>
> ::> cannot postinc eval

## Input

`````js
eval++
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:6},source:''},
  body: [
    {
      type: 'ExpressionStatement',
      loc:{start:{line:1,column:0},end:{line:1,column:6},source:''},
      expression: {
        type: 'UpdateExpression',
        loc:{start:{line:1,column:0},end:{line:1,column:6},source:''},
        argument: {
          type: 'Identifier',
          loc:{start:{line:1,column:0},end:{line:1,column:4},source:''},
          name: 'eval'
        },
        operator: '++',
        prefix: false
      }
    }
  ]
}

tokens (4x):
       ID_eval PUNC_PLUS_PLUS ASI
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

`````
throws: Parser error!
  Cannot assign to `eval` and `arguments` in strict mode

eval++
    ^------- error
`````


### Module goal

Parsed with the module goal.

_Output same as strict mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
eval++;
````

Produces same AST
