# Tenko parser test case

- Path: tests/testcases/strict_mode/eval/groups_are_just_one_way_to_destruct.md

> :: strict mode : eval
>
> ::> groups are just one way to destruct
>
> vs `x, [eval].foo`; make sure we dont assume destructuring without var/let/const happens with a group; that is just a way to disambiguate

## Input

`````js
x, [eval] = [x]
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:15},source:''},
  body: [
    {
      type: 'ExpressionStatement',
      loc:{start:{line:1,column:0},end:{line:1,column:15},source:''},
      expression: {
        type: 'SequenceExpression',
        loc:{start:{line:1,column:0},end:{line:1,column:15},source:''},
        expressions: [
          {
            type: 'Identifier',
            loc:{start:{line:1,column:0},end:{line:1,column:1},source:''},
            name: 'x'
          },
          {
            type: 'AssignmentExpression',
            loc:{start:{line:1,column:3},end:{line:1,column:15},source:''},
            left: {
              type: 'ArrayPattern',
              loc:{start:{line:1,column:3},end:{line:1,column:9},source:''},
              elements: [
                {
                  type: 'Identifier',
                  loc:{start:{line:1,column:4},end:{line:1,column:8},source:''},
                  name: 'eval'
                }
              ]
            },
            operator: '=',
            right: {
              type: 'ArrayExpression',
              loc:{start:{line:1,column:12},end:{line:1,column:15},source:''},
              elements: [
                {
                  type: 'Identifier',
                  loc:{start:{line:1,column:13},end:{line:1,column:14},source:''},
                  name: 'x'
                }
              ]
            }
          }
        ]
      }
    }
  ]
}

tokens (11x):
       IDENT PUNC_COMMA PUNC_BRACKET_OPEN ID_eval PUNC_BRACKET_CLOSE
       PUNC_EQ PUNC_BRACKET_OPEN IDENT PUNC_BRACKET_CLOSE ASI
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

`````
throws: Parser error!
  Tried to destructure something that is not destructible

x, [eval] = [x]
          ^------- error
`````


### Module goal

Parsed with the module goal.

_Output same as strict mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
((x, ([eval,] = [x,])));
````

Produces same AST
