# Tenko parser test case

- Path: tests/testcases/strict_mode/inside_a_class.md

> :: strict mode
>
> ::> inside a class
>
> The idea is that strict mode should throw for using `with` but fine in sloppy mode
>
> https://tc39.github.io/ecma262/#sec-strict-mode-code
>
> Global code is strict mode code if it starts with use strict
>
> Module code is always strict mode code.
>
> All parts of a ClassDeclaration or a ClassExpression are strict mode code.
>
> Eval code is strict mode code if
>
> - it begins with use strict
> - the call to eval is a direct eval that is contained in strict mode code.
>
> Function code is strict mode code if
>
> - it's contained in strict mode code
> - it starts with use strict
>
> Dynamic functions (like Function) with a body that starts with use strict
>
> Base case: with is not allowed in strict mode

## Input


`````js
class X { foo() { with (x) y; } }
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
throws: Parser error!
  The `with` statement is not allowed in strict mode

class X { foo() { with (x) y; } }
                  ^------- error
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._
