# Tenko parser test case

- Path: tests/testcases/strict_mode/octal_cases_regressions_from_x002315/octal_strict_global_asi.md

> :: strict mode : octal cases regressions from x002315
>
> ::> octal strict global asi
>
> The tricky part for us is that when consuming the "use strict" directive, we can't tell whether or not it actually is such. So that means that at the time of consuming the string token, it isn't considered a directive yet and as such the lexerflags are not updated yet.
>
> And since the lexerflags have not been updated yet, the next token won't trigger an error inside the tokenizer when it's an octal literal, like 077.
>
> This is the only exception since in all other cases the lexerflags are updated immediately and would catch this case.
>
> Without ASI the semi would serve as a buffer and be parsed without flag.

## Input

`````js
"use strict"
0777
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
throws: Parser error!
  Illegal legacy octal literal in strict mode

"use strict"
0777
^------- error
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

`````
throws: Lexer error!
    "Illegal" octal escape in strict mode

"use strict"
0777
^------- error
`````


### Module goal

Parsed with the module goal.

_Output same as strict mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._
