# Tenko parser test case

- Path: tests/testcases/strict_mode/with_directive/mixed_cases/NOT_block_scoped.md

> :: strict mode : with directive : mixed cases
>
> ::> NOT block scoped

## Input

`````js
if (x) { "use strict"; with (x) y; }
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:36},source:''},
  body: [
    {
      type: 'IfStatement',
      loc:{start:{line:1,column:0},end:{line:1,column:36},source:''},
      test: {
        type: 'Identifier',
        loc:{start:{line:1,column:4},end:{line:1,column:5},source:''},
        name: 'x'
      },
      consequent: {
        type: 'BlockStatement',
        loc:{start:{line:1,column:7},end:{line:1,column:36},source:''},
        body: [
          {
            type: 'ExpressionStatement',
            loc:{start:{line:1,column:9},end:{line:1,column:22},source:''},
            expression: {
              type: 'Literal',
              loc:{start:{line:1,column:9},end:{line:1,column:21},source:''},
              value: 'use strict',
              raw: '"use strict"'
            }
          },
          {
            type: 'WithStatement',
            loc:{start:{line:1,column:23},end:{line:1,column:34},source:''},
            object: {
              type: 'Identifier',
              loc:{start:{line:1,column:29},end:{line:1,column:30},source:''},
              name: 'x'
            },
            body: {
              type: 'ExpressionStatement',
              loc:{start:{line:1,column:32},end:{line:1,column:34},source:''},
              expression: {
                type: 'Identifier',
                loc:{start:{line:1,column:32},end:{line:1,column:33},source:''},
                name: 'y'
              }
            }
          }
        ]
      },
      alternate: null
    }
  ]
}

tokens (15x):
       ID_if PUNC_PAREN_OPEN IDENT PUNC_PAREN_CLOSE PUNC_CURLY_OPEN
       STRING_DOUBLE PUNC_SEMI ID_with PUNC_PAREN_OPEN IDENT
       PUNC_PAREN_CLOSE IDENT PUNC_SEMI PUNC_CURLY_CLOSE
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

`````
throws: Parser error!
  The `with` statement is not allowed in strict mode

if (x) { "use strict"; with (x) y; }
                       ^------- error
`````


### Module goal

Parsed with the module goal.

_Output same as strict mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
if (x) {("use strict");
with (x) (y);}
````

Produces same AST
