# Tenko parser test case

- Path: tests/testcases/strict_mode/with_directive/mixed_cases/ignored_when_not_first.md

> :: strict mode : with directive : mixed cases
>
> ::> ignored when not first

## Input

`````js
var x; "use strict"; with (x) y;
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:32},source:''},
  body: [
    {
      type: 'VariableDeclaration',
      loc:{start:{line:1,column:0},end:{line:1,column:6},source:''},
      kind: 'var',
      declarations: [
        {
          type: 'VariableDeclarator',
          loc:{start:{line:1,column:4},end:{line:1,column:5},source:''},
          id: {
            type: 'Identifier',
            loc:{start:{line:1,column:4},end:{line:1,column:5},source:''},
            name: 'x'
          },
          init: null
        }
      ]
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:1,column:7},end:{line:1,column:20},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:1,column:7},end:{line:1,column:19},source:''},
        value: 'use strict',
        raw: '"use strict"'
      }
    },
    {
      type: 'WithStatement',
      loc:{start:{line:1,column:21},end:{line:1,column:32},source:''},
      object: {
        type: 'Identifier',
        loc:{start:{line:1,column:27},end:{line:1,column:28},source:''},
        name: 'x'
      },
      body: {
        type: 'ExpressionStatement',
        loc:{start:{line:1,column:30},end:{line:1,column:32},source:''},
        expression: {
          type: 'Identifier',
          loc:{start:{line:1,column:30},end:{line:1,column:31},source:''},
          name: 'y'
        }
      }
    }
  ]
}

tokens (12x):
       ID_var IDENT PUNC_SEMI STRING_DOUBLE PUNC_SEMI ID_with
       PUNC_PAREN_OPEN IDENT PUNC_PAREN_CLOSE IDENT PUNC_SEMI
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

`````
throws: Parser error!
  The `with` statement is not allowed in strict mode

var x; "use strict"; with (x) y;
                     ^------- error
`````


### Module goal

Parsed with the module goal.

_Output same as strict mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
var x;
("use strict");
with (x) (y);
````

Produces same AST
