# Tenko parser test case

- Path: tests/testcases/string/2028_is_ok.md

> :: string
>
> ::> 2028 is ok
>
> A \u2028 char is considered a newline but at the same time a string can't contain newlines.
>
> However, the actual rule is:
>
> https://tc39.es/ecma262/#sec-literals-string-literals
>
> > All code points may appear literally in a string literal except for the closing quote code points, U+005C (REVERSE SOLIDUS), U+000D (CARRIAGE RETURN), and U+000A (LINE FEED).
>
> This was a regression caught by test262
>
> Note that https://tc39.es/ecma262/#prod-DoubleStringCharacter explicitly allows PS and LS in the single/double string productions.

## PASS

## Input

`````js
"@{x2028}@";
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:2,column:2},source:''},
  body: [
    {
      type: 'ExpressionStatement',
      loc:{start:{line:1,column:0},end:{line:2,column:2},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:1,column:0},end:{line:2,column:1},source:''},
        value: '@{x2028}@',
        raw: '"@{x2028}@"'
      },
      directive: '@{x2028}@'
    }
  ]
}

tokens (3x):
       STRING_DOUBLE PUNC_SEMI
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output was same as input [sloppy]
