# Tenko parser test case

- Path: tests/testcases/string/escapes/2029.md

> :: string : escapes
>
> ::> 2029
>
> An escaped 2028 is a line continuation (which does not add anything to the string value)
>
> Templates also support line continuations.

## Input

`````js
'\@{x2029}@'
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:2,column:1},source:''},
  body: [
    {
      type: 'ExpressionStatement',
      loc:{start:{line:1,column:0},end:{line:2,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:1,column:0},end:{line:2,column:1},source:''},
        value: '',
        raw: "'\\@{x2029}@'"
      },
      directive: '\\@{x2029}@'
    }
  ]
}

tokens (3x):
       STRING_SINGLE ASI
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
'\@{x2029}@';
````

Produces same AST
