# Tenko parser test case

- Path: tests/testcases/string/escapes/directives/octal/double_digit_low_9.md

> :: string : escapes : directives : octal
>
> ::> double digit low 9
>
> The 9 should stop an octal escape (when allowed) and the string value should be `"\12" + "9"`

## Input

`````js
"\129"
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
throws: Lexer error!
    Octal escapes are only allowed in sloppy mode with web compat enabled

"\129"
^------- error
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

`````
throws: Lexer error!
    Illegal legacy octal escape in strict mode

"\129"
^------- error
`````


### Module goal

Parsed with the module goal.

_Output same as strict mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:6},source:''},
  body: [
    {
      type: 'ExpressionStatement',
      loc:{start:{line:1,column:0},end:{line:1,column:6},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:1,column:0},end:{line:1,column:6},source:''},
        value: '\n9',
        raw: '"\\129"'
      },
      directive: '\\129'
    }
  ]
}

tokens (3x):
       STRING_DOUBLE ASI
`````


## AST Printer

Printer output different from input [web]:

````js
"\129";
````

Produces same AST
