# Tenko parser test case

- Path: tests/testcases/string/escapes/nondirectives/rest/escape_double_quote.md

> :: string : escapes : nondirectives : rest
>
> ::> escape double quote
>
> Checks the .value and .rawValue, making sure they are not directives

## Input

`````js
debugger;
"some \" quote";
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:2,column:16},source:''},
  body: [
    {
      type: 'DebuggerStatement',
      loc:{start:{line:1,column:0},end:{line:1,column:9},source:''}
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:2,column:0},end:{line:2,column:16},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:2,column:0},end:{line:2,column:15},source:''},
        value: 'some " quote',
        raw: '"some \\" quote"'
      }
    }
  ]
}

tokens (5x):
       ID_debugger PUNC_SEMI STRING_DOUBLE PUNC_SEMI
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
debugger;
("some \" quote");
````

Produces same AST
