# Tenko parser test case

- Path: tests/testcases/string/escapes/nondirectives/start/normalize_low_escapes.md

> :: string : escapes : nondirectives : start
>
> ::> normalize low escapes

## Input

`````js
debugger;
'\0137 \x18 \u{05} \0 finish';
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
throws: Lexer error!
    Octal escapes are only allowed in sloppy mode with web compat enabled

debugger;
'\0137 \x18 \u{05} \0 finish';
^------- error
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

`````
throws: Lexer error!
    Illegal legacy octal escape in strict mode

debugger;
'\0137 \x18 \u{05} \0 finish';
^------- error
`````


### Module goal

Parsed with the module goal.

_Output same as strict mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:2,column:30},source:''},
  body: [
    {
      type: 'DebuggerStatement',
      loc:{start:{line:1,column:0},end:{line:1,column:9},source:''}
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:2,column:0},end:{line:2,column:30},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:2,column:0},end:{line:2,column:29},source:''},
        value: '\u000b7 \u0018 \u0005 \u0000 finish',
        raw: "'\\0137 \\x18 \\u{05} \\0 finish'"
      }
    }
  ]
}

tokens (5x):
       ID_debugger PUNC_SEMI STRING_SINGLE PUNC_SEMI
`````


## AST Printer

Printer output different from input [web]:

````js
debugger;
('\0137 \x18 \u{05} \0 finish');
````

Produces same AST
