# Tenko parser test case

- Path: tests/testcases/string/escapes/nondirectives/start/octal/triple_digit_low_start.md

> :: string : escapes : nondirectives : start : octal
>
> ::> triple digit low start
>
> Octals can not exceed `\377` and should ignore any further digits, even if they are octals.
>
> Since this starts with `37` it can still have another octal value without breaking this rule.
>
> So in effect this string value should be as you see it; `"\373"`

## Input

`````js
debugger;
"\373"
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
throws: Lexer error!
    Octal escapes are only allowed in sloppy mode with web compat enabled

debugger;
"\373"
^------- error
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

`````
throws: Lexer error!
    Illegal legacy octal escape in strict mode

debugger;
"\373"
^------- error
`````


### Module goal

Parsed with the module goal.

_Output same as strict mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:2,column:6},source:''},
  body: [
    {
      type: 'DebuggerStatement',
      loc:{start:{line:1,column:0},end:{line:1,column:9},source:''}
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:2,column:0},end:{line:2,column:6},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:2,column:0},end:{line:2,column:6},source:''},
        value: '@{xfb}@',
        raw: '"\\373"'
      }
    }
  ]
}

tokens (5x):
       ID_debugger PUNC_SEMI STRING_DOUBLE ASI
`````


## AST Printer

Printer output different from input [web]:

````js
debugger;
("\373");
````

Produces same AST
