# Tenko parser test case

- Path: tests/testcases/tagged_templates/bad_escapes/escaped_vary_escape.md

> :: tagged templates : bad escapes
>
> ::> escaped vary escape
>
> This tests not detecting an escaped backslash as a unicode escape anyways.
>
> The bad unicode escape would have been allowed in tagged templates since es9, otherwise.

## PASS

## Input

`````js
tag`okay \\u{110001}`
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:21},source:''},
  body: [
    {
      type: 'ExpressionStatement',
      loc:{start:{line:1,column:0},end:{line:1,column:21},source:''},
      expression: {
        type: 'TaggedTemplateExpression',
        loc:{start:{line:1,column:0},end:{line:1,column:21},source:''},
        tag: {
          type: 'Identifier',
          loc:{start:{line:1,column:0},end:{line:1,column:3},source:''},
          name: 'tag'
        },
        quasi: {
          type: 'TemplateLiteral',
          loc:{start:{line:1,column:3},end:{line:1,column:21},source:''},
          expressions: [],
          quasis: [
            {
              type: 'TemplateElement',
              loc:{start:{line:1,column:4},end:{line:1,column:20},source:''},
              tail: true,
              value: { raw: 'okay \\\\u{110001}', cooked: 'okay \\u{110001}' }
            }
          ]
        }
      }
    }
  ]
}

tokens (4x):
       IDENT TICK_PURE ASI
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
(tag)`okay \\u{110001}`;
````

Produces same AST
