# Tenko parser test case

- Path: tests/testcases/tagged_templates/bad_escapes/octal_escapes/octal_at_start.md

> :: tagged templates : bad escapes : octal escapes
>
> ::> octal at start
>
> https://tc39.github.io/ecma262/#prod-CodePoint
>
> > "A conforming implementation must not use the extended definition of EscapeSequence described in B.1.2 when parsing a TemplateCharacter."
>
> (these can be extended for string but should always be errors for non-tagged templates)
>
> This must pass for tagged templates when bad escapes are allowed

## PASS

## Input

`````js
tag`\00`
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:8},source:''},
  body: [
    {
      type: 'ExpressionStatement',
      loc:{start:{line:1,column:0},end:{line:1,column:8},source:''},
      expression: {
        type: 'TaggedTemplateExpression',
        loc:{start:{line:1,column:0},end:{line:1,column:8},source:''},
        tag: {
          type: 'Identifier',
          loc:{start:{line:1,column:0},end:{line:1,column:3},source:''},
          name: 'tag'
        },
        quasi: {
          type: 'TemplateLiteral',
          loc:{start:{line:1,column:3},end:{line:1,column:8},source:''},
          expressions: [],
          quasis: [
            {
              type: 'TemplateElement',
              loc:{start:{line:1,column:4},end:{line:1,column:7},source:''},
              tail: true,
              value: { raw: '\\00', cooked: null }
            }
          ]
        }
      }
    }
  ]
}

tokens (4x):
       IDENT TICK_BAD_PURE ASI
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
(tag)`\00`;
````

Produces same AST
