# Tenko parser test case

- Path: tests/testcases/tagged_templates/escapes/octal/escape_1.md

> :: tagged templates : escapes : octal
>
> ::> escape 1
>
> Escaped non-zero digits are only considered octal in strings. In templates they just escape a single digit for no real reason.

## PASS

## Input

`````js
tag`a \1 b`;
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:12},source:''},
  body: [
    {
      type: 'ExpressionStatement',
      loc:{start:{line:1,column:0},end:{line:1,column:12},source:''},
      expression: {
        type: 'TaggedTemplateExpression',
        loc:{start:{line:1,column:0},end:{line:1,column:11},source:''},
        tag: {
          type: 'Identifier',
          loc:{start:{line:1,column:0},end:{line:1,column:3},source:''},
          name: 'tag'
        },
        quasi: {
          type: 'TemplateLiteral',
          loc:{start:{line:1,column:3},end:{line:1,column:11},source:''},
          expressions: [],
          quasis: [
            {
              type: 'TemplateElement',
              loc:{start:{line:1,column:4},end:{line:1,column:10},source:''},
              tail: true,
              value: { raw: 'a \\1 b', cooked: null }
            }
          ]
        }
      }
    }
  ]
}

tokens (4x):
       IDENT TICK_BAD_PURE PUNC_SEMI
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
(tag)`a \1 b`;
````

Produces same AST
