# Tenko parser test case

- Path: tests/testcases/tagged_templates/template_with_in_inside_for_header.md

> :: tagged templates
>
> ::> template with in inside for header
>
> Regression found by fuzzer

The problem was that the `in` would not be parsed because the parser was still parsing in the context of a `for`-header, which would disallow `in` as the lhs.

## Input

`````js
for(t`${x in y}`;;);
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:20},source:''},
  body: [
    {
      type: 'ForStatement',
      loc:{start:{line:1,column:0},end:{line:1,column:20},source:''},
      init: {
        type: 'TaggedTemplateExpression',
        loc:{start:{line:1,column:4},end:{line:1,column:16},source:''},
        tag: {
          type: 'Identifier',
          loc:{start:{line:1,column:4},end:{line:1,column:5},source:''},
          name: 't'
        },
        quasi: {
          type: 'TemplateLiteral',
          loc:{start:{line:1,column:5},end:{line:1,column:16},source:''},
          expressions: [
            {
              type: 'BinaryExpression',
              loc:{start:{line:1,column:8},end:{line:1,column:14},source:''},
              left: {
                type: 'Identifier',
                loc:{start:{line:1,column:8},end:{line:1,column:9},source:''},
                name: 'x'
              },
              operator: 'in',
              right: {
                type: 'Identifier',
                loc:{start:{line:1,column:13},end:{line:1,column:14},source:''},
                name: 'y'
              }
            }
          ],
          quasis: [
            {
              type: 'TemplateElement',
              loc:{start:{line:1,column:6},end:{line:1,column:6},source:''},
              tail: false,
              value: { raw: '', cooked: '' }
            },
            {
              type: 'TemplateElement',
              loc:{start:{line:1,column:15},end:{line:1,column:15},source:''},
              tail: true,
              value: { raw: '', cooked: '' }
            }
          ]
        }
      },
      test: null,
      update: null,
      body: {
        type: 'EmptyStatement',
        loc:{start:{line:1,column:19},end:{line:1,column:20},source:''}
      }
    }
  ]
}

tokens (13x):
       ID_for PUNC_PAREN_OPEN IDENT TICK_HEAD IDENT ID_in IDENT
       TICK_TAIL PUNC_SEMI PUNC_SEMI PUNC_PAREN_CLOSE PUNC_SEMI
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
for (((t)`${((x) in (y))}`);;) ;
````

Produces same AST
