# Tenko parser test case

- Path: tests/testcases/tagged_templates/template_with_multiple_parts.md

> :: tagged templates
>
> ::> template with multiple parts

## Input

`````js
foo`x${a}y${b}z`
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:16},source:''},
  body: [
    {
      type: 'ExpressionStatement',
      loc:{start:{line:1,column:0},end:{line:1,column:16},source:''},
      expression: {
        type: 'TaggedTemplateExpression',
        loc:{start:{line:1,column:0},end:{line:1,column:16},source:''},
        tag: {
          type: 'Identifier',
          loc:{start:{line:1,column:0},end:{line:1,column:3},source:''},
          name: 'foo'
        },
        quasi: {
          type: 'TemplateLiteral',
          loc:{start:{line:1,column:3},end:{line:1,column:16},source:''},
          expressions: [
            {
              type: 'Identifier',
              loc:{start:{line:1,column:7},end:{line:1,column:8},source:''},
              name: 'a'
            },
            {
              type: 'Identifier',
              loc:{start:{line:1,column:12},end:{line:1,column:13},source:''},
              name: 'b'
            }
          ],
          quasis: [
            {
              type: 'TemplateElement',
              loc:{start:{line:1,column:4},end:{line:1,column:5},source:''},
              tail: false,
              value: { raw: 'x', cooked: 'x' }
            },
            {
              type: 'TemplateElement',
              loc:{start:{line:1,column:9},end:{line:1,column:10},source:''},
              tail: false,
              value: { raw: 'y', cooked: 'y' }
            },
            {
              type: 'TemplateElement',
              loc:{start:{line:1,column:14},end:{line:1,column:15},source:''},
              tail: true,
              value: { raw: 'z', cooked: 'z' }
            }
          ]
        }
      }
    }
  ]
}

tokens (8x):
       IDENT TICK_HEAD IDENT TICK_BODY IDENT TICK_TAIL ASI
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
(foo)`x${a}y${b}z`;
````

Produces same AST
