# Tenko parser test case

- Path: tests/testcases/templates/and_yield/as_var_name/yield_in_with_another_part.md

> :: templates : and yield : as var name
>
> ::> yield in with another part

## Input

`````js
x = `1 ${ yield } 2 ${ 3 } 4`
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:29},source:''},
  body: [
    {
      type: 'ExpressionStatement',
      loc:{start:{line:1,column:0},end:{line:1,column:29},source:''},
      expression: {
        type: 'AssignmentExpression',
        loc:{start:{line:1,column:0},end:{line:1,column:29},source:''},
        left: {
          type: 'Identifier',
          loc:{start:{line:1,column:0},end:{line:1,column:1},source:''},
          name: 'x'
        },
        operator: '=',
        right: {
          type: 'TemplateLiteral',
          loc:{start:{line:1,column:4},end:{line:1,column:29},source:''},
          expressions: [
            {
              type: 'Identifier',
              loc:{start:{line:1,column:10},end:{line:1,column:15},source:''},
              name: 'yield'
            },
            {
              type: 'Literal',
              loc:{start:{line:1,column:23},end:{line:1,column:24},source:''},
              value: 3,
              raw: '3'
            }
          ],
          quasis: [
            {
              type: 'TemplateElement',
              loc:{start:{line:1,column:5},end:{line:1,column:7},source:''},
              tail: false,
              value: { raw: '1 ', cooked: '1 ' }
            },
            {
              type: 'TemplateElement',
              loc:{start:{line:1,column:17},end:{line:1,column:20},source:''},
              tail: false,
              value: { raw: ' 2 ', cooked: ' 2 ' }
            },
            {
              type: 'TemplateElement',
              loc:{start:{line:1,column:26},end:{line:1,column:28},source:''},
              tail: true,
              value: { raw: ' 4', cooked: ' 4' }
            }
          ]
        }
      }
    }
  ]
}

tokens (9x):
       IDENT PUNC_EQ TICK_HEAD ID_yield TICK_BODY NUMBER_DEC TICK_TAIL
       ASI
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

`````
throws: Parser error!
  Cannot use `yield` outside of generator functions when in strict mode

x = `1 ${ yield } 2 ${ 3 } 4`
                ^------- error
`````


### Module goal

Parsed with the module goal.

_Output same as strict mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
((x = `1 ${yield} 2 ${3} 4`));
````

Produces same AST
