# Tenko parser test case

- Path: tests/testcases/templates/escapes/canonize_tail.md

> :: templates : escapes
>
> ::> canonize tail
>
> Asserts the canon property of the tail of a tick token

## Input

`````js
`x ${x} \u0070 y`;
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:18},source:''},
  body: [
    {
      type: 'ExpressionStatement',
      loc:{start:{line:1,column:0},end:{line:1,column:18},source:''},
      expression: {
        type: 'TemplateLiteral',
        loc:{start:{line:1,column:0},end:{line:1,column:17},source:''},
        expressions: [
          {
            type: 'Identifier',
            loc:{start:{line:1,column:5},end:{line:1,column:6},source:''},
            name: 'x'
          }
        ],
        quasis: [
          {
            type: 'TemplateElement',
            loc:{start:{line:1,column:1},end:{line:1,column:3},source:''},
            tail: false,
            value: { raw: 'x ', cooked: 'x ' }
          },
          {
            type: 'TemplateElement',
            loc:{start:{line:1,column:7},end:{line:1,column:16},source:''},
            tail: true,
            value: { raw: ' \\u0070 y', cooked: ' p y' }
          }
        ]
      }
    }
  ]
}

tokens (5x):
       TICK_HEAD IDENT TICK_TAIL PUNC_SEMI
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output was same as input [sloppy]
