# Tenko parser test case

- Path: tests/testcases/templates/func_quasi.md

> :: templates
>
> ::> func quasi
>
> This tests whether or not the `}` that is part of the template is properly parsed after a function expression.

## PASS

## Input

`````js
`${function(){}}`
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:17},source:''},
  body: [
    {
      type: 'ExpressionStatement',
      loc:{start:{line:1,column:0},end:{line:1,column:17},source:''},
      expression: {
        type: 'TemplateLiteral',
        loc:{start:{line:1,column:0},end:{line:1,column:17},source:''},
        expressions: [
          {
            type: 'FunctionExpression',
            loc:{start:{line:1,column:3},end:{line:1,column:15},source:''},
            generator: false,
            async: false,
            id: null,
            params: [],
            body: {
              type: 'BlockStatement',
              loc:{start:{line:1,column:13},end:{line:1,column:15},source:''},
              body: []
            }
          }
        ],
        quasis: [
          {
            type: 'TemplateElement',
            loc:{start:{line:1,column:1},end:{line:1,column:1},source:''},
            tail: false,
            value: { raw: '', cooked: '' }
          },
          {
            type: 'TemplateElement',
            loc:{start:{line:1,column:16},end:{line:1,column:16},source:''},
            tail: true,
            value: { raw: '', cooked: '' }
          }
        ]
      }
    }
  ]
}

tokens (9x):
       TICK_HEAD ID_function PUNC_PAREN_OPEN PUNC_PAREN_CLOSE
       PUNC_CURLY_OPEN PUNC_CURLY_CLOSE TICK_TAIL ASI
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
`${function() {}}`;
````

Produces same AST
