# Tenko parser test case

- Path: tests/testcases/templates/object_literal_without_destruct_with_multiple_shorthands_inside_the_tick_expression.md

> :: templates
>
> ::> object literal without destruct with multiple shorthands inside the tick expression

## Input

`````js
`foo${{a,b}}baz`
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:16},source:''},
  body: [
    {
      type: 'ExpressionStatement',
      loc:{start:{line:1,column:0},end:{line:1,column:16},source:''},
      expression: {
        type: 'TemplateLiteral',
        loc:{start:{line:1,column:0},end:{line:1,column:16},source:''},
        expressions: [
          {
            type: 'ObjectExpression',
            loc:{start:{line:1,column:6},end:{line:1,column:11},source:''},
            properties: [
              {
                type: 'Property',
                loc:{start:{line:1,column:7},end:{line:1,column:8},source:''},
                key: {
                  type: 'Identifier',
                  loc:{start:{line:1,column:7},end:{line:1,column:8},source:''},
                  name: 'a'
                },
                kind: 'init',
                method: false,
                computed: false,
                value: {
                  type: 'Identifier',
                  loc:{start:{line:1,column:7},end:{line:1,column:8},source:''},
                  name: 'a'
                },
                shorthand: true
              },
              {
                type: 'Property',
                loc:{start:{line:1,column:9},end:{line:1,column:10},source:''},
                key: {
                  type: 'Identifier',
                  loc:{start:{line:1,column:9},end:{line:1,column:10},source:''},
                  name: 'b'
                },
                kind: 'init',
                method: false,
                computed: false,
                value: {
                  type: 'Identifier',
                  loc:{start:{line:1,column:9},end:{line:1,column:10},source:''},
                  name: 'b'
                },
                shorthand: true
              }
            ]
          }
        ],
        quasis: [
          {
            type: 'TemplateElement',
            loc:{start:{line:1,column:1},end:{line:1,column:4},source:''},
            tail: false,
            value: { raw: 'foo', cooked: 'foo' }
          },
          {
            type: 'TemplateElement',
            loc:{start:{line:1,column:12},end:{line:1,column:15},source:''},
            tail: true,
            value: { raw: 'baz', cooked: 'baz' }
          }
        ]
      }
    }
  ]
}

tokens (9x):
       TICK_HEAD PUNC_CURLY_OPEN IDENT PUNC_COMMA IDENT
       PUNC_CURLY_CLOSE TICK_TAIL ASI
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
`foo${{a, b}}baz`;
````

Produces same AST
