# Tenko parser test case

- Path: tests/testcases/ternary/precedence_case.md

> :: ternary
>
> ::> precedence case

## Input

`````js
a === b ? c : d % e;
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:20},source:''},
  body: [
    {
      type: 'ExpressionStatement',
      loc:{start:{line:1,column:0},end:{line:1,column:20},source:''},
      expression: {
        type: 'ConditionalExpression',
        loc:{start:{line:1,column:0},end:{line:1,column:19},source:''},
        test: {
          type: 'BinaryExpression',
          loc:{start:{line:1,column:0},end:{line:1,column:7},source:''},
          left: {
            type: 'Identifier',
            loc:{start:{line:1,column:0},end:{line:1,column:1},source:''},
            name: 'a'
          },
          operator: '===',
          right: {
            type: 'Identifier',
            loc:{start:{line:1,column:6},end:{line:1,column:7},source:''},
            name: 'b'
          }
        },
        consequent: {
          type: 'Identifier',
          loc:{start:{line:1,column:10},end:{line:1,column:11},source:''},
          name: 'c'
        },
        alternate: {
          type: 'BinaryExpression',
          loc:{start:{line:1,column:14},end:{line:1,column:19},source:''},
          left: {
            type: 'Identifier',
            loc:{start:{line:1,column:14},end:{line:1,column:15},source:''},
            name: 'd'
          },
          operator: '%',
          right: {
            type: 'Identifier',
            loc:{start:{line:1,column:18},end:{line:1,column:19},source:''},
            name: 'e'
          }
        }
      }
    }
  ]
}

tokens (11x):
       IDENT PUNC_EQ_EQ_EQ IDENT PUNC_QMARK IDENT PUNC_COLON IDENT
       PUNC_PERCENT IDENT PUNC_SEMI
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
((((a) === (b)))? (c) : (((d) % (e))));
````

Produces same AST
