# Tenko parser test case

- Path: tests/testcases/tests_related_to_bindings/arrow_args/dupe_between_args_and_local_bindings/simple_arg_as_a_func_name.md

> :: tests related to bindings : arrow args : dupe between args and local bindings
>
> ::> simple arg as a func name
> 
> https://tc39.github.io/ecma262/#sec-arrow-function-definitions-static-semantics-early-errors
>
> > It is a Syntax Error if any element of the BoundNames of ArrowParameters also occurs in the LexicallyDeclaredNames of ConciseBody.

## Input

`````js
(x) => { function x() {} }
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:26},source:''},
  body: [
    {
      type: 'ExpressionStatement',
      loc:{start:{line:1,column:0},end:{line:1,column:26},source:''},
      expression: {
        type: 'ArrowFunctionExpression',
        loc:{start:{line:1,column:0},end:{line:1,column:26},source:''},
        params: [
          {
            type: 'Identifier',
            loc:{start:{line:1,column:1},end:{line:1,column:2},source:''},
            name: 'x'
          }
        ],
        id: null,
        generator: false,
        async: false,
        expression: false,
        body: {
          type: 'BlockStatement',
          loc:{start:{line:1,column:7},end:{line:1,column:26},source:''},
          body: [
            {
              type: 'FunctionDeclaration',
              loc:{start:{line:1,column:9},end:{line:1,column:24},source:''},
              generator: false,
              async: false,
              id: {
                type: 'Identifier',
                loc:{start:{line:1,column:18},end:{line:1,column:19},source:''},
                name: 'x'
              },
              params: [],
              body: {
                type: 'BlockStatement',
                loc:{start:{line:1,column:22},end:{line:1,column:24},source:''},
                body: []
              }
            }
          ]
        }
      }
    }
  ]
}

tokens (14x):
       PUNC_PAREN_OPEN IDENT PUNC_PAREN_CLOSE PUNC_EQ_GT
       PUNC_CURLY_OPEN ID_function IDENT PUNC_PAREN_OPEN
       PUNC_PAREN_CLOSE PUNC_CURLY_OPEN PUNC_CURLY_CLOSE
       PUNC_CURLY_CLOSE ASI
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
x => {function x() {}};
````

Produces same AST
