# Tenko parser test case

- Path: tests/testcases/tests_related_to_bindings/block/annex_b_function_statement_exception/in_block_in_webcompat_lexical_declarations_should_not_trigger_syntax_error_if_only_bound_to_function_decl_names.md

> :: tests related to bindings : block : annex b function statement exception
>
> ::> in block in webcompat lexical declarations should not trigger syntax error if only bound to function decl names

## Input

`````js
{ function f() {} ; function f() {} }
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
throws: Parser error!
  Attempted to create a lexical binding for `f` but another binding already existed on the same level

{ function f() {} ; function f() {} }
                             ^------- error
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:37},source:''},
  body: [
    {
      type: 'BlockStatement',
      loc:{start:{line:1,column:0},end:{line:1,column:37},source:''},
      body: [
        {
          type: 'FunctionDeclaration',
          loc:{start:{line:1,column:2},end:{line:1,column:17},source:''},
          generator: false,
          async: false,
          id: {
            type: 'Identifier',
            loc:{start:{line:1,column:11},end:{line:1,column:12},source:''},
            name: 'f'
          },
          params: [],
          body: {
            type: 'BlockStatement',
            loc:{start:{line:1,column:15},end:{line:1,column:17},source:''},
            body: []
          }
        },
        {
          type: 'EmptyStatement',
          loc:{start:{line:1,column:18},end:{line:1,column:19},source:''}
        },
        {
          type: 'FunctionDeclaration',
          loc:{start:{line:1,column:20},end:{line:1,column:35},source:''},
          generator: false,
          async: false,
          id: {
            type: 'Identifier',
            loc:{start:{line:1,column:29},end:{line:1,column:30},source:''},
            name: 'f'
          },
          params: [],
          body: {
            type: 'BlockStatement',
            loc:{start:{line:1,column:33},end:{line:1,column:35},source:''},
            body: []
          }
        }
      ]
    }
  ]
}

tokens (16x):
       PUNC_CURLY_OPEN ID_function IDENT PUNC_PAREN_OPEN
       PUNC_PAREN_CLOSE PUNC_CURLY_OPEN PUNC_CURLY_CLOSE PUNC_SEMI
       ID_function IDENT PUNC_PAREN_OPEN PUNC_PAREN_CLOSE
       PUNC_CURLY_OPEN PUNC_CURLY_CLOSE PUNC_CURLY_CLOSE
`````


## AST Printer

Printer output different from input [web]:

````js
{function f() {}
;
function f() {}}
````

Produces same AST
