# Tenko parser test case

- Path: tests/testcases/tests_related_to_bindings/block/annex_b_function_statement_exception/label_func_and_var_in_block.md

> :: tests related to bindings : block : annex b function statement exception
>
> ::> label func and var in block
>
> > Labels pass the lex decl of function statements through to the parent scope so this should fail with lex/var dupe decl.
> 
> https://tc39.es/ecma262/#sec-labelled-statements-static-semantics-early-errors
> 
> > It is a Syntax Error if any source text matches this rule.
> 
> https://tc39.es/ecma262/#sec-labelled-function-declarations
> 
> > It is a Syntax Error if any strict mode source code matches this rule.
> 
> > The early error rules for WithStatement, IfStatement, and IterationStatement prevent these statements from containing a labelled FunctionDeclaration in non-strict code.
> 
> https://tc39.es/ecma262/#sec-labelled-statements-static-semantics-lexicallydeclarednames
> 
> > Return BoundNames of FunctionDeclaration.
> 
> So (in web compat only) the lex names of a labelled function statement is its name (same rules as plain function decls). So this is a lex name and it should clash with the var that was defined before.
> 
> In a block the name should propagate to the parent statement and clash with the var, in all modes.

## Input

`````js
{
  var f = 123;
  oops: function f(){}
}
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
throws: Parser error!
  A "labelled function declaration" is only allowed in sloppy web compat mode

{
  var f = 123;
  oops: function f(){}
                 ^------- error

}
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

`````
throws: Parser error!
  Attempted to create a lexical binding for `f` but another binding already existed on the same level

{
  var f = 123;
  oops: function f(){}
                 ^------- error

}
`````

