# Tenko parser test case

- Path: tests/testcases/tests_related_to_bindings/export/default/default_still_exports_symbol_too_but_the_export_does_not_add_another_binding.md

> :: tests related to bindings : export : default
>
> ::> default still exports symbol too but the export does not add another binding

## Input

`````js
export default function f(){}; export {f};
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
throws: Parser error!
  The `export` keyword can only be used with the module goal

export default function f(){}; export {f};
^------- error
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:42},source:''},
  body: [
    {
      type: 'ExportDefaultDeclaration',
      loc:{start:{line:1,column:0},end:{line:1,column:29},source:''},
      declaration: {
        type: 'FunctionDeclaration',
        loc:{start:{line:1,column:15},end:{line:1,column:29},source:''},
        generator: false,
        async: false,
        id: {
          type: 'Identifier',
          loc:{start:{line:1,column:24},end:{line:1,column:25},source:''},
          name: 'f'
        },
        params: [],
        body: {
          type: 'BlockStatement',
          loc:{start:{line:1,column:27},end:{line:1,column:29},source:''},
          body: []
        }
      }
    },
    {
      type: 'EmptyStatement',
      loc:{start:{line:1,column:29},end:{line:1,column:30},source:''}
    },
    {
      type: 'ExportNamedDeclaration',
      loc:{start:{line:1,column:31},end:{line:1,column:42},source:''},
      specifiers: [
        {
          type: 'ExportSpecifier',
          loc:{start:{line:1,column:39},end:{line:1,column:40},source:''},
          local: {
            type: 'Identifier',
            loc:{start:{line:1,column:39},end:{line:1,column:40},source:''},
            name: 'f'
          },
          exported: {
            type: 'Identifier',
            loc:{start:{line:1,column:39},end:{line:1,column:40},source:''},
            name: 'f'
          }
        }
      ],
      declaration: null,
      source: null
    }
  ]
}

tokens (15x):
       ID_export ID_default ID_function IDENT PUNC_PAREN_OPEN
       PUNC_PAREN_CLOSE PUNC_CURLY_OPEN PUNC_CURLY_CLOSE PUNC_SEMI
       ID_export PUNC_CURLY_OPEN IDENT PUNC_CURLY_CLOSE PUNC_SEMI
`````


### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [module]:

````js
export default function f() {}
;
export {f}
````

Produces same AST
