# Tenko parser test case

- Path: tests/testcases/tests_related_to_bindings/export/multiple_exports/demand_correct_name_to_be_declared_for_export_when_aliasing_this_declared_neither.md

> :: tests related to bindings : export : multiple exports
>
> ::> demand correct name to be declared for export when aliasing this declared neither
> 
> https://tc39.github.io/ecma262/#sec-module-semantics-static-semantics-early-errors
> 
> > It is a Syntax Error if the ExportedNames of ModuleItemList contains any duplicate entries.
> 
> > The duplicate ExportedNames rule implies that multiple export default ExportDeclaration items within a ModuleBody is a Syntax Error.
> 
> > It is a Syntax Error if any element of the ExportedBindings of ModuleItemList does not also occur in either the VarDeclaredNames of ModuleItemList, or the LexicallyDeclaredNames of ModuleItemList.


## Input


`````js
export {mustExist as canBeUndeclared};
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
throws: Parser error!
  The `export` keyword can only be used with the module goal

export {mustExist as canBeUndeclared};
^------- error
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

`````
throws: Parser error!
  Exporting a name that was not bound in global: `mustExist` (at EOF)

export {mustExist as canBeUndeclared};
                                     ^------- error
`````


### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._
