# Tenko parser test case

- Path: tests/testcases/tests_related_to_bindings/functions/dupe_args_definitions/simple_args/without_explicit_directive/a_a_b.md

> :: tests related to bindings : functions : dupe args definitions : simple args : without explicit directive
>
> ::> a a b
> 
> https://tc39.github.io/ecma262/#sec-function-definitions-static-semantics-early-errors
> > It is a Syntax Error if (IsSimpleParameterList of FormalParameterList is false or strict mode is true) and BoundNames of FormalParameterList contains any duplicate elements.
> 
> dupe bindings are okay in simple args in sloppy script

## Input

`````js
function f(a, a, b) {}
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:22},source:''},
  body: [
    {
      type: 'FunctionDeclaration',
      loc:{start:{line:1,column:0},end:{line:1,column:22},source:''},
      generator: false,
      async: false,
      id: {
        type: 'Identifier',
        loc:{start:{line:1,column:9},end:{line:1,column:10},source:''},
        name: 'f'
      },
      params: [
        {
          type: 'Identifier',
          loc:{start:{line:1,column:11},end:{line:1,column:12},source:''},
          name: 'a'
        },
        {
          type: 'Identifier',
          loc:{start:{line:1,column:14},end:{line:1,column:15},source:''},
          name: 'a'
        },
        {
          type: 'Identifier',
          loc:{start:{line:1,column:17},end:{line:1,column:18},source:''},
          name: 'b'
        }
      ],
      body: {
        type: 'BlockStatement',
        loc:{start:{line:1,column:20},end:{line:1,column:22},source:''},
        body: []
      }
    }
  ]
}

tokens (12x):
       ID_function IDENT PUNC_PAREN_OPEN IDENT PUNC_COMMA IDENT
       PUNC_COMMA IDENT PUNC_PAREN_CLOSE PUNC_CURLY_OPEN
       PUNC_CURLY_CLOSE
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

`````
throws: Parser error!
  Function had duplicate params

function f(a, a, b) {}
                     ^------- error
`````


### Module goal

Parsed with the module goal.

_Output same as strict mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output was same as input [sloppy]
