# Tenko parser test case

- Path: tests/testcases/tests_related_to_bindings/global/let_func.md

> :: tests related to bindings : global
>
> ::> let func
> 
> https://tc39.github.io/ecma262/#sec-scripts-static-semantics-early-errors
> 
> https://tc39.github.io/ecma262/#sec-module-semantics-static-semantics-early-errors
> 
> > It is a Syntax Error if the LexicallyDeclaredNames of ScriptBody contains any duplicate entries.
> 
> > It is a Syntax Error if any element of the LexicallyDeclaredNames of ScriptBody also occurs in the VarDeclaredNames of ScriptBody.

## Input

`````js
let x = a; function x(){};
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
throws: Parser error!
  Found a var binding that is duplicate of a lexical binding on the same or lower statement level

let x = a; function x(){};
                    ^------- error
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

`````
throws: Parser error!
  Attempted to create a lexical binding for `x` but another binding already existed on the same level

let x = a; function x(){};
                    ^------- error
`````


### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._
