# Tenko parser test case

- Path: tests/testcases/tests_related_to_bindings/global/var_var.md

> :: tests related to bindings : global
>
> ::> var var
> 
> https://tc39.github.io/ecma262/#sec-scripts-static-semantics-early-errors
> 
> https://tc39.github.io/ecma262/#sec-module-semantics-static-semantics-early-errors
> 
> > It is a Syntax Error if the LexicallyDeclaredNames of ScriptBody contains any duplicate entries.
> 
> > It is a Syntax Error if any element of the LexicallyDeclaredNames of ScriptBody also occurs in the VarDeclaredNames of ScriptBody.

## Input

`````js
var x = a; var x = b;
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:21},source:''},
  body: [
    {
      type: 'VariableDeclaration',
      loc:{start:{line:1,column:0},end:{line:1,column:10},source:''},
      kind: 'var',
      declarations: [
        {
          type: 'VariableDeclarator',
          loc:{start:{line:1,column:4},end:{line:1,column:9},source:''},
          id: {
            type: 'Identifier',
            loc:{start:{line:1,column:4},end:{line:1,column:5},source:''},
            name: 'x'
          },
          init: {
            type: 'Identifier',
            loc:{start:{line:1,column:8},end:{line:1,column:9},source:''},
            name: 'a'
          }
        }
      ]
    },
    {
      type: 'VariableDeclaration',
      loc:{start:{line:1,column:11},end:{line:1,column:21},source:''},
      kind: 'var',
      declarations: [
        {
          type: 'VariableDeclarator',
          loc:{start:{line:1,column:15},end:{line:1,column:20},source:''},
          id: {
            type: 'Identifier',
            loc:{start:{line:1,column:15},end:{line:1,column:16},source:''},
            name: 'x'
          },
          init: {
            type: 'Identifier',
            loc:{start:{line:1,column:19},end:{line:1,column:20},source:''},
            name: 'b'
          }
        }
      ]
    }
  ]
}

tokens (11x):
       ID_var IDENT PUNC_EQ IDENT PUNC_SEMI ID_var IDENT PUNC_EQ IDENT
       PUNC_SEMI
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
var x = a;
var x = b;
````

Produces same AST
