# Tenko parser test case

- Path: tests/testcases/tests_related_to_bindings/import/in_a_single_import/a_b.md

> :: tests related to bindings : import : in a single import
>
> ::> a b
> 
> https://tc39.github.io/ecma262/#sec-imports-static-semantics-early-errors
> 
> > It is a Syntax Error if the BoundNames of ImportDeclaration contains any duplicate entries.
> 
> https://tc39.github.io/ecma262/#sec-createimportbinding
> 
> The concrete Environment Record method CreateImportBinding for module Environment Records creates a new initialized immutable indirect binding for the name N. A binding must not already exist in this Environment Record for N.

## Input

`````js
import {a, b} from "c"
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
throws: Parser error!
  The `import` keyword can only be used with the module goal

import {a, b} from "c"
       ^------- error
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:22},source:''},
  body: [
    {
      type: 'ImportDeclaration',
      loc:{start:{line:1,column:0},end:{line:1,column:22},source:''},
      specifiers: [
        {
          type: 'ImportSpecifier',
          loc:{start:{line:1,column:8},end:{line:1,column:9},source:''},
          imported: {
            type: 'Identifier',
            loc:{start:{line:1,column:8},end:{line:1,column:9},source:''},
            name: 'a'
          },
          local: {
            type: 'Identifier',
            loc:{start:{line:1,column:8},end:{line:1,column:9},source:''},
            name: 'a'
          }
        },
        {
          type: 'ImportSpecifier',
          loc:{start:{line:1,column:11},end:{line:1,column:12},source:''},
          imported: {
            type: 'Identifier',
            loc:{start:{line:1,column:11},end:{line:1,column:12},source:''},
            name: 'b'
          },
          local: {
            type: 'Identifier',
            loc:{start:{line:1,column:11},end:{line:1,column:12},source:''},
            name: 'b'
          }
        }
      ],
      source: {
        type: 'Literal',
        loc:{start:{line:1,column:19},end:{line:1,column:22},source:''},
        value: 'c',
        raw: '"c"'
      }
    }
  ]
}

tokens (10x):
       ID_import PUNC_CURLY_OPEN IDENT PUNC_COMMA IDENT
       PUNC_CURLY_CLOSE ID_from STRING_DOUBLE ASI
`````


### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [module]:

````js
import {a as a, b as b} from "c";
````

Produces same AST
