# Tenko parser test case

- Path: tests/testcases/tests_related_to_bindings/import/in_a_single_import/a_b_a.md

> :: tests related to bindings : import : in a single import
>
> ::> a b a
> 
> https://tc39.github.io/ecma262/#sec-imports-static-semantics-early-errors
> 
> > It is a Syntax Error if the BoundNames of ImportDeclaration contains any duplicate entries.
> 
> https://tc39.github.io/ecma262/#sec-createimportbinding
> 
> The concrete Environment Record method CreateImportBinding for module Environment Records creates a new initialized immutable indirect binding for the name N. A binding must not already exist in this Environment Record for N.

## Input

`````js
import {a, b, a} from "c"
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
throws: Parser error!
  The `import` keyword can only be used with the module goal

import {a, b, a} from "c"
       ^------- error
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

`````
throws: Parser error!
  Attempted to create a lexical binding for `a` but another binding already existed on the same level

import {a, b, a} from "c"
               ^------- error
`````


### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._
