# Tenko parser test case

- Path: tests/testcases/tests_related_to_bindings/methods/classes/dupe_args_with_local_bindings/simple_arg_as_var_name.md

> :: tests related to bindings : methods : classes : dupe args with local bindings
>
> ::> simple arg as var name
> 
> https://tc39.github.io/ecma262/#sec-method-definitions-static-semantics-early-errors
> 
> > It is a Syntax Error if any element of the BoundNames of UniqueFormalParameters also occurs in the LexicallyDeclaredNames of FunctionBody.
> 
> > The LexicallyDeclaredNames of a FunctionBody does not include identifiers bound using var or function declarations.
> 
> (also applies to the arg of a setter)

## Input

`````js
class o {f(x) { var x; }}
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:25},source:''},
  body: [
    {
      type: 'ClassDeclaration',
      loc:{start:{line:1,column:0},end:{line:1,column:25},source:''},
      id: {
        type: 'Identifier',
        loc:{start:{line:1,column:6},end:{line:1,column:7},source:''},
        name: 'o'
      },
      superClass: null,
      body: {
        type: 'ClassBody',
        loc:{start:{line:1,column:8},end:{line:1,column:25},source:''},
        body: [
          {
            type: 'MethodDefinition',
            loc:{start:{line:1,column:9},end:{line:1,column:24},source:''},
            key: {
              type: 'Identifier',
              loc:{start:{line:1,column:9},end:{line:1,column:10},source:''},
              name: 'f'
            },
            static: false,
            computed: false,
            kind: 'method',
            value: {
              type: 'FunctionExpression',
              loc:{start:{line:1,column:9},end:{line:1,column:24},source:''},
              generator: false,
              async: false,
              id: null,
              params: [
                {
                  type: 'Identifier',
                  loc:{start:{line:1,column:11},end:{line:1,column:12},source:''},
                  name: 'x'
                }
              ],
              body: {
                type: 'BlockStatement',
                loc:{start:{line:1,column:14},end:{line:1,column:24},source:''},
                body: [
                  {
                    type: 'VariableDeclaration',
                    loc:{start:{line:1,column:16},end:{line:1,column:22},source:''},
                    kind: 'var',
                    declarations: [
                      {
                        type: 'VariableDeclarator',
                        loc:{start:{line:1,column:20},end:{line:1,column:21},source:''},
                        id: {
                          type: 'Identifier',
                          loc:{start:{line:1,column:20},end:{line:1,column:21},source:''},
                          name: 'x'
                        },
                        init: null
                      }
                    ]
                  }
                ]
              }
            }
          }
        ]
      }
    }
  ]
}

tokens (14x):
       ID_class IDENT PUNC_CURLY_OPEN IDENT PUNC_PAREN_OPEN IDENT
       PUNC_PAREN_CLOSE PUNC_CURLY_OPEN ID_var IDENT PUNC_SEMI
       PUNC_CURLY_CLOSE PUNC_CURLY_CLOSE
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
class o{f(x){var x;};}
````

Produces same AST
