# Tenko parser test case

- Path: tests/testcases/tests_related_to_bindings/methods/classes/dupe_local_vars/funcdecl_and_var.md

> :: tests related to bindings : methods : classes : dupe local vars
>
> ::> funcdecl and var
>
> https://tc39.github.io/ecma262/#sec-function-definitions-static-semantics-early-errors
>
> > It is a Syntax Error if any element of the LexicallyDeclaredNames of FunctionStatementList also occurs in the VarDeclaredNames of FunctionStatementList.
>
> > The LexicallyDeclaredNames of a FunctionBody does not include identifiers bound using var or function declarations.

## Input

`````js
class o {f(){ function x(){} var x = y; }}
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:42},source:''},
  body: [
    {
      type: 'ClassDeclaration',
      loc:{start:{line:1,column:0},end:{line:1,column:42},source:''},
      id: {
        type: 'Identifier',
        loc:{start:{line:1,column:6},end:{line:1,column:7},source:''},
        name: 'o'
      },
      superClass: null,
      body: {
        type: 'ClassBody',
        loc:{start:{line:1,column:8},end:{line:1,column:42},source:''},
        body: [
          {
            type: 'MethodDefinition',
            loc:{start:{line:1,column:9},end:{line:1,column:41},source:''},
            key: {
              type: 'Identifier',
              loc:{start:{line:1,column:9},end:{line:1,column:10},source:''},
              name: 'f'
            },
            static: false,
            computed: false,
            kind: 'method',
            value: {
              type: 'FunctionExpression',
              loc:{start:{line:1,column:9},end:{line:1,column:41},source:''},
              generator: false,
              async: false,
              id: null,
              params: [],
              body: {
                type: 'BlockStatement',
                loc:{start:{line:1,column:12},end:{line:1,column:41},source:''},
                body: [
                  {
                    type: 'FunctionDeclaration',
                    loc:{start:{line:1,column:14},end:{line:1,column:28},source:''},
                    generator: false,
                    async: false,
                    id: {
                      type: 'Identifier',
                      loc:{start:{line:1,column:23},end:{line:1,column:24},source:''},
                      name: 'x'
                    },
                    params: [],
                    body: {
                      type: 'BlockStatement',
                      loc:{start:{line:1,column:26},end:{line:1,column:28},source:''},
                      body: []
                    }
                  },
                  {
                    type: 'VariableDeclaration',
                    loc:{start:{line:1,column:29},end:{line:1,column:39},source:''},
                    kind: 'var',
                    declarations: [
                      {
                        type: 'VariableDeclarator',
                        loc:{start:{line:1,column:33},end:{line:1,column:38},source:''},
                        id: {
                          type: 'Identifier',
                          loc:{start:{line:1,column:33},end:{line:1,column:34},source:''},
                          name: 'x'
                        },
                        init: {
                          type: 'Identifier',
                          loc:{start:{line:1,column:37},end:{line:1,column:38},source:''},
                          name: 'y'
                        }
                      }
                    ]
                  }
                ]
              }
            }
          }
        ]
      }
    }
  ]
}

tokens (21x):
       ID_class IDENT PUNC_CURLY_OPEN IDENT PUNC_PAREN_OPEN
       PUNC_PAREN_CLOSE PUNC_CURLY_OPEN ID_function IDENT
       PUNC_PAREN_OPEN PUNC_PAREN_CLOSE PUNC_CURLY_OPEN
       PUNC_CURLY_CLOSE ID_var IDENT PUNC_EQ IDENT PUNC_SEMI
       PUNC_CURLY_CLOSE PUNC_CURLY_CLOSE
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
class o{f(){function x() {}
var x = y;};}
````

Produces same AST
