# Tenko parser test case

- Path: tests/testcases/tests_related_to_bindings/methods/object_literal/dupe_args_with_local_bindings/simple_arg_as_a_let.md

> :: tests related to bindings : methods : object literal : dupe args with local bindings
>
> ::> simple arg as a let
>
> https://tc39.github.io/ecma262/#sec-method-definitions-static-semantics-early-errors
>
> > It is a Syntax Error if any element of the BoundNames of UniqueFormalParameters also occurs in the LexicallyDeclaredNames of FunctionBody.
>
> > The LexicallyDeclaredNames of a FunctionBody does not include identifiers bound using var or function declarations.
> 
> (also applies to the arg of a setter)

## Input

`````js
o = {f(x) { let x }}
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
throws: Parser error!
  Cannot create lexical binding for `x` because it shadows a function parameter

o = {f(x) { let x }}
                ^------- error
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._
