# Tenko parser test case

- Path: tests/testcases/tests_related_to_bindings/methods/object_literal/dupe_args_with_local_bindings/simple_arg_as_var_name.md

> :: tests related to bindings : methods : object literal : dupe args with local bindings
>
> ::> simple arg as var name
>
> https://tc39.github.io/ecma262/#sec-method-definitions-static-semantics-early-errors
>
> > It is a Syntax Error if any element of the BoundNames of UniqueFormalParameters also occurs in the LexicallyDeclaredNames of FunctionBody.
>
> > The LexicallyDeclaredNames of a FunctionBody does not include identifiers bound using var or function declarations.
> 
> (also applies to the arg of a setter)

## Input

`````js
o = {f(x) { var x; }}
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:21},source:''},
  body: [
    {
      type: 'ExpressionStatement',
      loc:{start:{line:1,column:0},end:{line:1,column:21},source:''},
      expression: {
        type: 'AssignmentExpression',
        loc:{start:{line:1,column:0},end:{line:1,column:21},source:''},
        left: {
          type: 'Identifier',
          loc:{start:{line:1,column:0},end:{line:1,column:1},source:''},
          name: 'o'
        },
        operator: '=',
        right: {
          type: 'ObjectExpression',
          loc:{start:{line:1,column:4},end:{line:1,column:21},source:''},
          properties: [
            {
              type: 'Property',
              loc:{start:{line:1,column:5},end:{line:1,column:20},source:''},
              key: {
                type: 'Identifier',
                loc:{start:{line:1,column:5},end:{line:1,column:6},source:''},
                name: 'f'
              },
              kind: 'init',
              method: true,
              computed: false,
              value: {
                type: 'FunctionExpression',
                loc:{start:{line:1,column:5},end:{line:1,column:20},source:''},
                generator: false,
                async: false,
                id: null,
                params: [
                  {
                    type: 'Identifier',
                    loc:{start:{line:1,column:7},end:{line:1,column:8},source:''},
                    name: 'x'
                  }
                ],
                body: {
                  type: 'BlockStatement',
                  loc:{start:{line:1,column:10},end:{line:1,column:20},source:''},
                  body: [
                    {
                      type: 'VariableDeclaration',
                      loc:{start:{line:1,column:12},end:{line:1,column:18},source:''},
                      kind: 'var',
                      declarations: [
                        {
                          type: 'VariableDeclarator',
                          loc:{start:{line:1,column:16},end:{line:1,column:17},source:''},
                          id: {
                            type: 'Identifier',
                            loc:{start:{line:1,column:16},end:{line:1,column:17},source:''},
                            name: 'x'
                          },
                          init: null
                        }
                      ]
                    }
                  ]
                }
              },
              shorthand: false
            }
          ]
        }
      }
    }
  ]
}

tokens (15x):
       IDENT PUNC_EQ PUNC_CURLY_OPEN IDENT PUNC_PAREN_OPEN IDENT
       PUNC_PAREN_CLOSE PUNC_CURLY_OPEN ID_var IDENT PUNC_SEMI
       PUNC_CURLY_CLOSE PUNC_CURLY_CLOSE ASI
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
((o = {f(x){var x;}}));
````

Produces same AST
