# Tenko parser test case

- Path: tests/testcases/tests_related_to_bindings/switch/func_decls_are_considered_x0060letx0060_when_not_in_scope_root.md

> :: tests related to bindings : switch
>
> ::> func decls are considered x0060letx0060 when not in scope root
>
> throws in module goal since func decls are considered `let` there
> 
> https://tc39.github.io/ecma262/#sec-switch-statement-static-semantics-early-errors
> 
> > It is a Syntax Error if the LexicallyDeclaredNames of CaseBlock contains any duplicate entries.
> 
> > It is a Syntax Error if any element of the LexicallyDeclaredNames of CaseBlock also occurs in the VarDeclaredNames of CaseBlock.
> 
> https://tc39.github.io/ecma262/#sec-switch-duplicates-allowed-static-semantics
> 
> duplicate function decl names do not cause an error in BlockStatement and SwitchStatement

## Input

`````js
switch (x) {case a: function f(){}; break; case b: function f(){}; break; }
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
throws: Parser error!
  Attempted to create a lexical binding for `f` but another binding already existed on the same level

switch (x) {case a: function f(){}; break; case b: function f(){}; break; }
                                                            ^------- error
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:75},source:''},
  body: [
    {
      type: 'SwitchStatement',
      loc:{start:{line:1,column:0},end:{line:1,column:75},source:''},
      discriminant: {
        type: 'Identifier',
        loc:{start:{line:1,column:8},end:{line:1,column:9},source:''},
        name: 'x'
      },
      cases: [
        {
          type: 'SwitchCase',
          loc:{start:{line:1,column:12},end:{line:1,column:42},source:''},
          test: {
            type: 'Identifier',
            loc:{start:{line:1,column:17},end:{line:1,column:18},source:''},
            name: 'a'
          },
          consequent: [
            {
              type: 'FunctionDeclaration',
              loc:{start:{line:1,column:20},end:{line:1,column:34},source:''},
              generator: false,
              async: false,
              id: {
                type: 'Identifier',
                loc:{start:{line:1,column:29},end:{line:1,column:30},source:''},
                name: 'f'
              },
              params: [],
              body: {
                type: 'BlockStatement',
                loc:{start:{line:1,column:32},end:{line:1,column:34},source:''},
                body: []
              }
            },
            {
              type: 'EmptyStatement',
              loc:{start:{line:1,column:34},end:{line:1,column:35},source:''}
            },
            {
              type: 'BreakStatement',
              loc:{start:{line:1,column:36},end:{line:1,column:42},source:''},
              label: null
            }
          ]
        },
        {
          type: 'SwitchCase',
          loc:{start:{line:1,column:43},end:{line:1,column:73},source:''},
          test: {
            type: 'Identifier',
            loc:{start:{line:1,column:48},end:{line:1,column:49},source:''},
            name: 'b'
          },
          consequent: [
            {
              type: 'FunctionDeclaration',
              loc:{start:{line:1,column:51},end:{line:1,column:65},source:''},
              generator: false,
              async: false,
              id: {
                type: 'Identifier',
                loc:{start:{line:1,column:60},end:{line:1,column:61},source:''},
                name: 'f'
              },
              params: [],
              body: {
                type: 'BlockStatement',
                loc:{start:{line:1,column:63},end:{line:1,column:65},source:''},
                body: []
              }
            },
            {
              type: 'EmptyStatement',
              loc:{start:{line:1,column:65},end:{line:1,column:66},source:''}
            },
            {
              type: 'BreakStatement',
              loc:{start:{line:1,column:67},end:{line:1,column:73},source:''},
              label: null
            }
          ]
        }
      ]
    }
  ]
}

tokens (31x):
       ID_switch PUNC_PAREN_OPEN IDENT PUNC_PAREN_CLOSE
       PUNC_CURLY_OPEN ID_case IDENT PUNC_COLON ID_function IDENT
       PUNC_PAREN_OPEN PUNC_PAREN_CLOSE PUNC_CURLY_OPEN
       PUNC_CURLY_CLOSE PUNC_SEMI ID_break PUNC_SEMI ID_case IDENT
       PUNC_COLON ID_function IDENT PUNC_PAREN_OPEN PUNC_PAREN_CLOSE
       PUNC_CURLY_OPEN PUNC_CURLY_CLOSE PUNC_SEMI ID_break PUNC_SEMI
       PUNC_CURLY_CLOSE
`````


## AST Printer

Printer output different from input [web]:

````js
switch (x) {case a:
function f() {}
;
break;
case b:
function f() {}
;
break;}
````

Produces same AST
