# Tenko parser test case

- Path: tests/testcases/tests_related_to_bindings/switch/var_is_okay_default.md

> :: tests related to bindings : switch
>
> ::> var is okay default
> 
> https://tc39.github.io/ecma262/#sec-switch-statement-static-semantics-early-errors
> 
> > It is a Syntax Error if the LexicallyDeclaredNames of CaseBlock contains any duplicate entries.
> 
> > It is a Syntax Error if any element of the LexicallyDeclaredNames of CaseBlock also occurs in the VarDeclaredNames of CaseBlock.

## Input

`````js
switch (x) { case a: var foo; break; default: var foo; break; }
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:63},source:''},
  body: [
    {
      type: 'SwitchStatement',
      loc:{start:{line:1,column:0},end:{line:1,column:63},source:''},
      discriminant: {
        type: 'Identifier',
        loc:{start:{line:1,column:8},end:{line:1,column:9},source:''},
        name: 'x'
      },
      cases: [
        {
          type: 'SwitchCase',
          loc:{start:{line:1,column:13},end:{line:1,column:36},source:''},
          test: {
            type: 'Identifier',
            loc:{start:{line:1,column:18},end:{line:1,column:19},source:''},
            name: 'a'
          },
          consequent: [
            {
              type: 'VariableDeclaration',
              loc:{start:{line:1,column:21},end:{line:1,column:29},source:''},
              kind: 'var',
              declarations: [
                {
                  type: 'VariableDeclarator',
                  loc:{start:{line:1,column:25},end:{line:1,column:28},source:''},
                  id: {
                    type: 'Identifier',
                    loc:{start:{line:1,column:25},end:{line:1,column:28},source:''},
                    name: 'foo'
                  },
                  init: null
                }
              ]
            },
            {
              type: 'BreakStatement',
              loc:{start:{line:1,column:30},end:{line:1,column:36},source:''},
              label: null
            }
          ]
        },
        {
          type: 'SwitchCase',
          loc:{start:{line:1,column:37},end:{line:1,column:61},source:''},
          test: null,
          consequent: [
            {
              type: 'VariableDeclaration',
              loc:{start:{line:1,column:46},end:{line:1,column:54},source:''},
              kind: 'var',
              declarations: [
                {
                  type: 'VariableDeclarator',
                  loc:{start:{line:1,column:50},end:{line:1,column:53},source:''},
                  id: {
                    type: 'Identifier',
                    loc:{start:{line:1,column:50},end:{line:1,column:53},source:''},
                    name: 'foo'
                  },
                  init: null
                }
              ]
            },
            {
              type: 'BreakStatement',
              loc:{start:{line:1,column:55},end:{line:1,column:61},source:''},
              label: null
            }
          ]
        }
      ]
    }
  ]
}

tokens (22x):
       ID_switch PUNC_PAREN_OPEN IDENT PUNC_PAREN_CLOSE
       PUNC_CURLY_OPEN ID_case IDENT PUNC_COLON ID_var IDENT PUNC_SEMI
       ID_break PUNC_SEMI ID_default PUNC_COLON ID_var IDENT PUNC_SEMI
       ID_break PUNC_SEMI PUNC_CURLY_CLOSE
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
switch (x) {case a:
var foo;
break;
default:
var foo;
break;}
````

Produces same AST
