# Tenko parser test case

- Path: tests/testcases/tests_related_to_bindings/varx002flex_dupe_checks/for-statement_let_outer_var.md

> :: tests related to bindings : varx002flex dupe checks
>
> ::> for-statement let outer var
> 
> In general, you can not declare a lex binding if a var binding exists on the same statement level or below but this check stops at function boundaries. There are no further restriction for var bindings beyond that.

## Input

`````js
for (;;) { let x; } var x;
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:26},source:''},
  body: [
    {
      type: 'ForStatement',
      loc:{start:{line:1,column:0},end:{line:1,column:19},source:''},
      init: null,
      test: null,
      update: null,
      body: {
        type: 'BlockStatement',
        loc:{start:{line:1,column:9},end:{line:1,column:19},source:''},
        body: [
          {
            type: 'VariableDeclaration',
            loc:{start:{line:1,column:11},end:{line:1,column:17},source:''},
            kind: 'let',
            declarations: [
              {
                type: 'VariableDeclarator',
                loc:{start:{line:1,column:15},end:{line:1,column:16},source:''},
                id: {
                  type: 'Identifier',
                  loc:{start:{line:1,column:15},end:{line:1,column:16},source:''},
                  name: 'x'
                },
                init: null
              }
            ]
          }
        ]
      }
    },
    {
      type: 'VariableDeclaration',
      loc:{start:{line:1,column:20},end:{line:1,column:26},source:''},
      kind: 'var',
      declarations: [
        {
          type: 'VariableDeclarator',
          loc:{start:{line:1,column:24},end:{line:1,column:25},source:''},
          id: {
            type: 'Identifier',
            loc:{start:{line:1,column:24},end:{line:1,column:25},source:''},
            name: 'x'
          },
          init: null
        }
      ]
    }
  ]
}

tokens (14x):
       ID_for PUNC_PAREN_OPEN PUNC_SEMI PUNC_SEMI PUNC_PAREN_CLOSE
       PUNC_CURLY_OPEN ID_let IDENT PUNC_SEMI PUNC_CURLY_CLOSE ID_var
       IDENT PUNC_SEMI
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
for (;;) {let x;}
var x;
````

Produces same AST
