# Tenko parser test case

- Path: tests/testcases/tests_related_to_bindings/varx002flex_dupe_checks/outer_var_for-statement_let.md

> :: tests related to bindings : varx002flex dupe checks
>
> ::> outer var for-statement let
> 
> In general, you can not declare a lex binding if a var binding exists on the same statement level or below but this check stops at function boundaries. There are no further restriction for var bindings beyond that.

## Input

`````js
var x; for (;;) { let x; }
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:26},source:''},
  body: [
    {
      type: 'VariableDeclaration',
      loc:{start:{line:1,column:0},end:{line:1,column:6},source:''},
      kind: 'var',
      declarations: [
        {
          type: 'VariableDeclarator',
          loc:{start:{line:1,column:4},end:{line:1,column:5},source:''},
          id: {
            type: 'Identifier',
            loc:{start:{line:1,column:4},end:{line:1,column:5},source:''},
            name: 'x'
          },
          init: null
        }
      ]
    },
    {
      type: 'ForStatement',
      loc:{start:{line:1,column:7},end:{line:1,column:26},source:''},
      init: null,
      test: null,
      update: null,
      body: {
        type: 'BlockStatement',
        loc:{start:{line:1,column:16},end:{line:1,column:26},source:''},
        body: [
          {
            type: 'VariableDeclaration',
            loc:{start:{line:1,column:18},end:{line:1,column:24},source:''},
            kind: 'let',
            declarations: [
              {
                type: 'VariableDeclarator',
                loc:{start:{line:1,column:22},end:{line:1,column:23},source:''},
                id: {
                  type: 'Identifier',
                  loc:{start:{line:1,column:22},end:{line:1,column:23},source:''},
                  name: 'x'
                },
                init: null
              }
            ]
          }
        ]
      }
    }
  ]
}

tokens (14x):
       ID_var IDENT PUNC_SEMI ID_for PUNC_PAREN_OPEN PUNC_SEMI
       PUNC_SEMI PUNC_PAREN_CLOSE PUNC_CURLY_OPEN ID_let IDENT
       PUNC_SEMI PUNC_CURLY_CLOSE
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
var x;
for (;;) {let x;}
````

Produces same AST
