# Tenko parser test case

- Path: tests/testcases/throw_statement/throw_asi_newline_in_do_while.md

> :: throw statement
>
> ::> throw asi newline in do while
>
> ASI after throw statement in a do-while statement


## Input

`````js
function f() {
  do throw pass
  while(x);
}
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:4,column:1},source:''},
  body: [
    {
      type: 'FunctionDeclaration',
      loc:{start:{line:1,column:0},end:{line:4,column:1},source:''},
      generator: false,
      async: false,
      id: {
        type: 'Identifier',
        loc:{start:{line:1,column:9},end:{line:1,column:10},source:''},
        name: 'f'
      },
      params: [],
      body: {
        type: 'BlockStatement',
        loc:{start:{line:1,column:13},end:{line:4,column:1},source:''},
        body: [
          {
            type: 'DoWhileStatement',
            loc:{start:{line:2,column:2},end:{line:3,column:11},source:''},
            body: {
              type: 'ThrowStatement',
              loc:{start:{line:2,column:5},end:{line:2,column:15},source:''},
              argument: {
                type: 'Identifier',
                loc:{start:{line:2,column:11},end:{line:2,column:15},source:''},
                name: 'pass'
              }
            },
            test: {
              type: 'Identifier',
              loc:{start:{line:3,column:8},end:{line:3,column:9},source:''},
              name: 'x'
            }
          }
        ]
      }
    }
  ]
}

tokens (16x):
       ID_function IDENT PUNC_PAREN_OPEN PUNC_PAREN_CLOSE
       PUNC_CURLY_OPEN ID_do ID_throw IDENT ASI ID_while
       PUNC_PAREN_OPEN IDENT PUNC_PAREN_CLOSE PUNC_SEMI
       PUNC_CURLY_CLOSE
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
function f() {do throw pass; while (x);}
````

Produces same AST
