# Tenko parser test case

- Path: tests/testcases/try_statement/regex_edge_case/finally/sans_flag_2.md

> :: try statement : regex edge case : finally
>
> ::> sans flag 2
>
> no ASI is attempted because the finally does not expect a semi so this is fine

## Input

`````js
try {} finally {}
/foo/
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:2,column:5},source:''},
  body: [
    {
      type: 'TryStatement',
      loc:{start:{line:1,column:0},end:{line:1,column:17},source:''},
      block: {
        type: 'BlockStatement',
        loc:{start:{line:1,column:4},end:{line:1,column:6},source:''},
        body: []
      },
      handler: null,
      finalizer: {
        type: 'BlockStatement',
        loc:{start:{line:1,column:15},end:{line:1,column:17},source:''},
        body: []
      }
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:2,column:0},end:{line:2,column:5},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:2,column:0},end:{line:2,column:5},source:''},
        value: null,
        regex: { pattern: 'foo', flags: '' },
        raw: '/foo/'
      }
    }
  ]
}

tokens (9x):
       ID_try PUNC_CURLY_OPEN PUNC_CURLY_CLOSE ID_finally
       PUNC_CURLY_OPEN PUNC_CURLY_CLOSE REGEXN ASI
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
try {} finally {}
/foo/;
````

Produces same AST
