# Tenko parser test case

- Path: tests/testcases/update_x0028incrementx002fdecrementx0029_ops/update_expression_ambiguity/return/asi_before.md

> :: update x0028incrementx002fdecrementx0029 ops : update expression ambiguity : return
>
> ::> asi before
>
> postfix is restricted so ASI should happen
>
> https://tc39.github.io/ecma262/#sec-rules-of-automatic-semicolon-insertion (see notes)

## Input

`````js
function f(){ return a
++b; }
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:2,column:6},source:''},
  body: [
    {
      type: 'FunctionDeclaration',
      loc:{start:{line:1,column:0},end:{line:2,column:6},source:''},
      generator: false,
      async: false,
      id: {
        type: 'Identifier',
        loc:{start:{line:1,column:9},end:{line:1,column:10},source:''},
        name: 'f'
      },
      params: [],
      body: {
        type: 'BlockStatement',
        loc:{start:{line:1,column:12},end:{line:2,column:6},source:''},
        body: [
          {
            type: 'ReturnStatement',
            loc:{start:{line:1,column:14},end:{line:1,column:22},source:''},
            argument: {
              type: 'Identifier',
              loc:{start:{line:1,column:21},end:{line:1,column:22},source:''},
              name: 'a'
            }
          },
          {
            type: 'ExpressionStatement',
            loc:{start:{line:2,column:0},end:{line:2,column:4},source:''},
            expression: {
              type: 'UpdateExpression',
              loc:{start:{line:2,column:0},end:{line:2,column:3},source:''},
              argument: {
                type: 'Identifier',
                loc:{start:{line:2,column:2},end:{line:2,column:3},source:''},
                name: 'b'
              },
              operator: '++',
              prefix: true
            }
          }
        ]
      }
    }
  ]
}

tokens (13x):
       ID_function IDENT PUNC_PAREN_OPEN PUNC_PAREN_CLOSE
       PUNC_CURLY_OPEN ID_return IDENT ASI PUNC_PLUS_PLUS IDENT
       PUNC_SEMI PUNC_CURLY_CLOSE
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
function f() {return a;
++b;}
````

Produces same AST
