# Tenko parser test case

- Path: tests/testcases/var_statement/binding_generic/in_a_for-header/regular_vars/for-in/var_var_with_init_semi.md

> :: var statement : binding generic : in a for-header : regular vars : for-in
>
> ::> var var with init semi
>
> for some reason, it is not the "cannot have an init" one, probably because `in` is an op while `of` is not

## Input

`````js
for (var foo = bar in x);
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
throws: Parser error!
  For-in and for-of binding can not have an init

for (var foo = bar in x);
                   ^------- error
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:25},source:''},
  body: [
    {
      type: 'ForInStatement',
      loc:{start:{line:1,column:0},end:{line:1,column:25},source:''},
      left: {
        type: 'VariableDeclaration',
        loc:{start:{line:1,column:5},end:{line:1,column:18},source:''},
        kind: 'var',
        declarations: [
          {
            type: 'VariableDeclarator',
            loc:{start:{line:1,column:9},end:{line:1,column:18},source:''},
            id: {
              type: 'Identifier',
              loc:{start:{line:1,column:9},end:{line:1,column:12},source:''},
              name: 'foo'
            },
            init: {
              type: 'Identifier',
              loc:{start:{line:1,column:15},end:{line:1,column:18},source:''},
              name: 'bar'
            }
          }
        ]
      },
      right: {
        type: 'Identifier',
        loc:{start:{line:1,column:22},end:{line:1,column:23},source:''},
        name: 'x'
      },
      body: {
        type: 'EmptyStatement',
        loc:{start:{line:1,column:24},end:{line:1,column:25},source:''}
      }
    }
  ]
}

tokens (11x):
       ID_for PUNC_PAREN_OPEN ID_var IDENT PUNC_EQ IDENT ID_in IDENT
       PUNC_PAREN_CLOSE PUNC_SEMI
`````


## AST Printer

Printer output different from input [web]:

````js
for (var foo = bar in x) ;
````

Produces same AST
