# Tenko parser test case

- Path: tests/testcases/var_statement/binding_generic/in_export_decl/destructuring/array/double_destruct.md

> :: var statement : binding generic : in export decl : destructuring : array
>
> ::> double destruct

## Input

`````js
export var [foo] = arr, [bar] = arr2;
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
throws: Parser error!
  The `export` keyword can only be used with the module goal

export var [foo] = arr, [bar] = arr2;
^------- error
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:37},source:''},
  body: [
    {
      type: 'ExportNamedDeclaration',
      loc:{start:{line:1,column:0},end:{line:1,column:37},source:''},
      specifiers: [],
      declaration: {
        type: 'VariableDeclaration',
        loc:{start:{line:1,column:7},end:{line:1,column:37},source:''},
        kind: 'var',
        declarations: [
          {
            type: 'VariableDeclarator',
            loc:{start:{line:1,column:11},end:{line:1,column:22},source:''},
            id: {
              type: 'ArrayPattern',
              loc:{start:{line:1,column:11},end:{line:1,column:16},source:''},
              elements: [
                {
                  type: 'Identifier',
                  loc:{start:{line:1,column:12},end:{line:1,column:15},source:''},
                  name: 'foo'
                }
              ]
            },
            init: {
              type: 'Identifier',
              loc:{start:{line:1,column:19},end:{line:1,column:22},source:''},
              name: 'arr'
            }
          },
          {
            type: 'VariableDeclarator',
            loc:{start:{line:1,column:24},end:{line:1,column:36},source:''},
            id: {
              type: 'ArrayPattern',
              loc:{start:{line:1,column:24},end:{line:1,column:29},source:''},
              elements: [
                {
                  type: 'Identifier',
                  loc:{start:{line:1,column:25},end:{line:1,column:28},source:''},
                  name: 'bar'
                }
              ]
            },
            init: {
              type: 'Identifier',
              loc:{start:{line:1,column:32},end:{line:1,column:36},source:''},
              name: 'arr2'
            }
          }
        ]
      },
      source: null
    }
  ]
}

tokens (15x):
       ID_export ID_var PUNC_BRACKET_OPEN IDENT PUNC_BRACKET_CLOSE
       PUNC_EQ IDENT PUNC_COMMA PUNC_BRACKET_OPEN IDENT
       PUNC_BRACKET_CLOSE PUNC_EQ IDENT PUNC_SEMI
`````


### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [module]:

````js
export var [foo,] = arr, [bar,] = arr2;
````

Produces same AST
