# Tenko parser test case

- Path: tests/testcases/var_statement/binding_generic/in_export_decl/destructuring/array/two_vars.md

> :: var statement : binding generic : in export decl : destructuring : array
>
> ::> two vars

## Input

`````js
export var [foo,bar] = arr;
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
throws: Parser error!
  The `export` keyword can only be used with the module goal

export var [foo,bar] = arr;
^------- error
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:27},source:''},
  body: [
    {
      type: 'ExportNamedDeclaration',
      loc:{start:{line:1,column:0},end:{line:1,column:27},source:''},
      specifiers: [],
      declaration: {
        type: 'VariableDeclaration',
        loc:{start:{line:1,column:7},end:{line:1,column:27},source:''},
        kind: 'var',
        declarations: [
          {
            type: 'VariableDeclarator',
            loc:{start:{line:1,column:11},end:{line:1,column:26},source:''},
            id: {
              type: 'ArrayPattern',
              loc:{start:{line:1,column:11},end:{line:1,column:20},source:''},
              elements: [
                {
                  type: 'Identifier',
                  loc:{start:{line:1,column:12},end:{line:1,column:15},source:''},
                  name: 'foo'
                },
                {
                  type: 'Identifier',
                  loc:{start:{line:1,column:16},end:{line:1,column:19},source:''},
                  name: 'bar'
                }
              ]
            },
            init: {
              type: 'Identifier',
              loc:{start:{line:1,column:23},end:{line:1,column:26},source:''},
              name: 'arr'
            }
          }
        ]
      },
      source: null
    }
  ]
}

tokens (11x):
       ID_export ID_var PUNC_BRACKET_OPEN IDENT PUNC_COMMA IDENT
       PUNC_BRACKET_CLOSE PUNC_EQ IDENT PUNC_SEMI
`````


### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [module]:

````js
export var [foo, bar,] = arr;
````

Produces same AST
