# Tenko parser test case

- Path: tests/testcases/var_statement/html_comment_close_marks_start_of_single_line_comment.md

> :: var statement
>
> ::> html comment close marks start of single line comment
>
> source: test262/test/annexB/language/comments/single-line-html-close-asi.js (the html comment acts as // and the rest is ignored)

## Input

`````js
var foo = [23]
-->[0];
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
throws: Parser error!
  Expected to parse a value

var foo = [23]
-->[0];
  ^------- error
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:2,column:7},source:''},
  body: [
    {
      type: 'VariableDeclaration',
      loc:{start:{line:1,column:0},end:{line:1,column:14},source:''},
      kind: 'var',
      declarations: [
        {
          type: 'VariableDeclarator',
          loc:{start:{line:1,column:4},end:{line:1,column:14},source:''},
          id: {
            type: 'Identifier',
            loc:{start:{line:1,column:4},end:{line:1,column:7},source:''},
            name: 'foo'
          },
          init: {
            type: 'ArrayExpression',
            loc:{start:{line:1,column:10},end:{line:1,column:14},source:''},
            elements: [
              {
                type: 'Literal',
                loc:{start:{line:1,column:11},end:{line:1,column:13},source:''},
                value: 23,
                raw: '23'
              }
            ]
          }
        }
      ]
    }
  ]
}

tokens (8x):
       ID_var IDENT PUNC_EQ PUNC_BRACKET_OPEN NUMBER_DEC
       PUNC_BRACKET_CLOSE ASI
`````


## AST Printer

Printer output different from input [web]:

````js
var foo = [23,];
````

Produces same AST
