# Tenko parser test case

- Path: tests/testcases/yield/arguments_checks/arrow_func_args_in_block_scope/group_yield_as_rhs_sans_arg.md

> :: yield : arguments checks : arrow func args in block scope
>
> ::> group yield as rhs sans arg
>
> yield inside generator is never a var

## Input

`````js
{ (x = x + yield); }
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:20},source:''},
  body: [
    {
      type: 'BlockStatement',
      loc:{start:{line:1,column:0},end:{line:1,column:20},source:''},
      body: [
        {
          type: 'ExpressionStatement',
          loc:{start:{line:1,column:2},end:{line:1,column:18},source:''},
          expression: {
            type: 'AssignmentExpression',
            loc:{start:{line:1,column:3},end:{line:1,column:16},source:''},
            left: {
              type: 'Identifier',
              loc:{start:{line:1,column:3},end:{line:1,column:4},source:''},
              name: 'x'
            },
            operator: '=',
            right: {
              type: 'BinaryExpression',
              loc:{start:{line:1,column:7},end:{line:1,column:16},source:''},
              left: {
                type: 'Identifier',
                loc:{start:{line:1,column:7},end:{line:1,column:8},source:''},
                name: 'x'
              },
              operator: '+',
              right: {
                type: 'Identifier',
                loc:{start:{line:1,column:11},end:{line:1,column:16},source:''},
                name: 'yield'
              }
            }
          }
        }
      ]
    }
  ]
}

tokens (11x):
       PUNC_CURLY_OPEN PUNC_PAREN_OPEN IDENT PUNC_EQ IDENT PUNC_PLUS
       ID_yield PUNC_PAREN_CLOSE PUNC_SEMI PUNC_CURLY_CLOSE
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

`````
throws: Parser error!
  Cannot use `yield` outside of generator functions when in strict mode

{ (x = x + yield); }
                ^------- error
`````


### Module goal

Parsed with the module goal.

_Output same as strict mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
{((x = ((x) + (yield))));}
````

Produces same AST
