# Tenko parser test case

- Path: tests/testcases/yield/arguments_checks/more_arg_checks/grouped_arged_yield_expr_is_illegal_in_arrow_arg_default.md

> :: yield : arguments checks : more arg checks
>
> ::> grouped arged yield expr is illegal in arrow arg default
>
> https://tc39.github.io/ecma262/#prod-YieldExpression
>
> > YieldExpression cannot be used within the FormalParameters of a generator function because any expressions that are part of FormalParameters are evaluated before the resulting generator object is in a resumable state.
>
> > It is a Syntax Error if UniqueFormalParameters Contains YieldExpression is true.


## Input


`````js
function *f(){ async (x = (yield y)) => {} }
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
throws: Parser error!
  The arguments of an arrow cannot contain a yield expression in their defaults

function *f(){ async (x = (yield y)) => {} }
                                     ^------- error
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._
