# Tenko parser test case

- Path: tests/testcases/yield/arguments_checks/more_arg_checks/grouped_yield_var_legal_in_arrow_arg_default.md

> :: yield : arguments checks : more arg checks
>
> ::> grouped yield var legal in arrow arg default
>
> https://tc39.github.io/ecma262/#prod-YieldExpression
>
> > YieldExpression cannot be used within the FormalParameters of a generator function because any expressions that are part of FormalParameters are evaluated before the resulting generator object is in a resumable state.
>
> > It is a Syntax Error if UniqueFormalParameters Contains YieldExpression is true.

## Input

`````js
async (x = (yield)) => {}
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:25},source:''},
  body: [
    {
      type: 'ExpressionStatement',
      loc:{start:{line:1,column:0},end:{line:1,column:25},source:''},
      expression: {
        type: 'ArrowFunctionExpression',
        loc:{start:{line:1,column:0},end:{line:1,column:25},source:''},
        params: [
          {
            type: 'AssignmentPattern',
            loc:{start:{line:1,column:7},end:{line:1,column:18},source:''},
            left: {
              type: 'Identifier',
              loc:{start:{line:1,column:7},end:{line:1,column:8},source:''},
              name: 'x'
            },
            right: {
              type: 'Identifier',
              loc:{start:{line:1,column:12},end:{line:1,column:17},source:''},
              name: 'yield'
            }
          }
        ],
        id: null,
        generator: false,
        async: true,
        expression: false,
        body: {
          type: 'BlockStatement',
          loc:{start:{line:1,column:23},end:{line:1,column:25},source:''},
          body: []
        }
      }
    }
  ]
}

tokens (13x):
       ID_async PUNC_PAREN_OPEN IDENT PUNC_EQ PUNC_PAREN_OPEN ID_yield
       PUNC_PAREN_CLOSE PUNC_PAREN_CLOSE PUNC_EQ_GT PUNC_CURLY_OPEN
       PUNC_CURLY_CLOSE ASI
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

`````
throws: Parser error!
  Cannot use `yield` outside of generator functions when in strict mode

async (x = (yield)) => {}
                 ^------- error
`````


### Module goal

Parsed with the module goal.

_Output same as strict mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
async (x = yield) => {};
````

Produces same AST
