# Tenko parser test case

- Path: tests/testcases/yield/arguments_checks/more_arg_checks/no_arg_yield_expr_in_async_call.md

> :: yield : arguments checks : more arg checks
>
> ::> no arg yield expr in async call
>
> https://tc39.github.io/ecma262/#prod-YieldExpression
>
> > YieldExpression cannot be used within the FormalParameters of a generator function because any expressions that are part of FormalParameters are evaluated before the resulting generator object is in a resumable state.
>
> > It is a Syntax Error if UniqueFormalParameters Contains YieldExpression is true.

## Input

`````js
function *f(){ async (yield) }
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:30},source:''},
  body: [
    {
      type: 'FunctionDeclaration',
      loc:{start:{line:1,column:0},end:{line:1,column:30},source:''},
      generator: true,
      async: false,
      id: {
        type: 'Identifier',
        loc:{start:{line:1,column:10},end:{line:1,column:11},source:''},
        name: 'f'
      },
      params: [],
      body: {
        type: 'BlockStatement',
        loc:{start:{line:1,column:13},end:{line:1,column:30},source:''},
        body: [
          {
            type: 'ExpressionStatement',
            loc:{start:{line:1,column:15},end:{line:1,column:28},source:''},
            expression: {
              type: 'CallExpression',
              loc:{start:{line:1,column:15},end:{line:1,column:28},source:''},
              callee: {
                type: 'Identifier',
                loc:{start:{line:1,column:15},end:{line:1,column:20},source:''},
                name: 'async'
              },
              arguments: [
                {
                  type: 'YieldExpression',
                  loc:{start:{line:1,column:22},end:{line:1,column:27},source:''},
                  delegate: false,
                  argument: null
                }
              ]
            }
          }
        ]
      }
    }
  ]
}

tokens (13x):
       ID_function PUNC_STAR IDENT PUNC_PAREN_OPEN PUNC_PAREN_CLOSE
       PUNC_CURLY_OPEN ID_async PUNC_PAREN_OPEN ID_yield
       PUNC_PAREN_CLOSE ASI PUNC_CURLY_CLOSE
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
function* f() {(async((yield)));}
````

Produces same AST
