# Tenko parser test case

- Path: tests/testcases/yield/arguments_checks/more_arg_checks/regression.md

> :: yield : arguments checks : more arg checks
>
> ::> regression
>
> https://tc39.github.io/ecma262/#prod-YieldExpression
>
> > YieldExpression cannot be used within the FormalParameters of a generator function because any expressions that are part of FormalParameters are evaluated before the resulting generator object is in a resumable state.
>
> > It is a Syntax Error if UniqueFormalParameters Contains YieldExpression is true.

## Input

`````js
iter = yield();
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:15},source:''},
  body: [
    {
      type: 'ExpressionStatement',
      loc:{start:{line:1,column:0},end:{line:1,column:15},source:''},
      expression: {
        type: 'AssignmentExpression',
        loc:{start:{line:1,column:0},end:{line:1,column:14},source:''},
        left: {
          type: 'Identifier',
          loc:{start:{line:1,column:0},end:{line:1,column:4},source:''},
          name: 'iter'
        },
        operator: '=',
        right: {
          type: 'CallExpression',
          loc:{start:{line:1,column:7},end:{line:1,column:14},source:''},
          callee: {
            type: 'Identifier',
            loc:{start:{line:1,column:7},end:{line:1,column:12},source:''},
            name: 'yield'
          },
          arguments: []
        }
      }
    }
  ]
}

tokens (7x):
       IDENT PUNC_EQ ID_yield PUNC_PAREN_OPEN PUNC_PAREN_CLOSE
       PUNC_SEMI
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

`````
throws: Parser error!
  Cannot use `yield` outside of generator functions when in strict mode

iter = yield();
            ^------- error
`````


### Module goal

Parsed with the module goal.

_Output same as strict mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
((iter = (yield)()));
````

Produces same AST
