# Tenko parser test case

- Path: tests/testcases/yield/arguments_checks/more_arg_checks/yield_as_an_arg_of_a_generator.md

> :: yield : arguments checks : more arg checks
>
> ::> yield as an arg of a generator
>
> explicitly not allowed
>
> https://tc39.github.io/ecma262/#prod-YieldExpression
>
> > YieldExpression cannot be used within the FormalParameters of a generator function because any expressions that are part of FormalParameters are evaluated before the resulting generator object is in a resumable state.
>
> > It is a Syntax Error if UniqueFormalParameters Contains YieldExpression is true.

## Input


`````js
function *f(yield){}
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
throws: Parser error!
  Cannot use this name (yield) as a variable name because: Cannot use this reserved word as a variable name inside a generator

function *f(yield){}
            ^------- error
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

`````
throws: Parser error!
  Cannot use this name (yield) as a variable name because: Cannot use this reserved word as a variable name in strict mode

function *f(yield){}
            ^------- error
`````


### Module goal

Parsed with the module goal.

_Output same as strict mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._
