# Tenko parser test case

- Path: tests/testcases/yield/arguments_checks/more_arg_checks/yield_as_arg_inside_a_generator.md

> :: yield : arguments checks : more arg checks
>
> ::> yield as arg inside a generator
>
> the inner function resets the state
>
> https://tc39.github.io/ecma262/#prod-YieldExpression
>
> > YieldExpression cannot be used within the FormalParameters of a generator function because any expressions that are part of FormalParameters are evaluated before the resulting generator object is in a resumable state.
>
> > It is a Syntax Error if UniqueFormalParameters Contains YieldExpression is true.

## Input

`````js
function *f({x: x}) { function f({x: yield}) {} }
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:49},source:''},
  body: [
    {
      type: 'FunctionDeclaration',
      loc:{start:{line:1,column:0},end:{line:1,column:49},source:''},
      generator: true,
      async: false,
      id: {
        type: 'Identifier',
        loc:{start:{line:1,column:10},end:{line:1,column:11},source:''},
        name: 'f'
      },
      params: [
        {
          type: 'ObjectPattern',
          loc:{start:{line:1,column:12},end:{line:1,column:18},source:''},
          properties: [
            {
              type: 'Property',
              loc:{start:{line:1,column:13},end:{line:1,column:17},source:''},
              key: {
                type: 'Identifier',
                loc:{start:{line:1,column:13},end:{line:1,column:14},source:''},
                name: 'x'
              },
              kind: 'init',
              method: false,
              computed: false,
              value: {
                type: 'Identifier',
                loc:{start:{line:1,column:16},end:{line:1,column:17},source:''},
                name: 'x'
              },
              shorthand: false
            }
          ]
        }
      ],
      body: {
        type: 'BlockStatement',
        loc:{start:{line:1,column:20},end:{line:1,column:49},source:''},
        body: [
          {
            type: 'FunctionDeclaration',
            loc:{start:{line:1,column:22},end:{line:1,column:47},source:''},
            generator: false,
            async: false,
            id: {
              type: 'Identifier',
              loc:{start:{line:1,column:31},end:{line:1,column:32},source:''},
              name: 'f'
            },
            params: [
              {
                type: 'ObjectPattern',
                loc:{start:{line:1,column:33},end:{line:1,column:43},source:''},
                properties: [
                  {
                    type: 'Property',
                    loc:{start:{line:1,column:34},end:{line:1,column:42},source:''},
                    key: {
                      type: 'Identifier',
                      loc:{start:{line:1,column:34},end:{line:1,column:35},source:''},
                      name: 'x'
                    },
                    kind: 'init',
                    method: false,
                    computed: false,
                    value: {
                      type: 'Identifier',
                      loc:{start:{line:1,column:37},end:{line:1,column:42},source:''},
                      name: 'yield'
                    },
                    shorthand: false
                  }
                ]
              }
            ],
            body: {
              type: 'BlockStatement',
              loc:{start:{line:1,column:45},end:{line:1,column:47},source:''},
              body: []
            }
          }
        ]
      }
    }
  ]
}

tokens (24x):
       ID_function PUNC_STAR IDENT PUNC_PAREN_OPEN PUNC_CURLY_OPEN
       IDENT PUNC_COLON IDENT PUNC_CURLY_CLOSE PUNC_PAREN_CLOSE
       PUNC_CURLY_OPEN ID_function IDENT PUNC_PAREN_OPEN
       PUNC_CURLY_OPEN IDENT PUNC_COLON ID_yield PUNC_CURLY_CLOSE
       PUNC_PAREN_CLOSE PUNC_CURLY_OPEN PUNC_CURLY_CLOSE
       PUNC_CURLY_CLOSE
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

`````
throws: Parser error!
  Cannot use `yield` outside of generator functions when in strict mode

function *f({x: x}) { function f({x: yield}) {} }
                                          ^------- error
`````


### Module goal

Parsed with the module goal.

_Output same as strict mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
function* f({x:x}) {function f({x:yield}) {}}
````

Produces same AST
