# Tenko parser test case

- Path: tests/testcases/yield/inside_a_generator/inside_a_call/sans_args.md

> :: yield : inside a generator : inside a call
>
> ::> sans args

## Input

`````js
function* f(){ call(yield); }
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:29},source:''},
  body: [
    {
      type: 'FunctionDeclaration',
      loc:{start:{line:1,column:0},end:{line:1,column:29},source:''},
      generator: true,
      async: false,
      id: {
        type: 'Identifier',
        loc:{start:{line:1,column:10},end:{line:1,column:11},source:''},
        name: 'f'
      },
      params: [],
      body: {
        type: 'BlockStatement',
        loc:{start:{line:1,column:13},end:{line:1,column:29},source:''},
        body: [
          {
            type: 'ExpressionStatement',
            loc:{start:{line:1,column:15},end:{line:1,column:27},source:''},
            expression: {
              type: 'CallExpression',
              loc:{start:{line:1,column:15},end:{line:1,column:26},source:''},
              callee: {
                type: 'Identifier',
                loc:{start:{line:1,column:15},end:{line:1,column:19},source:''},
                name: 'call'
              },
              arguments: [
                {
                  type: 'YieldExpression',
                  loc:{start:{line:1,column:20},end:{line:1,column:25},source:''},
                  delegate: false,
                  argument: null
                }
              ]
            }
          }
        ]
      }
    }
  ]
}

tokens (13x):
       ID_function PUNC_STAR IDENT PUNC_PAREN_OPEN PUNC_PAREN_CLOSE
       PUNC_CURLY_OPEN IDENT PUNC_PAREN_OPEN ID_yield PUNC_PAREN_CLOSE
       PUNC_SEMI PUNC_CURLY_CLOSE
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
function* f() {((call)((yield)));}
````

Produces same AST
