# Tenko parser test case

- Path: tests/testcases/yield/lotta_yielding.md

> :: yield
>
> ::> lotta yielding
>
> This is a regression from test262
>
> test262/test/language/expressions/async-generator/named-yield-identifier-spread-non-strict.js
>
> The minimal test case was `function *f(){ return { ...(yield) } }` and triggered an assertion

## Input

`````js
var gen = async function *g() {
  callCount += 1;
  yield {
       ...yield yield,
       ...(function(arg) {
          var yield = arg;
          return {...yield};
       }(yield)),
       ...yield,
    }
};
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:11,column:2},source:''},
  body: [
    {
      type: 'VariableDeclaration',
      loc:{start:{line:1,column:0},end:{line:11,column:2},source:''},
      kind: 'var',
      declarations: [
        {
          type: 'VariableDeclarator',
          loc:{start:{line:1,column:4},end:{line:11,column:1},source:''},
          id: {
            type: 'Identifier',
            loc:{start:{line:1,column:4},end:{line:1,column:7},source:''},
            name: 'gen'
          },
          init: {
            type: 'FunctionExpression',
            loc:{start:{line:1,column:10},end:{line:11,column:1},source:''},
            generator: true,
            async: true,
            id: {
              type: 'Identifier',
              loc:{start:{line:1,column:26},end:{line:1,column:27},source:''},
              name: 'g'
            },
            params: [],
            body: {
              type: 'BlockStatement',
              loc:{start:{line:1,column:30},end:{line:11,column:1},source:''},
              body: [
                {
                  type: 'ExpressionStatement',
                  loc:{start:{line:2,column:2},end:{line:2,column:17},source:''},
                  expression: {
                    type: 'AssignmentExpression',
                    loc:{start:{line:2,column:2},end:{line:2,column:16},source:''},
                    left: {
                      type: 'Identifier',
                      loc:{start:{line:2,column:2},end:{line:2,column:11},source:''},
                      name: 'callCount'
                    },
                    operator: '+=',
                    right: {
                      type: 'Literal',
                      loc:{start:{line:2,column:15},end:{line:2,column:16},source:''},
                      value: 1,
                      raw: '1'
                    }
                  }
                },
                {
                  type: 'ExpressionStatement',
                  loc:{start:{line:3,column:2},end:{line:10,column:5},source:''},
                  expression: {
                    type: 'YieldExpression',
                    loc:{start:{line:3,column:2},end:{line:10,column:5},source:''},
                    delegate: false,
                    argument: {
                      type: 'ObjectExpression',
                      loc:{start:{line:3,column:8},end:{line:10,column:5},source:''},
                      properties: [
                        {
                          type: 'SpreadElement',
                          loc:{start:{line:4,column:7},end:{line:4,column:21},source:''},
                          argument: {
                            type: 'YieldExpression',
                            loc:{start:{line:4,column:10},end:{line:4,column:21},source:''},
                            delegate: false,
                            argument: {
                              type: 'YieldExpression',
                              loc:{start:{line:4,column:16},end:{line:4,column:21},source:''},
                              delegate: false,
                              argument: null
                            }
                          }
                        },
                        {
                          type: 'SpreadElement',
                          loc:{start:{line:5,column:7},end:{line:8,column:16},source:''},
                          argument: {
                            type: 'CallExpression',
                            loc:{start:{line:5,column:11},end:{line:8,column:15},source:''},
                            callee: {
                              type: 'FunctionExpression',
                              loc:{start:{line:5,column:11},end:{line:8,column:8},source:''},
                              generator: false,
                              async: false,
                              id: null,
                              params: [
                                {
                                  type: 'Identifier',
                                  loc:{start:{line:5,column:20},end:{line:5,column:23},source:''},
                                  name: 'arg'
                                }
                              ],
                              body: {
                                type: 'BlockStatement',
                                loc:{start:{line:5,column:25},end:{line:8,column:8},source:''},
                                body: [
                                  {
                                    type: 'VariableDeclaration',
                                    loc:{start:{line:6,column:10},end:{line:6,column:26},source:''},
                                    kind: 'var',
                                    declarations: [
                                      {
                                        type: 'VariableDeclarator',
                                        loc:{start:{line:6,column:14},end:{line:6,column:25},source:''},
                                        id: {
                                          type: 'Identifier',
                                          loc:{start:{line:6,column:14},end:{line:6,column:19},source:''},
                                          name: 'yield'
                                        },
                                        init: {
                                          type: 'Identifier',
                                          loc:{start:{line:6,column:22},end:{line:6,column:25},source:''},
                                          name: 'arg'
                                        }
                                      }
                                    ]
                                  },
                                  {
                                    type: 'ReturnStatement',
                                    loc:{start:{line:7,column:10},end:{line:7,column:28},source:''},
                                    argument: {
                                      type: 'ObjectExpression',
                                      loc:{start:{line:7,column:17},end:{line:7,column:27},source:''},
                                      properties: [
                                        {
                                          type: 'SpreadElement',
                                          loc:{start:{line:7,column:18},end:{line:7,column:26},source:''},
                                          argument: {
                                            type: 'Identifier',
                                            loc:{start:{line:7,column:21},end:{line:7,column:26},source:''},
                                            name: 'yield'
                                          }
                                        }
                                      ]
                                    }
                                  }
                                ]
                              }
                            },
                            arguments: [
                              {
                                type: 'YieldExpression',
                                loc:{start:{line:8,column:9},end:{line:8,column:14},source:''},
                                delegate: false,
                                argument: null
                              }
                            ]
                          }
                        },
                        {
                          type: 'SpreadElement',
                          loc:{start:{line:9,column:7},end:{line:9,column:15},source:''},
                          argument: {
                            type: 'YieldExpression',
                            loc:{start:{line:9,column:10},end:{line:9,column:15},source:''},
                            delegate: false,
                            argument: null
                          }
                        }
                      ]
                    }
                  }
                }
              ]
            }
          }
        }
      ]
    }
  ]
}

tokens (52x):
       ID_var IDENT PUNC_EQ ID_async ID_function PUNC_STAR IDENT
       PUNC_PAREN_OPEN PUNC_PAREN_CLOSE PUNC_CURLY_OPEN IDENT
       PUNC_PLUS_EQ NUMBER_DEC PUNC_SEMI ID_yield PUNC_CURLY_OPEN
       PUNC_DOT_DOT_DOT ID_yield ID_yield PUNC_COMMA PUNC_DOT_DOT_DOT
       PUNC_PAREN_OPEN ID_function PUNC_PAREN_OPEN IDENT
       PUNC_PAREN_CLOSE PUNC_CURLY_OPEN ID_var ID_yield PUNC_EQ IDENT
       PUNC_SEMI ID_return PUNC_CURLY_OPEN PUNC_DOT_DOT_DOT ID_yield
       PUNC_CURLY_CLOSE PUNC_SEMI PUNC_CURLY_CLOSE PUNC_PAREN_OPEN
       ID_yield PUNC_PAREN_CLOSE PUNC_PAREN_CLOSE PUNC_COMMA
       PUNC_DOT_DOT_DOT ID_yield PUNC_COMMA PUNC_CURLY_CLOSE ASI
       PUNC_CURLY_CLOSE PUNC_SEMI
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

`````
throws: Parser error!
  Cannot use this name (yield) as a variable name because: Cannot use this reserved word as a variable name in strict mode

 *g() {
  callCount += 1;
  yield {
       ...yield yield,
       ...(function(arg) {
          var yield = arg;
              ^------- error

          return {...yield};
       }(yield)),
       ...yield,
    }
};
`````


### Module goal

Parsed with the module goal.

_Output same as strict mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
var gen = async function* g() {((callCount += 1));
(yield ({...(yield ((yield))), ...(function(arg) {var yield = arg;
return {...yield};})((yield)), ...(yield)}));};
````

Produces same AST
