# Tenko parser test case

- Path: tests/testcases/yield/restricted_production/in_generator/asi_regex_arg_trail.md

> :: yield : restricted production : in generator
>
> ::> asi regex arg trail
>
> `yield` with arg may not have a newline before the arg but regex on newline can not have asi...
>
> This test makes sure workarounds do not just work on the expression statement level :)

## Input

`````js
function *f() {
  x = yield
    /x/
}
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:4,column:1},source:''},
  body: [
    {
      type: 'FunctionDeclaration',
      loc:{start:{line:1,column:0},end:{line:4,column:1},source:''},
      generator: true,
      async: false,
      id: {
        type: 'Identifier',
        loc:{start:{line:1,column:10},end:{line:1,column:11},source:''},
        name: 'f'
      },
      params: [],
      body: {
        type: 'BlockStatement',
        loc:{start:{line:1,column:14},end:{line:4,column:1},source:''},
        body: [
          {
            type: 'ExpressionStatement',
            loc:{start:{line:2,column:2},end:{line:2,column:11},source:''},
            expression: {
              type: 'AssignmentExpression',
              loc:{start:{line:2,column:2},end:{line:2,column:11},source:''},
              left: {
                type: 'Identifier',
                loc:{start:{line:2,column:2},end:{line:2,column:3},source:''},
                name: 'x'
              },
              operator: '=',
              right: {
                type: 'YieldExpression',
                loc:{start:{line:2,column:6},end:{line:2,column:11},source:''},
                delegate: false,
                argument: null
              }
            }
          },
          {
            type: 'ExpressionStatement',
            loc:{start:{line:3,column:4},end:{line:3,column:7},source:''},
            expression: {
              type: 'Literal',
              loc:{start:{line:3,column:4},end:{line:3,column:7},source:''},
              value: null,
              regex: { pattern: 'x', flags: '' },
              raw: '/x/'
            }
          }
        ]
      }
    }
  ]
}

tokens (14x):
       ID_function PUNC_STAR IDENT PUNC_PAREN_OPEN PUNC_PAREN_CLOSE
       PUNC_CURLY_OPEN IDENT PUNC_EQ ID_yield ASI REGEXN ASI
       PUNC_CURLY_CLOSE
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
function* f() {((x = (yield)));
/x/;}
````

Produces same AST
