# Tenko parser test case

- Path: tests/testcases/yield/restricted_production/plain/asi_div.md

> :: yield : restricted production : plain
>
> ::> asi div
>
> `yield` with arg may not have a newline before the arg, but here it is a regular division


## Input

`````js
yield
/x
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:2,column:2},source:''},
  body: [
    {
      type: 'ExpressionStatement',
      loc:{start:{line:1,column:0},end:{line:2,column:2},source:''},
      expression: {
        type: 'BinaryExpression',
        loc:{start:{line:1,column:0},end:{line:2,column:2},source:''},
        left: {
          type: 'Identifier',
          loc:{start:{line:1,column:0},end:{line:1,column:5},source:''},
          name: 'yield'
        },
        operator: '/',
        right: {
          type: 'Identifier',
          loc:{start:{line:2,column:1},end:{line:2,column:2},source:''},
          name: 'x'
        }
      }
    }
  ]
}

tokens (5x):
       ID_yield PUNC_DIV IDENT ASI
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

`````
throws: Lexer error!
    Regex: Found EOF before regex was closed

yield
/x
^------- error
`````


### Module goal

Parsed with the module goal.

_Output same as strict mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
(((yield) / (x)));
````

Produces same AST
