# Tenko parser test case

- Path: tests/testcases/yield/spreading_yield_expression.md

> :: yield
>
> ::> spreading yield expression
>
> Regression caught by test262
>
> Minimal test derived from the test in
>
> test262/test/language/expressions/async-generator/named-yield-identifier-spread-non-strict.js

## Input

`````js
function *f(){ return { ...(yield) } }
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:38},source:''},
  body: [
    {
      type: 'FunctionDeclaration',
      loc:{start:{line:1,column:0},end:{line:1,column:38},source:''},
      generator: true,
      async: false,
      id: {
        type: 'Identifier',
        loc:{start:{line:1,column:10},end:{line:1,column:11},source:''},
        name: 'f'
      },
      params: [],
      body: {
        type: 'BlockStatement',
        loc:{start:{line:1,column:13},end:{line:1,column:38},source:''},
        body: [
          {
            type: 'ReturnStatement',
            loc:{start:{line:1,column:15},end:{line:1,column:36},source:''},
            argument: {
              type: 'ObjectExpression',
              loc:{start:{line:1,column:22},end:{line:1,column:36},source:''},
              properties: [
                {
                  type: 'SpreadElement',
                  loc:{start:{line:1,column:24},end:{line:1,column:34},source:''},
                  argument: {
                    type: 'YieldExpression',
                    loc:{start:{line:1,column:28},end:{line:1,column:33},source:''},
                    delegate: false,
                    argument: null
                  }
                }
              ]
            }
          }
        ]
      }
    }
  ]
}

tokens (16x):
       ID_function PUNC_STAR IDENT PUNC_PAREN_OPEN PUNC_PAREN_CLOSE
       PUNC_CURLY_OPEN ID_return PUNC_CURLY_OPEN PUNC_DOT_DOT_DOT
       PUNC_PAREN_OPEN ID_yield PUNC_PAREN_CLOSE PUNC_CURLY_CLOSE ASI
       PUNC_CURLY_CLOSE
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
function* f() {return {...(yield)};}
````

Produces same AST
