# Tenko parser test case

- Path: tests/testcases/yield/yield_in_assignment_rhs_is_fine.md

> :: yield
>
> ::> yield in assignment rhs is fine
>
> AssignmentExpression can go into YieldExpression

## Input

`````js
function* g() { let x = yield 3; }
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:34},source:''},
  body: [
    {
      type: 'FunctionDeclaration',
      loc:{start:{line:1,column:0},end:{line:1,column:34},source:''},
      generator: true,
      async: false,
      id: {
        type: 'Identifier',
        loc:{start:{line:1,column:10},end:{line:1,column:11},source:''},
        name: 'g'
      },
      params: [],
      body: {
        type: 'BlockStatement',
        loc:{start:{line:1,column:14},end:{line:1,column:34},source:''},
        body: [
          {
            type: 'VariableDeclaration',
            loc:{start:{line:1,column:16},end:{line:1,column:32},source:''},
            kind: 'let',
            declarations: [
              {
                type: 'VariableDeclarator',
                loc:{start:{line:1,column:20},end:{line:1,column:31},source:''},
                id: {
                  type: 'Identifier',
                  loc:{start:{line:1,column:20},end:{line:1,column:21},source:''},
                  name: 'x'
                },
                init: {
                  type: 'YieldExpression',
                  loc:{start:{line:1,column:24},end:{line:1,column:31},source:''},
                  delegate: false,
                  argument: {
                    type: 'Literal',
                    loc:{start:{line:1,column:30},end:{line:1,column:31},source:''},
                    value: 3,
                    raw: '3'
                  }
                }
              }
            ]
          }
        ]
      }
    }
  ]
}

tokens (14x):
       ID_function PUNC_STAR IDENT PUNC_PAREN_OPEN PUNC_PAREN_CLOSE
       PUNC_CURLY_OPEN ID_let IDENT PUNC_EQ ID_yield NUMBER_DEC
       PUNC_SEMI PUNC_CURLY_CLOSE
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
function* g() {let x = (yield (3));}
````

Produces same AST
