# Tenko parser test case

- Path: tests/testcases/yield/yield_star/yield_multiplied_with_yield_in_sloppy_mode.md

> :: yield : yield star
>
> ::> yield multiplied with yield in sloppy mode

## Input

`````js
yield * yield
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:13},source:''},
  body: [
    {
      type: 'ExpressionStatement',
      loc:{start:{line:1,column:0},end:{line:1,column:13},source:''},
      expression: {
        type: 'BinaryExpression',
        loc:{start:{line:1,column:0},end:{line:1,column:13},source:''},
        left: {
          type: 'Identifier',
          loc:{start:{line:1,column:0},end:{line:1,column:5},source:''},
          name: 'yield'
        },
        operator: '*',
        right: {
          type: 'Identifier',
          loc:{start:{line:1,column:8},end:{line:1,column:13},source:''},
          name: 'yield'
        }
      }
    }
  ]
}

tokens (5x):
       ID_yield PUNC_STAR ID_yield ASI
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

`````
throws: Parser error!
  Cannot use `yield` outside of generator functions when in strict mode

yield * yield
      ^------- error
`````


### Module goal

Parsed with the module goal.

_Output same as strict mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
(((yield) * (yield)));
````

Produces same AST
