# Tenko parser test case

- Path: tests/testcases/yield/yielding_an_assignment_is_fine.md

> :: yield
>
> ::> yielding an assignment is fine
>
> AssignmentExpression can go into YieldExpression

## Input

`````js
function* g(x) { yield x = 3; }
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:31},source:''},
  body: [
    {
      type: 'FunctionDeclaration',
      loc:{start:{line:1,column:0},end:{line:1,column:31},source:''},
      generator: true,
      async: false,
      id: {
        type: 'Identifier',
        loc:{start:{line:1,column:10},end:{line:1,column:11},source:''},
        name: 'g'
      },
      params: [
        {
          type: 'Identifier',
          loc:{start:{line:1,column:12},end:{line:1,column:13},source:''},
          name: 'x'
        }
      ],
      body: {
        type: 'BlockStatement',
        loc:{start:{line:1,column:15},end:{line:1,column:31},source:''},
        body: [
          {
            type: 'ExpressionStatement',
            loc:{start:{line:1,column:17},end:{line:1,column:29},source:''},
            expression: {
              type: 'YieldExpression',
              loc:{start:{line:1,column:17},end:{line:1,column:28},source:''},
              delegate: false,
              argument: {
                type: 'AssignmentExpression',
                loc:{start:{line:1,column:23},end:{line:1,column:28},source:''},
                left: {
                  type: 'Identifier',
                  loc:{start:{line:1,column:23},end:{line:1,column:24},source:''},
                  name: 'x'
                },
                operator: '=',
                right: {
                  type: 'Literal',
                  loc:{start:{line:1,column:27},end:{line:1,column:28},source:''},
                  value: 3,
                  raw: '3'
                }
              }
            }
          }
        ]
      }
    }
  ]
}

tokens (14x):
       ID_function PUNC_STAR IDENT PUNC_PAREN_OPEN IDENT
       PUNC_PAREN_CLOSE PUNC_CURLY_OPEN ID_yield IDENT PUNC_EQ
       NUMBER_DEC PUNC_SEMI PUNC_CURLY_CLOSE
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
function* g(x) {(yield ((x = 3)));}
````

Produces same AST
