# Tenko parser test case

- Path: tests/testcases/zeprinter/grouped_fake_directive.md

> :: zeprinter
>
> ::> grouped fake directive
>
> A directive that is grouped should not become ungrouped by the printer

## Input

`````js
("use strict");
yield = x;
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:2,column:10},source:''},
  body: [
    {
      type: 'ExpressionStatement',
      loc:{start:{line:1,column:0},end:{line:1,column:15},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:1,column:1},end:{line:1,column:13},source:''},
        value: 'use strict',
        raw: '"use strict"'
      }
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:2,column:0},end:{line:2,column:10},source:''},
      expression: {
        type: 'AssignmentExpression',
        loc:{start:{line:2,column:0},end:{line:2,column:9},source:''},
        left: {
          type: 'Identifier',
          loc:{start:{line:2,column:0},end:{line:2,column:5},source:''},
          name: 'yield'
        },
        operator: '=',
        right: {
          type: 'Identifier',
          loc:{start:{line:2,column:8},end:{line:2,column:9},source:''},
          name: 'x'
        }
      }
    }
  ]
}

tokens (9x):
       PUNC_PAREN_OPEN STRING_DOUBLE PUNC_PAREN_CLOSE PUNC_SEMI
       ID_yield PUNC_EQ IDENT PUNC_SEMI
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

`````
throws: Parser error!
  Cannot use `yield` outside of generator functions when in strict mode

("use strict");
yield = x;
      ^------- error
`````


### Module goal

Parsed with the module goal.

_Output same as strict mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
("use strict");
((yield = x));
````

Produces same AST
