# Tenko parser test case

- Path: tests/testcases/zeprinter/grouped_yield_dynamic_prop.md

> :: zeprinter
>
> ::> grouped yield dynamic prop
>
> Printer was changing AST by removing the parenthesis around `yield`.
>
> Right now it's a `yield` expression, and then assignment to a property access on that result value.
>
> So; `x=yield; x[this]=y`. Without the parenthesis it would be the `yield` with as argument a destructuring assignment that tries to write to `this` (which can't be written to).

## PASS

## Input

`````js
function * f(){
  (yield)[this] = y
}
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:3,column:1},source:''},
  body: [
    {
      type: 'FunctionDeclaration',
      loc:{start:{line:1,column:0},end:{line:3,column:1},source:''},
      generator: true,
      async: false,
      id: {
        type: 'Identifier',
        loc:{start:{line:1,column:11},end:{line:1,column:12},source:''},
        name: 'f'
      },
      params: [],
      body: {
        type: 'BlockStatement',
        loc:{start:{line:1,column:14},end:{line:3,column:1},source:''},
        body: [
          {
            type: 'ExpressionStatement',
            loc:{start:{line:2,column:2},end:{line:2,column:19},source:''},
            expression: {
              type: 'AssignmentExpression',
              loc:{start:{line:2,column:2},end:{line:2,column:19},source:''},
              left: {
                type: 'MemberExpression',
                loc:{start:{line:2,column:2},end:{line:2,column:15},source:''},
                object: {
                  type: 'YieldExpression',
                  loc:{start:{line:2,column:3},end:{line:2,column:8},source:''},
                  delegate: false,
                  argument: null
                },
                property: {
                  type: 'ThisExpression',
                  loc:{start:{line:2,column:10},end:{line:2,column:14},source:''}
                },
                computed: true
              },
              operator: '=',
              right: {
                type: 'Identifier',
                loc:{start:{line:2,column:18},end:{line:2,column:19},source:''},
                name: 'y'
              }
            }
          }
        ]
      }
    }
  ]
}

tokens (17x):
       ID_function PUNC_STAR IDENT PUNC_PAREN_OPEN PUNC_PAREN_CLOSE
       PUNC_CURLY_OPEN PUNC_PAREN_OPEN ID_yield PUNC_PAREN_CLOSE
       PUNC_BRACKET_OPEN ID_this PUNC_BRACKET_CLOSE PUNC_EQ IDENT ASI
       PUNC_CURLY_CLOSE
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
function* f() {(((yield)[this] = y));}
````

Produces same AST
