# Tenko parser test case

- Path: tests/testcases/zeprinter/let_paren_lhs_for.md

> :: zeprinter
>
> ::> let paren lhs for
>
> Parenthesized `let` as lhs of a `for` header (threw off zeprinter)
>
> `for((let) of y);` would print `for(let of y);` which is illegal

## Input

`````js
for((let) of y);
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:1,column:16},source:''},
  body: [
    {
      type: 'ForOfStatement',
      loc:{start:{line:1,column:0},end:{line:1,column:16},source:''},
      left: {
        type: 'Identifier',
        loc:{start:{line:1,column:5},end:{line:1,column:8},source:''},
        name: 'let'
      },
      right: {
        type: 'Identifier',
        loc:{start:{line:1,column:13},end:{line:1,column:14},source:''},
        name: 'y'
      },
      await: false,
      body: {
        type: 'EmptyStatement',
        loc:{start:{line:1,column:15},end:{line:1,column:16},source:''}
      }
    }
  ]
}

tokens (10x):
       ID_for PUNC_PAREN_OPEN PUNC_PAREN_OPEN ID_let PUNC_PAREN_CLOSE
       ID_of IDENT PUNC_PAREN_CLOSE PUNC_SEMI
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

`````
throws: Parser error!
  Can not use `let` as variable name in strict mode

for((let) of y);
        ^------- error
`````


### Module goal

Parsed with the module goal.

_Output same as strict mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
for ((let) of y) ;
````

Produces same AST
