# Tenko parser test case

- Path: tests/testcases/lexer_cases/regexesu/brute_force_surrogate_ranges/769.pass.md

> :: lexer cases : regexesu : brute force surrogate ranges
>
> ::> 769.pass
>
> Imported lexer test
>
> all passing variations of charclass ranges containing surrogate characters

## PASS

## Input

`````js
/B-B[x-x]/u
;
/B-BB[x-xx]/u
;
/B-BL[x-x\uD83D]/u
;
/B-BT[x-x\uDCA9]/u
;
/B-BB[x-xx]/u
;
/B-BBB[x-xxx]/u
;
/B-BBL[x-xx\uD83D]/u
;
/B-BBT[x-xx\uDCA9]/u
;
/B-BL[x-x\uD83D]/u
;
/B-BLB[x-x\uD83Dx]/u
;
/B-BLL[x-x\uD83D\uD83D]/u
;
/B-BLT[x-x\uD83D\uDCA9]/u
;
/B-BT[x-x\uDCA9]/u
;
/B-BTB[x-x\uDCA9x]/u
;
/B-BTL[x-x\uDCA9\uD83D]/u
;
/B-BTT[x-x\uDCA9\uDCA9]/u
;
/B-L[x-\uD83D]/u
;
/B-LB[x-\uD83Dx]/u
;
/B-LL[x-\uD83D\uD83D]/u
;
/B-LT[x-\uD83D\uDCA9]/u
;
/B-LB[x-\uD83Dx]/u
;
/B-LBB[x-\uD83Dxx]/u
;
/B-LBL[x-\uD83Dx\uD83D]/u
;
/B-LBT[x-\uD83Dx\uDCA9]/u
;
/B-LL[x-\uD83D\uD83D]/u
;
/B-LLB[x-\uD83D\uD83Dx]/u
;
/B-LLL[x-\uD83D\uD83D\uD83D]/u
;
/B-LLT[x-\uD83D\uD83D\uDCA9]/u
;
/B-LT[x-\uD83D\uDCA9]/u
;
/B-LTB[x-\uD83D\uDCA9x]/u
;
/B-LTL[x-\uD83D\uDCA9\uD83D]/u
;
/B-LTT[x-\uD83D\uDCA9\uDCA9]/u
;
/B-T[x-\uDCA9]/u
;
/B-TB[x-\uDCA9x]/u
;
/B-TL[x-\uDCA9\uD83D]/u
;
/B-TT[x-\uDCA9\uDCA9]/u
;
/B-TB[x-\uDCA9x]/u
;
/B-TBB[x-\uDCA9xx]/u
;
/B-TBL[x-\uDCA9x\uD83D]/u
;
/B-TBT[x-\uDCA9x\uDCA9]/u
;
/B-TL[x-\uDCA9\uD83D]/u
;
/B-TLB[x-\uDCA9\uD83Dx]/u
;
/B-TLL[x-\uDCA9\uD83D\uD83D]/u
;
/B-TLT[x-\uDCA9\uD83D\uDCA9]/u
;
/B-TT[x-\uDCA9\uDCA9]/u
;
/B-TTB[x-\uDCA9\uDCA9x]/u
;
/B-TTL[x-\uDCA9\uDCA9\uD83D]/u
;
/B-TTT[x-\uDCA9\uDCA9\uDCA9]/u
;
/L-L[\uD83D-\uD83D]/u
;
/L-LB[\uD83D-\uD83Dx]/u
;
/L-LL[\uD83D-\uD83D\uD83D]/u
;
/L-LT[\uD83D-\uD83D\uDCA9]/u
;
/L-LB[\uD83D-\uD83Dx]/u
;
/L-LBB[\uD83D-\uD83Dxx]/u
;
/L-LBL[\uD83D-\uD83Dx\uD83D]/u
;
/L-LBT[\uD83D-\uD83Dx\uDCA9]/u
;
/L-LL[\uD83D-\uD83D\uD83D]/u
;
/L-LLB[\uD83D-\uD83D\uD83Dx]/u
;
/L-LLL[\uD83D-\uD83D\uD83D\uD83D]/u
;
/L-LLT[\uD83D-\uD83D\uD83D\uDCA9]/u
;
/L-LT[\uD83D-\uD83D\uDCA9]/u
;
/L-LTB[\uD83D-\uD83D\uDCA9x]/u
;
/L-LTL[\uD83D-\uD83D\uDCA9\uD83D]/u
;
/L-LTT[\uD83D-\uD83D\uDCA9\uDCA9]/u
;
/L-T[\uD83D-\uDCA9]/u
;
/L-TB[\uD83D-\uDCA9x]/u
;
/L-TL[\uD83D-\uDCA9\uD83D]/u
;
/L-TT[\uD83D-\uDCA9\uDCA9]/u
;
/L-TB[\uD83D-\uDCA9x]/u
;
/L-TBB[\uD83D-\uDCA9xx]/u
;
/L-TBL[\uD83D-\uDCA9x\uD83D]/u
;
/L-TBT[\uD83D-\uDCA9x\uDCA9]/u
;
/L-TL[\uD83D-\uDCA9\uD83D]/u
;
/L-TLB[\uD83D-\uDCA9\uD83Dx]/u
;
/L-TLL[\uD83D-\uDCA9\uD83D\uD83D]/u
;
/L-TLT[\uD83D-\uDCA9\uD83D\uDCA9]/u
;
/L-TT[\uD83D-\uDCA9\uDCA9]/u
;
/L-TTB[\uD83D-\uDCA9\uDCA9x]/u
;
/L-TTL[\uD83D-\uDCA9\uDCA9\uD83D]/u
;
/L-TTT[\uD83D-\uDCA9\uDCA9\uDCA9]/u
;
/T-LT[\uDCA9-\uD83D\uDCA9]/u
;
/T-LT[\uDCA9-\uD83D\uDCA9]/u
;
/T-LTB[\uDCA9-\uD83D\uDCA9x]/u
;
/T-LTL[\uDCA9-\uD83D\uDCA9\uD83D]/u
;
/T-LTT[\uDCA9-\uD83D\uDCA9\uDCA9]/u
;
/T-T[\uDCA9-\uDCA9]/u
;
/T-TB[\uDCA9-\uDCA9x]/u
;
/T-TL[\uDCA9-\uDCA9\uD83D]/u
;
/T-TT[\uDCA9-\uDCA9\uDCA9]/u
;
/T-TB[\uDCA9-\uDCA9x]/u
;
/T-TBB[\uDCA9-\uDCA9xx]/u
;
/T-TBL[\uDCA9-\uDCA9x\uD83D]/u
;
/T-TBT[\uDCA9-\uDCA9x\uDCA9]/u
;
/T-TL[\uDCA9-\uDCA9\uD83D]/u
;
/T-TLB[\uDCA9-\uDCA9\uD83Dx]/u
;
/T-TLL[\uDCA9-\uDCA9\uD83D\uD83D]/u
;
/T-TLT[\uDCA9-\uDCA9\uD83D\uDCA9]/u
;
/T-TT[\uDCA9-\uDCA9\uDCA9]/u
;
/T-TTB[\uDCA9-\uDCA9\uDCA9x]/u
;
/T-TTL[\uDCA9-\uDCA9\uDCA9\uD83D]/u
;
/T-TTT[\uDCA9-\uDCA9\uDCA9\uDCA9]/u
;
/BB-B[xx-x]/u
;
/BB-BB[xx-xx]/u
;
/BB-BL[xx-x\uD83D]/u
;
/BB-BT[xx-x\uDCA9]/u
;
/BB-BB[xx-xx]/u
;
/BB-BBB[xx-xxx]/u
;
/BB-BBL[xx-xx\uD83D]/u
;
/BB-BBT[xx-xx\uDCA9]/u
;
/BB-BL[xx-x\uD83D]/u
;
/BB-BLB[xx-x\uD83Dx]/u
;
/BB-BLL[xx-x\uD83D\uD83D]/u
;
/BB-BLT[xx-x\uD83D\uDCA9]/u
;
/BB-BT[xx-x\uDCA9]/u
;
/BB-BTB[xx-x\uDCA9x]/u
;
/BB-BTL[xx-x\uDCA9\uD83D]/u
;
/BB-BTT[xx-x\uDCA9\uDCA9]/u
;
/BB-L[xx-\uD83D]/u
;
/BB-LB[xx-\uD83Dx]/u
;
/BB-LL[xx-\uD83D\uD83D]/u
;
/BB-LT[xx-\uD83D\uDCA9]/u
;
/BB-LB[xx-\uD83Dx]/u
;
/BB-LBB[xx-\uD83Dxx]/u
;
/BB-LBL[xx-\uD83Dx\uD83D]/u
;
/BB-LBT[xx-\uD83Dx\uDCA9]/u
;
/BB-LL[xx-\uD83D\uD83D]/u
;
/BB-LLB[xx-\uD83D\uD83Dx]/u
;
/BB-LLL[xx-\uD83D\uD83D\uD83D]/u
;
/BB-LLT[xx-\uD83D\uD83D\uDCA9]/u
;
/BB-LT[xx-\uD83D\uDCA9]/u
;
/BB-LTB[xx-\uD83D\uDCA9x]/u
;
/BB-LTL[xx-\uD83D\uDCA9\uD83D]/u
;
/BB-LTT[xx-\uD83D\uDCA9\uDCA9]/u
;
/BB-T[xx-\uDCA9]/u
;
/BB-TB[xx-\uDCA9x]/u
;
/BB-TL[xx-\uDCA9\uD83D]/u
;
/BB-TT[xx-\uDCA9\uDCA9]/u
;
/BB-TB[xx-\uDCA9x]/u
;
/BB-TBB[xx-\uDCA9xx]/u
;
/BB-TBL[xx-\uDCA9x\uD83D]/u
;
/BB-TBT[xx-\uDCA9x\uDCA9]/u
;
/BB-TL[xx-\uDCA9\uD83D]/u
;
/BB-TLB[xx-\uDCA9\uD83Dx]/u
;
/BB-TLL[xx-\uDCA9\uD83D\uD83D]/u
;
/BB-TLT[xx-\uDCA9\uD83D\uDCA9]/u
;
/BB-TT[xx-\uDCA9\uDCA9]/u
;
/BB-TTB[xx-\uDCA9\uDCA9x]/u
;
/BB-TTL[xx-\uDCA9\uDCA9\uD83D]/u
;
/BB-TTT[xx-\uDCA9\uDCA9\uDCA9]/u
;
/BL-L[x\uD83D-\uD83D]/u
;
/BL-LB[x\uD83D-\uD83Dx]/u
;
/BL-LL[x\uD83D-\uD83D\uD83D]/u
;
/BL-LT[x\uD83D-\uD83D\uDCA9]/u
;
/BL-LB[x\uD83D-\uD83Dx]/u
;
/BL-LBB[x\uD83D-\uD83Dxx]/u
;
/BL-LBL[x\uD83D-\uD83Dx\uD83D]/u
;
/BL-LBT[x\uD83D-\uD83Dx\uDCA9]/u
;
/BL-LL[x\uD83D-\uD83D\uD83D]/u
;
/BL-LLB[x\uD83D-\uD83D\uD83Dx]/u
;
/BL-LLL[x\uD83D-\uD83D\uD83D\uD83D]/u
;
/BL-LLT[x\uD83D-\uD83D\uD83D\uDCA9]/u
;
/BL-LT[x\uD83D-\uD83D\uDCA9]/u
;
/BL-LTB[x\uD83D-\uD83D\uDCA9x]/u
;
/BL-LTL[x\uD83D-\uD83D\uDCA9\uD83D]/u
;
/BL-LTT[x\uD83D-\uD83D\uDCA9\uDCA9]/u
;
/BL-T[x\uD83D-\uDCA9]/u
;
/BL-TB[x\uD83D-\uDCA9x]/u
;
/BL-TL[x\uD83D-\uDCA9\uD83D]/u
;
/BL-TT[x\uD83D-\uDCA9\uDCA9]/u
;
/BL-TB[x\uD83D-\uDCA9x]/u
;
/BL-TBB[x\uD83D-\uDCA9xx]/u
;
/BL-TBL[x\uD83D-\uDCA9x\uD83D]/u
;
/BL-TBT[x\uD83D-\uDCA9x\uDCA9]/u
;
/BL-TL[x\uD83D-\uDCA9\uD83D]/u
;
/BL-TLB[x\uD83D-\uDCA9\uD83Dx]/u
;
/BL-TLL[x\uD83D-\uDCA9\uD83D\uD83D]/u
;
/BL-TLT[x\uD83D-\uDCA9\uD83D\uDCA9]/u
;
/BL-TT[x\uD83D-\uDCA9\uDCA9]/u
;
/BL-TTB[x\uD83D-\uDCA9\uDCA9x]/u
;
/BL-TTL[x\uD83D-\uDCA9\uDCA9\uD83D]/u
;
/BL-TTT[x\uD83D-\uDCA9\uDCA9\uDCA9]/u
;
/BT-LT[x\uDCA9-\uD83D\uDCA9]/u
;
/BT-LT[x\uDCA9-\uD83D\uDCA9]/u
;
/BT-LTB[x\uDCA9-\uD83D\uDCA9x]/u
;
/BT-LTL[x\uDCA9-\uD83D\uDCA9\uD83D]/u
;
/BT-LTT[x\uDCA9-\uD83D\uDCA9\uDCA9]/u
;
/BT-T[x\uDCA9-\uDCA9]/u
;
/BT-TB[x\uDCA9-\uDCA9x]/u
;
/BT-TL[x\uDCA9-\uDCA9\uD83D]/u
;
/BT-TT[x\uDCA9-\uDCA9\uDCA9]/u
;
/BT-TB[x\uDCA9-\uDCA9x]/u
;
/BT-TBB[x\uDCA9-\uDCA9xx]/u
;
/BT-TBL[x\uDCA9-\uDCA9x\uD83D]/u
;
/BT-TBT[x\uDCA9-\uDCA9x\uDCA9]/u
;
/BT-TL[x\uDCA9-\uDCA9\uD83D]/u
;
/BT-TLB[x\uDCA9-\uDCA9\uD83Dx]/u
;
/BT-TLL[x\uDCA9-\uDCA9\uD83D\uD83D]/u
;
/BT-TLT[x\uDCA9-\uDCA9\uD83D\uDCA9]/u
;
/BT-TT[x\uDCA9-\uDCA9\uDCA9]/u
;
/BT-TTB[x\uDCA9-\uDCA9\uDCA9x]/u
;
/BT-TTL[x\uDCA9-\uDCA9\uDCA9\uD83D]/u
;
/BT-TTT[x\uDCA9-\uDCA9\uDCA9\uDCA9]/u
;
/LB-B[\uD83Dx-x]/u
;
/LB-BB[\uD83Dx-xx]/u
;
/LB-BL[\uD83Dx-x\uD83D]/u
;
/LB-BT[\uD83Dx-x\uDCA9]/u
;
/LB-BB[\uD83Dx-xx]/u
;
/LB-BBB[\uD83Dx-xxx]/u
;
/LB-BBL[\uD83Dx-xx\uD83D]/u
;
/LB-BBT[\uD83Dx-xx\uDCA9]/u
;
/LB-BL[\uD83Dx-x\uD83D]/u
;
/LB-BLB[\uD83Dx-x\uD83Dx]/u
;
/LB-BLL[\uD83Dx-x\uD83D\uD83D]/u
;
/LB-BLT[\uD83Dx-x\uD83D\uDCA9]/u
;
/LB-BT[\uD83Dx-x\uDCA9]/u
;
/LB-BTB[\uD83Dx-x\uDCA9x]/u
;
/LB-BTL[\uD83Dx-x\uDCA9\uD83D]/u
;
/LB-BTT[\uD83Dx-x\uDCA9\uDCA9]/u
;
/LB-L[\uD83Dx-\uD83D]/u
;
/LB-LB[\uD83Dx-\uD83Dx]/u
;
/LB-LL[\uD83Dx-\uD83D\uD83D]/u
;
/LB-LT[\uD83Dx-\uD83D\uDCA9]/u
;
/LB-LB[\uD83Dx-\uD83Dx]/u
;
/LB-LBB[\uD83Dx-\uD83Dxx]/u
;
/LB-LBL[\uD83Dx-\uD83Dx\uD83D]/u
;
/LB-LBT[\uD83Dx-\uD83Dx\uDCA9]/u
;
/LB-LL[\uD83Dx-\uD83D\uD83D]/u
;
/LB-LLB[\uD83Dx-\uD83D\uD83Dx]/u
;
/LB-LLL[\uD83Dx-\uD83D\uD83D\uD83D]/u
;
/LB-LLT[\uD83Dx-\uD83D\uD83D\uDCA9]/u
;
/LB-LT[\uD83Dx-\uD83D\uDCA9]/u
;
/LB-LTB[\uD83Dx-\uD83D\uDCA9x]/u
;
/LB-LTL[\uD83Dx-\uD83D\uDCA9\uD83D]/u
;
/LB-LTT[\uD83Dx-\uD83D\uDCA9\uDCA9]/u
;
/LB-T[\uD83Dx-\uDCA9]/u
;
/LB-TB[\uD83Dx-\uDCA9x]/u
;
/LB-TL[\uD83Dx-\uDCA9\uD83D]/u
;
/LB-TT[\uD83Dx-\uDCA9\uDCA9]/u
;
/LB-TB[\uD83Dx-\uDCA9x]/u
;
/LB-TBB[\uD83Dx-\uDCA9xx]/u
;
/LB-TBL[\uD83Dx-\uDCA9x\uD83D]/u
;
/LB-TBT[\uD83Dx-\uDCA9x\uDCA9]/u
;
/LB-TL[\uD83Dx-\uDCA9\uD83D]/u
;
/LB-TLB[\uD83Dx-\uDCA9\uD83Dx]/u
;
/LB-TLL[\uD83Dx-\uDCA9\uD83D\uD83D]/u
;
/LB-TLT[\uD83Dx-\uDCA9\uD83D\uDCA9]/u
;
/LB-TT[\uD83Dx-\uDCA9\uDCA9]/u
;
/LB-TTB[\uD83Dx-\uDCA9\uDCA9x]/u
;
/LB-TTL[\uD83Dx-\uDCA9\uDCA9\uD83D]/u
;
/LB-TTT[\uD83Dx-\uDCA9\uDCA9\uDCA9]/u
;
/LL-L[\uD83D\uD83D-\uD83D]/u
;
/LL-LB[\uD83D\uD83D-\uD83Dx]/u
;
/LL-LL[\uD83D\uD83D-\uD83D\uD83D]/u
;
/LL-LT[\uD83D\uD83D-\uD83D\uDCA9]/u
;
/LL-LB[\uD83D\uD83D-\uD83Dx]/u
;
/LL-LBB[\uD83D\uD83D-\uD83Dxx]/u
;
/LL-LBL[\uD83D\uD83D-\uD83Dx\uD83D]/u
;
/LL-LBT[\uD83D\uD83D-\uD83Dx\uDCA9]/u
;
/LL-LL[\uD83D\uD83D-\uD83D\uD83D]/u
;
/LL-LLB[\uD83D\uD83D-\uD83D\uD83Dx]/u
;
/LL-LLL[\uD83D\uD83D-\uD83D\uD83D\uD83D]/u
;
/LL-LLT[\uD83D\uD83D-\uD83D\uD83D\uDCA9]/u
;
/LL-LT[\uD83D\uD83D-\uD83D\uDCA9]/u
;
/LL-LTB[\uD83D\uD83D-\uD83D\uDCA9x]/u
;
/LL-LTL[\uD83D\uD83D-\uD83D\uDCA9\uD83D]/u
;
/LL-LTT[\uD83D\uD83D-\uD83D\uDCA9\uDCA9]/u
;
/LL-T[\uD83D\uD83D-\uDCA9]/u
;
/LL-TB[\uD83D\uD83D-\uDCA9x]/u
;
/LL-TL[\uD83D\uD83D-\uDCA9\uD83D]/u
;
/LL-TT[\uD83D\uD83D-\uDCA9\uDCA9]/u
;
/LL-TB[\uD83D\uD83D-\uDCA9x]/u
;
/LL-TBB[\uD83D\uD83D-\uDCA9xx]/u
;
/LL-TBL[\uD83D\uD83D-\uDCA9x\uD83D]/u
;
/LL-TBT[\uD83D\uD83D-\uDCA9x\uDCA9]/u
;
/LL-TL[\uD83D\uD83D-\uDCA9\uD83D]/u
;
/LL-TLB[\uD83D\uD83D-\uDCA9\uD83Dx]/u
;
/LL-TLL[\uD83D\uD83D-\uDCA9\uD83D\uD83D]/u
;
/LL-TLT[\uD83D\uD83D-\uDCA9\uD83D\uDCA9]/u
;
/LL-TT[\uD83D\uD83D-\uDCA9\uDCA9]/u
;
/LL-TTB[\uD83D\uD83D-\uDCA9\uDCA9x]/u
;
/LL-TTL[\uD83D\uD83D-\uDCA9\uDCA9\uD83D]/u
;
/LL-TTT[\uD83D\uD83D-\uDCA9\uDCA9\uDCA9]/u
;
/LT-LT[\uD83D\uDCA9-\uD83D\uDCA9]/u
;
/LT-LT[\uD83D\uDCA9-\uD83D\uDCA9]/u
;
/LT-LTB[\uD83D\uDCA9-\uD83D\uDCA9x]/u
;
/LT-LTL[\uD83D\uDCA9-\uD83D\uDCA9\uD83D]/u
;
/LT-LTT[\uD83D\uDCA9-\uD83D\uDCA9\uDCA9]/u
;
/TB-B[\uDCA9x-x]/u
;
/TB-BB[\uDCA9x-xx]/u
;
/TB-BL[\uDCA9x-x\uD83D]/u
;
/TB-BT[\uDCA9x-x\uDCA9]/u
;
/TB-BB[\uDCA9x-xx]/u
;
/TB-BBB[\uDCA9x-xxx]/u
;
/TB-BBL[\uDCA9x-xx\uD83D]/u
;
/TB-BBT[\uDCA9x-xx\uDCA9]/u
;
/TB-BL[\uDCA9x-x\uD83D]/u
;
/TB-BLB[\uDCA9x-x\uD83Dx]/u
;
/TB-BLL[\uDCA9x-x\uD83D\uD83D]/u
;
/TB-BLT[\uDCA9x-x\uD83D\uDCA9]/u
;
/TB-BT[\uDCA9x-x\uDCA9]/u
;
/TB-BTB[\uDCA9x-x\uDCA9x]/u
;
/TB-BTL[\uDCA9x-x\uDCA9\uD83D]/u
;
/TB-BTT[\uDCA9x-x\uDCA9\uDCA9]/u
;
/TB-L[\uDCA9x-\uD83D]/u
;
/TB-LB[\uDCA9x-\uD83Dx]/u
;
/TB-LL[\uDCA9x-\uD83D\uD83D]/u
;
/TB-LT[\uDCA9x-\uD83D\uDCA9]/u
;
/TB-LB[\uDCA9x-\uD83Dx]/u
;
/TB-LBB[\uDCA9x-\uD83Dxx]/u
;
/TB-LBL[\uDCA9x-\uD83Dx\uD83D]/u
;
/TB-LBT[\uDCA9x-\uD83Dx\uDCA9]/u
;
/TB-LL[\uDCA9x-\uD83D\uD83D]/u
;
/TB-LLB[\uDCA9x-\uD83D\uD83Dx]/u
;
/TB-LLL[\uDCA9x-\uD83D\uD83D\uD83D]/u
;
/TB-LLT[\uDCA9x-\uD83D\uD83D\uDCA9]/u
;
/TB-LT[\uDCA9x-\uD83D\uDCA9]/u
;
/TB-LTB[\uDCA9x-\uD83D\uDCA9x]/u
;
/TB-LTL[\uDCA9x-\uD83D\uDCA9\uD83D]/u
;
/TB-LTT[\uDCA9x-\uD83D\uDCA9\uDCA9]/u
;
/TB-T[\uDCA9x-\uDCA9]/u
;
/TB-TB[\uDCA9x-\uDCA9x]/u
;
/TB-TL[\uDCA9x-\uDCA9\uD83D]/u
;
/TB-TT[\uDCA9x-\uDCA9\uDCA9]/u
;
/TB-TB[\uDCA9x-\uDCA9x]/u
;
/TB-TBB[\uDCA9x-\uDCA9xx]/u
;
/TB-TBL[\uDCA9x-\uDCA9x\uD83D]/u
;
/TB-TBT[\uDCA9x-\uDCA9x\uDCA9]/u
;
/TB-TL[\uDCA9x-\uDCA9\uD83D]/u
;
/TB-TLB[\uDCA9x-\uDCA9\uD83Dx]/u
;
/TB-TLL[\uDCA9x-\uDCA9\uD83D\uD83D]/u
;
/TB-TLT[\uDCA9x-\uDCA9\uD83D\uDCA9]/u
;
/TB-TT[\uDCA9x-\uDCA9\uDCA9]/u
;
/TB-TTB[\uDCA9x-\uDCA9\uDCA9x]/u
;
/TB-TTL[\uDCA9x-\uDCA9\uDCA9\uD83D]/u
;
/TB-TTT[\uDCA9x-\uDCA9\uDCA9\uDCA9]/u
;
/TL-L[\uDCA9\uD83D-\uD83D]/u
;
/TL-LB[\uDCA9\uD83D-\uD83Dx]/u
;
/TL-LL[\uDCA9\uD83D-\uD83D\uD83D]/u
;
/TL-LT[\uDCA9\uD83D-\uD83D\uDCA9]/u
;
/TL-LB[\uDCA9\uD83D-\uD83Dx]/u
;
/TL-LBB[\uDCA9\uD83D-\uD83Dxx]/u
;
/TL-LBL[\uDCA9\uD83D-\uD83Dx\uD83D]/u
;
/TL-LBT[\uDCA9\uD83D-\uD83Dx\uDCA9]/u
;
/TL-LL[\uDCA9\uD83D-\uD83D\uD83D]/u
;
/TL-LLB[\uDCA9\uD83D-\uD83D\uD83Dx]/u
;
/TL-LLL[\uDCA9\uD83D-\uD83D\uD83D\uD83D]/u
;
/TL-LLT[\uDCA9\uD83D-\uD83D\uD83D\uDCA9]/u
;
/TL-LT[\uDCA9\uD83D-\uD83D\uDCA9]/u
;
/TL-LTB[\uDCA9\uD83D-\uD83D\uDCA9x]/u
;
/TL-LTL[\uDCA9\uD83D-\uD83D\uDCA9\uD83D]/u
;
/TL-LTT[\uDCA9\uD83D-\uD83D\uDCA9\uDCA9]/u
;
/TL-T[\uDCA9\uD83D-\uDCA9]/u
;
/TL-TB[\uDCA9\uD83D-\uDCA9x]/u
;
/TL-TL[\uDCA9\uD83D-\uDCA9\uD83D]/u
;
/TL-TT[\uDCA9\uD83D-\uDCA9\uDCA9]/u
;
/TL-TB[\uDCA9\uD83D-\uDCA9x]/u
;
/TL-TBB[\uDCA9\uD83D-\uDCA9xx]/u
;
/TL-TBL[\uDCA9\uD83D-\uDCA9x\uD83D]/u
;
/TL-TBT[\uDCA9\uD83D-\uDCA9x\uDCA9]/u
;
/TL-TL[\uDCA9\uD83D-\uDCA9\uD83D]/u
;
/TL-TLB[\uDCA9\uD83D-\uDCA9\uD83Dx]/u
;
/TL-TLL[\uDCA9\uD83D-\uDCA9\uD83D\uD83D]/u
;
/TL-TLT[\uDCA9\uD83D-\uDCA9\uD83D\uDCA9]/u
;
/TL-TT[\uDCA9\uD83D-\uDCA9\uDCA9]/u
;
/TL-TTB[\uDCA9\uD83D-\uDCA9\uDCA9x]/u
;
/TL-TTL[\uDCA9\uD83D-\uDCA9\uDCA9\uD83D]/u
;
/TL-TTT[\uDCA9\uD83D-\uDCA9\uDCA9\uDCA9]/u
;
/TT-LT[\uDCA9\uDCA9-\uD83D\uDCA9]/u
;
/TT-LT[\uDCA9\uDCA9-\uD83D\uDCA9]/u
;
/TT-LTB[\uDCA9\uDCA9-\uD83D\uDCA9x]/u
;
/TT-LTL[\uDCA9\uDCA9-\uD83D\uDCA9\uD83D]/u
;
/TT-LTT[\uDCA9\uDCA9-\uD83D\uDCA9\uDCA9]/u
;
/TT-T[\uDCA9\uDCA9-\uDCA9]/u
;
/TT-TB[\uDCA9\uDCA9-\uDCA9x]/u
;
/TT-TL[\uDCA9\uDCA9-\uDCA9\uD83D]/u
;
/TT-TT[\uDCA9\uDCA9-\uDCA9\uDCA9]/u
;
/TT-TB[\uDCA9\uDCA9-\uDCA9x]/u
;
/TT-TBB[\uDCA9\uDCA9-\uDCA9xx]/u
;
/TT-TBL[\uDCA9\uDCA9-\uDCA9x\uD83D]/u
;
/TT-TBT[\uDCA9\uDCA9-\uDCA9x\uDCA9]/u
;
/TT-TL[\uDCA9\uDCA9-\uDCA9\uD83D]/u
;
/TT-TLB[\uDCA9\uDCA9-\uDCA9\uD83Dx]/u
;
/TT-TLL[\uDCA9\uDCA9-\uDCA9\uD83D\uD83D]/u
;
/TT-TLT[\uDCA9\uDCA9-\uDCA9\uD83D\uDCA9]/u
;
/TT-TT[\uDCA9\uDCA9-\uDCA9\uDCA9]/u
;
/TT-TTB[\uDCA9\uDCA9-\uDCA9\uDCA9x]/u
;
/TT-TTL[\uDCA9\uDCA9-\uDCA9\uDCA9\uD83D]/u
;
/TT-TTT[\uDCA9\uDCA9-\uDCA9\uDCA9\uDCA9]/u
;
/BB-B[xx-x]/u
;
/BB-BB[xx-xx]/u
;
/BB-BL[xx-x\uD83D]/u
;
/BB-BT[xx-x\uDCA9]/u
;
/BB-BB[xx-xx]/u
;
/BB-BBB[xx-xxx]/u
;
/BB-BBL[xx-xx\uD83D]/u
;
/BB-BBT[xx-xx\uDCA9]/u
;
/BB-BL[xx-x\uD83D]/u
;
/BB-BLB[xx-x\uD83Dx]/u
;
/BB-BLL[xx-x\uD83D\uD83D]/u
;
/BB-BLT[xx-x\uD83D\uDCA9]/u
;
/BB-BT[xx-x\uDCA9]/u
;
/BB-BTB[xx-x\uDCA9x]/u
;
/BB-BTL[xx-x\uDCA9\uD83D]/u
;
/BB-BTT[xx-x\uDCA9\uDCA9]/u
;
/BB-L[xx-\uD83D]/u
;
/BB-LB[xx-\uD83Dx]/u
;
/BB-LL[xx-\uD83D\uD83D]/u
;
/BB-LT[xx-\uD83D\uDCA9]/u
;
/BB-LB[xx-\uD83Dx]/u
;
/BB-LBB[xx-\uD83Dxx]/u
;
/BB-LBL[xx-\uD83Dx\uD83D]/u
;
/BB-LBT[xx-\uD83Dx\uDCA9]/u
;
/BB-LL[xx-\uD83D\uD83D]/u
;
/BB-LLB[xx-\uD83D\uD83Dx]/u
;
/BB-LLL[xx-\uD83D\uD83D\uD83D]/u
;
/BB-LLT[xx-\uD83D\uD83D\uDCA9]/u
;
/BB-LT[xx-\uD83D\uDCA9]/u
;
/BB-LTB[xx-\uD83D\uDCA9x]/u
;
/BB-LTL[xx-\uD83D\uDCA9\uD83D]/u
;
/BB-LTT[xx-\uD83D\uDCA9\uDCA9]/u
;
/BB-T[xx-\uDCA9]/u
;
/BB-TB[xx-\uDCA9x]/u
;
/BB-TL[xx-\uDCA9\uD83D]/u
;
/BB-TT[xx-\uDCA9\uDCA9]/u
;
/BB-TB[xx-\uDCA9x]/u
;
/BB-TBB[xx-\uDCA9xx]/u
;
/BB-TBL[xx-\uDCA9x\uD83D]/u
;
/BB-TBT[xx-\uDCA9x\uDCA9]/u
;
/BB-TL[xx-\uDCA9\uD83D]/u
;
/BB-TLB[xx-\uDCA9\uD83Dx]/u
;
/BB-TLL[xx-\uDCA9\uD83D\uD83D]/u
;
/BB-TLT[xx-\uDCA9\uD83D\uDCA9]/u
;
/BB-TT[xx-\uDCA9\uDCA9]/u
;
/BB-TTB[xx-\uDCA9\uDCA9x]/u
;
/BB-TTL[xx-\uDCA9\uDCA9\uD83D]/u
;
/BB-TTT[xx-\uDCA9\uDCA9\uDCA9]/u
;
/BL-L[x\uD83D-\uD83D]/u
;
/BL-LB[x\uD83D-\uD83Dx]/u
;
/BL-LL[x\uD83D-\uD83D\uD83D]/u
;
/BL-LT[x\uD83D-\uD83D\uDCA9]/u
;
/BL-LB[x\uD83D-\uD83Dx]/u
;
/BL-LBB[x\uD83D-\uD83Dxx]/u
;
/BL-LBL[x\uD83D-\uD83Dx\uD83D]/u
;
/BL-LBT[x\uD83D-\uD83Dx\uDCA9]/u
;
/BL-LL[x\uD83D-\uD83D\uD83D]/u
;
/BL-LLB[x\uD83D-\uD83D\uD83Dx]/u
;
/BL-LLL[x\uD83D-\uD83D\uD83D\uD83D]/u
;
/BL-LLT[x\uD83D-\uD83D\uD83D\uDCA9]/u
;
/BL-LT[x\uD83D-\uD83D\uDCA9]/u
;
/BL-LTB[x\uD83D-\uD83D\uDCA9x]/u
;
/BL-LTL[x\uD83D-\uD83D\uDCA9\uD83D]/u
;
/BL-LTT[x\uD83D-\uD83D\uDCA9\uDCA9]/u
;
/BL-T[x\uD83D-\uDCA9]/u
;
/BL-TB[x\uD83D-\uDCA9x]/u
;
/BL-TL[x\uD83D-\uDCA9\uD83D]/u
;
/BL-TT[x\uD83D-\uDCA9\uDCA9]/u
;
/BL-TB[x\uD83D-\uDCA9x]/u
;
/BL-TBB[x\uD83D-\uDCA9xx]/u
;
/BL-TBL[x\uD83D-\uDCA9x\uD83D]/u
;
/BL-TBT[x\uD83D-\uDCA9x\uDCA9]/u
;
/BL-TL[x\uD83D-\uDCA9\uD83D]/u
;
/BL-TLB[x\uD83D-\uDCA9\uD83Dx]/u
;
/BL-TLL[x\uD83D-\uDCA9\uD83D\uD83D]/u
;
/BL-TLT[x\uD83D-\uDCA9\uD83D\uDCA9]/u
;
/BL-TT[x\uD83D-\uDCA9\uDCA9]/u
;
/BL-TTB[x\uD83D-\uDCA9\uDCA9x]/u
;
/BL-TTL[x\uD83D-\uDCA9\uDCA9\uD83D]/u
;
/BL-TTT[x\uD83D-\uDCA9\uDCA9\uDCA9]/u
;
/BT-LT[x\uDCA9-\uD83D\uDCA9]/u
;
/BT-LT[x\uDCA9-\uD83D\uDCA9]/u
;
/BT-LTB[x\uDCA9-\uD83D\uDCA9x]/u
;
/BT-LTL[x\uDCA9-\uD83D\uDCA9\uD83D]/u
;
/BT-LTT[x\uDCA9-\uD83D\uDCA9\uDCA9]/u
;
/BT-T[x\uDCA9-\uDCA9]/u
;
/BT-TB[x\uDCA9-\uDCA9x]/u
;
/BT-TL[x\uDCA9-\uDCA9\uD83D]/u
;
/BT-TT[x\uDCA9-\uDCA9\uDCA9]/u
;
/BT-TB[x\uDCA9-\uDCA9x]/u
;
/BT-TBB[x\uDCA9-\uDCA9xx]/u
;
/BT-TBL[x\uDCA9-\uDCA9x\uD83D]/u
;
/BT-TBT[x\uDCA9-\uDCA9x\uDCA9]/u
;
/BT-TL[x\uDCA9-\uDCA9\uD83D]/u
;
/BT-TLB[x\uDCA9-\uDCA9\uD83Dx]/u
;
/BT-TLL[x\uDCA9-\uDCA9\uD83D\uD83D]/u
;
/BT-TLT[x\uDCA9-\uDCA9\uD83D\uDCA9]/u
;
/BT-TT[x\uDCA9-\uDCA9\uDCA9]/u
;
/BT-TTB[x\uDCA9-\uDCA9\uDCA9x]/u
;
/BT-TTL[x\uDCA9-\uDCA9\uDCA9\uD83D]/u
;
/BT-TTT[x\uDCA9-\uDCA9\uDCA9\uDCA9]/u
;
/BBB-B[xxx-x]/u
;
/BBB-BB[xxx-xx]/u
;
/BBB-BL[xxx-x\uD83D]/u
;
/BBB-BT[xxx-x\uDCA9]/u
;
/BBB-BB[xxx-xx]/u
;
/BBB-BBB[xxx-xxx]/u
;
/BBB-BBL[xxx-xx\uD83D]/u
;
/BBB-BBT[xxx-xx\uDCA9]/u
;
/BBB-BL[xxx-x\uD83D]/u
;
/BBB-BLB[xxx-x\uD83Dx]/u
;
/BBB-BLL[xxx-x\uD83D\uD83D]/u
;
/BBB-BLT[xxx-x\uD83D\uDCA9]/u
;
/BBB-BT[xxx-x\uDCA9]/u
;
/BBB-BTB[xxx-x\uDCA9x]/u
;
/BBB-BTL[xxx-x\uDCA9\uD83D]/u
;
/BBB-BTT[xxx-x\uDCA9\uDCA9]/u
;
/BBB-L[xxx-\uD83D]/u
;
/BBB-LB[xxx-\uD83Dx]/u
;
/BBB-LL[xxx-\uD83D\uD83D]/u
;
/BBB-LT[xxx-\uD83D\uDCA9]/u
;
/BBB-LB[xxx-\uD83Dx]/u
;
/BBB-LBB[xxx-\uD83Dxx]/u
;
/BBB-LBL[xxx-\uD83Dx\uD83D]/u
;
/BBB-LBT[xxx-\uD83Dx\uDCA9]/u
;
/BBB-LL[xxx-\uD83D\uD83D]/u
;
/BBB-LLB[xxx-\uD83D\uD83Dx]/u
;
/BBB-LLL[xxx-\uD83D\uD83D\uD83D]/u
;
/BBB-LLT[xxx-\uD83D\uD83D\uDCA9]/u
;
/BBB-LT[xxx-\uD83D\uDCA9]/u
;
/BBB-LTB[xxx-\uD83D\uDCA9x]/u
;
/BBB-LTL[xxx-\uD83D\uDCA9\uD83D]/u
;
/BBB-LTT[xxx-\uD83D\uDCA9\uDCA9]/u
;
/BBB-T[xxx-\uDCA9]/u
;
/BBB-TB[xxx-\uDCA9x]/u
;
/BBB-TL[xxx-\uDCA9\uD83D]/u
;
/BBB-TT[xxx-\uDCA9\uDCA9]/u
;
/BBB-TB[xxx-\uDCA9x]/u
;
/BBB-TBB[xxx-\uDCA9xx]/u
;
/BBB-TBL[xxx-\uDCA9x\uD83D]/u
;
/BBB-TBT[xxx-\uDCA9x\uDCA9]/u
;
/BBB-TL[xxx-\uDCA9\uD83D]/u
;
/BBB-TLB[xxx-\uDCA9\uD83Dx]/u
;
/BBB-TLL[xxx-\uDCA9\uD83D\uD83D]/u
;
/BBB-TLT[xxx-\uDCA9\uD83D\uDCA9]/u
;
/BBB-TT[xxx-\uDCA9\uDCA9]/u
;
/BBB-TTB[xxx-\uDCA9\uDCA9x]/u
;
/BBB-TTL[xxx-\uDCA9\uDCA9\uD83D]/u
;
/BBB-TTT[xxx-\uDCA9\uDCA9\uDCA9]/u
;
/BBL-L[xx\uD83D-\uD83D]/u
;
/BBL-LB[xx\uD83D-\uD83Dx]/u
;
/BBL-LL[xx\uD83D-\uD83D\uD83D]/u
;
/BBL-LT[xx\uD83D-\uD83D\uDCA9]/u
;
/BBL-LB[xx\uD83D-\uD83Dx]/u
;
/BBL-LBB[xx\uD83D-\uD83Dxx]/u
;
/BBL-LBL[xx\uD83D-\uD83Dx\uD83D]/u
;
/BBL-LBT[xx\uD83D-\uD83Dx\uDCA9]/u
;
/BBL-LL[xx\uD83D-\uD83D\uD83D]/u
;
/BBL-LLB[xx\uD83D-\uD83D\uD83Dx]/u
;
/BBL-LLL[xx\uD83D-\uD83D\uD83D\uD83D]/u
;
/BBL-LLT[xx\uD83D-\uD83D\uD83D\uDCA9]/u
;
/BBL-LT[xx\uD83D-\uD83D\uDCA9]/u
;
/BBL-LTB[xx\uD83D-\uD83D\uDCA9x]/u
;
/BBL-LTL[xx\uD83D-\uD83D\uDCA9\uD83D]/u
;
/BBL-LTT[xx\uD83D-\uD83D\uDCA9\uDCA9]/u
;
/BBL-T[xx\uD83D-\uDCA9]/u
;
/BBL-TB[xx\uD83D-\uDCA9x]/u
;
/BBL-TL[xx\uD83D-\uDCA9\uD83D]/u
;
/BBL-TT[xx\uD83D-\uDCA9\uDCA9]/u
;
/BBL-TB[xx\uD83D-\uDCA9x]/u
;
/BBL-TBB[xx\uD83D-\uDCA9xx]/u
;
/BBL-TBL[xx\uD83D-\uDCA9x\uD83D]/u
;
/BBL-TBT[xx\uD83D-\uDCA9x\uDCA9]/u
;
/BBL-TL[xx\uD83D-\uDCA9\uD83D]/u
;
/BBL-TLB[xx\uD83D-\uDCA9\uD83Dx]/u
;
/BBL-TLL[xx\uD83D-\uDCA9\uD83D\uD83D]/u
;
/BBL-TLT[xx\uD83D-\uDCA9\uD83D\uDCA9]/u
;
/BBL-TT[xx\uD83D-\uDCA9\uDCA9]/u
;
/BBL-TTB[xx\uD83D-\uDCA9\uDCA9x]/u
;
/BBL-TTL[xx\uD83D-\uDCA9\uDCA9\uD83D]/u
;
/BBL-TTT[xx\uD83D-\uDCA9\uDCA9\uDCA9]/u
;
/BBT-LT[xx\uDCA9-\uD83D\uDCA9]/u
;
/BBT-LT[xx\uDCA9-\uD83D\uDCA9]/u
;
/BBT-LTB[xx\uDCA9-\uD83D\uDCA9x]/u
;
/BBT-LTL[xx\uDCA9-\uD83D\uDCA9\uD83D]/u
;
/BBT-LTT[xx\uDCA9-\uD83D\uDCA9\uDCA9]/u
;
/BBT-T[xx\uDCA9-\uDCA9]/u
;
/BBT-TB[xx\uDCA9-\uDCA9x]/u
;
/BBT-TL[xx\uDCA9-\uDCA9\uD83D]/u
;
/BBT-TT[xx\uDCA9-\uDCA9\uDCA9]/u
;
/BBT-TB[xx\uDCA9-\uDCA9x]/u
;
/BBT-TBB[xx\uDCA9-\uDCA9xx]/u
;
/BBT-TBL[xx\uDCA9-\uDCA9x\uD83D]/u
;
/BBT-TBT[xx\uDCA9-\uDCA9x\uDCA9]/u
;
/BBT-TL[xx\uDCA9-\uDCA9\uD83D]/u
;
/BBT-TLB[xx\uDCA9-\uDCA9\uD83Dx]/u
;
/BBT-TLL[xx\uDCA9-\uDCA9\uD83D\uD83D]/u
;
/BBT-TLT[xx\uDCA9-\uDCA9\uD83D\uDCA9]/u
;
/BBT-TT[xx\uDCA9-\uDCA9\uDCA9]/u
;
/BBT-TTB[xx\uDCA9-\uDCA9\uDCA9x]/u
;
/BBT-TTL[xx\uDCA9-\uDCA9\uDCA9\uD83D]/u
;
/BBT-TTT[xx\uDCA9-\uDCA9\uDCA9\uDCA9]/u
;
/BLB-B[x\uD83Dx-x]/u
;
/BLB-BB[x\uD83Dx-xx]/u
;
/BLB-BL[x\uD83Dx-x\uD83D]/u
;
/BLB-BT[x\uD83Dx-x\uDCA9]/u
;
/BLB-BB[x\uD83Dx-xx]/u
;
/BLB-BBB[x\uD83Dx-xxx]/u
;
/BLB-BBL[x\uD83Dx-xx\uD83D]/u
;
/BLB-BBT[x\uD83Dx-xx\uDCA9]/u
;
/BLB-BL[x\uD83Dx-x\uD83D]/u
;
/BLB-BLB[x\uD83Dx-x\uD83Dx]/u
;
/BLB-BLL[x\uD83Dx-x\uD83D\uD83D]/u
;
/BLB-BLT[x\uD83Dx-x\uD83D\uDCA9]/u
;
/BLB-BT[x\uD83Dx-x\uDCA9]/u
;
/BLB-BTB[x\uD83Dx-x\uDCA9x]/u
;
/BLB-BTL[x\uD83Dx-x\uDCA9\uD83D]/u
;
/BLB-BTT[x\uD83Dx-x\uDCA9\uDCA9]/u
;
/BLB-L[x\uD83Dx-\uD83D]/u
;
/BLB-LB[x\uD83Dx-\uD83Dx]/u
;
/BLB-LL[x\uD83Dx-\uD83D\uD83D]/u
;
/BLB-LT[x\uD83Dx-\uD83D\uDCA9]/u
;
/BLB-LB[x\uD83Dx-\uD83Dx]/u
;
/BLB-LBB[x\uD83Dx-\uD83Dxx]/u
;
/BLB-LBL[x\uD83Dx-\uD83Dx\uD83D]/u
;
/BLB-LBT[x\uD83Dx-\uD83Dx\uDCA9]/u
;
/BLB-LL[x\uD83Dx-\uD83D\uD83D]/u
;
/BLB-LLB[x\uD83Dx-\uD83D\uD83Dx]/u
;
/BLB-LLL[x\uD83Dx-\uD83D\uD83D\uD83D]/u
;
/BLB-LLT[x\uD83Dx-\uD83D\uD83D\uDCA9]/u
;
/BLB-LT[x\uD83Dx-\uD83D\uDCA9]/u
;
/BLB-LTB[x\uD83Dx-\uD83D\uDCA9x]/u
;
/BLB-LTL[x\uD83Dx-\uD83D\uDCA9\uD83D]/u
;
/BLB-LTT[x\uD83Dx-\uD83D\uDCA9\uDCA9]/u
;
/BLB-T[x\uD83Dx-\uDCA9]/u
;
/BLB-TB[x\uD83Dx-\uDCA9x]/u
;
/BLB-TL[x\uD83Dx-\uDCA9\uD83D]/u
;
/BLB-TT[x\uD83Dx-\uDCA9\uDCA9]/u
;
/BLB-TB[x\uD83Dx-\uDCA9x]/u
;
/BLB-TBB[x\uD83Dx-\uDCA9xx]/u
;
/BLB-TBL[x\uD83Dx-\uDCA9x\uD83D]/u
;
/BLB-TBT[x\uD83Dx-\uDCA9x\uDCA9]/u
;
/BLB-TL[x\uD83Dx-\uDCA9\uD83D]/u
;
/BLB-TLB[x\uD83Dx-\uDCA9\uD83Dx]/u
;
/BLB-TLL[x\uD83Dx-\uDCA9\uD83D\uD83D]/u
;
/BLB-TLT[x\uD83Dx-\uDCA9\uD83D\uDCA9]/u
;
/BLB-TT[x\uD83Dx-\uDCA9\uDCA9]/u
;
/BLB-TTB[x\uD83Dx-\uDCA9\uDCA9x]/u
;
/BLB-TTL[x\uD83Dx-\uDCA9\uDCA9\uD83D]/u
;
/BLB-TTT[x\uD83Dx-\uDCA9\uDCA9\uDCA9]/u
;
/BLL-L[x\uD83D\uD83D-\uD83D]/u
;
/BLL-LB[x\uD83D\uD83D-\uD83Dx]/u
;
/BLL-LL[x\uD83D\uD83D-\uD83D\uD83D]/u
;
/BLL-LT[x\uD83D\uD83D-\uD83D\uDCA9]/u
;
/BLL-LB[x\uD83D\uD83D-\uD83Dx]/u
;
/BLL-LBB[x\uD83D\uD83D-\uD83Dxx]/u
;
/BLL-LBL[x\uD83D\uD83D-\uD83Dx\uD83D]/u
;
/BLL-LBT[x\uD83D\uD83D-\uD83Dx\uDCA9]/u
;
/BLL-LL[x\uD83D\uD83D-\uD83D\uD83D]/u
;
/BLL-LLB[x\uD83D\uD83D-\uD83D\uD83Dx]/u
;
/BLL-LLL[x\uD83D\uD83D-\uD83D\uD83D\uD83D]/u
;
/BLL-LLT[x\uD83D\uD83D-\uD83D\uD83D\uDCA9]/u
;
/BLL-LT[x\uD83D\uD83D-\uD83D\uDCA9]/u
;
/BLL-LTB[x\uD83D\uD83D-\uD83D\uDCA9x]/u
;
/BLL-LTL[x\uD83D\uD83D-\uD83D\uDCA9\uD83D]/u
;
/BLL-LTT[x\uD83D\uD83D-\uD83D\uDCA9\uDCA9]/u
;
/BLL-T[x\uD83D\uD83D-\uDCA9]/u
;
/BLL-TB[x\uD83D\uD83D-\uDCA9x]/u
;
/BLL-TL[x\uD83D\uD83D-\uDCA9\uD83D]/u
;
/BLL-TT[x\uD83D\uD83D-\uDCA9\uDCA9]/u
;
/BLL-TB[x\uD83D\uD83D-\uDCA9x]/u
;
/BLL-TBB[x\uD83D\uD83D-\uDCA9xx]/u
;
/BLL-TBL[x\uD83D\uD83D-\uDCA9x\uD83D]/u
;
/BLL-TBT[x\uD83D\uD83D-\uDCA9x\uDCA9]/u
;
/BLL-TL[x\uD83D\uD83D-\uDCA9\uD83D]/u
;
/BLL-TLB[x\uD83D\uD83D-\uDCA9\uD83Dx]/u
;
/BLL-TLL[x\uD83D\uD83D-\uDCA9\uD83D\uD83D]/u
;
/BLL-TLT[x\uD83D\uD83D-\uDCA9\uD83D\uDCA9]/u
;
/BLL-TT[x\uD83D\uD83D-\uDCA9\uDCA9]/u
;
/BLL-TTB[x\uD83D\uD83D-\uDCA9\uDCA9x]/u
;
/BLL-TTL[x\uD83D\uD83D-\uDCA9\uDCA9\uD83D]/u
;
/BLL-TTT[x\uD83D\uD83D-\uDCA9\uDCA9\uDCA9]/u
;
/BLT-LT[x\uD83D\uDCA9-\uD83D\uDCA9]/u
;
/BLT-LT[x\uD83D\uDCA9-\uD83D\uDCA9]/u
;
/BLT-LTB[x\uD83D\uDCA9-\uD83D\uDCA9x]/u
;
/BLT-LTL[x\uD83D\uDCA9-\uD83D\uDCA9\uD83D]/u
;
/BLT-LTT[x\uD83D\uDCA9-\uD83D\uDCA9\uDCA9]/u
;
/BTB-B[x\uDCA9x-x]/u
;
/BTB-BB[x\uDCA9x-xx]/u
;
/BTB-BL[x\uDCA9x-x\uD83D]/u
;
/BTB-BT[x\uDCA9x-x\uDCA9]/u
;
/BTB-BB[x\uDCA9x-xx]/u
;
/BTB-BBB[x\uDCA9x-xxx]/u
;
/BTB-BBL[x\uDCA9x-xx\uD83D]/u
;
/BTB-BBT[x\uDCA9x-xx\uDCA9]/u
;
/BTB-BL[x\uDCA9x-x\uD83D]/u
;
/BTB-BLB[x\uDCA9x-x\uD83Dx]/u
;
/BTB-BLL[x\uDCA9x-x\uD83D\uD83D]/u
;
/BTB-BLT[x\uDCA9x-x\uD83D\uDCA9]/u
;
/BTB-BT[x\uDCA9x-x\uDCA9]/u
;
/BTB-BTB[x\uDCA9x-x\uDCA9x]/u
;
/BTB-BTL[x\uDCA9x-x\uDCA9\uD83D]/u
;
/BTB-BTT[x\uDCA9x-x\uDCA9\uDCA9]/u
;
/BTB-L[x\uDCA9x-\uD83D]/u
;
/BTB-LB[x\uDCA9x-\uD83Dx]/u
;
/BTB-LL[x\uDCA9x-\uD83D\uD83D]/u
;
/BTB-LT[x\uDCA9x-\uD83D\uDCA9]/u
;
/BTB-LB[x\uDCA9x-\uD83Dx]/u
;
/BTB-LBB[x\uDCA9x-\uD83Dxx]/u
;
/BTB-LBL[x\uDCA9x-\uD83Dx\uD83D]/u
;
/BTB-LBT[x\uDCA9x-\uD83Dx\uDCA9]/u
;
/BTB-LL[x\uDCA9x-\uD83D\uD83D]/u
;
/BTB-LLB[x\uDCA9x-\uD83D\uD83Dx]/u
;
/BTB-LLL[x\uDCA9x-\uD83D\uD83D\uD83D]/u
;
/BTB-LLT[x\uDCA9x-\uD83D\uD83D\uDCA9]/u
;
/BTB-LT[x\uDCA9x-\uD83D\uDCA9]/u
;
/BTB-LTB[x\uDCA9x-\uD83D\uDCA9x]/u
;
/BTB-LTL[x\uDCA9x-\uD83D\uDCA9\uD83D]/u
;
/BTB-LTT[x\uDCA9x-\uD83D\uDCA9\uDCA9]/u
;
/BTB-T[x\uDCA9x-\uDCA9]/u
;
/BTB-TB[x\uDCA9x-\uDCA9x]/u
;
/BTB-TL[x\uDCA9x-\uDCA9\uD83D]/u
;
/BTB-TT[x\uDCA9x-\uDCA9\uDCA9]/u
;
/BTB-TB[x\uDCA9x-\uDCA9x]/u
;
/BTB-TBB[x\uDCA9x-\uDCA9xx]/u
;
/BTB-TBL[x\uDCA9x-\uDCA9x\uD83D]/u
;
/BTB-TBT[x\uDCA9x-\uDCA9x\uDCA9]/u
;
/BTB-TL[x\uDCA9x-\uDCA9\uD83D]/u
;
/BTB-TLB[x\uDCA9x-\uDCA9\uD83Dx]/u
;
/BTB-TLL[x\uDCA9x-\uDCA9\uD83D\uD83D]/u
;
/BTB-TLT[x\uDCA9x-\uDCA9\uD83D\uDCA9]/u
;
/BTB-TT[x\uDCA9x-\uDCA9\uDCA9]/u
;
/BTB-TTB[x\uDCA9x-\uDCA9\uDCA9x]/u
;
/BTB-TTL[x\uDCA9x-\uDCA9\uDCA9\uD83D]/u
;
/BTB-TTT[x\uDCA9x-\uDCA9\uDCA9\uDCA9]/u
;
/BTL-L[x\uDCA9\uD83D-\uD83D]/u
;
/BTL-LB[x\uDCA9\uD83D-\uD83Dx]/u
;
/BTL-LL[x\uDCA9\uD83D-\uD83D\uD83D]/u
;
/BTL-LT[x\uDCA9\uD83D-\uD83D\uDCA9]/u
;
/BTL-LB[x\uDCA9\uD83D-\uD83Dx]/u
;
/BTL-LBB[x\uDCA9\uD83D-\uD83Dxx]/u
;
/BTL-LBL[x\uDCA9\uD83D-\uD83Dx\uD83D]/u
;
/BTL-LBT[x\uDCA9\uD83D-\uD83Dx\uDCA9]/u
;
/BTL-LL[x\uDCA9\uD83D-\uD83D\uD83D]/u
;
/BTL-LLB[x\uDCA9\uD83D-\uD83D\uD83Dx]/u
;
/BTL-LLL[x\uDCA9\uD83D-\uD83D\uD83D\uD83D]/u
;
/BTL-LLT[x\uDCA9\uD83D-\uD83D\uD83D\uDCA9]/u
;
/BTL-LT[x\uDCA9\uD83D-\uD83D\uDCA9]/u
;
/BTL-LTB[x\uDCA9\uD83D-\uD83D\uDCA9x]/u
;
/BTL-LTL[x\uDCA9\uD83D-\uD83D\uDCA9\uD83D]/u
;
/BTL-LTT[x\uDCA9\uD83D-\uD83D\uDCA9\uDCA9]/u
;
/BTL-T[x\uDCA9\uD83D-\uDCA9]/u
;
/BTL-TB[x\uDCA9\uD83D-\uDCA9x]/u
;
/BTL-TL[x\uDCA9\uD83D-\uDCA9\uD83D]/u
;
/BTL-TT[x\uDCA9\uD83D-\uDCA9\uDCA9]/u
;
/BTL-TB[x\uDCA9\uD83D-\uDCA9x]/u
;
/BTL-TBB[x\uDCA9\uD83D-\uDCA9xx]/u
;
/BTL-TBL[x\uDCA9\uD83D-\uDCA9x\uD83D]/u
;
/BTL-TBT[x\uDCA9\uD83D-\uDCA9x\uDCA9]/u
;
/BTL-TL[x\uDCA9\uD83D-\uDCA9\uD83D]/u
;
/BTL-TLB[x\uDCA9\uD83D-\uDCA9\uD83Dx]/u
;
/BTL-TLL[x\uDCA9\uD83D-\uDCA9\uD83D\uD83D]/u
;
/BTL-TLT[x\uDCA9\uD83D-\uDCA9\uD83D\uDCA9]/u
;
/BTL-TT[x\uDCA9\uD83D-\uDCA9\uDCA9]/u
;
/BTL-TTB[x\uDCA9\uD83D-\uDCA9\uDCA9x]/u
;
/BTL-TTL[x\uDCA9\uD83D-\uDCA9\uDCA9\uD83D]/u
;
/BTL-TTT[x\uDCA9\uD83D-\uDCA9\uDCA9\uDCA9]/u
;
/BTT-LT[x\uDCA9\uDCA9-\uD83D\uDCA9]/u
;
/BTT-LT[x\uDCA9\uDCA9-\uD83D\uDCA9]/u
;
/BTT-LTB[x\uDCA9\uDCA9-\uD83D\uDCA9x]/u
;
/BTT-LTL[x\uDCA9\uDCA9-\uD83D\uDCA9\uD83D]/u
;
/BTT-LTT[x\uDCA9\uDCA9-\uD83D\uDCA9\uDCA9]/u
;
/BTT-T[x\uDCA9\uDCA9-\uDCA9]/u
;
/BTT-TB[x\uDCA9\uDCA9-\uDCA9x]/u
;
/BTT-TL[x\uDCA9\uDCA9-\uDCA9\uD83D]/u
;
/BTT-TT[x\uDCA9\uDCA9-\uDCA9\uDCA9]/u
;
/BTT-TB[x\uDCA9\uDCA9-\uDCA9x]/u
;
/BTT-TBB[x\uDCA9\uDCA9-\uDCA9xx]/u
;
/BTT-TBL[x\uDCA9\uDCA9-\uDCA9x\uD83D]/u
;
/BTT-TBT[x\uDCA9\uDCA9-\uDCA9x\uDCA9]/u
;
/BTT-TL[x\uDCA9\uDCA9-\uDCA9\uD83D]/u
;
/BTT-TLB[x\uDCA9\uDCA9-\uDCA9\uD83Dx]/u
;
/BTT-TLL[x\uDCA9\uDCA9-\uDCA9\uD83D\uD83D]/u
;
/BTT-TLT[x\uDCA9\uDCA9-\uDCA9\uD83D\uDCA9]/u
;
/BTT-TT[x\uDCA9\uDCA9-\uDCA9\uDCA9]/u
;
/BTT-TTB[x\uDCA9\uDCA9-\uDCA9\uDCA9x]/u
;
/BTT-TTL[x\uDCA9\uDCA9-\uDCA9\uDCA9\uD83D]/u
;
/BTT-TTT[x\uDCA9\uDCA9-\uDCA9\uDCA9\uDCA9]/u
;
/LB-B[\uD83Dx-x]/u
;
/LB-BB[\uD83Dx-xx]/u
;
/LB-BL[\uD83Dx-x\uD83D]/u
;
/LB-BT[\uD83Dx-x\uDCA9]/u
;
/LB-BB[\uD83Dx-xx]/u
;
/LB-BBB[\uD83Dx-xxx]/u
;
/LB-BBL[\uD83Dx-xx\uD83D]/u
;
/LB-BBT[\uD83Dx-xx\uDCA9]/u
;
/LB-BL[\uD83Dx-x\uD83D]/u
;
/LB-BLB[\uD83Dx-x\uD83Dx]/u
;
/LB-BLL[\uD83Dx-x\uD83D\uD83D]/u
;
/LB-BLT[\uD83Dx-x\uD83D\uDCA9]/u
;
/LB-BT[\uD83Dx-x\uDCA9]/u
;
/LB-BTB[\uD83Dx-x\uDCA9x]/u
;
/LB-BTL[\uD83Dx-x\uDCA9\uD83D]/u
;
/LB-BTT[\uD83Dx-x\uDCA9\uDCA9]/u
;
/LB-L[\uD83Dx-\uD83D]/u
;
/LB-LB[\uD83Dx-\uD83Dx]/u
;
/LB-LL[\uD83Dx-\uD83D\uD83D]/u
;
/LB-LT[\uD83Dx-\uD83D\uDCA9]/u
;
/LB-LB[\uD83Dx-\uD83Dx]/u
;
/LB-LBB[\uD83Dx-\uD83Dxx]/u
;
/LB-LBL[\uD83Dx-\uD83Dx\uD83D]/u
;
/LB-LBT[\uD83Dx-\uD83Dx\uDCA9]/u
;
/LB-LL[\uD83Dx-\uD83D\uD83D]/u
;
/LB-LLB[\uD83Dx-\uD83D\uD83Dx]/u
;
/LB-LLL[\uD83Dx-\uD83D\uD83D\uD83D]/u
;
/LB-LLT[\uD83Dx-\uD83D\uD83D\uDCA9]/u
;
/LB-LT[\uD83Dx-\uD83D\uDCA9]/u
;
/LB-LTB[\uD83Dx-\uD83D\uDCA9x]/u
;
/LB-LTL[\uD83Dx-\uD83D\uDCA9\uD83D]/u
;
/LB-LTT[\uD83Dx-\uD83D\uDCA9\uDCA9]/u
;
/LB-T[\uD83Dx-\uDCA9]/u
;
/LB-TB[\uD83Dx-\uDCA9x]/u
;
/LB-TL[\uD83Dx-\uDCA9\uD83D]/u
;
/LB-TT[\uD83Dx-\uDCA9\uDCA9]/u
;
/LB-TB[\uD83Dx-\uDCA9x]/u
;
/LB-TBB[\uD83Dx-\uDCA9xx]/u
;
/LB-TBL[\uD83Dx-\uDCA9x\uD83D]/u
;
/LB-TBT[\uD83Dx-\uDCA9x\uDCA9]/u
;
/LB-TL[\uD83Dx-\uDCA9\uD83D]/u
;
/LB-TLB[\uD83Dx-\uDCA9\uD83Dx]/u
;
/LB-TLL[\uD83Dx-\uDCA9\uD83D\uD83D]/u
;
/LB-TLT[\uD83Dx-\uDCA9\uD83D\uDCA9]/u
;
/LB-TT[\uD83Dx-\uDCA9\uDCA9]/u
;
/LB-TTB[\uD83Dx-\uDCA9\uDCA9x]/u
;
/LB-TTL[\uD83Dx-\uDCA9\uDCA9\uD83D]/u
;
/LB-TTT[\uD83Dx-\uDCA9\uDCA9\uDCA9]/u
;
/LL-L[\uD83D\uD83D-\uD83D]/u
;
/LL-LB[\uD83D\uD83D-\uD83Dx]/u
;
/LL-LL[\uD83D\uD83D-\uD83D\uD83D]/u
;
/LL-LT[\uD83D\uD83D-\uD83D\uDCA9]/u
;
/LL-LB[\uD83D\uD83D-\uD83Dx]/u
;
/LL-LBB[\uD83D\uD83D-\uD83Dxx]/u
;
/LL-LBL[\uD83D\uD83D-\uD83Dx\uD83D]/u
;
/LL-LBT[\uD83D\uD83D-\uD83Dx\uDCA9]/u
;
/LL-LL[\uD83D\uD83D-\uD83D\uD83D]/u
;
/LL-LLB[\uD83D\uD83D-\uD83D\uD83Dx]/u
;
/LL-LLL[\uD83D\uD83D-\uD83D\uD83D\uD83D]/u
;
/LL-LLT[\uD83D\uD83D-\uD83D\uD83D\uDCA9]/u
;
/LL-LT[\uD83D\uD83D-\uD83D\uDCA9]/u
;
/LL-LTB[\uD83D\uD83D-\uD83D\uDCA9x]/u
;
/LL-LTL[\uD83D\uD83D-\uD83D\uDCA9\uD83D]/u
;
/LL-LTT[\uD83D\uD83D-\uD83D\uDCA9\uDCA9]/u
;
/LL-T[\uD83D\uD83D-\uDCA9]/u
;
/LL-TB[\uD83D\uD83D-\uDCA9x]/u
;
/LL-TL[\uD83D\uD83D-\uDCA9\uD83D]/u
;
/LL-TT[\uD83D\uD83D-\uDCA9\uDCA9]/u
;
/LL-TB[\uD83D\uD83D-\uDCA9x]/u
;
/LL-TBB[\uD83D\uD83D-\uDCA9xx]/u
;
/LL-TBL[\uD83D\uD83D-\uDCA9x\uD83D]/u
;
/LL-TBT[\uD83D\uD83D-\uDCA9x\uDCA9]/u
;
/LL-TL[\uD83D\uD83D-\uDCA9\uD83D]/u
;
/LL-TLB[\uD83D\uD83D-\uDCA9\uD83Dx]/u
;
/LL-TLL[\uD83D\uD83D-\uDCA9\uD83D\uD83D]/u
;
/LL-TLT[\uD83D\uD83D-\uDCA9\uD83D\uDCA9]/u
;
/LL-TT[\uD83D\uD83D-\uDCA9\uDCA9]/u
;
/LL-TTB[\uD83D\uD83D-\uDCA9\uDCA9x]/u
;
/LL-TTL[\uD83D\uD83D-\uDCA9\uDCA9\uD83D]/u
;
/LL-TTT[\uD83D\uD83D-\uDCA9\uDCA9\uDCA9]/u
;
/LT-LT[\uD83D\uDCA9-\uD83D\uDCA9]/u
;
/LT-LT[\uD83D\uDCA9-\uD83D\uDCA9]/u
;
/LT-LTB[\uD83D\uDCA9-\uD83D\uDCA9x]/u
;
/LT-LTL[\uD83D\uDCA9-\uD83D\uDCA9\uD83D]/u
;
/LT-LTT[\uD83D\uDCA9-\uD83D\uDCA9\uDCA9]/u
;
/LBB-B[\uD83Dxx-x]/u
;
/LBB-BB[\uD83Dxx-xx]/u
;
/LBB-BL[\uD83Dxx-x\uD83D]/u
;
/LBB-BT[\uD83Dxx-x\uDCA9]/u
;
/LBB-BB[\uD83Dxx-xx]/u
;
/LBB-BBB[\uD83Dxx-xxx]/u
;
/LBB-BBL[\uD83Dxx-xx\uD83D]/u
;
/LBB-BBT[\uD83Dxx-xx\uDCA9]/u
;
/LBB-BL[\uD83Dxx-x\uD83D]/u
;
/LBB-BLB[\uD83Dxx-x\uD83Dx]/u
;
/LBB-BLL[\uD83Dxx-x\uD83D\uD83D]/u
;
/LBB-BLT[\uD83Dxx-x\uD83D\uDCA9]/u
;
/LBB-BT[\uD83Dxx-x\uDCA9]/u
;
/LBB-BTB[\uD83Dxx-x\uDCA9x]/u
;
/LBB-BTL[\uD83Dxx-x\uDCA9\uD83D]/u
;
/LBB-BTT[\uD83Dxx-x\uDCA9\uDCA9]/u
;
/LBB-L[\uD83Dxx-\uD83D]/u
;
/LBB-LB[\uD83Dxx-\uD83Dx]/u
;
/LBB-LL[\uD83Dxx-\uD83D\uD83D]/u
;
/LBB-LT[\uD83Dxx-\uD83D\uDCA9]/u
;
/LBB-LB[\uD83Dxx-\uD83Dx]/u
;
/LBB-LBB[\uD83Dxx-\uD83Dxx]/u
;
/LBB-LBL[\uD83Dxx-\uD83Dx\uD83D]/u
;
/LBB-LBT[\uD83Dxx-\uD83Dx\uDCA9]/u
;
/LBB-LL[\uD83Dxx-\uD83D\uD83D]/u
;
/LBB-LLB[\uD83Dxx-\uD83D\uD83Dx]/u
;
/LBB-LLL[\uD83Dxx-\uD83D\uD83D\uD83D]/u
;
/LBB-LLT[\uD83Dxx-\uD83D\uD83D\uDCA9]/u
;
/LBB-LT[\uD83Dxx-\uD83D\uDCA9]/u
;
/LBB-LTB[\uD83Dxx-\uD83D\uDCA9x]/u
;
/LBB-LTL[\uD83Dxx-\uD83D\uDCA9\uD83D]/u
;
/LBB-LTT[\uD83Dxx-\uD83D\uDCA9\uDCA9]/u
;
/LBB-T[\uD83Dxx-\uDCA9]/u
;
/LBB-TB[\uD83Dxx-\uDCA9x]/u
;
/LBB-TL[\uD83Dxx-\uDCA9\uD83D]/u
;
/LBB-TT[\uD83Dxx-\uDCA9\uDCA9]/u
;
/LBB-TB[\uD83Dxx-\uDCA9x]/u
;
/LBB-TBB[\uD83Dxx-\uDCA9xx]/u
;
/LBB-TBL[\uD83Dxx-\uDCA9x\uD83D]/u
;
/LBB-TBT[\uD83Dxx-\uDCA9x\uDCA9]/u
;
/LBB-TL[\uD83Dxx-\uDCA9\uD83D]/u
;
/LBB-TLB[\uD83Dxx-\uDCA9\uD83Dx]/u
;
/LBB-TLL[\uD83Dxx-\uDCA9\uD83D\uD83D]/u
;
/LBB-TLT[\uD83Dxx-\uDCA9\uD83D\uDCA9]/u
;
/LBB-TT[\uD83Dxx-\uDCA9\uDCA9]/u
;
/LBB-TTB[\uD83Dxx-\uDCA9\uDCA9x]/u
;
/LBB-TTL[\uD83Dxx-\uDCA9\uDCA9\uD83D]/u
;
/LBB-TTT[\uD83Dxx-\uDCA9\uDCA9\uDCA9]/u
;
/LBL-L[\uD83Dx\uD83D-\uD83D]/u
;
/LBL-LB[\uD83Dx\uD83D-\uD83Dx]/u
;
/LBL-LL[\uD83Dx\uD83D-\uD83D\uD83D]/u
;
/LBL-LT[\uD83Dx\uD83D-\uD83D\uDCA9]/u
;
/LBL-LB[\uD83Dx\uD83D-\uD83Dx]/u
;
/LBL-LBB[\uD83Dx\uD83D-\uD83Dxx]/u
;
/LBL-LBL[\uD83Dx\uD83D-\uD83Dx\uD83D]/u
;
/LBL-LBT[\uD83Dx\uD83D-\uD83Dx\uDCA9]/u
;
/LBL-LL[\uD83Dx\uD83D-\uD83D\uD83D]/u
;
/LBL-LLB[\uD83Dx\uD83D-\uD83D\uD83Dx]/u
;
/LBL-LLL[\uD83Dx\uD83D-\uD83D\uD83D\uD83D]/u
;
/LBL-LLT[\uD83Dx\uD83D-\uD83D\uD83D\uDCA9]/u
;
/LBL-LT[\uD83Dx\uD83D-\uD83D\uDCA9]/u
;
/LBL-LTB[\uD83Dx\uD83D-\uD83D\uDCA9x]/u
;
/LBL-LTL[\uD83Dx\uD83D-\uD83D\uDCA9\uD83D]/u
;
/LBL-LTT[\uD83Dx\uD83D-\uD83D\uDCA9\uDCA9]/u
;
/LBL-T[\uD83Dx\uD83D-\uDCA9]/u
;
/LBL-TB[\uD83Dx\uD83D-\uDCA9x]/u
;
/LBL-TL[\uD83Dx\uD83D-\uDCA9\uD83D]/u
;
/LBL-TT[\uD83Dx\uD83D-\uDCA9\uDCA9]/u
;
/LBL-TB[\uD83Dx\uD83D-\uDCA9x]/u
;
/LBL-TBB[\uD83Dx\uD83D-\uDCA9xx]/u
;
/LBL-TBL[\uD83Dx\uD83D-\uDCA9x\uD83D]/u
;
/LBL-TBT[\uD83Dx\uD83D-\uDCA9x\uDCA9]/u
;
/LBL-TL[\uD83Dx\uD83D-\uDCA9\uD83D]/u
;
/LBL-TLB[\uD83Dx\uD83D-\uDCA9\uD83Dx]/u
;
/LBL-TLL[\uD83Dx\uD83D-\uDCA9\uD83D\uD83D]/u
;
/LBL-TLT[\uD83Dx\uD83D-\uDCA9\uD83D\uDCA9]/u
;
/LBL-TT[\uD83Dx\uD83D-\uDCA9\uDCA9]/u
;
/LBL-TTB[\uD83Dx\uD83D-\uDCA9\uDCA9x]/u
;
/LBL-TTL[\uD83Dx\uD83D-\uDCA9\uDCA9\uD83D]/u
;
/LBL-TTT[\uD83Dx\uD83D-\uDCA9\uDCA9\uDCA9]/u
;
/LBT-LT[\uD83Dx\uDCA9-\uD83D\uDCA9]/u
;
/LBT-LT[\uD83Dx\uDCA9-\uD83D\uDCA9]/u
;
/LBT-LTB[\uD83Dx\uDCA9-\uD83D\uDCA9x]/u
;
/LBT-LTL[\uD83Dx\uDCA9-\uD83D\uDCA9\uD83D]/u
;
/LBT-LTT[\uD83Dx\uDCA9-\uD83D\uDCA9\uDCA9]/u
;
/LBT-T[\uD83Dx\uDCA9-\uDCA9]/u
;
/LBT-TB[\uD83Dx\uDCA9-\uDCA9x]/u
;
/LBT-TL[\uD83Dx\uDCA9-\uDCA9\uD83D]/u
;
/LBT-TT[\uD83Dx\uDCA9-\uDCA9\uDCA9]/u
;
/LBT-TB[\uD83Dx\uDCA9-\uDCA9x]/u
;
/LBT-TBB[\uD83Dx\uDCA9-\uDCA9xx]/u
;
/LBT-TBL[\uD83Dx\uDCA9-\uDCA9x\uD83D]/u
;
/LBT-TBT[\uD83Dx\uDCA9-\uDCA9x\uDCA9]/u
;
/LBT-TL[\uD83Dx\uDCA9-\uDCA9\uD83D]/u
;
/LBT-TLB[\uD83Dx\uDCA9-\uDCA9\uD83Dx]/u
;
/LBT-TLL[\uD83Dx\uDCA9-\uDCA9\uD83D\uD83D]/u
;
/LBT-TLT[\uD83Dx\uDCA9-\uDCA9\uD83D\uDCA9]/u
;
/LBT-TT[\uD83Dx\uDCA9-\uDCA9\uDCA9]/u
;
/LBT-TTB[\uD83Dx\uDCA9-\uDCA9\uDCA9x]/u
;
/LBT-TTL[\uD83Dx\uDCA9-\uDCA9\uDCA9\uD83D]/u
;
/LBT-TTT[\uD83Dx\uDCA9-\uDCA9\uDCA9\uDCA9]/u
;
/LLB-B[\uD83D\uD83Dx-x]/u
;
/LLB-BB[\uD83D\uD83Dx-xx]/u
;
/LLB-BL[\uD83D\uD83Dx-x\uD83D]/u
;
/LLB-BT[\uD83D\uD83Dx-x\uDCA9]/u
;
/LLB-BB[\uD83D\uD83Dx-xx]/u
;
/LLB-BBB[\uD83D\uD83Dx-xxx]/u
;
/LLB-BBL[\uD83D\uD83Dx-xx\uD83D]/u
;
/LLB-BBT[\uD83D\uD83Dx-xx\uDCA9]/u
;
/LLB-BL[\uD83D\uD83Dx-x\uD83D]/u
;
/LLB-BLB[\uD83D\uD83Dx-x\uD83Dx]/u
;
/LLB-BLL[\uD83D\uD83Dx-x\uD83D\uD83D]/u
;
/LLB-BLT[\uD83D\uD83Dx-x\uD83D\uDCA9]/u
;
/LLB-BT[\uD83D\uD83Dx-x\uDCA9]/u
;
/LLB-BTB[\uD83D\uD83Dx-x\uDCA9x]/u
;
/LLB-BTL[\uD83D\uD83Dx-x\uDCA9\uD83D]/u
;
/LLB-BTT[\uD83D\uD83Dx-x\uDCA9\uDCA9]/u
;
/LLB-L[\uD83D\uD83Dx-\uD83D]/u
;
/LLB-LB[\uD83D\uD83Dx-\uD83Dx]/u
;
/LLB-LL[\uD83D\uD83Dx-\uD83D\uD83D]/u
;
/LLB-LT[\uD83D\uD83Dx-\uD83D\uDCA9]/u
;
/LLB-LB[\uD83D\uD83Dx-\uD83Dx]/u
;
/LLB-LBB[\uD83D\uD83Dx-\uD83Dxx]/u
;
/LLB-LBL[\uD83D\uD83Dx-\uD83Dx\uD83D]/u
;
/LLB-LBT[\uD83D\uD83Dx-\uD83Dx\uDCA9]/u
;
/LLB-LL[\uD83D\uD83Dx-\uD83D\uD83D]/u
;
/LLB-LLB[\uD83D\uD83Dx-\uD83D\uD83Dx]/u
;
/LLB-LLL[\uD83D\uD83Dx-\uD83D\uD83D\uD83D]/u
;
/LLB-LLT[\uD83D\uD83Dx-\uD83D\uD83D\uDCA9]/u
;
/LLB-LT[\uD83D\uD83Dx-\uD83D\uDCA9]/u
;
/LLB-LTB[\uD83D\uD83Dx-\uD83D\uDCA9x]/u
;
/LLB-LTL[\uD83D\uD83Dx-\uD83D\uDCA9\uD83D]/u
;
/LLB-LTT[\uD83D\uD83Dx-\uD83D\uDCA9\uDCA9]/u
;
/LLB-T[\uD83D\uD83Dx-\uDCA9]/u
;
/LLB-TB[\uD83D\uD83Dx-\uDCA9x]/u
;
/LLB-TL[\uD83D\uD83Dx-\uDCA9\uD83D]/u
;
/LLB-TT[\uD83D\uD83Dx-\uDCA9\uDCA9]/u
;
/LLB-TB[\uD83D\uD83Dx-\uDCA9x]/u
;
/LLB-TBB[\uD83D\uD83Dx-\uDCA9xx]/u
;
/LLB-TBL[\uD83D\uD83Dx-\uDCA9x\uD83D]/u
;
/LLB-TBT[\uD83D\uD83Dx-\uDCA9x\uDCA9]/u
;
/LLB-TL[\uD83D\uD83Dx-\uDCA9\uD83D]/u
;
/LLB-TLB[\uD83D\uD83Dx-\uDCA9\uD83Dx]/u
;
/LLB-TLL[\uD83D\uD83Dx-\uDCA9\uD83D\uD83D]/u
;
/LLB-TLT[\uD83D\uD83Dx-\uDCA9\uD83D\uDCA9]/u
;
/LLB-TT[\uD83D\uD83Dx-\uDCA9\uDCA9]/u
;
/LLB-TTB[\uD83D\uD83Dx-\uDCA9\uDCA9x]/u
;
/LLB-TTL[\uD83D\uD83Dx-\uDCA9\uDCA9\uD83D]/u
;
/LLB-TTT[\uD83D\uD83Dx-\uDCA9\uDCA9\uDCA9]/u
;
/LLL-L[\uD83D\uD83D\uD83D-\uD83D]/u
;
/LLL-LB[\uD83D\uD83D\uD83D-\uD83Dx]/u
;
/LLL-LL[\uD83D\uD83D\uD83D-\uD83D\uD83D]/u
;
/LLL-LT[\uD83D\uD83D\uD83D-\uD83D\uDCA9]/u
;
/LLL-LB[\uD83D\uD83D\uD83D-\uD83Dx]/u
;
/LLL-LBB[\uD83D\uD83D\uD83D-\uD83Dxx]/u
;
/LLL-LBL[\uD83D\uD83D\uD83D-\uD83Dx\uD83D]/u
;
/LLL-LBT[\uD83D\uD83D\uD83D-\uD83Dx\uDCA9]/u
;
/LLL-LL[\uD83D\uD83D\uD83D-\uD83D\uD83D]/u
;
/LLL-LLB[\uD83D\uD83D\uD83D-\uD83D\uD83Dx]/u
;
/LLL-LLL[\uD83D\uD83D\uD83D-\uD83D\uD83D\uD83D]/u
;
/LLL-LLT[\uD83D\uD83D\uD83D-\uD83D\uD83D\uDCA9]/u
;
/LLL-LT[\uD83D\uD83D\uD83D-\uD83D\uDCA9]/u
;
/LLL-LTB[\uD83D\uD83D\uD83D-\uD83D\uDCA9x]/u
;
/LLL-LTL[\uD83D\uD83D\uD83D-\uD83D\uDCA9\uD83D]/u
;
/LLL-LTT[\uD83D\uD83D\uD83D-\uD83D\uDCA9\uDCA9]/u
;
/LLL-T[\uD83D\uD83D\uD83D-\uDCA9]/u
;
/LLL-TB[\uD83D\uD83D\uD83D-\uDCA9x]/u
;
/LLL-TL[\uD83D\uD83D\uD83D-\uDCA9\uD83D]/u
;
/LLL-TT[\uD83D\uD83D\uD83D-\uDCA9\uDCA9]/u
;
/LLL-TB[\uD83D\uD83D\uD83D-\uDCA9x]/u
;
/LLL-TBB[\uD83D\uD83D\uD83D-\uDCA9xx]/u
;
/LLL-TBL[\uD83D\uD83D\uD83D-\uDCA9x\uD83D]/u
;
/LLL-TBT[\uD83D\uD83D\uD83D-\uDCA9x\uDCA9]/u
;
/LLL-TL[\uD83D\uD83D\uD83D-\uDCA9\uD83D]/u
;
/LLL-TLB[\uD83D\uD83D\uD83D-\uDCA9\uD83Dx]/u
;
/LLL-TLL[\uD83D\uD83D\uD83D-\uDCA9\uD83D\uD83D]/u
;
/LLL-TLT[\uD83D\uD83D\uD83D-\uDCA9\uD83D\uDCA9]/u
;
/LLL-TT[\uD83D\uD83D\uD83D-\uDCA9\uDCA9]/u
;
/LLL-TTB[\uD83D\uD83D\uD83D-\uDCA9\uDCA9x]/u
;
/LLL-TTL[\uD83D\uD83D\uD83D-\uDCA9\uDCA9\uD83D]/u
;
/LLL-TTT[\uD83D\uD83D\uD83D-\uDCA9\uDCA9\uDCA9]/u
;
/LLT-LT[\uD83D\uD83D\uDCA9-\uD83D\uDCA9]/u
;
/LLT-LT[\uD83D\uD83D\uDCA9-\uD83D\uDCA9]/u
;
/LLT-LTB[\uD83D\uD83D\uDCA9-\uD83D\uDCA9x]/u
;
/LLT-LTL[\uD83D\uD83D\uDCA9-\uD83D\uDCA9\uD83D]/u
;
/LLT-LTT[\uD83D\uD83D\uDCA9-\uD83D\uDCA9\uDCA9]/u
;
/LTB-B[\uD83D\uDCA9x-x]/u
;
/LTB-BB[\uD83D\uDCA9x-xx]/u
;
/LTB-BL[\uD83D\uDCA9x-x\uD83D]/u
;
/LTB-BT[\uD83D\uDCA9x-x\uDCA9]/u
;
/LTB-BB[\uD83D\uDCA9x-xx]/u
;
/LTB-BBB[\uD83D\uDCA9x-xxx]/u
;
/LTB-BBL[\uD83D\uDCA9x-xx\uD83D]/u
;
/LTB-BBT[\uD83D\uDCA9x-xx\uDCA9]/u
;
/LTB-BL[\uD83D\uDCA9x-x\uD83D]/u
;
/LTB-BLB[\uD83D\uDCA9x-x\uD83Dx]/u
;
/LTB-BLL[\uD83D\uDCA9x-x\uD83D\uD83D]/u
;
/LTB-BLT[\uD83D\uDCA9x-x\uD83D\uDCA9]/u
;
/LTB-BT[\uD83D\uDCA9x-x\uDCA9]/u
;
/LTB-BTB[\uD83D\uDCA9x-x\uDCA9x]/u
;
/LTB-BTL[\uD83D\uDCA9x-x\uDCA9\uD83D]/u
;
/LTB-BTT[\uD83D\uDCA9x-x\uDCA9\uDCA9]/u
;
/LTB-L[\uD83D\uDCA9x-\uD83D]/u
;
/LTB-LB[\uD83D\uDCA9x-\uD83Dx]/u
;
/LTB-LL[\uD83D\uDCA9x-\uD83D\uD83D]/u
;
/LTB-LT[\uD83D\uDCA9x-\uD83D\uDCA9]/u
;
/LTB-LB[\uD83D\uDCA9x-\uD83Dx]/u
;
/LTB-LBB[\uD83D\uDCA9x-\uD83Dxx]/u
;
/LTB-LBL[\uD83D\uDCA9x-\uD83Dx\uD83D]/u
;
/LTB-LBT[\uD83D\uDCA9x-\uD83Dx\uDCA9]/u
;
/LTB-LL[\uD83D\uDCA9x-\uD83D\uD83D]/u
;
/LTB-LLB[\uD83D\uDCA9x-\uD83D\uD83Dx]/u
;
/LTB-LLL[\uD83D\uDCA9x-\uD83D\uD83D\uD83D]/u
;
/LTB-LLT[\uD83D\uDCA9x-\uD83D\uD83D\uDCA9]/u
;
/LTB-LT[\uD83D\uDCA9x-\uD83D\uDCA9]/u
;
/LTB-LTB[\uD83D\uDCA9x-\uD83D\uDCA9x]/u
;
/LTB-LTL[\uD83D\uDCA9x-\uD83D\uDCA9\uD83D]/u
;
/LTB-LTT[\uD83D\uDCA9x-\uD83D\uDCA9\uDCA9]/u
;
/LTB-T[\uD83D\uDCA9x-\uDCA9]/u
;
/LTB-TB[\uD83D\uDCA9x-\uDCA9x]/u
;
/LTB-TL[\uD83D\uDCA9x-\uDCA9\uD83D]/u
;
/LTB-TT[\uD83D\uDCA9x-\uDCA9\uDCA9]/u
;
/LTB-TB[\uD83D\uDCA9x-\uDCA9x]/u
;
/LTB-TBB[\uD83D\uDCA9x-\uDCA9xx]/u
;
/LTB-TBL[\uD83D\uDCA9x-\uDCA9x\uD83D]/u
;
/LTB-TBT[\uD83D\uDCA9x-\uDCA9x\uDCA9]/u
;
/LTB-TL[\uD83D\uDCA9x-\uDCA9\uD83D]/u
;
/LTB-TLB[\uD83D\uDCA9x-\uDCA9\uD83Dx]/u
;
/LTB-TLL[\uD83D\uDCA9x-\uDCA9\uD83D\uD83D]/u
;
/LTB-TLT[\uD83D\uDCA9x-\uDCA9\uD83D\uDCA9]/u
;
/LTB-TT[\uD83D\uDCA9x-\uDCA9\uDCA9]/u
;
/LTB-TTB[\uD83D\uDCA9x-\uDCA9\uDCA9x]/u
;
/LTB-TTL[\uD83D\uDCA9x-\uDCA9\uDCA9\uD83D]/u
;
/LTB-TTT[\uD83D\uDCA9x-\uDCA9\uDCA9\uDCA9]/u
;
/LTL-L[\uD83D\uDCA9\uD83D-\uD83D]/u
;
/LTL-LB[\uD83D\uDCA9\uD83D-\uD83Dx]/u
;
/LTL-LL[\uD83D\uDCA9\uD83D-\uD83D\uD83D]/u
;
/LTL-LT[\uD83D\uDCA9\uD83D-\uD83D\uDCA9]/u
;
/LTL-LB[\uD83D\uDCA9\uD83D-\uD83Dx]/u
;
/LTL-LBB[\uD83D\uDCA9\uD83D-\uD83Dxx]/u
;
/LTL-LBL[\uD83D\uDCA9\uD83D-\uD83Dx\uD83D]/u
;
/LTL-LBT[\uD83D\uDCA9\uD83D-\uD83Dx\uDCA9]/u
;
/LTL-LL[\uD83D\uDCA9\uD83D-\uD83D\uD83D]/u
;
/LTL-LLB[\uD83D\uDCA9\uD83D-\uD83D\uD83Dx]/u
;
/LTL-LLL[\uD83D\uDCA9\uD83D-\uD83D\uD83D\uD83D]/u
;
/LTL-LLT[\uD83D\uDCA9\uD83D-\uD83D\uD83D\uDCA9]/u
;
/LTL-LT[\uD83D\uDCA9\uD83D-\uD83D\uDCA9]/u
;
/LTL-LTB[\uD83D\uDCA9\uD83D-\uD83D\uDCA9x]/u
;
/LTL-LTL[\uD83D\uDCA9\uD83D-\uD83D\uDCA9\uD83D]/u
;
/LTL-LTT[\uD83D\uDCA9\uD83D-\uD83D\uDCA9\uDCA9]/u
;
/LTL-T[\uD83D\uDCA9\uD83D-\uDCA9]/u
;
/LTL-TB[\uD83D\uDCA9\uD83D-\uDCA9x]/u
;
/LTL-TL[\uD83D\uDCA9\uD83D-\uDCA9\uD83D]/u
;
/LTL-TT[\uD83D\uDCA9\uD83D-\uDCA9\uDCA9]/u
;
/LTL-TB[\uD83D\uDCA9\uD83D-\uDCA9x]/u
;
/LTL-TBB[\uD83D\uDCA9\uD83D-\uDCA9xx]/u
;
/LTL-TBL[\uD83D\uDCA9\uD83D-\uDCA9x\uD83D]/u
;
/LTL-TBT[\uD83D\uDCA9\uD83D-\uDCA9x\uDCA9]/u
;
/LTL-TL[\uD83D\uDCA9\uD83D-\uDCA9\uD83D]/u
;
/LTL-TLB[\uD83D\uDCA9\uD83D-\uDCA9\uD83Dx]/u
;
/LTL-TLL[\uD83D\uDCA9\uD83D-\uDCA9\uD83D\uD83D]/u
;
/LTL-TLT[\uD83D\uDCA9\uD83D-\uDCA9\uD83D\uDCA9]/u
;
/LTL-TT[\uD83D\uDCA9\uD83D-\uDCA9\uDCA9]/u
;
/LTL-TTB[\uD83D\uDCA9\uD83D-\uDCA9\uDCA9x]/u
;
/LTL-TTL[\uD83D\uDCA9\uD83D-\uDCA9\uDCA9\uD83D]/u
;
/LTL-TTT[\uD83D\uDCA9\uD83D-\uDCA9\uDCA9\uDCA9]/u
;
/LTT-LT[\uD83D\uDCA9\uDCA9-\uD83D\uDCA9]/u
;
/LTT-LT[\uD83D\uDCA9\uDCA9-\uD83D\uDCA9]/u
;
/LTT-LTB[\uD83D\uDCA9\uDCA9-\uD83D\uDCA9x]/u
;
/LTT-LTL[\uD83D\uDCA9\uDCA9-\uD83D\uDCA9\uD83D]/u
;
/LTT-LTT[\uD83D\uDCA9\uDCA9-\uD83D\uDCA9\uDCA9]/u
;
/LTT-T[\uD83D\uDCA9\uDCA9-\uDCA9]/u
;
/LTT-TB[\uD83D\uDCA9\uDCA9-\uDCA9x]/u
;
/LTT-TL[\uD83D\uDCA9\uDCA9-\uDCA9\uD83D]/u
;
/LTT-TT[\uD83D\uDCA9\uDCA9-\uDCA9\uDCA9]/u
;
/LTT-TB[\uD83D\uDCA9\uDCA9-\uDCA9x]/u
;
/LTT-TBB[\uD83D\uDCA9\uDCA9-\uDCA9xx]/u
;
/LTT-TBL[\uD83D\uDCA9\uDCA9-\uDCA9x\uD83D]/u
;
/LTT-TBT[\uD83D\uDCA9\uDCA9-\uDCA9x\uDCA9]/u
;
/LTT-TL[\uD83D\uDCA9\uDCA9-\uDCA9\uD83D]/u
;
/LTT-TLB[\uD83D\uDCA9\uDCA9-\uDCA9\uD83Dx]/u
;
/LTT-TLL[\uD83D\uDCA9\uDCA9-\uDCA9\uD83D\uD83D]/u
;
/LTT-TLT[\uD83D\uDCA9\uDCA9-\uDCA9\uD83D\uDCA9]/u
;
/LTT-TT[\uD83D\uDCA9\uDCA9-\uDCA9\uDCA9]/u
;
/LTT-TTB[\uD83D\uDCA9\uDCA9-\uDCA9\uDCA9x]/u
;
/LTT-TTL[\uD83D\uDCA9\uDCA9-\uDCA9\uDCA9\uD83D]/u
;
/LTT-TTT[\uD83D\uDCA9\uDCA9-\uDCA9\uDCA9\uDCA9]/u
;
/TB-B[\uDCA9x-x]/u
;
/TB-BB[\uDCA9x-xx]/u
;
/TB-BL[\uDCA9x-x\uD83D]/u
;
/TB-BT[\uDCA9x-x\uDCA9]/u
;
/TB-BB[\uDCA9x-xx]/u
;
/TB-BBB[\uDCA9x-xxx]/u
;
/TB-BBL[\uDCA9x-xx\uD83D]/u
;
/TB-BBT[\uDCA9x-xx\uDCA9]/u
;
/TB-BL[\uDCA9x-x\uD83D]/u
;
/TB-BLB[\uDCA9x-x\uD83Dx]/u
;
/TB-BLL[\uDCA9x-x\uD83D\uD83D]/u
;
/TB-BLT[\uDCA9x-x\uD83D\uDCA9]/u
;
/TB-BT[\uDCA9x-x\uDCA9]/u
;
/TB-BTB[\uDCA9x-x\uDCA9x]/u
;
/TB-BTL[\uDCA9x-x\uDCA9\uD83D]/u
;
/TB-BTT[\uDCA9x-x\uDCA9\uDCA9]/u
;
/TB-L[\uDCA9x-\uD83D]/u
;
/TB-LB[\uDCA9x-\uD83Dx]/u
;
/TB-LL[\uDCA9x-\uD83D\uD83D]/u
;
/TB-LT[\uDCA9x-\uD83D\uDCA9]/u
;
/TB-LB[\uDCA9x-\uD83Dx]/u
;
/TB-LBB[\uDCA9x-\uD83Dxx]/u
;
/TB-LBL[\uDCA9x-\uD83Dx\uD83D]/u
;
/TB-LBT[\uDCA9x-\uD83Dx\uDCA9]/u
;
/TB-LL[\uDCA9x-\uD83D\uD83D]/u
;
/TB-LLB[\uDCA9x-\uD83D\uD83Dx]/u
;
/TB-LLL[\uDCA9x-\uD83D\uD83D\uD83D]/u
;
/TB-LLT[\uDCA9x-\uD83D\uD83D\uDCA9]/u
;
/TB-LT[\uDCA9x-\uD83D\uDCA9]/u
;
/TB-LTB[\uDCA9x-\uD83D\uDCA9x]/u
;
/TB-LTL[\uDCA9x-\uD83D\uDCA9\uD83D]/u
;
/TB-LTT[\uDCA9x-\uD83D\uDCA9\uDCA9]/u
;
/TB-T[\uDCA9x-\uDCA9]/u
;
/TB-TB[\uDCA9x-\uDCA9x]/u
;
/TB-TL[\uDCA9x-\uDCA9\uD83D]/u
;
/TB-TT[\uDCA9x-\uDCA9\uDCA9]/u
;
/TB-TB[\uDCA9x-\uDCA9x]/u
;
/TB-TBB[\uDCA9x-\uDCA9xx]/u
;
/TB-TBL[\uDCA9x-\uDCA9x\uD83D]/u
;
/TB-TBT[\uDCA9x-\uDCA9x\uDCA9]/u
;
/TB-TL[\uDCA9x-\uDCA9\uD83D]/u
;
/TB-TLB[\uDCA9x-\uDCA9\uD83Dx]/u
;
/TB-TLL[\uDCA9x-\uDCA9\uD83D\uD83D]/u
;
/TB-TLT[\uDCA9x-\uDCA9\uD83D\uDCA9]/u
;
/TB-TT[\uDCA9x-\uDCA9\uDCA9]/u
;
/TB-TTB[\uDCA9x-\uDCA9\uDCA9x]/u
;
/TB-TTL[\uDCA9x-\uDCA9\uDCA9\uD83D]/u
;
/TB-TTT[\uDCA9x-\uDCA9\uDCA9\uDCA9]/u
;
/TL-L[\uDCA9\uD83D-\uD83D]/u
;
/TL-LB[\uDCA9\uD83D-\uD83Dx]/u
;
/TL-LL[\uDCA9\uD83D-\uD83D\uD83D]/u
;
/TL-LT[\uDCA9\uD83D-\uD83D\uDCA9]/u
;
/TL-LB[\uDCA9\uD83D-\uD83Dx]/u
;
/TL-LBB[\uDCA9\uD83D-\uD83Dxx]/u
;
/TL-LBL[\uDCA9\uD83D-\uD83Dx\uD83D]/u
;
/TL-LBT[\uDCA9\uD83D-\uD83Dx\uDCA9]/u
;
/TL-LL[\uDCA9\uD83D-\uD83D\uD83D]/u
;
/TL-LLB[\uDCA9\uD83D-\uD83D\uD83Dx]/u
;
/TL-LLL[\uDCA9\uD83D-\uD83D\uD83D\uD83D]/u
;
/TL-LLT[\uDCA9\uD83D-\uD83D\uD83D\uDCA9]/u
;
/TL-LT[\uDCA9\uD83D-\uD83D\uDCA9]/u
;
/TL-LTB[\uDCA9\uD83D-\uD83D\uDCA9x]/u
;
/TL-LTL[\uDCA9\uD83D-\uD83D\uDCA9\uD83D]/u
;
/TL-LTT[\uDCA9\uD83D-\uD83D\uDCA9\uDCA9]/u
;
/TL-T[\uDCA9\uD83D-\uDCA9]/u
;
/TL-TB[\uDCA9\uD83D-\uDCA9x]/u
;
/TL-TL[\uDCA9\uD83D-\uDCA9\uD83D]/u
;
/TL-TT[\uDCA9\uD83D-\uDCA9\uDCA9]/u
;
/TL-TB[\uDCA9\uD83D-\uDCA9x]/u
;
/TL-TBB[\uDCA9\uD83D-\uDCA9xx]/u
;
/TL-TBL[\uDCA9\uD83D-\uDCA9x\uD83D]/u
;
/TL-TBT[\uDCA9\uD83D-\uDCA9x\uDCA9]/u
;
/TL-TL[\uDCA9\uD83D-\uDCA9\uD83D]/u
;
/TL-TLB[\uDCA9\uD83D-\uDCA9\uD83Dx]/u
;
/TL-TLL[\uDCA9\uD83D-\uDCA9\uD83D\uD83D]/u
;
/TL-TLT[\uDCA9\uD83D-\uDCA9\uD83D\uDCA9]/u
;
/TL-TT[\uDCA9\uD83D-\uDCA9\uDCA9]/u
;
/TL-TTB[\uDCA9\uD83D-\uDCA9\uDCA9x]/u
;
/TL-TTL[\uDCA9\uD83D-\uDCA9\uDCA9\uD83D]/u
;
/TL-TTT[\uDCA9\uD83D-\uDCA9\uDCA9\uDCA9]/u
;
/TT-LT[\uDCA9\uDCA9-\uD83D\uDCA9]/u
;
/TT-LT[\uDCA9\uDCA9-\uD83D\uDCA9]/u
;
/TT-LTB[\uDCA9\uDCA9-\uD83D\uDCA9x]/u
;
/TT-LTL[\uDCA9\uDCA9-\uD83D\uDCA9\uD83D]/u
;
/TT-LTT[\uDCA9\uDCA9-\uD83D\uDCA9\uDCA9]/u
;
/TT-T[\uDCA9\uDCA9-\uDCA9]/u
;
/TT-TB[\uDCA9\uDCA9-\uDCA9x]/u
;
/TT-TL[\uDCA9\uDCA9-\uDCA9\uD83D]/u
;
/TT-TT[\uDCA9\uDCA9-\uDCA9\uDCA9]/u
;
/TT-TB[\uDCA9\uDCA9-\uDCA9x]/u
;
/TT-TBB[\uDCA9\uDCA9-\uDCA9xx]/u
;
/TT-TBL[\uDCA9\uDCA9-\uDCA9x\uD83D]/u
;
/TT-TBT[\uDCA9\uDCA9-\uDCA9x\uDCA9]/u
;
/TT-TL[\uDCA9\uDCA9-\uDCA9\uD83D]/u
;
/TT-TLB[\uDCA9\uDCA9-\uDCA9\uD83Dx]/u
;
/TT-TLL[\uDCA9\uDCA9-\uDCA9\uD83D\uD83D]/u
;
/TT-TLT[\uDCA9\uDCA9-\uDCA9\uD83D\uDCA9]/u
;
/TT-TT[\uDCA9\uDCA9-\uDCA9\uDCA9]/u
;
/TT-TTB[\uDCA9\uDCA9-\uDCA9\uDCA9x]/u
;
/TT-TTL[\uDCA9\uDCA9-\uDCA9\uDCA9\uD83D]/u
;
/TT-TTT[\uDCA9\uDCA9-\uDCA9\uDCA9\uDCA9]/u
;
/TBB-B[\uDCA9xx-x]/u
;
/TBB-BB[\uDCA9xx-xx]/u
;
/TBB-BL[\uDCA9xx-x\uD83D]/u
;
/TBB-BT[\uDCA9xx-x\uDCA9]/u
;
/TBB-BB[\uDCA9xx-xx]/u
;
/TBB-BBB[\uDCA9xx-xxx]/u
;
/TBB-BBL[\uDCA9xx-xx\uD83D]/u
;
/TBB-BBT[\uDCA9xx-xx\uDCA9]/u
;
/TBB-BL[\uDCA9xx-x\uD83D]/u
;
/TBB-BLB[\uDCA9xx-x\uD83Dx]/u
;
/TBB-BLL[\uDCA9xx-x\uD83D\uD83D]/u
;
/TBB-BLT[\uDCA9xx-x\uD83D\uDCA9]/u
;
/TBB-BT[\uDCA9xx-x\uDCA9]/u
;
/TBB-BTB[\uDCA9xx-x\uDCA9x]/u
;
/TBB-BTL[\uDCA9xx-x\uDCA9\uD83D]/u
;
/TBB-BTT[\uDCA9xx-x\uDCA9\uDCA9]/u
;
/TBB-L[\uDCA9xx-\uD83D]/u
;
/TBB-LB[\uDCA9xx-\uD83Dx]/u
;
/TBB-LL[\uDCA9xx-\uD83D\uD83D]/u
;
/TBB-LT[\uDCA9xx-\uD83D\uDCA9]/u
;
/TBB-LB[\uDCA9xx-\uD83Dx]/u
;
/TBB-LBB[\uDCA9xx-\uD83Dxx]/u
;
/TBB-LBL[\uDCA9xx-\uD83Dx\uD83D]/u
;
/TBB-LBT[\uDCA9xx-\uD83Dx\uDCA9]/u
;
/TBB-LL[\uDCA9xx-\uD83D\uD83D]/u
;
/TBB-LLB[\uDCA9xx-\uD83D\uD83Dx]/u
;
/TBB-LLL[\uDCA9xx-\uD83D\uD83D\uD83D]/u
;
/TBB-LLT[\uDCA9xx-\uD83D\uD83D\uDCA9]/u
;
/TBB-LT[\uDCA9xx-\uD83D\uDCA9]/u
;
/TBB-LTB[\uDCA9xx-\uD83D\uDCA9x]/u
;
/TBB-LTL[\uDCA9xx-\uD83D\uDCA9\uD83D]/u
;
/TBB-LTT[\uDCA9xx-\uD83D\uDCA9\uDCA9]/u
;
/TBB-T[\uDCA9xx-\uDCA9]/u
;
/TBB-TB[\uDCA9xx-\uDCA9x]/u
;
/TBB-TL[\uDCA9xx-\uDCA9\uD83D]/u
;
/TBB-TT[\uDCA9xx-\uDCA9\uDCA9]/u
;
/TBB-TB[\uDCA9xx-\uDCA9x]/u
;
/TBB-TBB[\uDCA9xx-\uDCA9xx]/u
;
/TBB-TBL[\uDCA9xx-\uDCA9x\uD83D]/u
;
/TBB-TBT[\uDCA9xx-\uDCA9x\uDCA9]/u
;
/TBB-TL[\uDCA9xx-\uDCA9\uD83D]/u
;
/TBB-TLB[\uDCA9xx-\uDCA9\uD83Dx]/u
;
/TBB-TLL[\uDCA9xx-\uDCA9\uD83D\uD83D]/u
;
/TBB-TLT[\uDCA9xx-\uDCA9\uD83D\uDCA9]/u
;
/TBB-TT[\uDCA9xx-\uDCA9\uDCA9]/u
;
/TBB-TTB[\uDCA9xx-\uDCA9\uDCA9x]/u
;
/TBB-TTL[\uDCA9xx-\uDCA9\uDCA9\uD83D]/u
;
/TBB-TTT[\uDCA9xx-\uDCA9\uDCA9\uDCA9]/u
;
/TBL-L[\uDCA9x\uD83D-\uD83D]/u
;
/TBL-LB[\uDCA9x\uD83D-\uD83Dx]/u
;
/TBL-LL[\uDCA9x\uD83D-\uD83D\uD83D]/u
;
/TBL-LT[\uDCA9x\uD83D-\uD83D\uDCA9]/u
;
/TBL-LB[\uDCA9x\uD83D-\uD83Dx]/u
;
/TBL-LBB[\uDCA9x\uD83D-\uD83Dxx]/u
;
/TBL-LBL[\uDCA9x\uD83D-\uD83Dx\uD83D]/u
;
/TBL-LBT[\uDCA9x\uD83D-\uD83Dx\uDCA9]/u
;
/TBL-LL[\uDCA9x\uD83D-\uD83D\uD83D]/u
;
/TBL-LLB[\uDCA9x\uD83D-\uD83D\uD83Dx]/u
;
/TBL-LLL[\uDCA9x\uD83D-\uD83D\uD83D\uD83D]/u
;
/TBL-LLT[\uDCA9x\uD83D-\uD83D\uD83D\uDCA9]/u
;
/TBL-LT[\uDCA9x\uD83D-\uD83D\uDCA9]/u
;
/TBL-LTB[\uDCA9x\uD83D-\uD83D\uDCA9x]/u
;
/TBL-LTL[\uDCA9x\uD83D-\uD83D\uDCA9\uD83D]/u
;
/TBL-LTT[\uDCA9x\uD83D-\uD83D\uDCA9\uDCA9]/u
;
/TBL-T[\uDCA9x\uD83D-\uDCA9]/u
;
/TBL-TB[\uDCA9x\uD83D-\uDCA9x]/u
;
/TBL-TL[\uDCA9x\uD83D-\uDCA9\uD83D]/u
;
/TBL-TT[\uDCA9x\uD83D-\uDCA9\uDCA9]/u
;
/TBL-TB[\uDCA9x\uD83D-\uDCA9x]/u
;
/TBL-TBB[\uDCA9x\uD83D-\uDCA9xx]/u
;
/TBL-TBL[\uDCA9x\uD83D-\uDCA9x\uD83D]/u
;
/TBL-TBT[\uDCA9x\uD83D-\uDCA9x\uDCA9]/u
;
/TBL-TL[\uDCA9x\uD83D-\uDCA9\uD83D]/u
;
/TBL-TLB[\uDCA9x\uD83D-\uDCA9\uD83Dx]/u
;
/TBL-TLL[\uDCA9x\uD83D-\uDCA9\uD83D\uD83D]/u
;
/TBL-TLT[\uDCA9x\uD83D-\uDCA9\uD83D\uDCA9]/u
;
/TBL-TT[\uDCA9x\uD83D-\uDCA9\uDCA9]/u
;
/TBL-TTB[\uDCA9x\uD83D-\uDCA9\uDCA9x]/u
;
/TBL-TTL[\uDCA9x\uD83D-\uDCA9\uDCA9\uD83D]/u
;
/TBL-TTT[\uDCA9x\uD83D-\uDCA9\uDCA9\uDCA9]/u
;
/TBT-LT[\uDCA9x\uDCA9-\uD83D\uDCA9]/u
;
/TBT-LT[\uDCA9x\uDCA9-\uD83D\uDCA9]/u
;
/TBT-LTB[\uDCA9x\uDCA9-\uD83D\uDCA9x]/u
;
/TBT-LTL[\uDCA9x\uDCA9-\uD83D\uDCA9\uD83D]/u
;
/TBT-LTT[\uDCA9x\uDCA9-\uD83D\uDCA9\uDCA9]/u
;
/TBT-T[\uDCA9x\uDCA9-\uDCA9]/u
;
/TBT-TB[\uDCA9x\uDCA9-\uDCA9x]/u
;
/TBT-TL[\uDCA9x\uDCA9-\uDCA9\uD83D]/u
;
/TBT-TT[\uDCA9x\uDCA9-\uDCA9\uDCA9]/u
;
/TBT-TB[\uDCA9x\uDCA9-\uDCA9x]/u
;
/TBT-TBB[\uDCA9x\uDCA9-\uDCA9xx]/u
;
/TBT-TBL[\uDCA9x\uDCA9-\uDCA9x\uD83D]/u
;
/TBT-TBT[\uDCA9x\uDCA9-\uDCA9x\uDCA9]/u
;
/TBT-TL[\uDCA9x\uDCA9-\uDCA9\uD83D]/u
;
/TBT-TLB[\uDCA9x\uDCA9-\uDCA9\uD83Dx]/u
;
/TBT-TLL[\uDCA9x\uDCA9-\uDCA9\uD83D\uD83D]/u
;
/TBT-TLT[\uDCA9x\uDCA9-\uDCA9\uD83D\uDCA9]/u
;
/TBT-TT[\uDCA9x\uDCA9-\uDCA9\uDCA9]/u
;
/TBT-TTB[\uDCA9x\uDCA9-\uDCA9\uDCA9x]/u
;
/TBT-TTL[\uDCA9x\uDCA9-\uDCA9\uDCA9\uD83D]/u
;
/TBT-TTT[\uDCA9x\uDCA9-\uDCA9\uDCA9\uDCA9]/u
;
/TLB-B[\uDCA9\uD83Dx-x]/u
;
/TLB-BB[\uDCA9\uD83Dx-xx]/u
;
/TLB-BL[\uDCA9\uD83Dx-x\uD83D]/u
;
/TLB-BT[\uDCA9\uD83Dx-x\uDCA9]/u
;
/TLB-BB[\uDCA9\uD83Dx-xx]/u
;
/TLB-BBB[\uDCA9\uD83Dx-xxx]/u
;
/TLB-BBL[\uDCA9\uD83Dx-xx\uD83D]/u
;
/TLB-BBT[\uDCA9\uD83Dx-xx\uDCA9]/u
;
/TLB-BL[\uDCA9\uD83Dx-x\uD83D]/u
;
/TLB-BLB[\uDCA9\uD83Dx-x\uD83Dx]/u
;
/TLB-BLL[\uDCA9\uD83Dx-x\uD83D\uD83D]/u
;
/TLB-BLT[\uDCA9\uD83Dx-x\uD83D\uDCA9]/u
;
/TLB-BT[\uDCA9\uD83Dx-x\uDCA9]/u
;
/TLB-BTB[\uDCA9\uD83Dx-x\uDCA9x]/u
;
/TLB-BTL[\uDCA9\uD83Dx-x\uDCA9\uD83D]/u
;
/TLB-BTT[\uDCA9\uD83Dx-x\uDCA9\uDCA9]/u
;
/TLB-L[\uDCA9\uD83Dx-\uD83D]/u
;
/TLB-LB[\uDCA9\uD83Dx-\uD83Dx]/u
;
/TLB-LL[\uDCA9\uD83Dx-\uD83D\uD83D]/u
;
/TLB-LT[\uDCA9\uD83Dx-\uD83D\uDCA9]/u
;
/TLB-LB[\uDCA9\uD83Dx-\uD83Dx]/u
;
/TLB-LBB[\uDCA9\uD83Dx-\uD83Dxx]/u
;
/TLB-LBL[\uDCA9\uD83Dx-\uD83Dx\uD83D]/u
;
/TLB-LBT[\uDCA9\uD83Dx-\uD83Dx\uDCA9]/u
;
/TLB-LL[\uDCA9\uD83Dx-\uD83D\uD83D]/u
;
/TLB-LLB[\uDCA9\uD83Dx-\uD83D\uD83Dx]/u
;
/TLB-LLL[\uDCA9\uD83Dx-\uD83D\uD83D\uD83D]/u
;
/TLB-LLT[\uDCA9\uD83Dx-\uD83D\uD83D\uDCA9]/u
;
/TLB-LT[\uDCA9\uD83Dx-\uD83D\uDCA9]/u
;
/TLB-LTB[\uDCA9\uD83Dx-\uD83D\uDCA9x]/u
;
/TLB-LTL[\uDCA9\uD83Dx-\uD83D\uDCA9\uD83D]/u
;
/TLB-LTT[\uDCA9\uD83Dx-\uD83D\uDCA9\uDCA9]/u
;
/TLB-T[\uDCA9\uD83Dx-\uDCA9]/u
;
/TLB-TB[\uDCA9\uD83Dx-\uDCA9x]/u
;
/TLB-TL[\uDCA9\uD83Dx-\uDCA9\uD83D]/u
;
/TLB-TT[\uDCA9\uD83Dx-\uDCA9\uDCA9]/u
;
/TLB-TB[\uDCA9\uD83Dx-\uDCA9x]/u
;
/TLB-TBB[\uDCA9\uD83Dx-\uDCA9xx]/u
;
/TLB-TBL[\uDCA9\uD83Dx-\uDCA9x\uD83D]/u
;
/TLB-TBT[\uDCA9\uD83Dx-\uDCA9x\uDCA9]/u
;
/TLB-TL[\uDCA9\uD83Dx-\uDCA9\uD83D]/u
;
/TLB-TLB[\uDCA9\uD83Dx-\uDCA9\uD83Dx]/u
;
/TLB-TLL[\uDCA9\uD83Dx-\uDCA9\uD83D\uD83D]/u
;
/TLB-TLT[\uDCA9\uD83Dx-\uDCA9\uD83D\uDCA9]/u
;
/TLB-TT[\uDCA9\uD83Dx-\uDCA9\uDCA9]/u
;
/TLB-TTB[\uDCA9\uD83Dx-\uDCA9\uDCA9x]/u
;
/TLB-TTL[\uDCA9\uD83Dx-\uDCA9\uDCA9\uD83D]/u
;
/TLB-TTT[\uDCA9\uD83Dx-\uDCA9\uDCA9\uDCA9]/u
;
/TLL-L[\uDCA9\uD83D\uD83D-\uD83D]/u
;
/TLL-LB[\uDCA9\uD83D\uD83D-\uD83Dx]/u
;
/TLL-LL[\uDCA9\uD83D\uD83D-\uD83D\uD83D]/u
;
/TLL-LT[\uDCA9\uD83D\uD83D-\uD83D\uDCA9]/u
;
/TLL-LB[\uDCA9\uD83D\uD83D-\uD83Dx]/u
;
/TLL-LBB[\uDCA9\uD83D\uD83D-\uD83Dxx]/u
;
/TLL-LBL[\uDCA9\uD83D\uD83D-\uD83Dx\uD83D]/u
;
/TLL-LBT[\uDCA9\uD83D\uD83D-\uD83Dx\uDCA9]/u
;
/TLL-LL[\uDCA9\uD83D\uD83D-\uD83D\uD83D]/u
;
/TLL-LLB[\uDCA9\uD83D\uD83D-\uD83D\uD83Dx]/u
;
/TLL-LLL[\uDCA9\uD83D\uD83D-\uD83D\uD83D\uD83D]/u
;
/TLL-LLT[\uDCA9\uD83D\uD83D-\uD83D\uD83D\uDCA9]/u
;
/TLL-LT[\uDCA9\uD83D\uD83D-\uD83D\uDCA9]/u
;
/TLL-LTB[\uDCA9\uD83D\uD83D-\uD83D\uDCA9x]/u
;
/TLL-LTL[\uDCA9\uD83D\uD83D-\uD83D\uDCA9\uD83D]/u
;
/TLL-LTT[\uDCA9\uD83D\uD83D-\uD83D\uDCA9\uDCA9]/u
;
/TLL-T[\uDCA9\uD83D\uD83D-\uDCA9]/u
;
/TLL-TB[\uDCA9\uD83D\uD83D-\uDCA9x]/u
;
/TLL-TL[\uDCA9\uD83D\uD83D-\uDCA9\uD83D]/u
;
/TLL-TT[\uDCA9\uD83D\uD83D-\uDCA9\uDCA9]/u
;
/TLL-TB[\uDCA9\uD83D\uD83D-\uDCA9x]/u
;
/TLL-TBB[\uDCA9\uD83D\uD83D-\uDCA9xx]/u
;
/TLL-TBL[\uDCA9\uD83D\uD83D-\uDCA9x\uD83D]/u
;
/TLL-TBT[\uDCA9\uD83D\uD83D-\uDCA9x\uDCA9]/u
;
/TLL-TL[\uDCA9\uD83D\uD83D-\uDCA9\uD83D]/u
;
/TLL-TLB[\uDCA9\uD83D\uD83D-\uDCA9\uD83Dx]/u
;
/TLL-TLL[\uDCA9\uD83D\uD83D-\uDCA9\uD83D\uD83D]/u
;
/TLL-TLT[\uDCA9\uD83D\uD83D-\uDCA9\uD83D\uDCA9]/u
;
/TLL-TT[\uDCA9\uD83D\uD83D-\uDCA9\uDCA9]/u
;
/TLL-TTB[\uDCA9\uD83D\uD83D-\uDCA9\uDCA9x]/u
;
/TLL-TTL[\uDCA9\uD83D\uD83D-\uDCA9\uDCA9\uD83D]/u
;
/TLL-TTT[\uDCA9\uD83D\uD83D-\uDCA9\uDCA9\uDCA9]/u
;
/TLT-LT[\uDCA9\uD83D\uDCA9-\uD83D\uDCA9]/u
;
/TLT-LT[\uDCA9\uD83D\uDCA9-\uD83D\uDCA9]/u
;
/TLT-LTB[\uDCA9\uD83D\uDCA9-\uD83D\uDCA9x]/u
;
/TLT-LTL[\uDCA9\uD83D\uDCA9-\uD83D\uDCA9\uD83D]/u
;
/TLT-LTT[\uDCA9\uD83D\uDCA9-\uD83D\uDCA9\uDCA9]/u
;
/TTB-B[\uDCA9\uDCA9x-x]/u
;
/TTB-BB[\uDCA9\uDCA9x-xx]/u
;
/TTB-BL[\uDCA9\uDCA9x-x\uD83D]/u
;
/TTB-BT[\uDCA9\uDCA9x-x\uDCA9]/u
;
/TTB-BB[\uDCA9\uDCA9x-xx]/u
;
/TTB-BBB[\uDCA9\uDCA9x-xxx]/u
;
/TTB-BBL[\uDCA9\uDCA9x-xx\uD83D]/u
;
/TTB-BBT[\uDCA9\uDCA9x-xx\uDCA9]/u
;
/TTB-BL[\uDCA9\uDCA9x-x\uD83D]/u
;
/TTB-BLB[\uDCA9\uDCA9x-x\uD83Dx]/u
;
/TTB-BLL[\uDCA9\uDCA9x-x\uD83D\uD83D]/u
;
/TTB-BLT[\uDCA9\uDCA9x-x\uD83D\uDCA9]/u
;
/TTB-BT[\uDCA9\uDCA9x-x\uDCA9]/u
;
/TTB-BTB[\uDCA9\uDCA9x-x\uDCA9x]/u
;
/TTB-BTL[\uDCA9\uDCA9x-x\uDCA9\uD83D]/u
;
/TTB-BTT[\uDCA9\uDCA9x-x\uDCA9\uDCA9]/u
;
/TTB-L[\uDCA9\uDCA9x-\uD83D]/u
;
/TTB-LB[\uDCA9\uDCA9x-\uD83Dx]/u
;
/TTB-LL[\uDCA9\uDCA9x-\uD83D\uD83D]/u
;
/TTB-LT[\uDCA9\uDCA9x-\uD83D\uDCA9]/u
;
/TTB-LB[\uDCA9\uDCA9x-\uD83Dx]/u
;
/TTB-LBB[\uDCA9\uDCA9x-\uD83Dxx]/u
;
/TTB-LBL[\uDCA9\uDCA9x-\uD83Dx\uD83D]/u
;
/TTB-LBT[\uDCA9\uDCA9x-\uD83Dx\uDCA9]/u
;
/TTB-LL[\uDCA9\uDCA9x-\uD83D\uD83D]/u
;
/TTB-LLB[\uDCA9\uDCA9x-\uD83D\uD83Dx]/u
;
/TTB-LLL[\uDCA9\uDCA9x-\uD83D\uD83D\uD83D]/u
;
/TTB-LLT[\uDCA9\uDCA9x-\uD83D\uD83D\uDCA9]/u
;
/TTB-LT[\uDCA9\uDCA9x-\uD83D\uDCA9]/u
;
/TTB-LTB[\uDCA9\uDCA9x-\uD83D\uDCA9x]/u
;
/TTB-LTL[\uDCA9\uDCA9x-\uD83D\uDCA9\uD83D]/u
;
/TTB-LTT[\uDCA9\uDCA9x-\uD83D\uDCA9\uDCA9]/u
;
/TTB-T[\uDCA9\uDCA9x-\uDCA9]/u
;
/TTB-TB[\uDCA9\uDCA9x-\uDCA9x]/u
;
/TTB-TL[\uDCA9\uDCA9x-\uDCA9\uD83D]/u
;
/TTB-TT[\uDCA9\uDCA9x-\uDCA9\uDCA9]/u
;
/TTB-TB[\uDCA9\uDCA9x-\uDCA9x]/u
;
/TTB-TBB[\uDCA9\uDCA9x-\uDCA9xx]/u
;
/TTB-TBL[\uDCA9\uDCA9x-\uDCA9x\uD83D]/u
;
/TTB-TBT[\uDCA9\uDCA9x-\uDCA9x\uDCA9]/u
;
/TTB-TL[\uDCA9\uDCA9x-\uDCA9\uD83D]/u
;
/TTB-TLB[\uDCA9\uDCA9x-\uDCA9\uD83Dx]/u
;
/TTB-TLL[\uDCA9\uDCA9x-\uDCA9\uD83D\uD83D]/u
;
/TTB-TLT[\uDCA9\uDCA9x-\uDCA9\uD83D\uDCA9]/u
;
/TTB-TT[\uDCA9\uDCA9x-\uDCA9\uDCA9]/u
;
/TTB-TTB[\uDCA9\uDCA9x-\uDCA9\uDCA9x]/u
;
/TTB-TTL[\uDCA9\uDCA9x-\uDCA9\uDCA9\uD83D]/u
;
/TTB-TTT[\uDCA9\uDCA9x-\uDCA9\uDCA9\uDCA9]/u
;
/TTL-L[\uDCA9\uDCA9\uD83D-\uD83D]/u
;
/TTL-LB[\uDCA9\uDCA9\uD83D-\uD83Dx]/u
;
/TTL-LL[\uDCA9\uDCA9\uD83D-\uD83D\uD83D]/u
;
/TTL-LT[\uDCA9\uDCA9\uD83D-\uD83D\uDCA9]/u
;
/TTL-LB[\uDCA9\uDCA9\uD83D-\uD83Dx]/u
;
/TTL-LBB[\uDCA9\uDCA9\uD83D-\uD83Dxx]/u
;
/TTL-LBL[\uDCA9\uDCA9\uD83D-\uD83Dx\uD83D]/u
;
/TTL-LBT[\uDCA9\uDCA9\uD83D-\uD83Dx\uDCA9]/u
;
/TTL-LL[\uDCA9\uDCA9\uD83D-\uD83D\uD83D]/u
;
/TTL-LLB[\uDCA9\uDCA9\uD83D-\uD83D\uD83Dx]/u
;
/TTL-LLL[\uDCA9\uDCA9\uD83D-\uD83D\uD83D\uD83D]/u
;
/TTL-LLT[\uDCA9\uDCA9\uD83D-\uD83D\uD83D\uDCA9]/u
;
/TTL-LT[\uDCA9\uDCA9\uD83D-\uD83D\uDCA9]/u
;
/TTL-LTB[\uDCA9\uDCA9\uD83D-\uD83D\uDCA9x]/u
;
/TTL-LTL[\uDCA9\uDCA9\uD83D-\uD83D\uDCA9\uD83D]/u
;
/TTL-LTT[\uDCA9\uDCA9\uD83D-\uD83D\uDCA9\uDCA9]/u
;
/TTL-T[\uDCA9\uDCA9\uD83D-\uDCA9]/u
;
/TTL-TB[\uDCA9\uDCA9\uD83D-\uDCA9x]/u
;
/TTL-TL[\uDCA9\uDCA9\uD83D-\uDCA9\uD83D]/u
;
/TTL-TT[\uDCA9\uDCA9\uD83D-\uDCA9\uDCA9]/u
;
/TTL-TB[\uDCA9\uDCA9\uD83D-\uDCA9x]/u
;
/TTL-TBB[\uDCA9\uDCA9\uD83D-\uDCA9xx]/u
;
/TTL-TBL[\uDCA9\uDCA9\uD83D-\uDCA9x\uD83D]/u
;
/TTL-TBT[\uDCA9\uDCA9\uD83D-\uDCA9x\uDCA9]/u
;
/TTL-TL[\uDCA9\uDCA9\uD83D-\uDCA9\uD83D]/u
;
/TTL-TLB[\uDCA9\uDCA9\uD83D-\uDCA9\uD83Dx]/u
;
/TTL-TLL[\uDCA9\uDCA9\uD83D-\uDCA9\uD83D\uD83D]/u
;
/TTL-TLT[\uDCA9\uDCA9\uD83D-\uDCA9\uD83D\uDCA9]/u
;
/TTL-TT[\uDCA9\uDCA9\uD83D-\uDCA9\uDCA9]/u
;
/TTL-TTB[\uDCA9\uDCA9\uD83D-\uDCA9\uDCA9x]/u
;
/TTL-TTL[\uDCA9\uDCA9\uD83D-\uDCA9\uDCA9\uD83D]/u
;
/TTL-TTT[\uDCA9\uDCA9\uD83D-\uDCA9\uDCA9\uDCA9]/u
;
/TTT-LT[\uDCA9\uDCA9\uDCA9-\uD83D\uDCA9]/u
;
/TTT-LT[\uDCA9\uDCA9\uDCA9-\uD83D\uDCA9]/u
;
/TTT-LTB[\uDCA9\uDCA9\uDCA9-\uD83D\uDCA9x]/u
;
/TTT-LTL[\uDCA9\uDCA9\uDCA9-\uD83D\uDCA9\uD83D]/u
;
/TTT-LTT[\uDCA9\uDCA9\uDCA9-\uD83D\uDCA9\uDCA9]/u
;
/TTT-T[\uDCA9\uDCA9\uDCA9-\uDCA9]/u
;
/TTT-TB[\uDCA9\uDCA9\uDCA9-\uDCA9x]/u
;
/TTT-TL[\uDCA9\uDCA9\uDCA9-\uDCA9\uD83D]/u
;
/TTT-TT[\uDCA9\uDCA9\uDCA9-\uDCA9\uDCA9]/u
;
/TTT-TB[\uDCA9\uDCA9\uDCA9-\uDCA9x]/u
;
/TTT-TBB[\uDCA9\uDCA9\uDCA9-\uDCA9xx]/u
;
/TTT-TBL[\uDCA9\uDCA9\uDCA9-\uDCA9x\uD83D]/u
;
/TTT-TBT[\uDCA9\uDCA9\uDCA9-\uDCA9x\uDCA9]/u
;
/TTT-TL[\uDCA9\uDCA9\uDCA9-\uDCA9\uD83D]/u
;
/TTT-TLB[\uDCA9\uDCA9\uDCA9-\uDCA9\uD83Dx]/u
;
/TTT-TLL[\uDCA9\uDCA9\uDCA9-\uDCA9\uD83D\uD83D]/u
;
/TTT-TLT[\uDCA9\uDCA9\uDCA9-\uDCA9\uD83D\uDCA9]/u
;
/TTT-TT[\uDCA9\uDCA9\uDCA9-\uDCA9\uDCA9]/u
;
/TTT-TTB[\uDCA9\uDCA9\uDCA9-\uDCA9\uDCA9x]/u
;
/TTT-TTL[\uDCA9\uDCA9\uDCA9-\uDCA9\uDCA9\uD83D]/u
;
/TTT-TTT[\uDCA9\uDCA9\uDCA9-\uDCA9\uDCA9\uDCA9]/u
`````

## Output

_Note: the whole output block is auto-generated. Manual changes will be overwritten!_

Below follow outputs in four parsing modes: sloppy mode, strict mode script goal, module goal, web compat mode (always sloppy).

Note that the output parts are auto-generated by the test runner to reflect actual result.

### Sloppy mode

Parsed with script goal and as if the code did not start with strict mode header.

`````
ast: {
  type: 'Program',
  loc:{start:{line:1,column:0},end:{line:3071,column:49},source:''},
  body: [
    {
      type: 'ExpressionStatement',
      loc:{start:{line:1,column:0},end:{line:2,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:1,column:0},end:{line:1,column:11},source:''},
        value: null,
        regex: { pattern: 'B-B[x-x]', flags: 'u' },
        raw: '/B-B[x-x]/u'
      }
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:3,column:0},end:{line:4,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:3,column:0},end:{line:3,column:13},source:''},
        value: null,
        regex: { pattern: 'B-BB[x-xx]', flags: 'u' },
        raw: '/B-BB[x-xx]/u'
      }
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:5,column:0},end:{line:6,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:5,column:0},end:{line:5,column:18},source:''},
        value: null,
        regex: { pattern: 'B-BL[x-x\\uD83D]', flags: 'u' },
        raw: '/B-BL[x-x\\uD83D]/u'
      }
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:7,column:0},end:{line:8,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:7,column:0},end:{line:7,column:18},source:''},
        value: null,
        regex: { pattern: 'B-BT[x-x\\uDCA9]', flags: 'u' },
        raw: '/B-BT[x-x\\uDCA9]/u'
      }
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:9,column:0},end:{line:10,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:9,column:0},end:{line:9,column:13},source:''},
        value: null,
        regex: { pattern: 'B-BB[x-xx]', flags: 'u' },
        raw: '/B-BB[x-xx]/u'
      }
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:11,column:0},end:{line:12,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:11,column:0},end:{line:11,column:15},source:''},
        value: null,
        regex: { pattern: 'B-BBB[x-xxx]', flags: 'u' },
        raw: '/B-BBB[x-xxx]/u'
      }
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:13,column:0},end:{line:14,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:13,column:0},end:{line:13,column:20},source:''},
        value: null,
        regex: { pattern: 'B-BBL[x-xx\\uD83D]', flags: 'u' },
        raw: '/B-BBL[x-xx\\uD83D]/u'
      }
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:15,column:0},end:{line:16,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:15,column:0},end:{line:15,column:20},source:''},
        value: null,
        regex: { pattern: 'B-BBT[x-xx\\uDCA9]', flags: 'u' },
        raw: '/B-BBT[x-xx\\uDCA9]/u'
      }
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:17,column:0},end:{line:18,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:17,column:0},end:{line:17,column:18},source:''},
        value: null,
        regex: { pattern: 'B-BL[x-x\\uD83D]', flags: 'u' },
        raw: '/B-BL[x-x\\uD83D]/u'
      }
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:19,column:0},end:{line:20,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:19,column:0},end:{line:19,column:20},source:''},
        value: null,
        regex: { pattern: 'B-BLB[x-x\\uD83Dx]', flags: 'u' },
        raw: '/B-BLB[x-x\\uD83Dx]/u'
      }
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:21,column:0},end:{line:22,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:21,column:0},end:{line:21,column:25},source:''},
        value: null,
        regex: { pattern: 'B-BLL[x-x\\uD83D\\uD83D]', flags: 'u' },
        raw: '/B-BLL[x-x\\uD83D\\uD83D]/u'
      }
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:23,column:0},end:{line:24,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:23,column:0},end:{line:23,column:25},source:''},
        value: null,
        regex: { pattern: 'B-BLT[x-x\\uD83D\\uDCA9]', flags: 'u' },
        raw: '/B-BLT[x-x\\uD83D\\uDCA9]/u'
      }
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:25,column:0},end:{line:26,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:25,column:0},end:{line:25,column:18},source:''},
        value: null,
        regex: { pattern: 'B-BT[x-x\\uDCA9]', flags: 'u' },
        raw: '/B-BT[x-x\\uDCA9]/u'
      }
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:27,column:0},end:{line:28,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:27,column:0},end:{line:27,column:20},source:''},
        value: null,
        regex: { pattern: 'B-BTB[x-x\\uDCA9x]', flags: 'u' },
        raw: '/B-BTB[x-x\\uDCA9x]/u'
      }
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:29,column:0},end:{line:30,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:29,column:0},end:{line:29,column:25},source:''},
        value: null,
        regex: { pattern: 'B-BTL[x-x\\uDCA9\\uD83D]', flags: 'u' },
        raw: '/B-BTL[x-x\\uDCA9\\uD83D]/u'
      }
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:31,column:0},end:{line:32,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:31,column:0},end:{line:31,column:25},source:''},
        value: null,
        regex: { pattern: 'B-BTT[x-x\\uDCA9\\uDCA9]', flags: 'u' },
        raw: '/B-BTT[x-x\\uDCA9\\uDCA9]/u'
      }
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:33,column:0},end:{line:34,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:33,column:0},end:{line:33,column:16},source:''},
        value: null,
        regex: { pattern: 'B-L[x-\\uD83D]', flags: 'u' },
        raw: '/B-L[x-\\uD83D]/u'
      }
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:35,column:0},end:{line:36,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:35,column:0},end:{line:35,column:18},source:''},
        value: null,
        regex: { pattern: 'B-LB[x-\\uD83Dx]', flags: 'u' },
        raw: '/B-LB[x-\\uD83Dx]/u'
      }
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:37,column:0},end:{line:38,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:37,column:0},end:{line:37,column:23},source:''},
        value: null,
        regex: { pattern: 'B-LL[x-\\uD83D\\uD83D]', flags: 'u' },
        raw: '/B-LL[x-\\uD83D\\uD83D]/u'
      }
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:39,column:0},end:{line:40,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:39,column:0},end:{line:39,column:23},source:''},
        value: null,
        regex: { pattern: 'B-LT[x-\\uD83D\\uDCA9]', flags: 'u' },
        raw: '/B-LT[x-\\uD83D\\uDCA9]/u'
      }
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:41,column:0},end:{line:42,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:41,column:0},end:{line:41,column:18},source:''},
        value: null,
        regex: { pattern: 'B-LB[x-\\uD83Dx]', flags: 'u' },
        raw: '/B-LB[x-\\uD83Dx]/u'
      }
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:43,column:0},end:{line:44,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:43,column:0},end:{line:43,column:20},source:''},
        value: null,
        regex: { pattern: 'B-LBB[x-\\uD83Dxx]', flags: 'u' },
        raw: '/B-LBB[x-\\uD83Dxx]/u'
      }
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:45,column:0},end:{line:46,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:45,column:0},end:{line:45,column:25},source:''},
        value: null,
        regex: { pattern: 'B-LBL[x-\\uD83Dx\\uD83D]', flags: 'u' },
        raw: '/B-LBL[x-\\uD83Dx\\uD83D]/u'
      }
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:47,column:0},end:{line:48,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:47,column:0},end:{line:47,column:25},source:''},
        value: null,
        regex: { pattern: 'B-LBT[x-\\uD83Dx\\uDCA9]', flags: 'u' },
        raw: '/B-LBT[x-\\uD83Dx\\uDCA9]/u'
      }
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:49,column:0},end:{line:50,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:49,column:0},end:{line:49,column:23},source:''},
        value: null,
        regex: { pattern: 'B-LL[x-\\uD83D\\uD83D]', flags: 'u' },
        raw: '/B-LL[x-\\uD83D\\uD83D]/u'
      }
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:51,column:0},end:{line:52,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:51,column:0},end:{line:51,column:25},source:''},
        value: null,
        regex: { pattern: 'B-LLB[x-\\uD83D\\uD83Dx]', flags: 'u' },
        raw: '/B-LLB[x-\\uD83D\\uD83Dx]/u'
      }
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:53,column:0},end:{line:54,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:53,column:0},end:{line:53,column:30},source:''},
        value: null,
        regex: { pattern: 'B-LLL[x-\\uD83D\\uD83D\\uD83D]', flags: 'u' },
        raw: '/B-LLL[x-\\uD83D\\uD83D\\uD83D]/u'
      }
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:55,column:0},end:{line:56,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:55,column:0},end:{line:55,column:30},source:''},
        value: null,
        regex: { pattern: 'B-LLT[x-\\uD83D\\uD83D\\uDCA9]', flags: 'u' },
        raw: '/B-LLT[x-\\uD83D\\uD83D\\uDCA9]/u'
      }
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:57,column:0},end:{line:58,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:57,column:0},end:{line:57,column:23},source:''},
        value: null,
        regex: { pattern: 'B-LT[x-\\uD83D\\uDCA9]', flags: 'u' },
        raw: '/B-LT[x-\\uD83D\\uDCA9]/u'
      }
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:59,column:0},end:{line:60,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:59,column:0},end:{line:59,column:25},source:''},
        value: null,
        regex: { pattern: 'B-LTB[x-\\uD83D\\uDCA9x]', flags: 'u' },
        raw: '/B-LTB[x-\\uD83D\\uDCA9x]/u'
      }
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:61,column:0},end:{line:62,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:61,column:0},end:{line:61,column:30},source:''},
        value: null,
        regex: { pattern: 'B-LTL[x-\\uD83D\\uDCA9\\uD83D]', flags: 'u' },
        raw: '/B-LTL[x-\\uD83D\\uDCA9\\uD83D]/u'
      }
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:63,column:0},end:{line:64,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:63,column:0},end:{line:63,column:30},source:''},
        value: null,
        regex: { pattern: 'B-LTT[x-\\uD83D\\uDCA9\\uDCA9]', flags: 'u' },
        raw: '/B-LTT[x-\\uD83D\\uDCA9\\uDCA9]/u'
      }
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:65,column:0},end:{line:66,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:65,column:0},end:{line:65,column:16},source:''},
        value: null,
        regex: { pattern: 'B-T[x-\\uDCA9]', flags: 'u' },
        raw: '/B-T[x-\\uDCA9]/u'
      }
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:67,column:0},end:{line:68,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:67,column:0},end:{line:67,column:18},source:''},
        value: null,
        regex: { pattern: 'B-TB[x-\\uDCA9x]', flags: 'u' },
        raw: '/B-TB[x-\\uDCA9x]/u'
      }
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:69,column:0},end:{line:70,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:69,column:0},end:{line:69,column:23},source:''},
        value: null,
        regex: { pattern: 'B-TL[x-\\uDCA9\\uD83D]', flags: 'u' },
        raw: '/B-TL[x-\\uDCA9\\uD83D]/u'
      }
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:71,column:0},end:{line:72,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:71,column:0},end:{line:71,column:23},source:''},
        value: null,
        regex: { pattern: 'B-TT[x-\\uDCA9\\uDCA9]', flags: 'u' },
        raw: '/B-TT[x-\\uDCA9\\uDCA9]/u'
      }
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:73,column:0},end:{line:74,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:73,column:0},end:{line:73,column:18},source:''},
        value: null,
        regex: { pattern: 'B-TB[x-\\uDCA9x]', flags: 'u' },
        raw: '/B-TB[x-\\uDCA9x]/u'
      }
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:75,column:0},end:{line:76,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:75,column:0},end:{line:75,column:20},source:''},
        value: null,
        regex: { pattern: 'B-TBB[x-\\uDCA9xx]', flags: 'u' },
        raw: '/B-TBB[x-\\uDCA9xx]/u'
      }
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:77,column:0},end:{line:78,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:77,column:0},end:{line:77,column:25},source:''},
        value: null,
        regex: { pattern: 'B-TBL[x-\\uDCA9x\\uD83D]', flags: 'u' },
        raw: '/B-TBL[x-\\uDCA9x\\uD83D]/u'
      }
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:79,column:0},end:{line:80,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:79,column:0},end:{line:79,column:25},source:''},
        value: null,
        regex: { pattern: 'B-TBT[x-\\uDCA9x\\uDCA9]', flags: 'u' },
        raw: '/B-TBT[x-\\uDCA9x\\uDCA9]/u'
      }
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:81,column:0},end:{line:82,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:81,column:0},end:{line:81,column:23},source:''},
        value: null,
        regex: { pattern: 'B-TL[x-\\uDCA9\\uD83D]', flags: 'u' },
        raw: '/B-TL[x-\\uDCA9\\uD83D]/u'
      }
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:83,column:0},end:{line:84,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:83,column:0},end:{line:83,column:25},source:''},
        value: null,
        regex: { pattern: 'B-TLB[x-\\uDCA9\\uD83Dx]', flags: 'u' },
        raw: '/B-TLB[x-\\uDCA9\\uD83Dx]/u'
      }
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:85,column:0},end:{line:86,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:85,column:0},end:{line:85,column:30},source:''},
        value: null,
        regex: { pattern: 'B-TLL[x-\\uDCA9\\uD83D\\uD83D]', flags: 'u' },
        raw: '/B-TLL[x-\\uDCA9\\uD83D\\uD83D]/u'
      }
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:87,column:0},end:{line:88,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:87,column:0},end:{line:87,column:30},source:''},
        value: null,
        regex: { pattern: 'B-TLT[x-\\uDCA9\\uD83D\\uDCA9]', flags: 'u' },
        raw: '/B-TLT[x-\\uDCA9\\uD83D\\uDCA9]/u'
      }
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:89,column:0},end:{line:90,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:89,column:0},end:{line:89,column:23},source:''},
        value: null,
        regex: { pattern: 'B-TT[x-\\uDCA9\\uDCA9]', flags: 'u' },
        raw: '/B-TT[x-\\uDCA9\\uDCA9]/u'
      }
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:91,column:0},end:{line:92,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:91,column:0},end:{line:91,column:25},source:''},
        value: null,
        regex: { pattern: 'B-TTB[x-\\uDCA9\\uDCA9x]', flags: 'u' },
        raw: '/B-TTB[x-\\uDCA9\\uDCA9x]/u'
      }
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:93,column:0},end:{line:94,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:93,column:0},end:{line:93,column:30},source:''},
        value: null,
        regex: { pattern: 'B-TTL[x-\\uDCA9\\uDCA9\\uD83D]', flags: 'u' },
        raw: '/B-TTL[x-\\uDCA9\\uDCA9\\uD83D]/u'
      }
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:95,column:0},end:{line:96,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:95,column:0},end:{line:95,column:30},source:''},
        value: null,
        regex: { pattern: 'B-TTT[x-\\uDCA9\\uDCA9\\uDCA9]', flags: 'u' },
        raw: '/B-TTT[x-\\uDCA9\\uDCA9\\uDCA9]/u'
      }
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:97,column:0},end:{line:98,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:97,column:0},end:{line:97,column:21},source:''},
        value: null,
        regex: { pattern: 'L-L[\\uD83D-\\uD83D]', flags: 'u' },
        raw: '/L-L[\\uD83D-\\uD83D]/u'
      }
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:99,column:0},end:{line:100,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:99,column:0},end:{line:99,column:23},source:''},
        value: null,
        regex: { pattern: 'L-LB[\\uD83D-\\uD83Dx]', flags: 'u' },
        raw: '/L-LB[\\uD83D-\\uD83Dx]/u'
      }
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:101,column:0},end:{line:102,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:101,column:0},end:{line:101,column:28},source:''},
        value: null,
        regex: { pattern: 'L-LL[\\uD83D-\\uD83D\\uD83D]', flags: 'u' },
        raw: '/L-LL[\\uD83D-\\uD83D\\uD83D]/u'
      }
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:103,column:0},end:{line:104,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:103,column:0},end:{line:103,column:28},source:''},
        value: null,
        regex: { pattern: 'L-LT[\\uD83D-\\uD83D\\uDCA9]', flags: 'u' },
        raw: '/L-LT[\\uD83D-\\uD83D\\uDCA9]/u'
      }
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:105,column:0},end:{line:106,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:105,column:0},end:{line:105,column:23},source:''},
        value: null,
        regex: { pattern: 'L-LB[\\uD83D-\\uD83Dx]', flags: 'u' },
        raw: '/L-LB[\\uD83D-\\uD83Dx]/u'
      }
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:107,column:0},end:{line:108,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:107,column:0},end:{line:107,column:25},source:''},
        value: null,
        regex: { pattern: 'L-LBB[\\uD83D-\\uD83Dxx]', flags: 'u' },
        raw: '/L-LBB[\\uD83D-\\uD83Dxx]/u'
      }
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:109,column:0},end:{line:110,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:109,column:0},end:{line:109,column:30},source:''},
        value: null,
        regex: { pattern: 'L-LBL[\\uD83D-\\uD83Dx\\uD83D]', flags: 'u' },
        raw: '/L-LBL[\\uD83D-\\uD83Dx\\uD83D]/u'
      }
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:111,column:0},end:{line:112,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:111,column:0},end:{line:111,column:30},source:''},
        value: null,
        regex: { pattern: 'L-LBT[\\uD83D-\\uD83Dx\\uDCA9]', flags: 'u' },
        raw: '/L-LBT[\\uD83D-\\uD83Dx\\uDCA9]/u'
      }
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:113,column:0},end:{line:114,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:113,column:0},end:{line:113,column:28},source:''},
        value: null,
        regex: { pattern: 'L-LL[\\uD83D-\\uD83D\\uD83D]', flags: 'u' },
        raw: '/L-LL[\\uD83D-\\uD83D\\uD83D]/u'
      }
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:115,column:0},end:{line:116,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:115,column:0},end:{line:115,column:30},source:''},
        value: null,
        regex: { pattern: 'L-LLB[\\uD83D-\\uD83D\\uD83Dx]', flags: 'u' },
        raw: '/L-LLB[\\uD83D-\\uD83D\\uD83Dx]/u'
      }
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:117,column:0},end:{line:118,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:117,column:0},end:{line:117,column:35},source:''},
        value: null,
        regex: { pattern: 'L-LLL[\\uD83D-\\uD83D\\uD83D\\uD83D]', flags: 'u' },
        raw: '/L-LLL[\\uD83D-\\uD83D\\uD83D\\uD83D]/u'
      }
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:119,column:0},end:{line:120,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:119,column:0},end:{line:119,column:35},source:''},
        value: null,
        regex: { pattern: 'L-LLT[\\uD83D-\\uD83D\\uD83D\\uDCA9]', flags: 'u' },
        raw: '/L-LLT[\\uD83D-\\uD83D\\uD83D\\uDCA9]/u'
      }
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:121,column:0},end:{line:122,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:121,column:0},end:{line:121,column:28},source:''},
        value: null,
        regex: { pattern: 'L-LT[\\uD83D-\\uD83D\\uDCA9]', flags: 'u' },
        raw: '/L-LT[\\uD83D-\\uD83D\\uDCA9]/u'
      }
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:123,column:0},end:{line:124,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:123,column:0},end:{line:123,column:30},source:''},
        value: null,
        regex: { pattern: 'L-LTB[\\uD83D-\\uD83D\\uDCA9x]', flags: 'u' },
        raw: '/L-LTB[\\uD83D-\\uD83D\\uDCA9x]/u'
      }
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:125,column:0},end:{line:126,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:125,column:0},end:{line:125,column:35},source:''},
        value: null,
        regex: { pattern: 'L-LTL[\\uD83D-\\uD83D\\uDCA9\\uD83D]', flags: 'u' },
        raw: '/L-LTL[\\uD83D-\\uD83D\\uDCA9\\uD83D]/u'
      }
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:127,column:0},end:{line:128,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:127,column:0},end:{line:127,column:35},source:''},
        value: null,
        regex: { pattern: 'L-LTT[\\uD83D-\\uD83D\\uDCA9\\uDCA9]', flags: 'u' },
        raw: '/L-LTT[\\uD83D-\\uD83D\\uDCA9\\uDCA9]/u'
      }
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:129,column:0},end:{line:130,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:129,column:0},end:{line:129,column:21},source:''},
        value: null,
        regex: { pattern: 'L-T[\\uD83D-\\uDCA9]', flags: 'u' },
        raw: '/L-T[\\uD83D-\\uDCA9]/u'
      }
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:131,column:0},end:{line:132,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:131,column:0},end:{line:131,column:23},source:''},
        value: null,
        regex: { pattern: 'L-TB[\\uD83D-\\uDCA9x]', flags: 'u' },
        raw: '/L-TB[\\uD83D-\\uDCA9x]/u'
      }
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:133,column:0},end:{line:134,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:133,column:0},end:{line:133,column:28},source:''},
        value: null,
        regex: { pattern: 'L-TL[\\uD83D-\\uDCA9\\uD83D]', flags: 'u' },
        raw: '/L-TL[\\uD83D-\\uDCA9\\uD83D]/u'
      }
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:135,column:0},end:{line:136,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:135,column:0},end:{line:135,column:28},source:''},
        value: null,
        regex: { pattern: 'L-TT[\\uD83D-\\uDCA9\\uDCA9]', flags: 'u' },
        raw: '/L-TT[\\uD83D-\\uDCA9\\uDCA9]/u'
      }
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:137,column:0},end:{line:138,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:137,column:0},end:{line:137,column:23},source:''},
        value: null,
        regex: { pattern: 'L-TB[\\uD83D-\\uDCA9x]', flags: 'u' },
        raw: '/L-TB[\\uD83D-\\uDCA9x]/u'
      }
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:139,column:0},end:{line:140,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:139,column:0},end:{line:139,column:25},source:''},
        value: null,
        regex: { pattern: 'L-TBB[\\uD83D-\\uDCA9xx]', flags: 'u' },
        raw: '/L-TBB[\\uD83D-\\uDCA9xx]/u'
      }
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:141,column:0},end:{line:142,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:141,column:0},end:{line:141,column:30},source:''},
        value: null,
        regex: { pattern: 'L-TBL[\\uD83D-\\uDCA9x\\uD83D]', flags: 'u' },
        raw: '/L-TBL[\\uD83D-\\uDCA9x\\uD83D]/u'
      }
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:143,column:0},end:{line:144,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:143,column:0},end:{line:143,column:30},source:''},
        value: null,
        regex: { pattern: 'L-TBT[\\uD83D-\\uDCA9x\\uDCA9]', flags: 'u' },
        raw: '/L-TBT[\\uD83D-\\uDCA9x\\uDCA9]/u'
      }
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:145,column:0},end:{line:146,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:145,column:0},end:{line:145,column:28},source:''},
        value: null,
        regex: { pattern: 'L-TL[\\uD83D-\\uDCA9\\uD83D]', flags: 'u' },
        raw: '/L-TL[\\uD83D-\\uDCA9\\uD83D]/u'
      }
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:147,column:0},end:{line:148,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:147,column:0},end:{line:147,column:30},source:''},
        value: null,
        regex: { pattern: 'L-TLB[\\uD83D-\\uDCA9\\uD83Dx]', flags: 'u' },
        raw: '/L-TLB[\\uD83D-\\uDCA9\\uD83Dx]/u'
      }
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:149,column:0},end:{line:150,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:149,column:0},end:{line:149,column:35},source:''},
        value: null,
        regex: { pattern: 'L-TLL[\\uD83D-\\uDCA9\\uD83D\\uD83D]', flags: 'u' },
        raw: '/L-TLL[\\uD83D-\\uDCA9\\uD83D\\uD83D]/u'
      }
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:151,column:0},end:{line:152,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:151,column:0},end:{line:151,column:35},source:''},
        value: null,
        regex: { pattern: 'L-TLT[\\uD83D-\\uDCA9\\uD83D\\uDCA9]', flags: 'u' },
        raw: '/L-TLT[\\uD83D-\\uDCA9\\uD83D\\uDCA9]/u'
      }
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:153,column:0},end:{line:154,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:153,column:0},end:{line:153,column:28},source:''},
        value: null,
        regex: { pattern: 'L-TT[\\uD83D-\\uDCA9\\uDCA9]', flags: 'u' },
        raw: '/L-TT[\\uD83D-\\uDCA9\\uDCA9]/u'
      }
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:155,column:0},end:{line:156,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:155,column:0},end:{line:155,column:30},source:''},
        value: null,
        regex: { pattern: 'L-TTB[\\uD83D-\\uDCA9\\uDCA9x]', flags: 'u' },
        raw: '/L-TTB[\\uD83D-\\uDCA9\\uDCA9x]/u'
      }
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:157,column:0},end:{line:158,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:157,column:0},end:{line:157,column:35},source:''},
        value: null,
        regex: { pattern: 'L-TTL[\\uD83D-\\uDCA9\\uDCA9\\uD83D]', flags: 'u' },
        raw: '/L-TTL[\\uD83D-\\uDCA9\\uDCA9\\uD83D]/u'
      }
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:159,column:0},end:{line:160,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:159,column:0},end:{line:159,column:35},source:''},
        value: null,
        regex: { pattern: 'L-TTT[\\uD83D-\\uDCA9\\uDCA9\\uDCA9]', flags: 'u' },
        raw: '/L-TTT[\\uD83D-\\uDCA9\\uDCA9\\uDCA9]/u'
      }
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:161,column:0},end:{line:162,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:161,column:0},end:{line:161,column:28},source:''},
        value: null,
        regex: { pattern: 'T-LT[\\uDCA9-\\uD83D\\uDCA9]', flags: 'u' },
        raw: '/T-LT[\\uDCA9-\\uD83D\\uDCA9]/u'
      }
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:163,column:0},end:{line:164,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:163,column:0},end:{line:163,column:28},source:''},
        value: null,
        regex: { pattern: 'T-LT[\\uDCA9-\\uD83D\\uDCA9]', flags: 'u' },
        raw: '/T-LT[\\uDCA9-\\uD83D\\uDCA9]/u'
      }
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:165,column:0},end:{line:166,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:165,column:0},end:{line:165,column:30},source:''},
        value: null,
        regex: { pattern: 'T-LTB[\\uDCA9-\\uD83D\\uDCA9x]', flags: 'u' },
        raw: '/T-LTB[\\uDCA9-\\uD83D\\uDCA9x]/u'
      }
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:167,column:0},end:{line:168,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:167,column:0},end:{line:167,column:35},source:''},
        value: null,
        regex: { pattern: 'T-LTL[\\uDCA9-\\uD83D\\uDCA9\\uD83D]', flags: 'u' },
        raw: '/T-LTL[\\uDCA9-\\uD83D\\uDCA9\\uD83D]/u'
      }
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:169,column:0},end:{line:170,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:169,column:0},end:{line:169,column:35},source:''},
        value: null,
        regex: { pattern: 'T-LTT[\\uDCA9-\\uD83D\\uDCA9\\uDCA9]', flags: 'u' },
        raw: '/T-LTT[\\uDCA9-\\uD83D\\uDCA9\\uDCA9]/u'
      }
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:171,column:0},end:{line:172,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:171,column:0},end:{line:171,column:21},source:''},
        value: null,
        regex: { pattern: 'T-T[\\uDCA9-\\uDCA9]', flags: 'u' },
        raw: '/T-T[\\uDCA9-\\uDCA9]/u'
      }
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:173,column:0},end:{line:174,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:173,column:0},end:{line:173,column:23},source:''},
        value: null,
        regex: { pattern: 'T-TB[\\uDCA9-\\uDCA9x]', flags: 'u' },
        raw: '/T-TB[\\uDCA9-\\uDCA9x]/u'
      }
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:175,column:0},end:{line:176,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:175,column:0},end:{line:175,column:28},source:''},
        value: null,
        regex: { pattern: 'T-TL[\\uDCA9-\\uDCA9\\uD83D]', flags: 'u' },
        raw: '/T-TL[\\uDCA9-\\uDCA9\\uD83D]/u'
      }
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:177,column:0},end:{line:178,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:177,column:0},end:{line:177,column:28},source:''},
        value: null,
        regex: { pattern: 'T-TT[\\uDCA9-\\uDCA9\\uDCA9]', flags: 'u' },
        raw: '/T-TT[\\uDCA9-\\uDCA9\\uDCA9]/u'
      }
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:179,column:0},end:{line:180,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:179,column:0},end:{line:179,column:23},source:''},
        value: null,
        regex: { pattern: 'T-TB[\\uDCA9-\\uDCA9x]', flags: 'u' },
        raw: '/T-TB[\\uDCA9-\\uDCA9x]/u'
      }
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:181,column:0},end:{line:182,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:181,column:0},end:{line:181,column:25},source:''},
        value: null,
        regex: { pattern: 'T-TBB[\\uDCA9-\\uDCA9xx]', flags: 'u' },
        raw: '/T-TBB[\\uDCA9-\\uDCA9xx]/u'
      }
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:183,column:0},end:{line:184,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:183,column:0},end:{line:183,column:30},source:''},
        value: null,
        regex: { pattern: 'T-TBL[\\uDCA9-\\uDCA9x\\uD83D]', flags: 'u' },
        raw: '/T-TBL[\\uDCA9-\\uDCA9x\\uD83D]/u'
      }
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:185,column:0},end:{line:186,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:185,column:0},end:{line:185,column:30},source:''},
        value: null,
        regex: { pattern: 'T-TBT[\\uDCA9-\\uDCA9x\\uDCA9]', flags: 'u' },
        raw: '/T-TBT[\\uDCA9-\\uDCA9x\\uDCA9]/u'
      }
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:187,column:0},end:{line:188,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:187,column:0},end:{line:187,column:28},source:''},
        value: null,
        regex: { pattern: 'T-TL[\\uDCA9-\\uDCA9\\uD83D]', flags: 'u' },
        raw: '/T-TL[\\uDCA9-\\uDCA9\\uD83D]/u'
      }
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:189,column:0},end:{line:190,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:189,column:0},end:{line:189,column:30},source:''},
        value: null,
        regex: { pattern: 'T-TLB[\\uDCA9-\\uDCA9\\uD83Dx]', flags: 'u' },
        raw: '/T-TLB[\\uDCA9-\\uDCA9\\uD83Dx]/u'
      }
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:191,column:0},end:{line:192,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:191,column:0},end:{line:191,column:35},source:''},
        value: null,
        regex: { pattern: 'T-TLL[\\uDCA9-\\uDCA9\\uD83D\\uD83D]', flags: 'u' },
        raw: '/T-TLL[\\uDCA9-\\uDCA9\\uD83D\\uD83D]/u'
      }
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:193,column:0},end:{line:194,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:193,column:0},end:{line:193,column:35},source:''},
        value: null,
        regex: { pattern: 'T-TLT[\\uDCA9-\\uDCA9\\uD83D\\uDCA9]', flags: 'u' },
        raw: '/T-TLT[\\uDCA9-\\uDCA9\\uD83D\\uDCA9]/u'
      }
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:195,column:0},end:{line:196,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:195,column:0},end:{line:195,column:28},source:''},
        value: null,
        regex: { pattern: 'T-TT[\\uDCA9-\\uDCA9\\uDCA9]', flags: 'u' },
        raw: '/T-TT[\\uDCA9-\\uDCA9\\uDCA9]/u'
      }
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:197,column:0},end:{line:198,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:197,column:0},end:{line:197,column:30},source:''},
        value: null,
        regex: { pattern: 'T-TTB[\\uDCA9-\\uDCA9\\uDCA9x]', flags: 'u' },
        raw: '/T-TTB[\\uDCA9-\\uDCA9\\uDCA9x]/u'
      }
    },
    {
      type: 'ExpressionStatement',
      loc:{start:{line:199,column:0},end:{line:200,column:1},source:''},
      expression: {
        type: 'Literal',
        loc:{start:{line:199,column:0},end:{line:199,column:35},source:''},
        value: null,
        regex: { pattern: 'T-TTL[\\uDCA9-\\uDCA9\\uDCA9\\uD83D]', flags: 'u' },
        raw: '/T-TTL[\\uDCA9-\\uDCA9\\uDCA9\\uD83D]/u'
      }
    },
    ... 1436 more items
  ]
}

tokens (3073x):
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU
       PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU PUNC_SEMI
       REGEXU PUNC_SEMI REGEXU PUNC_SEMI REGEXU ASI
`````

### Strict mode

Parsed with script goal but as if it was starting with `"use strict"` at the top.

_Output same as sloppy mode._

### Module goal

Parsed with the module goal.

_Output same as sloppy mode._

### Web compat mode

Parsed in sloppy script mode but with the web compat flag enabled.

_Output same as sloppy mode._

## AST Printer

Printer output different from input [sloppy]:

````js
/B-B[x-x]/u;
/B-BB[x-xx]/u;
/B-BL[x-x\uD83D]/u;
/B-BT[x-x\uDCA9]/u;
/B-BB[x-xx]/u;
/B-BBB[x-xxx]/u;
/B-BBL[x-xx\uD83D]/u;
/B-BBT[x-xx\uDCA9]/u;
/B-BL[x-x\uD83D]/u;
/B-BLB[x-x\uD83Dx]/u;
/B-BLL[x-x\uD83D\uD83D]/u;
/B-BLT[x-x\uD83D\uDCA9]/u;
/B-BT[x-x\uDCA9]/u;
/B-BTB[x-x\uDCA9x]/u;
/B-BTL[x-x\uDCA9\uD83D]/u;
/B-BTT[x-x\uDCA9\uDCA9]/u;
/B-L[x-\uD83D]/u;
/B-LB[x-\uD83Dx]/u;
/B-LL[x-\uD83D\uD83D]/u;
/B-LT[x-\uD83D\uDCA9]/u;
/B-LB[x-\uD83Dx]/u;
/B-LBB[x-\uD83Dxx]/u;
/B-LBL[x-\uD83Dx\uD83D]/u;
/B-LBT[x-\uD83Dx\uDCA9]/u;
/B-LL[x-\uD83D\uD83D]/u;
/B-LLB[x-\uD83D\uD83Dx]/u;
/B-LLL[x-\uD83D\uD83D\uD83D]/u;
/B-LLT[x-\uD83D\uD83D\uDCA9]/u;
/B-LT[x-\uD83D\uDCA9]/u;
/B-LTB[x-\uD83D\uDCA9x]/u;
/B-LTL[x-\uD83D\uDCA9\uD83D]/u;
/B-LTT[x-\uD83D\uDCA9\uDCA9]/u;
/B-T[x-\uDCA9]/u;
/B-TB[x-\uDCA9x]/u;
/B-TL[x-\uDCA9\uD83D]/u;
/B-TT[x-\uDCA9\uDCA9]/u;
/B-TB[x-\uDCA9x]/u;
/B-TBB[x-\uDCA9xx]/u;
/B-TBL[x-\uDCA9x\uD83D]/u;
/B-TBT[x-\uDCA9x\uDCA9]/u;
/B-TL[x-\uDCA9\uD83D]/u;
/B-TLB[x-\uDCA9\uD83Dx]/u;
/B-TLL[x-\uDCA9\uD83D\uD83D]/u;
/B-TLT[x-\uDCA9\uD83D\uDCA9]/u;
/B-TT[x-\uDCA9\uDCA9]/u;
/B-TTB[x-\uDCA9\uDCA9x]/u;
/B-TTL[x-\uDCA9\uDCA9\uD83D]/u;
/B-TTT[x-\uDCA9\uDCA9\uDCA9]/u;
/L-L[\uD83D-\uD83D]/u;
/L-LB[\uD83D-\uD83Dx]/u;
/L-LL[\uD83D-\uD83D\uD83D]/u;
/L-LT[\uD83D-\uD83D\uDCA9]/u;
/L-LB[\uD83D-\uD83Dx]/u;
/L-LBB[\uD83D-\uD83Dxx]/u;
/L-LBL[\uD83D-\uD83Dx\uD83D]/u;
/L-LBT[\uD83D-\uD83Dx\uDCA9]/u;
/L-LL[\uD83D-\uD83D\uD83D]/u;
/L-LLB[\uD83D-\uD83D\uD83Dx]/u;
/L-LLL[\uD83D-\uD83D\uD83D\uD83D]/u;
/L-LLT[\uD83D-\uD83D\uD83D\uDCA9]/u;
/L-LT[\uD83D-\uD83D\uDCA9]/u;
/L-LTB[\uD83D-\uD83D\uDCA9x]/u;
/L-LTL[\uD83D-\uD83D\uDCA9\uD83D]/u;
/L-LTT[\uD83D-\uD83D\uDCA9\uDCA9]/u;
/L-T[\uD83D-\uDCA9]/u;
/L-TB[\uD83D-\uDCA9x]/u;
/L-TL[\uD83D-\uDCA9\uD83D]/u;
/L-TT[\uD83D-\uDCA9\uDCA9]/u;
/L-TB[\uD83D-\uDCA9x]/u;
/L-TBB[\uD83D-\uDCA9xx]/u;
/L-TBL[\uD83D-\uDCA9x\uD83D]/u;
/L-TBT[\uD83D-\uDCA9x\uDCA9]/u;
/L-TL[\uD83D-\uDCA9\uD83D]/u;
/L-TLB[\uD83D-\uDCA9\uD83Dx]/u;
/L-TLL[\uD83D-\uDCA9\uD83D\uD83D]/u;
/L-TLT[\uD83D-\uDCA9\uD83D\uDCA9]/u;
/L-TT[\uD83D-\uDCA9\uDCA9]/u;
/L-TTB[\uD83D-\uDCA9\uDCA9x]/u;
/L-TTL[\uD83D-\uDCA9\uDCA9\uD83D]/u;
/L-TTT[\uD83D-\uDCA9\uDCA9\uDCA9]/u;
/T-LT[\uDCA9-\uD83D\uDCA9]/u;
/T-LT[\uDCA9-\uD83D\uDCA9]/u;
/T-LTB[\uDCA9-\uD83D\uDCA9x]/u;
/T-LTL[\uDCA9-\uD83D\uDCA9\uD83D]/u;
/T-LTT[\uDCA9-\uD83D\uDCA9\uDCA9]/u;
/T-T[\uDCA9-\uDCA9]/u;
/T-TB[\uDCA9-\uDCA9x]/u;
/T-TL[\uDCA9-\uDCA9\uD83D]/u;
/T-TT[\uDCA9-\uDCA9\uDCA9]/u;
/T-TB[\uDCA9-\uDCA9x]/u;
/T-TBB[\uDCA9-\uDCA9xx]/u;
/T-TBL[\uDCA9-\uDCA9x\uD83D]/u;
/T-TBT[\uDCA9-\uDCA9x\uDCA9]/u;
/T-TL[\uDCA9-\uDCA9\uD83D]/u;
/T-TLB[\uDCA9-\uDCA9\uD83Dx]/u;
/T-TLL[\uDCA9-\uDCA9\uD83D\uD83D]/u;
/T-TLT[\uDCA9-\uDCA9\uD83D\uDCA9]/u;
/T-TT[\uDCA9-\uDCA9\uDCA9]/u;
/T-TTB[\uDCA9-\uDCA9\uDCA9x]/u;
/T-TTL[\uDCA9-\uDCA9\uDCA9\uD83D]/u;
/T-TTT[\uDCA9-\uDCA9\uDCA9\uDCA9]/u;
/BB-B[xx-x]/u;
/BB-BB[xx-xx]/u;
/BB-BL[xx-x\uD83D]/u;
/BB-BT[xx-x\uDCA9]/u;
/BB-BB[xx-xx]/u;
/BB-BBB[xx-xxx]/u;
/BB-BBL[xx-xx\uD83D]/u;
/BB-BBT[xx-xx\uDCA9]/u;
/BB-BL[xx-x\uD83D]/u;
/BB-BLB[xx-x\uD83Dx]/u;
/BB-BLL[xx-x\uD83D\uD83D]/u;
/BB-BLT[xx-x\uD83D\uDCA9]/u;
/BB-BT[xx-x\uDCA9]/u;
/BB-BTB[xx-x\uDCA9x]/u;
/BB-BTL[xx-x\uDCA9\uD83D]/u;
/BB-BTT[xx-x\uDCA9\uDCA9]/u;
/BB-L[xx-\uD83D]/u;
/BB-LB[xx-\uD83Dx]/u;
/BB-LL[xx-\uD83D\uD83D]/u;
/BB-LT[xx-\uD83D\uDCA9]/u;
/BB-LB[xx-\uD83Dx]/u;
/BB-LBB[xx-\uD83Dxx]/u;
/BB-LBL[xx-\uD83Dx\uD83D]/u;
/BB-LBT[xx-\uD83Dx\uDCA9]/u;
/BB-LL[xx-\uD83D\uD83D]/u;
/BB-LLB[xx-\uD83D\uD83Dx]/u;
/BB-LLL[xx-\uD83D\uD83D\uD83D]/u;
/BB-LLT[xx-\uD83D\uD83D\uDCA9]/u;
/BB-LT[xx-\uD83D\uDCA9]/u;
/BB-LTB[xx-\uD83D\uDCA9x]/u;
/BB-LTL[xx-\uD83D\uDCA9\uD83D]/u;
/BB-LTT[xx-\uD83D\uDCA9\uDCA9]/u;
/BB-T[xx-\uDCA9]/u;
/BB-TB[xx-\uDCA9x]/u;
/BB-TL[xx-\uDCA9\uD83D]/u;
/BB-TT[xx-\uDCA9\uDCA9]/u;
/BB-TB[xx-\uDCA9x]/u;
/BB-TBB[xx-\uDCA9xx]/u;
/BB-TBL[xx-\uDCA9x\uD83D]/u;
/BB-TBT[xx-\uDCA9x\uDCA9]/u;
/BB-TL[xx-\uDCA9\uD83D]/u;
/BB-TLB[xx-\uDCA9\uD83Dx]/u;
/BB-TLL[xx-\uDCA9\uD83D\uD83D]/u;
/BB-TLT[xx-\uDCA9\uD83D\uDCA9]/u;
/BB-TT[xx-\uDCA9\uDCA9]/u;
/BB-TTB[xx-\uDCA9\uDCA9x]/u;
/BB-TTL[xx-\uDCA9\uDCA9\uD83D]/u;
/BB-TTT[xx-\uDCA9\uDCA9\uDCA9]/u;
/BL-L[x\uD83D-\uD83D]/u;
/BL-LB[x\uD83D-\uD83Dx]/u;
/BL-LL[x\uD83D-\uD83D\uD83D]/u;
/BL-LT[x\uD83D-\uD83D\uDCA9]/u;
/BL-LB[x\uD83D-\uD83Dx]/u;
/BL-LBB[x\uD83D-\uD83Dxx]/u;
/BL-LBL[x\uD83D-\uD83Dx\uD83D]/u;
/BL-LBT[x\uD83D-\uD83Dx\uDCA9]/u;
/BL-LL[x\uD83D-\uD83D\uD83D]/u;
/BL-LLB[x\uD83D-\uD83D\uD83Dx]/u;
/BL-LLL[x\uD83D-\uD83D\uD83D\uD83D]/u;
/BL-LLT[x\uD83D-\uD83D\uD83D\uDCA9]/u;
/BL-LT[x\uD83D-\uD83D\uDCA9]/u;
/BL-LTB[x\uD83D-\uD83D\uDCA9x]/u;
/BL-LTL[x\uD83D-\uD83D\uDCA9\uD83D]/u;
/BL-LTT[x\uD83D-\uD83D\uDCA9\uDCA9]/u;
/BL-T[x\uD83D-\uDCA9]/u;
/BL-TB[x\uD83D-\uDCA9x]/u;
/BL-TL[x\uD83D-\uDCA9\uD83D]/u;
/BL-TT[x\uD83D-\uDCA9\uDCA9]/u;
/BL-TB[x\uD83D-\uDCA9x]/u;
/BL-TBB[x\uD83D-\uDCA9xx]/u;
/BL-TBL[x\uD83D-\uDCA9x\uD83D]/u;
/BL-TBT[x\uD83D-\uDCA9x\uDCA9]/u;
/BL-TL[x\uD83D-\uDCA9\uD83D]/u;
/BL-TLB[x\uD83D-\uDCA9\uD83Dx]/u;
/BL-TLL[x\uD83D-\uDCA9\uD83D\uD83D]/u;
/BL-TLT[x\uD83D-\uDCA9\uD83D\uDCA9]/u;
/BL-TT[x\uD83D-\uDCA9\uDCA9]/u;
/BL-TTB[x\uD83D-\uDCA9\uDCA9x]/u;
/BL-TTL[x\uD83D-\uDCA9\uDCA9\uD83D]/u;
/BL-TTT[x\uD83D-\uDCA9\uDCA9\uDCA9]/u;
/BT-LT[x\uDCA9-\uD83D\uDCA9]/u;
/BT-LT[x\uDCA9-\uD83D\uDCA9]/u;
/BT-LTB[x\uDCA9-\uD83D\uDCA9x]/u;
/BT-LTL[x\uDCA9-\uD83D\uDCA9\uD83D]/u;
/BT-LTT[x\uDCA9-\uD83D\uDCA9\uDCA9]/u;
/BT-T[x\uDCA9-\uDCA9]/u;
/BT-TB[x\uDCA9-\uDCA9x]/u;
/BT-TL[x\uDCA9-\uDCA9\uD83D]/u;
/BT-TT[x\uDCA9-\uDCA9\uDCA9]/u;
/BT-TB[x\uDCA9-\uDCA9x]/u;
/BT-TBB[x\uDCA9-\uDCA9xx]/u;
/BT-TBL[x\uDCA9-\uDCA9x\uD83D]/u;
/BT-TBT[x\uDCA9-\uDCA9x\uDCA9]/u;
/BT-TL[x\uDCA9-\uDCA9\uD83D]/u;
/BT-TLB[x\uDCA9-\uDCA9\uD83Dx]/u;
/BT-TLL[x\uDCA9-\uDCA9\uD83D\uD83D]/u;
/BT-TLT[x\uDCA9-\uDCA9\uD83D\uDCA9]/u;
/BT-TT[x\uDCA9-\uDCA9\uDCA9]/u;
/BT-TTB[x\uDCA9-\uDCA9\uDCA9x]/u;
/BT-TTL[x\uDCA9-\uDCA9\uDCA9\uD83D]/u;
/BT-TTT[x\uDCA9-\uDCA9\uDCA9\uDCA9]/u;
/LB-B[\uD83Dx-x]/u;
/LB-BB[\uD83Dx-xx]/u;
/LB-BL[\uD83Dx-x\uD83D]/u;
/LB-BT[\uD83Dx-x\uDCA9]/u;
/LB-BB[\uD83Dx-xx]/u;
/LB-BBB[\uD83Dx-xxx]/u;
/LB-BBL[\uD83Dx-xx\uD83D]/u;
/LB-BBT[\uD83Dx-xx\uDCA9]/u;
/LB-BL[\uD83Dx-x\uD83D]/u;
/LB-BLB[\uD83Dx-x\uD83Dx]/u;
/LB-BLL[\uD83Dx-x\uD83D\uD83D]/u;
/LB-BLT[\uD83Dx-x\uD83D\uDCA9]/u;
/LB-BT[\uD83Dx-x\uDCA9]/u;
/LB-BTB[\uD83Dx-x\uDCA9x]/u;
/LB-BTL[\uD83Dx-x\uDCA9\uD83D]/u;
/LB-BTT[\uD83Dx-x\uDCA9\uDCA9]/u;
/LB-L[\uD83Dx-\uD83D]/u;
/LB-LB[\uD83Dx-\uD83Dx]/u;
/LB-LL[\uD83Dx-\uD83D\uD83D]/u;
/LB-LT[\uD83Dx-\uD83D\uDCA9]/u;
/LB-LB[\uD83Dx-\uD83Dx]/u;
/LB-LBB[\uD83Dx-\uD83Dxx]/u;
/LB-LBL[\uD83Dx-\uD83Dx\uD83D]/u;
/LB-LBT[\uD83Dx-\uD83Dx\uDCA9]/u;
/LB-LL[\uD83Dx-\uD83D\uD83D]/u;
/LB-LLB[\uD83Dx-\uD83D\uD83Dx]/u;
/LB-LLL[\uD83Dx-\uD83D\uD83D\uD83D]/u;
/LB-LLT[\uD83Dx-\uD83D\uD83D\uDCA9]/u;
/LB-LT[\uD83Dx-\uD83D\uDCA9]/u;
/LB-LTB[\uD83Dx-\uD83D\uDCA9x]/u;
/LB-LTL[\uD83Dx-\uD83D\uDCA9\uD83D]/u;
/LB-LTT[\uD83Dx-\uD83D\uDCA9\uDCA9]/u;
/LB-T[\uD83Dx-\uDCA9]/u;
/LB-TB[\uD83Dx-\uDCA9x]/u;
/LB-TL[\uD83Dx-\uDCA9\uD83D]/u;
/LB-TT[\uD83Dx-\uDCA9\uDCA9]/u;
/LB-TB[\uD83Dx-\uDCA9x]/u;
/LB-TBB[\uD83Dx-\uDCA9xx]/u;
/LB-TBL[\uD83Dx-\uDCA9x\uD83D]/u;
/LB-TBT[\uD83Dx-\uDCA9x\uDCA9]/u;
/LB-TL[\uD83Dx-\uDCA9\uD83D]/u;
/LB-TLB[\uD83Dx-\uDCA9\uD83Dx]/u;
/LB-TLL[\uD83Dx-\uDCA9\uD83D\uD83D]/u;
/LB-TLT[\uD83Dx-\uDCA9\uD83D\uDCA9]/u;
/LB-TT[\uD83Dx-\uDCA9\uDCA9]/u;
/LB-TTB[\uD83Dx-\uDCA9\uDCA9x]/u;
/LB-TTL[\uD83Dx-\uDCA9\uDCA9\uD83D]/u;
/LB-TTT[\uD83Dx-\uDCA9\uDCA9\uDCA9]/u;
/LL-L[\uD83D\uD83D-\uD83D]/u;
/LL-LB[\uD83D\uD83D-\uD83Dx]/u;
/LL-LL[\uD83D\uD83D-\uD83D\uD83D]/u;
/LL-LT[\uD83D\uD83D-\uD83D\uDCA9]/u;
/LL-LB[\uD83D\uD83D-\uD83Dx]/u;
/LL-LBB[\uD83D\uD83D-\uD83Dxx]/u;
/LL-LBL[\uD83D\uD83D-\uD83Dx\uD83D]/u;
/LL-LBT[\uD83D\uD83D-\uD83Dx\uDCA9]/u;
/LL-LL[\uD83D\uD83D-\uD83D\uD83D]/u;
/LL-LLB[\uD83D\uD83D-\uD83D\uD83Dx]/u;
/LL-LLL[\uD83D\uD83D-\uD83D\uD83D\uD83D]/u;
/LL-LLT[\uD83D\uD83D-\uD83D\uD83D\uDCA9]/u;
/LL-LT[\uD83D\uD83D-\uD83D\uDCA9]/u;
/LL-LTB[\uD83D\uD83D-\uD83D\uDCA9x]/u;
/LL-LTL[\uD83D\uD83D-\uD83D\uDCA9\uD83D]/u;
/LL-LTT[\uD83D\uD83D-\uD83D\uDCA9\uDCA9]/u;
/LL-T[\uD83D\uD83D-\uDCA9]/u;
/LL-TB[\uD83D\uD83D-\uDCA9x]/u;
/LL-TL[\uD83D\uD83D-\uDCA9\uD83D]/u;
/LL-TT[\uD83D\uD83D-\uDCA9\uDCA9]/u;
/LL-TB[\uD83D\uD83D-\uDCA9x]/u;
/LL-TBB[\uD83D\uD83D-\uDCA9xx]/u;
/LL-TBL[\uD83D\uD83D-\uDCA9x\uD83D]/u;
/LL-TBT[\uD83D\uD83D-\uDCA9x\uDCA9]/u;
/LL-TL[\uD83D\uD83D-\uDCA9\uD83D]/u;
/LL-TLB[\uD83D\uD83D-\uDCA9\uD83Dx]/u;
/LL-TLL[\uD83D\uD83D-\uDCA9\uD83D\uD83D]/u;
/LL-TLT[\uD83D\uD83D-\uDCA9\uD83D\uDCA9]/u;
/LL-TT[\uD83D\uD83D-\uDCA9\uDCA9]/u;
/LL-TTB[\uD83D\uD83D-\uDCA9\uDCA9x]/u;
/LL-TTL[\uD83D\uD83D-\uDCA9\uDCA9\uD83D]/u;
/LL-TTT[\uD83D\uD83D-\uDCA9\uDCA9\uDCA9]/u;
/LT-LT[\uD83D\uDCA9-\uD83D\uDCA9]/u;
/LT-LT[\uD83D\uDCA9-\uD83D\uDCA9]/u;
/LT-LTB[\uD83D\uDCA9-\uD83D\uDCA9x]/u;
/LT-LTL[\uD83D\uDCA9-\uD83D\uDCA9\uD83D]/u;
/LT-LTT[\uD83D\uDCA9-\uD83D\uDCA9\uDCA9]/u;
/TB-B[\uDCA9x-x]/u;
/TB-BB[\uDCA9x-xx]/u;
/TB-BL[\uDCA9x-x\uD83D]/u;
/TB-BT[\uDCA9x-x\uDCA9]/u;
/TB-BB[\uDCA9x-xx]/u;
/TB-BBB[\uDCA9x-xxx]/u;
/TB-BBL[\uDCA9x-xx\uD83D]/u;
/TB-BBT[\uDCA9x-xx\uDCA9]/u;
/TB-BL[\uDCA9x-x\uD83D]/u;
/TB-BLB[\uDCA9x-x\uD83Dx]/u;
/TB-BLL[\uDCA9x-x\uD83D\uD83D]/u;
/TB-BLT[\uDCA9x-x\uD83D\uDCA9]/u;
/TB-BT[\uDCA9x-x\uDCA9]/u;
/TB-BTB[\uDCA9x-x\uDCA9x]/u;
/TB-BTL[\uDCA9x-x\uDCA9\uD83D]/u;
/TB-BTT[\uDCA9x-x\uDCA9\uDCA9]/u;
/TB-L[\uDCA9x-\uD83D]/u;
/TB-LB[\uDCA9x-\uD83Dx]/u;
/TB-LL[\uDCA9x-\uD83D\uD83D]/u;
/TB-LT[\uDCA9x-\uD83D\uDCA9]/u;
/TB-LB[\uDCA9x-\uD83Dx]/u;
/TB-LBB[\uDCA9x-\uD83Dxx]/u;
/TB-LBL[\uDCA9x-\uD83Dx\uD83D]/u;
/TB-LBT[\uDCA9x-\uD83Dx\uDCA9]/u;
/TB-LL[\uDCA9x-\uD83D\uD83D]/u;
/TB-LLB[\uDCA9x-\uD83D\uD83Dx]/u;
/TB-LLL[\uDCA9x-\uD83D\uD83D\uD83D]/u;
/TB-LLT[\uDCA9x-\uD83D\uD83D\uDCA9]/u;
/TB-LT[\uDCA9x-\uD83D\uDCA9]/u;
/TB-LTB[\uDCA9x-\uD83D\uDCA9x]/u;
/TB-LTL[\uDCA9x-\uD83D\uDCA9\uD83D]/u;
/TB-LTT[\uDCA9x-\uD83D\uDCA9\uDCA9]/u;
/TB-T[\uDCA9x-\uDCA9]/u;
/TB-TB[\uDCA9x-\uDCA9x]/u;
/TB-TL[\uDCA9x-\uDCA9\uD83D]/u;
/TB-TT[\uDCA9x-\uDCA9\uDCA9]/u;
/TB-TB[\uDCA9x-\uDCA9x]/u;
/TB-TBB[\uDCA9x-\uDCA9xx]/u;
/TB-TBL[\uDCA9x-\uDCA9x\uD83D]/u;
/TB-TBT[\uDCA9x-\uDCA9x\uDCA9]/u;
/TB-TL[\uDCA9x-\uDCA9\uD83D]/u;
/TB-TLB[\uDCA9x-\uDCA9\uD83Dx]/u;
/TB-TLL[\uDCA9x-\uDCA9\uD83D\uD83D]/u;
/TB-TLT[\uDCA9x-\uDCA9\uD83D\uDCA9]/u;
/TB-TT[\uDCA9x-\uDCA9\uDCA9]/u;
/TB-TTB[\uDCA9x-\uDCA9\uDCA9x]/u;
/TB-TTL[\uDCA9x-\uDCA9\uDCA9\uD83D]/u;
/TB-TTT[\uDCA9x-\uDCA9\uDCA9\uDCA9]/u;
/TL-L[\uDCA9\uD83D-\uD83D]/u;
/TL-LB[\uDCA9\uD83D-\uD83Dx]/u;
/TL-LL[\uDCA9\uD83D-\uD83D\uD83D]/u;
/TL-LT[\uDCA9\uD83D-\uD83D\uDCA9]/u;
/TL-LB[\uDCA9\uD83D-\uD83Dx]/u;
/TL-LBB[\uDCA9\uD83D-\uD83Dxx]/u;
/TL-LBL[\uDCA9\uD83D-\uD83Dx\uD83D]/u;
/TL-LBT[\uDCA9\uD83D-\uD83Dx\uDCA9]/u;
/TL-LL[\uDCA9\uD83D-\uD83D\uD83D]/u;
/TL-LLB[\uDCA9\uD83D-\uD83D\uD83Dx]/u;
/TL-LLL[\uDCA9\uD83D-\uD83D\uD83D\uD83D]/u;
/TL-LLT[\uDCA9\uD83D-\uD83D\uD83D\uDCA9]/u;
/TL-LT[\uDCA9\uD83D-\uD83D\uDCA9]/u;
/TL-LTB[\uDCA9\uD83D-\uD83D\uDCA9x]/u;
/TL-LTL[\uDCA9\uD83D-\uD83D\uDCA9\uD83D]/u;
/TL-LTT[\uDCA9\uD83D-\uD83D\uDCA9\uDCA9]/u;
/TL-T[\uDCA9\uD83D-\uDCA9]/u;
/TL-TB[\uDCA9\uD83D-\uDCA9x]/u;
/TL-TL[\uDCA9\uD83D-\uDCA9\uD83D]/u;
/TL-TT[\uDCA9\uD83D-\uDCA9\uDCA9]/u;
/TL-TB[\uDCA9\uD83D-\uDCA9x]/u;
/TL-TBB[\uDCA9\uD83D-\uDCA9xx]/u;
/TL-TBL[\uDCA9\uD83D-\uDCA9x\uD83D]/u;
/TL-TBT[\uDCA9\uD83D-\uDCA9x\uDCA9]/u;
/TL-TL[\uDCA9\uD83D-\uDCA9\uD83D]/u;
/TL-TLB[\uDCA9\uD83D-\uDCA9\uD83Dx]/u;
/TL-TLL[\uDCA9\uD83D-\uDCA9\uD83D\uD83D]/u;
/TL-TLT[\uDCA9\uD83D-\uDCA9\uD83D\uDCA9]/u;
/TL-TT[\uDCA9\uD83D-\uDCA9\uDCA9]/u;
/TL-TTB[\uDCA9\uD83D-\uDCA9\uDCA9x]/u;
/TL-TTL[\uDCA9\uD83D-\uDCA9\uDCA9\uD83D]/u;
/TL-TTT[\uDCA9\uD83D-\uDCA9\uDCA9\uDCA9]/u;
/TT-LT[\uDCA9\uDCA9-\uD83D\uDCA9]/u;
/TT-LT[\uDCA9\uDCA9-\uD83D\uDCA9]/u;
/TT-LTB[\uDCA9\uDCA9-\uD83D\uDCA9x]/u;
/TT-LTL[\uDCA9\uDCA9-\uD83D\uDCA9\uD83D]/u;
/TT-LTT[\uDCA9\uDCA9-\uD83D\uDCA9\uDCA9]/u;
/TT-T[\uDCA9\uDCA9-\uDCA9]/u;
/TT-TB[\uDCA9\uDCA9-\uDCA9x]/u;
/TT-TL[\uDCA9\uDCA9-\uDCA9\uD83D]/u;
/TT-TT[\uDCA9\uDCA9-\uDCA9\uDCA9]/u;
/TT-TB[\uDCA9\uDCA9-\uDCA9x]/u;
/TT-TBB[\uDCA9\uDCA9-\uDCA9xx]/u;
/TT-TBL[\uDCA9\uDCA9-\uDCA9x\uD83D]/u;
/TT-TBT[\uDCA9\uDCA9-\uDCA9x\uDCA9]/u;
/TT-TL[\uDCA9\uDCA9-\uDCA9\uD83D]/u;
/TT-TLB[\uDCA9\uDCA9-\uDCA9\uD83Dx]/u;
/TT-TLL[\uDCA9\uDCA9-\uDCA9\uD83D\uD83D]/u;
/TT-TLT[\uDCA9\uDCA9-\uDCA9\uD83D\uDCA9]/u;
/TT-TT[\uDCA9\uDCA9-\uDCA9\uDCA9]/u;
/TT-TTB[\uDCA9\uDCA9-\uDCA9\uDCA9x]/u;
/TT-TTL[\uDCA9\uDCA9-\uDCA9\uDCA9\uD83D]/u;
/TT-TTT[\uDCA9\uDCA9-\uDCA9\uDCA9\uDCA9]/u;
/BB-B[xx-x]/u;
/BB-BB[xx-xx]/u;
/BB-BL[xx-x\uD83D]/u;
/BB-BT[xx-x\uDCA9]/u;
/BB-BB[xx-xx]/u;
/BB-BBB[xx-xxx]/u;
/BB-BBL[xx-xx\uD83D]/u;
/BB-BBT[xx-xx\uDCA9]/u;
/BB-BL[xx-x\uD83D]/u;
/BB-BLB[xx-x\uD83Dx]/u;
/BB-BLL[xx-x\uD83D\uD83D]/u;
/BB-BLT[xx-x\uD83D\uDCA9]/u;
/BB-BT[xx-x\uDCA9]/u;
/BB-BTB[xx-x\uDCA9x]/u;
/BB-BTL[xx-x\uDCA9\uD83D]/u;
/BB-BTT[xx-x\uDCA9\uDCA9]/u;
/BB-L[xx-\uD83D]/u;
/BB-LB[xx-\uD83Dx]/u;
/BB-LL[xx-\uD83D\uD83D]/u;
/BB-LT[xx-\uD83D\uDCA9]/u;
/BB-LB[xx-\uD83Dx]/u;
/BB-LBB[xx-\uD83Dxx]/u;
/BB-LBL[xx-\uD83Dx\uD83D]/u;
/BB-LBT[xx-\uD83Dx\uDCA9]/u;
/BB-LL[xx-\uD83D\uD83D]/u;
/BB-LLB[xx-\uD83D\uD83Dx]/u;
/BB-LLL[xx-\uD83D\uD83D\uD83D]/u;
/BB-LLT[xx-\uD83D\uD83D\uDCA9]/u;
/BB-LT[xx-\uD83D\uDCA9]/u;
/BB-LTB[xx-\uD83D\uDCA9x]/u;
/BB-LTL[xx-\uD83D\uDCA9\uD83D]/u;
/BB-LTT[xx-\uD83D\uDCA9\uDCA9]/u;
/BB-T[xx-\uDCA9]/u;
/BB-TB[xx-\uDCA9x]/u;
/BB-TL[xx-\uDCA9\uD83D]/u;
/BB-TT[xx-\uDCA9\uDCA9]/u;
/BB-TB[xx-\uDCA9x]/u;
/BB-TBB[xx-\uDCA9xx]/u;
/BB-TBL[xx-\uDCA9x\uD83D]/u;
/BB-TBT[xx-\uDCA9x\uDCA9]/u;
/BB-TL[xx-\uDCA9\uD83D]/u;
/BB-TLB[xx-\uDCA9\uD83Dx]/u;
/BB-TLL[xx-\uDCA9\uD83D\uD83D]/u;
/BB-TLT[xx-\uDCA9\uD83D\uDCA9]/u;
/BB-TT[xx-\uDCA9\uDCA9]/u;
/BB-TTB[xx-\uDCA9\uDCA9x]/u;
/BB-TTL[xx-\uDCA9\uDCA9\uD83D]/u;
/BB-TTT[xx-\uDCA9\uDCA9\uDCA9]/u;
/BL-L[x\uD83D-\uD83D]/u;
/BL-LB[x\uD83D-\uD83Dx]/u;
/BL-LL[x\uD83D-\uD83D\uD83D]/u;
/BL-LT[x\uD83D-\uD83D\uDCA9]/u;
/BL-LB[x\uD83D-\uD83Dx]/u;
/BL-LBB[x\uD83D-\uD83Dxx]/u;
/BL-LBL[x\uD83D-\uD83Dx\uD83D]/u;
/BL-LBT[x\uD83D-\uD83Dx\uDCA9]/u;
/BL-LL[x\uD83D-\uD83D\uD83D]/u;
/BL-LLB[x\uD83D-\uD83D\uD83Dx]/u;
/BL-LLL[x\uD83D-\uD83D\uD83D\uD83D]/u;
/BL-LLT[x\uD83D-\uD83D\uD83D\uDCA9]/u;
/BL-LT[x\uD83D-\uD83D\uDCA9]/u;
/BL-LTB[x\uD83D-\uD83D\uDCA9x]/u;
/BL-LTL[x\uD83D-\uD83D\uDCA9\uD83D]/u;
/BL-LTT[x\uD83D-\uD83D\uDCA9\uDCA9]/u;
/BL-T[x\uD83D-\uDCA9]/u;
/BL-TB[x\uD83D-\uDCA9x]/u;
/BL-TL[x\uD83D-\uDCA9\uD83D]/u;
/BL-TT[x\uD83D-\uDCA9\uDCA9]/u;
/BL-TB[x\uD83D-\uDCA9x]/u;
/BL-TBB[x\uD83D-\uDCA9xx]/u;
/BL-TBL[x\uD83D-\uDCA9x\uD83D]/u;
/BL-TBT[x\uD83D-\uDCA9x\uDCA9]/u;
/BL-TL[x\uD83D-\uDCA9\uD83D]/u;
/BL-TLB[x\uD83D-\uDCA9\uD83Dx]/u;
/BL-TLL[x\uD83D-\uDCA9\uD83D\uD83D]/u;
/BL-TLT[x\uD83D-\uDCA9\uD83D\uDCA9]/u;
/BL-TT[x\uD83D-\uDCA9\uDCA9]/u;
/BL-TTB[x\uD83D-\uDCA9\uDCA9x]/u;
/BL-TTL[x\uD83D-\uDCA9\uDCA9\uD83D]/u;
/BL-TTT[x\uD83D-\uDCA9\uDCA9\uDCA9]/u;
/BT-LT[x\uDCA9-\uD83D\uDCA9]/u;
/BT-LT[x\uDCA9-\uD83D\uDCA9]/u;
/BT-LTB[x\uDCA9-\uD83D\uDCA9x]/u;
/BT-LTL[x\uDCA9-\uD83D\uDCA9\uD83D]/u;
/BT-LTT[x\uDCA9-\uD83D\uDCA9\uDCA9]/u;
/BT-T[x\uDCA9-\uDCA9]/u;
/BT-TB[x\uDCA9-\uDCA9x]/u;
/BT-TL[x\uDCA9-\uDCA9\uD83D]/u;
/BT-TT[x\uDCA9-\uDCA9\uDCA9]/u;
/BT-TB[x\uDCA9-\uDCA9x]/u;
/BT-TBB[x\uDCA9-\uDCA9xx]/u;
/BT-TBL[x\uDCA9-\uDCA9x\uD83D]/u;
/BT-TBT[x\uDCA9-\uDCA9x\uDCA9]/u;
/BT-TL[x\uDCA9-\uDCA9\uD83D]/u;
/BT-TLB[x\uDCA9-\uDCA9\uD83Dx]/u;
/BT-TLL[x\uDCA9-\uDCA9\uD83D\uD83D]/u;
/BT-TLT[x\uDCA9-\uDCA9\uD83D\uDCA9]/u;
/BT-TT[x\uDCA9-\uDCA9\uDCA9]/u;
/BT-TTB[x\uDCA9-\uDCA9\uDCA9x]/u;
/BT-TTL[x\uDCA9-\uDCA9\uDCA9\uD83D]/u;
/BT-TTT[x\uDCA9-\uDCA9\uDCA9\uDCA9]/u;
/BBB-B[xxx-x]/u;
/BBB-BB[xxx-xx]/u;
/BBB-BL[xxx-x\uD83D]/u;
/BBB-BT[xxx-x\uDCA9]/u;
/BBB-BB[xxx-xx]/u;
/BBB-BBB[xxx-xxx]/u;
/BBB-BBL[xxx-xx\uD83D]/u;
/BBB-BBT[xxx-xx\uDCA9]/u;
/BBB-BL[xxx-x\uD83D]/u;
/BBB-BLB[xxx-x\uD83Dx]/u;
/BBB-BLL[xxx-x\uD83D\uD83D]/u;
/BBB-BLT[xxx-x\uD83D\uDCA9]/u;
/BBB-BT[xxx-x\uDCA9]/u;
/BBB-BTB[xxx-x\uDCA9x]/u;
/BBB-BTL[xxx-x\uDCA9\uD83D]/u;
/BBB-BTT[xxx-x\uDCA9\uDCA9]/u;
/BBB-L[xxx-\uD83D]/u;
/BBB-LB[xxx-\uD83Dx]/u;
/BBB-LL[xxx-\uD83D\uD83D]/u;
/BBB-LT[xxx-\uD83D\uDCA9]/u;
/BBB-LB[xxx-\uD83Dx]/u;
/BBB-LBB[xxx-\uD83Dxx]/u;
/BBB-LBL[xxx-\uD83Dx\uD83D]/u;
/BBB-LBT[xxx-\uD83Dx\uDCA9]/u;
/BBB-LL[xxx-\uD83D\uD83D]/u;
/BBB-LLB[xxx-\uD83D\uD83Dx]/u;
/BBB-LLL[xxx-\uD83D\uD83D\uD83D]/u;
/BBB-LLT[xxx-\uD83D\uD83D\uDCA9]/u;
/BBB-LT[xxx-\uD83D\uDCA9]/u;
/BBB-LTB[xxx-\uD83D\uDCA9x]/u;
/BBB-LTL[xxx-\uD83D\uDCA9\uD83D]/u;
/BBB-LTT[xxx-\uD83D\uDCA9\uDCA9]/u;
/BBB-T[xxx-\uDCA9]/u;
/BBB-TB[xxx-\uDCA9x]/u;
/BBB-TL[xxx-\uDCA9\uD83D]/u;
/BBB-TT[xxx-\uDCA9\uDCA9]/u;
/BBB-TB[xxx-\uDCA9x]/u;
/BBB-TBB[xxx-\uDCA9xx]/u;
/BBB-TBL[xxx-\uDCA9x\uD83D]/u;
/BBB-TBT[xxx-\uDCA9x\uDCA9]/u;
/BBB-TL[xxx-\uDCA9\uD83D]/u;
/BBB-TLB[xxx-\uDCA9\uD83Dx]/u;
/BBB-TLL[xxx-\uDCA9\uD83D\uD83D]/u;
/BBB-TLT[xxx-\uDCA9\uD83D\uDCA9]/u;
/BBB-TT[xxx-\uDCA9\uDCA9]/u;
/BBB-TTB[xxx-\uDCA9\uDCA9x]/u;
/BBB-TTL[xxx-\uDCA9\uDCA9\uD83D]/u;
/BBB-TTT[xxx-\uDCA9\uDCA9\uDCA9]/u;
/BBL-L[xx\uD83D-\uD83D]/u;
/BBL-LB[xx\uD83D-\uD83Dx]/u;
/BBL-LL[xx\uD83D-\uD83D\uD83D]/u;
/BBL-LT[xx\uD83D-\uD83D\uDCA9]/u;
/BBL-LB[xx\uD83D-\uD83Dx]/u;
/BBL-LBB[xx\uD83D-\uD83Dxx]/u;
/BBL-LBL[xx\uD83D-\uD83Dx\uD83D]/u;
/BBL-LBT[xx\uD83D-\uD83Dx\uDCA9]/u;
/BBL-LL[xx\uD83D-\uD83D\uD83D]/u;
/BBL-LLB[xx\uD83D-\uD83D\uD83Dx]/u;
/BBL-LLL[xx\uD83D-\uD83D\uD83D\uD83D]/u;
/BBL-LLT[xx\uD83D-\uD83D\uD83D\uDCA9]/u;
/BBL-LT[xx\uD83D-\uD83D\uDCA9]/u;
/BBL-LTB[xx\uD83D-\uD83D\uDCA9x]/u;
/BBL-LTL[xx\uD83D-\uD83D\uDCA9\uD83D]/u;
/BBL-LTT[xx\uD83D-\uD83D\uDCA9\uDCA9]/u;
/BBL-T[xx\uD83D-\uDCA9]/u;
/BBL-TB[xx\uD83D-\uDCA9x]/u;
/BBL-TL[xx\uD83D-\uDCA9\uD83D]/u;
/BBL-TT[xx\uD83D-\uDCA9\uDCA9]/u;
/BBL-TB[xx\uD83D-\uDCA9x]/u;
/BBL-TBB[xx\uD83D-\uDCA9xx]/u;
/BBL-TBL[xx\uD83D-\uDCA9x\uD83D]/u;
/BBL-TBT[xx\uD83D-\uDCA9x\uDCA9]/u;
/BBL-TL[xx\uD83D-\uDCA9\uD83D]/u;
/BBL-TLB[xx\uD83D-\uDCA9\uD83Dx]/u;
/BBL-TLL[xx\uD83D-\uDCA9\uD83D\uD83D]/u;
/BBL-TLT[xx\uD83D-\uDCA9\uD83D\uDCA9]/u;
/BBL-TT[xx\uD83D-\uDCA9\uDCA9]/u;
/BBL-TTB[xx\uD83D-\uDCA9\uDCA9x]/u;
/BBL-TTL[xx\uD83D-\uDCA9\uDCA9\uD83D]/u;
/BBL-TTT[xx\uD83D-\uDCA9\uDCA9\uDCA9]/u;
/BBT-LT[xx\uDCA9-\uD83D\uDCA9]/u;
/BBT-LT[xx\uDCA9-\uD83D\uDCA9]/u;
/BBT-LTB[xx\uDCA9-\uD83D\uDCA9x]/u;
/BBT-LTL[xx\uDCA9-\uD83D\uDCA9\uD83D]/u;
/BBT-LTT[xx\uDCA9-\uD83D\uDCA9\uDCA9]/u;
/BBT-T[xx\uDCA9-\uDCA9]/u;
/BBT-TB[xx\uDCA9-\uDCA9x]/u;
/BBT-TL[xx\uDCA9-\uDCA9\uD83D]/u;
/BBT-TT[xx\uDCA9-\uDCA9\uDCA9]/u;
/BBT-TB[xx\uDCA9-\uDCA9x]/u;
/BBT-TBB[xx\uDCA9-\uDCA9xx]/u;
/BBT-TBL[xx\uDCA9-\uDCA9x\uD83D]/u;
/BBT-TBT[xx\uDCA9-\uDCA9x\uDCA9]/u;
/BBT-TL[xx\uDCA9-\uDCA9\uD83D]/u;
/BBT-TLB[xx\uDCA9-\uDCA9\uD83Dx]/u;
/BBT-TLL[xx\uDCA9-\uDCA9\uD83D\uD83D]/u;
/BBT-TLT[xx\uDCA9-\uDCA9\uD83D\uDCA9]/u;
/BBT-TT[xx\uDCA9-\uDCA9\uDCA9]/u;
/BBT-TTB[xx\uDCA9-\uDCA9\uDCA9x]/u;
/BBT-TTL[xx\uDCA9-\uDCA9\uDCA9\uD83D]/u;
/BBT-TTT[xx\uDCA9-\uDCA9\uDCA9\uDCA9]/u;
/BLB-B[x\uD83Dx-x]/u;
/BLB-BB[x\uD83Dx-xx]/u;
/BLB-BL[x\uD83Dx-x\uD83D]/u;
/BLB-BT[x\uD83Dx-x\uDCA9]/u;
/BLB-BB[x\uD83Dx-xx]/u;
/BLB-BBB[x\uD83Dx-xxx]/u;
/BLB-BBL[x\uD83Dx-xx\uD83D]/u;
/BLB-BBT[x\uD83Dx-xx\uDCA9]/u;
/BLB-BL[x\uD83Dx-x\uD83D]/u;
/BLB-BLB[x\uD83Dx-x\uD83Dx]/u;
/BLB-BLL[x\uD83Dx-x\uD83D\uD83D]/u;
/BLB-BLT[x\uD83Dx-x\uD83D\uDCA9]/u;
/BLB-BT[x\uD83Dx-x\uDCA9]/u;
/BLB-BTB[x\uD83Dx-x\uDCA9x]/u;
/BLB-BTL[x\uD83Dx-x\uDCA9\uD83D]/u;
/BLB-BTT[x\uD83Dx-x\uDCA9\uDCA9]/u;
/BLB-L[x\uD83Dx-\uD83D]/u;
/BLB-LB[x\uD83Dx-\uD83Dx]/u;
/BLB-LL[x\uD83Dx-\uD83D\uD83D]/u;
/BLB-LT[x\uD83Dx-\uD83D\uDCA9]/u;
/BLB-LB[x\uD83Dx-\uD83Dx]/u;
/BLB-LBB[x\uD83Dx-\uD83Dxx]/u;
/BLB-LBL[x\uD83Dx-\uD83Dx\uD83D]/u;
/BLB-LBT[x\uD83Dx-\uD83Dx\uDCA9]/u;
/BLB-LL[x\uD83Dx-\uD83D\uD83D]/u;
/BLB-LLB[x\uD83Dx-\uD83D\uD83Dx]/u;
/BLB-LLL[x\uD83Dx-\uD83D\uD83D\uD83D]/u;
/BLB-LLT[x\uD83Dx-\uD83D\uD83D\uDCA9]/u;
/BLB-LT[x\uD83Dx-\uD83D\uDCA9]/u;
/BLB-LTB[x\uD83Dx-\uD83D\uDCA9x]/u;
/BLB-LTL[x\uD83Dx-\uD83D\uDCA9\uD83D]/u;
/BLB-LTT[x\uD83Dx-\uD83D\uDCA9\uDCA9]/u;
/BLB-T[x\uD83Dx-\uDCA9]/u;
/BLB-TB[x\uD83Dx-\uDCA9x]/u;
/BLB-TL[x\uD83Dx-\uDCA9\uD83D]/u;
/BLB-TT[x\uD83Dx-\uDCA9\uDCA9]/u;
/BLB-TB[x\uD83Dx-\uDCA9x]/u;
/BLB-TBB[x\uD83Dx-\uDCA9xx]/u;
/BLB-TBL[x\uD83Dx-\uDCA9x\uD83D]/u;
/BLB-TBT[x\uD83Dx-\uDCA9x\uDCA9]/u;
/BLB-TL[x\uD83Dx-\uDCA9\uD83D]/u;
/BLB-TLB[x\uD83Dx-\uDCA9\uD83Dx]/u;
/BLB-TLL[x\uD83Dx-\uDCA9\uD83D\uD83D]/u;
/BLB-TLT[x\uD83Dx-\uDCA9\uD83D\uDCA9]/u;
/BLB-TT[x\uD83Dx-\uDCA9\uDCA9]/u;
/BLB-TTB[x\uD83Dx-\uDCA9\uDCA9x]/u;
/BLB-TTL[x\uD83Dx-\uDCA9\uDCA9\uD83D]/u;
/BLB-TTT[x\uD83Dx-\uDCA9\uDCA9\uDCA9]/u;
/BLL-L[x\uD83D\uD83D-\uD83D]/u;
/BLL-LB[x\uD83D\uD83D-\uD83Dx]/u;
/BLL-LL[x\uD83D\uD83D-\uD83D\uD83D]/u;
/BLL-LT[x\uD83D\uD83D-\uD83D\uDCA9]/u;
/BLL-LB[x\uD83D\uD83D-\uD83Dx]/u;
/BLL-LBB[x\uD83D\uD83D-\uD83Dxx]/u;
/BLL-LBL[x\uD83D\uD83D-\uD83Dx\uD83D]/u;
/BLL-LBT[x\uD83D\uD83D-\uD83Dx\uDCA9]/u;
/BLL-LL[x\uD83D\uD83D-\uD83D\uD83D]/u;
/BLL-LLB[x\uD83D\uD83D-\uD83D\uD83Dx]/u;
/BLL-LLL[x\uD83D\uD83D-\uD83D\uD83D\uD83D]/u;
/BLL-LLT[x\uD83D\uD83D-\uD83D\uD83D\uDCA9]/u;
/BLL-LT[x\uD83D\uD83D-\uD83D\uDCA9]/u;
/BLL-LTB[x\uD83D\uD83D-\uD83D\uDCA9x]/u;
/BLL-LTL[x\uD83D\uD83D-\uD83D\uDCA9\uD83D]/u;
/BLL-LTT[x\uD83D\uD83D-\uD83D\uDCA9\uDCA9]/u;
/BLL-T[x\uD83D\uD83D-\uDCA9]/u;
/BLL-TB[x\uD83D\uD83D-\uDCA9x]/u;
/BLL-TL[x\uD83D\uD83D-\uDCA9\uD83D]/u;
/BLL-TT[x\uD83D\uD83D-\uDCA9\uDCA9]/u;
/BLL-TB[x\uD83D\uD83D-\uDCA9x]/u;
/BLL-TBB[x\uD83D\uD83D-\uDCA9xx]/u;
/BLL-TBL[x\uD83D\uD83D-\uDCA9x\uD83D]/u;
/BLL-TBT[x\uD83D\uD83D-\uDCA9x\uDCA9]/u;
/BLL-TL[x\uD83D\uD83D-\uDCA9\uD83D]/u;
/BLL-TLB[x\uD83D\uD83D-\uDCA9\uD83Dx]/u;
/BLL-TLL[x\uD83D\uD83D-\uDCA9\uD83D\uD83D]/u;
/BLL-TLT[x\uD83D\uD83D-\uDCA9\uD83D\uDCA9]/u;
/BLL-TT[x\uD83D\uD83D-\uDCA9\uDCA9]/u;
/BLL-TTB[x\uD83D\uD83D-\uDCA9\uDCA9x]/u;
/BLL-TTL[x\uD83D\uD83D-\uDCA9\uDCA9\uD83D]/u;
/BLL-TTT[x\uD83D\uD83D-\uDCA9\uDCA9\uDCA9]/u;
/BLT-LT[x\uD83D\uDCA9-\uD83D\uDCA9]/u;
/BLT-LT[x\uD83D\uDCA9-\uD83D\uDCA9]/u;
/BLT-LTB[x\uD83D\uDCA9-\uD83D\uDCA9x]/u;
/BLT-LTL[x\uD83D\uDCA9-\uD83D\uDCA9\uD83D]/u;
/BLT-LTT[x\uD83D\uDCA9-\uD83D\uDCA9\uDCA9]/u;
/BTB-B[x\uDCA9x-x]/u;
/BTB-BB[x\uDCA9x-xx]/u;
/BTB-BL[x\uDCA9x-x\uD83D]/u;
/BTB-BT[x\uDCA9x-x\uDCA9]/u;
/BTB-BB[x\uDCA9x-xx]/u;
/BTB-BBB[x\uDCA9x-xxx]/u;
/BTB-BBL[x\uDCA9x-xx\uD83D]/u;
/BTB-BBT[x\uDCA9x-xx\uDCA9]/u;
/BTB-BL[x\uDCA9x-x\uD83D]/u;
/BTB-BLB[x\uDCA9x-x\uD83Dx]/u;
/BTB-BLL[x\uDCA9x-x\uD83D\uD83D]/u;
/BTB-BLT[x\uDCA9x-x\uD83D\uDCA9]/u;
/BTB-BT[x\uDCA9x-x\uDCA9]/u;
/BTB-BTB[x\uDCA9x-x\uDCA9x]/u;
/BTB-BTL[x\uDCA9x-x\uDCA9\uD83D]/u;
/BTB-BTT[x\uDCA9x-x\uDCA9\uDCA9]/u;
/BTB-L[x\uDCA9x-\uD83D]/u;
/BTB-LB[x\uDCA9x-\uD83Dx]/u;
/BTB-LL[x\uDCA9x-\uD83D\uD83D]/u;
/BTB-LT[x\uDCA9x-\uD83D\uDCA9]/u;
/BTB-LB[x\uDCA9x-\uD83Dx]/u;
/BTB-LBB[x\uDCA9x-\uD83Dxx]/u;
/BTB-LBL[x\uDCA9x-\uD83Dx\uD83D]/u;
/BTB-LBT[x\uDCA9x-\uD83Dx\uDCA9]/u;
/BTB-LL[x\uDCA9x-\uD83D\uD83D]/u;
/BTB-LLB[x\uDCA9x-\uD83D\uD83Dx]/u;
/BTB-LLL[x\uDCA9x-\uD83D\uD83D\uD83D]/u;
/BTB-LLT[x\uDCA9x-\uD83D\uD83D\uDCA9]/u;
/BTB-LT[x\uDCA9x-\uD83D\uDCA9]/u;
/BTB-LTB[x\uDCA9x-\uD83D\uDCA9x]/u;
/BTB-LTL[x\uDCA9x-\uD83D\uDCA9\uD83D]/u;
/BTB-LTT[x\uDCA9x-\uD83D\uDCA9\uDCA9]/u;
/BTB-T[x\uDCA9x-\uDCA9]/u;
/BTB-TB[x\uDCA9x-\uDCA9x]/u;
/BTB-TL[x\uDCA9x-\uDCA9\uD83D]/u;
/BTB-TT[x\uDCA9x-\uDCA9\uDCA9]/u;
/BTB-TB[x\uDCA9x-\uDCA9x]/u;
/BTB-TBB[x\uDCA9x-\uDCA9xx]/u;
/BTB-TBL[x\uDCA9x-\uDCA9x\uD83D]/u;
/BTB-TBT[x\uDCA9x-\uDCA9x\uDCA9]/u;
/BTB-TL[x\uDCA9x-\uDCA9\uD83D]/u;
/BTB-TLB[x\uDCA9x-\uDCA9\uD83Dx]/u;
/BTB-TLL[x\uDCA9x-\uDCA9\uD83D\uD83D]/u;
/BTB-TLT[x\uDCA9x-\uDCA9\uD83D\uDCA9]/u;
/BTB-TT[x\uDCA9x-\uDCA9\uDCA9]/u;
/BTB-TTB[x\uDCA9x-\uDCA9\uDCA9x]/u;
/BTB-TTL[x\uDCA9x-\uDCA9\uDCA9\uD83D]/u;
/BTB-TTT[x\uDCA9x-\uDCA9\uDCA9\uDCA9]/u;
/BTL-L[x\uDCA9\uD83D-\uD83D]/u;
/BTL-LB[x\uDCA9\uD83D-\uD83Dx]/u;
/BTL-LL[x\uDCA9\uD83D-\uD83D\uD83D]/u;
/BTL-LT[x\uDCA9\uD83D-\uD83D\uDCA9]/u;
/BTL-LB[x\uDCA9\uD83D-\uD83Dx]/u;
/BTL-LBB[x\uDCA9\uD83D-\uD83Dxx]/u;
/BTL-LBL[x\uDCA9\uD83D-\uD83Dx\uD83D]/u;
/BTL-LBT[x\uDCA9\uD83D-\uD83Dx\uDCA9]/u;
/BTL-LL[x\uDCA9\uD83D-\uD83D\uD83D]/u;
/BTL-LLB[x\uDCA9\uD83D-\uD83D\uD83Dx]/u;
/BTL-LLL[x\uDCA9\uD83D-\uD83D\uD83D\uD83D]/u;
/BTL-LLT[x\uDCA9\uD83D-\uD83D\uD83D\uDCA9]/u;
/BTL-LT[x\uDCA9\uD83D-\uD83D\uDCA9]/u;
/BTL-LTB[x\uDCA9\uD83D-\uD83D\uDCA9x]/u;
/BTL-LTL[x\uDCA9\uD83D-\uD83D\uDCA9\uD83D]/u;
/BTL-LTT[x\uDCA9\uD83D-\uD83D\uDCA9\uDCA9]/u;
/BTL-T[x\uDCA9\uD83D-\uDCA9]/u;
/BTL-TB[x\uDCA9\uD83D-\uDCA9x]/u;
/BTL-TL[x\uDCA9\uD83D-\uDCA9\uD83D]/u;
/BTL-TT[x\uDCA9\uD83D-\uDCA9\uDCA9]/u;
/BTL-TB[x\uDCA9\uD83D-\uDCA9x]/u;
/BTL-TBB[x\uDCA9\uD83D-\uDCA9xx]/u;
/BTL-TBL[x\uDCA9\uD83D-\uDCA9x\uD83D]/u;
/BTL-TBT[x\uDCA9\uD83D-\uDCA9x\uDCA9]/u;
/BTL-TL[x\uDCA9\uD83D-\uDCA9\uD83D]/u;
/BTL-TLB[x\uDCA9\uD83D-\uDCA9\uD83Dx]/u;
/BTL-TLL[x\uDCA9\uD83D-\uDCA9\uD83D\uD83D]/u;
/BTL-TLT[x\uDCA9\uD83D-\uDCA9\uD83D\uDCA9]/u;
/BTL-TT[x\uDCA9\uD83D-\uDCA9\uDCA9]/u;
/BTL-TTB[x\uDCA9\uD83D-\uDCA9\uDCA9x]/u;
/BTL-TTL[x\uDCA9\uD83D-\uDCA9\uDCA9\uD83D]/u;
/BTL-TTT[x\uDCA9\uD83D-\uDCA9\uDCA9\uDCA9]/u;
/BTT-LT[x\uDCA9\uDCA9-\uD83D\uDCA9]/u;
/BTT-LT[x\uDCA9\uDCA9-\uD83D\uDCA9]/u;
/BTT-LTB[x\uDCA9\uDCA9-\uD83D\uDCA9x]/u;
/BTT-LTL[x\uDCA9\uDCA9-\uD83D\uDCA9\uD83D]/u;
/BTT-LTT[x\uDCA9\uDCA9-\uD83D\uDCA9\uDCA9]/u;
/BTT-T[x\uDCA9\uDCA9-\uDCA9]/u;
/BTT-TB[x\uDCA9\uDCA9-\uDCA9x]/u;
/BTT-TL[x\uDCA9\uDCA9-\uDCA9\uD83D]/u;
/BTT-TT[x\uDCA9\uDCA9-\uDCA9\uDCA9]/u;
/BTT-TB[x\uDCA9\uDCA9-\uDCA9x]/u;
/BTT-TBB[x\uDCA9\uDCA9-\uDCA9xx]/u;
/BTT-TBL[x\uDCA9\uDCA9-\uDCA9x\uD83D]/u;
/BTT-TBT[x\uDCA9\uDCA9-\uDCA9x\uDCA9]/u;
/BTT-TL[x\uDCA9\uDCA9-\uDCA9\uD83D]/u;
/BTT-TLB[x\uDCA9\uDCA9-\uDCA9\uD83Dx]/u;
/BTT-TLL[x\uDCA9\uDCA9-\uDCA9\uD83D\uD83D]/u;
/BTT-TLT[x\uDCA9\uDCA9-\uDCA9\uD83D\uDCA9]/u;
/BTT-TT[x\uDCA9\uDCA9-\uDCA9\uDCA9]/u;
/BTT-TTB[x\uDCA9\uDCA9-\uDCA9\uDCA9x]/u;
/BTT-TTL[x\uDCA9\uDCA9-\uDCA9\uDCA9\uD83D]/u;
/BTT-TTT[x\uDCA9\uDCA9-\uDCA9\uDCA9\uDCA9]/u;
/LB-B[\uD83Dx-x]/u;
/LB-BB[\uD83Dx-xx]/u;
/LB-BL[\uD83Dx-x\uD83D]/u;
/LB-BT[\uD83Dx-x\uDCA9]/u;
/LB-BB[\uD83Dx-xx]/u;
/LB-BBB[\uD83Dx-xxx]/u;
/LB-BBL[\uD83Dx-xx\uD83D]/u;
/LB-BBT[\uD83Dx-xx\uDCA9]/u;
/LB-BL[\uD83Dx-x\uD83D]/u;
/LB-BLB[\uD83Dx-x\uD83Dx]/u;
/LB-BLL[\uD83Dx-x\uD83D\uD83D]/u;
/LB-BLT[\uD83Dx-x\uD83D\uDCA9]/u;
/LB-BT[\uD83Dx-x\uDCA9]/u;
/LB-BTB[\uD83Dx-x\uDCA9x]/u;
/LB-BTL[\uD83Dx-x\uDCA9\uD83D]/u;
/LB-BTT[\uD83Dx-x\uDCA9\uDCA9]/u;
/LB-L[\uD83Dx-\uD83D]/u;
/LB-LB[\uD83Dx-\uD83Dx]/u;
/LB-LL[\uD83Dx-\uD83D\uD83D]/u;
/LB-LT[\uD83Dx-\uD83D\uDCA9]/u;
/LB-LB[\uD83Dx-\uD83Dx]/u;
/LB-LBB[\uD83Dx-\uD83Dxx]/u;
/LB-LBL[\uD83Dx-\uD83Dx\uD83D]/u;
/LB-LBT[\uD83Dx-\uD83Dx\uDCA9]/u;
/LB-LL[\uD83Dx-\uD83D\uD83D]/u;
/LB-LLB[\uD83Dx-\uD83D\uD83Dx]/u;
/LB-LLL[\uD83Dx-\uD83D\uD83D\uD83D]/u;
/LB-LLT[\uD83Dx-\uD83D\uD83D\uDCA9]/u;
/LB-LT[\uD83Dx-\uD83D\uDCA9]/u;
/LB-LTB[\uD83Dx-\uD83D\uDCA9x]/u;
/LB-LTL[\uD83Dx-\uD83D\uDCA9\uD83D]/u;
/LB-LTT[\uD83Dx-\uD83D\uDCA9\uDCA9]/u;
/LB-T[\uD83Dx-\uDCA9]/u;
/LB-TB[\uD83Dx-\uDCA9x]/u;
/LB-TL[\uD83Dx-\uDCA9\uD83D]/u;
/LB-TT[\uD83Dx-\uDCA9\uDCA9]/u;
/LB-TB[\uD83Dx-\uDCA9x]/u;
/LB-TBB[\uD83Dx-\uDCA9xx]/u;
/LB-TBL[\uD83Dx-\uDCA9x\uD83D]/u;
/LB-TBT[\uD83Dx-\uDCA9x\uDCA9]/u;
/LB-TL[\uD83Dx-\uDCA9\uD83D]/u;
/LB-TLB[\uD83Dx-\uDCA9\uD83Dx]/u;
/LB-TLL[\uD83Dx-\uDCA9\uD83D\uD83D]/u;
/LB-TLT[\uD83Dx-\uDCA9\uD83D\uDCA9]/u;
/LB-TT[\uD83Dx-\uDCA9\uDCA9]/u;
/LB-TTB[\uD83Dx-\uDCA9\uDCA9x]/u;
/LB-TTL[\uD83Dx-\uDCA9\uDCA9\uD83D]/u;
/LB-TTT[\uD83Dx-\uDCA9\uDCA9\uDCA9]/u;
/LL-L[\uD83D\uD83D-\uD83D]/u;
/LL-LB[\uD83D\uD83D-\uD83Dx]/u;
/LL-LL[\uD83D\uD83D-\uD83D\uD83D]/u;
/LL-LT[\uD83D\uD83D-\uD83D\uDCA9]/u;
/LL-LB[\uD83D\uD83D-\uD83Dx]/u;
/LL-LBB[\uD83D\uD83D-\uD83Dxx]/u;
/LL-LBL[\uD83D\uD83D-\uD83Dx\uD83D]/u;
/LL-LBT[\uD83D\uD83D-\uD83Dx\uDCA9]/u;
/LL-LL[\uD83D\uD83D-\uD83D\uD83D]/u;
/LL-LLB[\uD83D\uD83D-\uD83D\uD83Dx]/u;
/LL-LLL[\uD83D\uD83D-\uD83D\uD83D\uD83D]/u;
/LL-LLT[\uD83D\uD83D-\uD83D\uD83D\uDCA9]/u;
/LL-LT[\uD83D\uD83D-\uD83D\uDCA9]/u;
/LL-LTB[\uD83D\uD83D-\uD83D\uDCA9x]/u;
/LL-LTL[\uD83D\uD83D-\uD83D\uDCA9\uD83D]/u;
/LL-LTT[\uD83D\uD83D-\uD83D\uDCA9\uDCA9]/u;
/LL-T[\uD83D\uD83D-\uDCA9]/u;
/LL-TB[\uD83D\uD83D-\uDCA9x]/u;
/LL-TL[\uD83D\uD83D-\uDCA9\uD83D]/u;
/LL-TT[\uD83D\uD83D-\uDCA9\uDCA9]/u;
/LL-TB[\uD83D\uD83D-\uDCA9x]/u;
/LL-TBB[\uD83D\uD83D-\uDCA9xx]/u;
/LL-TBL[\uD83D\uD83D-\uDCA9x\uD83D]/u;
/LL-TBT[\uD83D\uD83D-\uDCA9x\uDCA9]/u;
/LL-TL[\uD83D\uD83D-\uDCA9\uD83D]/u;
/LL-TLB[\uD83D\uD83D-\uDCA9\uD83Dx]/u;
/LL-TLL[\uD83D\uD83D-\uDCA9\uD83D\uD83D]/u;
/LL-TLT[\uD83D\uD83D-\uDCA9\uD83D\uDCA9]/u;
/LL-TT[\uD83D\uD83D-\uDCA9\uDCA9]/u;
/LL-TTB[\uD83D\uD83D-\uDCA9\uDCA9x]/u;
/LL-TTL[\uD83D\uD83D-\uDCA9\uDCA9\uD83D]/u;
/LL-TTT[\uD83D\uD83D-\uDCA9\uDCA9\uDCA9]/u;
/LT-LT[\uD83D\uDCA9-\uD83D\uDCA9]/u;
/LT-LT[\uD83D\uDCA9-\uD83D\uDCA9]/u;
/LT-LTB[\uD83D\uDCA9-\uD83D\uDCA9x]/u;
/LT-LTL[\uD83D\uDCA9-\uD83D\uDCA9\uD83D]/u;
/LT-LTT[\uD83D\uDCA9-\uD83D\uDCA9\uDCA9]/u;
/LBB-B[\uD83Dxx-x]/u;
/LBB-BB[\uD83Dxx-xx]/u;
/LBB-BL[\uD83Dxx-x\uD83D]/u;
/LBB-BT[\uD83Dxx-x\uDCA9]/u;
/LBB-BB[\uD83Dxx-xx]/u;
/LBB-BBB[\uD83Dxx-xxx]/u;
/LBB-BBL[\uD83Dxx-xx\uD83D]/u;
/LBB-BBT[\uD83Dxx-xx\uDCA9]/u;
/LBB-BL[\uD83Dxx-x\uD83D]/u;
/LBB-BLB[\uD83Dxx-x\uD83Dx]/u;
/LBB-BLL[\uD83Dxx-x\uD83D\uD83D]/u;
/LBB-BLT[\uD83Dxx-x\uD83D\uDCA9]/u;
/LBB-BT[\uD83Dxx-x\uDCA9]/u;
/LBB-BTB[\uD83Dxx-x\uDCA9x]/u;
/LBB-BTL[\uD83Dxx-x\uDCA9\uD83D]/u;
/LBB-BTT[\uD83Dxx-x\uDCA9\uDCA9]/u;
/LBB-L[\uD83Dxx-\uD83D]/u;
/LBB-LB[\uD83Dxx-\uD83Dx]/u;
/LBB-LL[\uD83Dxx-\uD83D\uD83D]/u;
/LBB-LT[\uD83Dxx-\uD83D\uDCA9]/u;
/LBB-LB[\uD83Dxx-\uD83Dx]/u;
/LBB-LBB[\uD83Dxx-\uD83Dxx]/u;
/LBB-LBL[\uD83Dxx-\uD83Dx\uD83D]/u;
/LBB-LBT[\uD83Dxx-\uD83Dx\uDCA9]/u;
/LBB-LL[\uD83Dxx-\uD83D\uD83D]/u;
/LBB-LLB[\uD83Dxx-\uD83D\uD83Dx]/u;
/LBB-LLL[\uD83Dxx-\uD83D\uD83D\uD83D]/u;
/LBB-LLT[\uD83Dxx-\uD83D\uD83D\uDCA9]/u;
/LBB-LT[\uD83Dxx-\uD83D\uDCA9]/u;
/LBB-LTB[\uD83Dxx-\uD83D\uDCA9x]/u;
/LBB-LTL[\uD83Dxx-\uD83D\uDCA9\uD83D]/u;
/LBB-LTT[\uD83Dxx-\uD83D\uDCA9\uDCA9]/u;
/LBB-T[\uD83Dxx-\uDCA9]/u;
/LBB-TB[\uD83Dxx-\uDCA9x]/u;
/LBB-TL[\uD83Dxx-\uDCA9\uD83D]/u;
/LBB-TT[\uD83Dxx-\uDCA9\uDCA9]/u;
/LBB-TB[\uD83Dxx-\uDCA9x]/u;
/LBB-TBB[\uD83Dxx-\uDCA9xx]/u;
/LBB-TBL[\uD83Dxx-\uDCA9x\uD83D]/u;
/LBB-TBT[\uD83Dxx-\uDCA9x\uDCA9]/u;
/LBB-TL[\uD83Dxx-\uDCA9\uD83D]/u;
/LBB-TLB[\uD83Dxx-\uDCA9\uD83Dx]/u;
/LBB-TLL[\uD83Dxx-\uDCA9\uD83D\uD83D]/u;
/LBB-TLT[\uD83Dxx-\uDCA9\uD83D\uDCA9]/u;
/LBB-TT[\uD83Dxx-\uDCA9\uDCA9]/u;
/LBB-TTB[\uD83Dxx-\uDCA9\uDCA9x]/u;
/LBB-TTL[\uD83Dxx-\uDCA9\uDCA9\uD83D]/u;
/LBB-TTT[\uD83Dxx-\uDCA9\uDCA9\uDCA9]/u;
/LBL-L[\uD83Dx\uD83D-\uD83D]/u;
/LBL-LB[\uD83Dx\uD83D-\uD83Dx]/u;
/LBL-LL[\uD83Dx\uD83D-\uD83D\uD83D]/u;
/LBL-LT[\uD83Dx\uD83D-\uD83D\uDCA9]/u;
/LBL-LB[\uD83Dx\uD83D-\uD83Dx]/u;
/LBL-LBB[\uD83Dx\uD83D-\uD83Dxx]/u;
/LBL-LBL[\uD83Dx\uD83D-\uD83Dx\uD83D]/u;
/LBL-LBT[\uD83Dx\uD83D-\uD83Dx\uDCA9]/u;
/LBL-LL[\uD83Dx\uD83D-\uD83D\uD83D]/u;
/LBL-LLB[\uD83Dx\uD83D-\uD83D\uD83Dx]/u;
/LBL-LLL[\uD83Dx\uD83D-\uD83D\uD83D\uD83D]/u;
/LBL-LLT[\uD83Dx\uD83D-\uD83D\uD83D\uDCA9]/u;
/LBL-LT[\uD83Dx\uD83D-\uD83D\uDCA9]/u;
/LBL-LTB[\uD83Dx\uD83D-\uD83D\uDCA9x]/u;
/LBL-LTL[\uD83Dx\uD83D-\uD83D\uDCA9\uD83D]/u;
/LBL-LTT[\uD83Dx\uD83D-\uD83D\uDCA9\uDCA9]/u;
/LBL-T[\uD83Dx\uD83D-\uDCA9]/u;
/LBL-TB[\uD83Dx\uD83D-\uDCA9x]/u;
/LBL-TL[\uD83Dx\uD83D-\uDCA9\uD83D]/u;
/LBL-TT[\uD83Dx\uD83D-\uDCA9\uDCA9]/u;
/LBL-TB[\uD83Dx\uD83D-\uDCA9x]/u;
/LBL-TBB[\uD83Dx\uD83D-\uDCA9xx]/u;
/LBL-TBL[\uD83Dx\uD83D-\uDCA9x\uD83D]/u;
/LBL-TBT[\uD83Dx\uD83D-\uDCA9x\uDCA9]/u;
/LBL-TL[\uD83Dx\uD83D-\uDCA9\uD83D]/u;
/LBL-TLB[\uD83Dx\uD83D-\uDCA9\uD83Dx]/u;
/LBL-TLL[\uD83Dx\uD83D-\uDCA9\uD83D\uD83D]/u;
/LBL-TLT[\uD83Dx\uD83D-\uDCA9\uD83D\uDCA9]/u;
/LBL-TT[\uD83Dx\uD83D-\uDCA9\uDCA9]/u;
/LBL-TTB[\uD83Dx\uD83D-\uDCA9\uDCA9x]/u;
/LBL-TTL[\uD83Dx\uD83D-\uDCA9\uDCA9\uD83D]/u;
/LBL-TTT[\uD83Dx\uD83D-\uDCA9\uDCA9\uDCA9]/u;
/LBT-LT[\uD83Dx\uDCA9-\uD83D\uDCA9]/u;
/LBT-LT[\uD83Dx\uDCA9-\uD83D\uDCA9]/u;
/LBT-LTB[\uD83Dx\uDCA9-\uD83D\uDCA9x]/u;
/LBT-LTL[\uD83Dx\uDCA9-\uD83D\uDCA9\uD83D]/u;
/LBT-LTT[\uD83Dx\uDCA9-\uD83D\uDCA9\uDCA9]/u;
/LBT-T[\uD83Dx\uDCA9-\uDCA9]/u;
/LBT-TB[\uD83Dx\uDCA9-\uDCA9x]/u;
/LBT-TL[\uD83Dx\uDCA9-\uDCA9\uD83D]/u;
/LBT-TT[\uD83Dx\uDCA9-\uDCA9\uDCA9]/u;
/LBT-TB[\uD83Dx\uDCA9-\uDCA9x]/u;
/LBT-TBB[\uD83Dx\uDCA9-\uDCA9xx]/u;
/LBT-TBL[\uD83Dx\uDCA9-\uDCA9x\uD83D]/u;
/LBT-TBT[\uD83Dx\uDCA9-\uDCA9x\uDCA9]/u;
/LBT-TL[\uD83Dx\uDCA9-\uDCA9\uD83D]/u;
/LBT-TLB[\uD83Dx\uDCA9-\uDCA9\uD83Dx]/u;
/LBT-TLL[\uD83Dx\uDCA9-\uDCA9\uD83D\uD83D]/u;
/LBT-TLT[\uD83Dx\uDCA9-\uDCA9\uD83D\uDCA9]/u;
/LBT-TT[\uD83Dx\uDCA9-\uDCA9\uDCA9]/u;
/LBT-TTB[\uD83Dx\uDCA9-\uDCA9\uDCA9x]/u;
/LBT-TTL[\uD83Dx\uDCA9-\uDCA9\uDCA9\uD83D]/u;
/LBT-TTT[\uD83Dx\uDCA9-\uDCA9\uDCA9\uDCA9]/u;
/LLB-B[\uD83D\uD83Dx-x]/u;
/LLB-BB[\uD83D\uD83Dx-xx]/u;
/LLB-BL[\uD83D\uD83Dx-x\uD83D]/u;
/LLB-BT[\uD83D\uD83Dx-x\uDCA9]/u;
/LLB-BB[\uD83D\uD83Dx-xx]/u;
/LLB-BBB[\uD83D\uD83Dx-xxx]/u;
/LLB-BBL[\uD83D\uD83Dx-xx\uD83D]/u;
/LLB-BBT[\uD83D\uD83Dx-xx\uDCA9]/u;
/LLB-BL[\uD83D\uD83Dx-x\uD83D]/u;
/LLB-BLB[\uD83D\uD83Dx-x\uD83Dx]/u;
/LLB-BLL[\uD83D\uD83Dx-x\uD83D\uD83D]/u;
/LLB-BLT[\uD83D\uD83Dx-x\uD83D\uDCA9]/u;
/LLB-BT[\uD83D\uD83Dx-x\uDCA9]/u;
/LLB-BTB[\uD83D\uD83Dx-x\uDCA9x]/u;
/LLB-BTL[\uD83D\uD83Dx-x\uDCA9\uD83D]/u;
/LLB-BTT[\uD83D\uD83Dx-x\uDCA9\uDCA9]/u;
/LLB-L[\uD83D\uD83Dx-\uD83D]/u;
/LLB-LB[\uD83D\uD83Dx-\uD83Dx]/u;
/LLB-LL[\uD83D\uD83Dx-\uD83D\uD83D]/u;
/LLB-LT[\uD83D\uD83Dx-\uD83D\uDCA9]/u;
/LLB-LB[\uD83D\uD83Dx-\uD83Dx]/u;
/LLB-LBB[\uD83D\uD83Dx-\uD83Dxx]/u;
/LLB-LBL[\uD83D\uD83Dx-\uD83Dx\uD83D]/u;
/LLB-LBT[\uD83D\uD83Dx-\uD83Dx\uDCA9]/u;
/LLB-LL[\uD83D\uD83Dx-\uD83D\uD83D]/u;
/LLB-LLB[\uD83D\uD83Dx-\uD83D\uD83Dx]/u;
/LLB-LLL[\uD83D\uD83Dx-\uD83D\uD83D\uD83D]/u;
/LLB-LLT[\uD83D\uD83Dx-\uD83D\uD83D\uDCA9]/u;
/LLB-LT[\uD83D\uD83Dx-\uD83D\uDCA9]/u;
/LLB-LTB[\uD83D\uD83Dx-\uD83D\uDCA9x]/u;
/LLB-LTL[\uD83D\uD83Dx-\uD83D\uDCA9\uD83D]/u;
/LLB-LTT[\uD83D\uD83Dx-\uD83D\uDCA9\uDCA9]/u;
/LLB-T[\uD83D\uD83Dx-\uDCA9]/u;
/LLB-TB[\uD83D\uD83Dx-\uDCA9x]/u;
/LLB-TL[\uD83D\uD83Dx-\uDCA9\uD83D]/u;
/LLB-TT[\uD83D\uD83Dx-\uDCA9\uDCA9]/u;
/LLB-TB[\uD83D\uD83Dx-\uDCA9x]/u;
/LLB-TBB[\uD83D\uD83Dx-\uDCA9xx]/u;
/LLB-TBL[\uD83D\uD83Dx-\uDCA9x\uD83D]/u;
/LLB-TBT[\uD83D\uD83Dx-\uDCA9x\uDCA9]/u;
/LLB-TL[\uD83D\uD83Dx-\uDCA9\uD83D]/u;
/LLB-TLB[\uD83D\uD83Dx-\uDCA9\uD83Dx]/u;
/LLB-TLL[\uD83D\uD83Dx-\uDCA9\uD83D\uD83D]/u;
/LLB-TLT[\uD83D\uD83Dx-\uDCA9\uD83D\uDCA9]/u;
/LLB-TT[\uD83D\uD83Dx-\uDCA9\uDCA9]/u;
/LLB-TTB[\uD83D\uD83Dx-\uDCA9\uDCA9x]/u;
/LLB-TTL[\uD83D\uD83Dx-\uDCA9\uDCA9\uD83D]/u;
/LLB-TTT[\uD83D\uD83Dx-\uDCA9\uDCA9\uDCA9]/u;
/LLL-L[\uD83D\uD83D\uD83D-\uD83D]/u;
/LLL-LB[\uD83D\uD83D\uD83D-\uD83Dx]/u;
/LLL-LL[\uD83D\uD83D\uD83D-\uD83D\uD83D]/u;
/LLL-LT[\uD83D\uD83D\uD83D-\uD83D\uDCA9]/u;
/LLL-LB[\uD83D\uD83D\uD83D-\uD83Dx]/u;
/LLL-LBB[\uD83D\uD83D\uD83D-\uD83Dxx]/u;
/LLL-LBL[\uD83D\uD83D\uD83D-\uD83Dx\uD83D]/u;
/LLL-LBT[\uD83D\uD83D\uD83D-\uD83Dx\uDCA9]/u;
/LLL-LL[\uD83D\uD83D\uD83D-\uD83D\uD83D]/u;
/LLL-LLB[\uD83D\uD83D\uD83D-\uD83D\uD83Dx]/u;
/LLL-LLL[\uD83D\uD83D\uD83D-\uD83D\uD83D\uD83D]/u;
/LLL-LLT[\uD83D\uD83D\uD83D-\uD83D\uD83D\uDCA9]/u;
/LLL-LT[\uD83D\uD83D\uD83D-\uD83D\uDCA9]/u;
/LLL-LTB[\uD83D\uD83D\uD83D-\uD83D\uDCA9x]/u;
/LLL-LTL[\uD83D\uD83D\uD83D-\uD83D\uDCA9\uD83D]/u;
/LLL-LTT[\uD83D\uD83D\uD83D-\uD83D\uDCA9\uDCA9]/u;
/LLL-T[\uD83D\uD83D\uD83D-\uDCA9]/u;
/LLL-TB[\uD83D\uD83D\uD83D-\uDCA9x]/u;
/LLL-TL[\uD83D\uD83D\uD83D-\uDCA9\uD83D]/u;
/LLL-TT[\uD83D\uD83D\uD83D-\uDCA9\uDCA9]/u;
/LLL-TB[\uD83D\uD83D\uD83D-\uDCA9x]/u;
/LLL-TBB[\uD83D\uD83D\uD83D-\uDCA9xx]/u;
/LLL-TBL[\uD83D\uD83D\uD83D-\uDCA9x\uD83D]/u;
/LLL-TBT[\uD83D\uD83D\uD83D-\uDCA9x\uDCA9]/u;
/LLL-TL[\uD83D\uD83D\uD83D-\uDCA9\uD83D]/u;
/LLL-TLB[\uD83D\uD83D\uD83D-\uDCA9\uD83Dx]/u;
/LLL-TLL[\uD83D\uD83D\uD83D-\uDCA9\uD83D\uD83D]/u;
/LLL-TLT[\uD83D\uD83D\uD83D-\uDCA9\uD83D\uDCA9]/u;
/LLL-TT[\uD83D\uD83D\uD83D-\uDCA9\uDCA9]/u;
/LLL-TTB[\uD83D\uD83D\uD83D-\uDCA9\uDCA9x]/u;
/LLL-TTL[\uD83D\uD83D\uD83D-\uDCA9\uDCA9\uD83D]/u;
/LLL-TTT[\uD83D\uD83D\uD83D-\uDCA9\uDCA9\uDCA9]/u;
/LLT-LT[\uD83D\uD83D\uDCA9-\uD83D\uDCA9]/u;
/LLT-LT[\uD83D\uD83D\uDCA9-\uD83D\uDCA9]/u;
/LLT-LTB[\uD83D\uD83D\uDCA9-\uD83D\uDCA9x]/u;
/LLT-LTL[\uD83D\uD83D\uDCA9-\uD83D\uDCA9\uD83D]/u;
/LLT-LTT[\uD83D\uD83D\uDCA9-\uD83D\uDCA9\uDCA9]/u;
/LTB-B[\uD83D\uDCA9x-x]/u;
/LTB-BB[\uD83D\uDCA9x-xx]/u;
/LTB-BL[\uD83D\uDCA9x-x\uD83D]/u;
/LTB-BT[\uD83D\uDCA9x-x\uDCA9]/u;
/LTB-BB[\uD83D\uDCA9x-xx]/u;
/LTB-BBB[\uD83D\uDCA9x-xxx]/u;
/LTB-BBL[\uD83D\uDCA9x-xx\uD83D]/u;
/LTB-BBT[\uD83D\uDCA9x-xx\uDCA9]/u;
/LTB-BL[\uD83D\uDCA9x-x\uD83D]/u;
/LTB-BLB[\uD83D\uDCA9x-x\uD83Dx]/u;
/LTB-BLL[\uD83D\uDCA9x-x\uD83D\uD83D]/u;
/LTB-BLT[\uD83D\uDCA9x-x\uD83D\uDCA9]/u;
/LTB-BT[\uD83D\uDCA9x-x\uDCA9]/u;
/LTB-BTB[\uD83D\uDCA9x-x\uDCA9x]/u;
/LTB-BTL[\uD83D\uDCA9x-x\uDCA9\uD83D]/u;
/LTB-BTT[\uD83D\uDCA9x-x\uDCA9\uDCA9]/u;
/LTB-L[\uD83D\uDCA9x-\uD83D]/u;
/LTB-LB[\uD83D\uDCA9x-\uD83Dx]/u;
/LTB-LL[\uD83D\uDCA9x-\uD83D\uD83D]/u;
/LTB-LT[\uD83D\uDCA9x-\uD83D\uDCA9]/u;
/LTB-LB[\uD83D\uDCA9x-\uD83Dx]/u;
/LTB-LBB[\uD83D\uDCA9x-\uD83Dxx]/u;
/LTB-LBL[\uD83D\uDCA9x-\uD83Dx\uD83D]/u;
/LTB-LBT[\uD83D\uDCA9x-\uD83Dx\uDCA9]/u;
/LTB-LL[\uD83D\uDCA9x-\uD83D\uD83D]/u;
/LTB-LLB[\uD83D\uDCA9x-\uD83D\uD83Dx]/u;
/LTB-LLL[\uD83D\uDCA9x-\uD83D\uD83D\uD83D]/u;
/LTB-LLT[\uD83D\uDCA9x-\uD83D\uD83D\uDCA9]/u;
/LTB-LT[\uD83D\uDCA9x-\uD83D\uDCA9]/u;
/LTB-LTB[\uD83D\uDCA9x-\uD83D\uDCA9x]/u;
/LTB-LTL[\uD83D\uDCA9x-\uD83D\uDCA9\uD83D]/u;
/LTB-LTT[\uD83D\uDCA9x-\uD83D\uDCA9\uDCA9]/u;
/LTB-T[\uD83D\uDCA9x-\uDCA9]/u;
/LTB-TB[\uD83D\uDCA9x-\uDCA9x]/u;
/LTB-TL[\uD83D\uDCA9x-\uDCA9\uD83D]/u;
/LTB-TT[\uD83D\uDCA9x-\uDCA9\uDCA9]/u;
/LTB-TB[\uD83D\uDCA9x-\uDCA9x]/u;
/LTB-TBB[\uD83D\uDCA9x-\uDCA9xx]/u;
/LTB-TBL[\uD83D\uDCA9x-\uDCA9x\uD83D]/u;
/LTB-TBT[\uD83D\uDCA9x-\uDCA9x\uDCA9]/u;
/LTB-TL[\uD83D\uDCA9x-\uDCA9\uD83D]/u;
/LTB-TLB[\uD83D\uDCA9x-\uDCA9\uD83Dx]/u;
/LTB-TLL[\uD83D\uDCA9x-\uDCA9\uD83D\uD83D]/u;
/LTB-TLT[\uD83D\uDCA9x-\uDCA9\uD83D\uDCA9]/u;
/LTB-TT[\uD83D\uDCA9x-\uDCA9\uDCA9]/u;
/LTB-TTB[\uD83D\uDCA9x-\uDCA9\uDCA9x]/u;
/LTB-TTL[\uD83D\uDCA9x-\uDCA9\uDCA9\uD83D]/u;
/LTB-TTT[\uD83D\uDCA9x-\uDCA9\uDCA9\uDCA9]/u;
/LTL-L[\uD83D\uDCA9\uD83D-\uD83D]/u;
/LTL-LB[\uD83D\uDCA9\uD83D-\uD83Dx]/u;
/LTL-LL[\uD83D\uDCA9\uD83D-\uD83D\uD83D]/u;
/LTL-LT[\uD83D\uDCA9\uD83D-\uD83D\uDCA9]/u;
/LTL-LB[\uD83D\uDCA9\uD83D-\uD83Dx]/u;
/LTL-LBB[\uD83D\uDCA9\uD83D-\uD83Dxx]/u;
/LTL-LBL[\uD83D\uDCA9\uD83D-\uD83Dx\uD83D]/u;
/LTL-LBT[\uD83D\uDCA9\uD83D-\uD83Dx\uDCA9]/u;
/LTL-LL[\uD83D\uDCA9\uD83D-\uD83D\uD83D]/u;
/LTL-LLB[\uD83D\uDCA9\uD83D-\uD83D\uD83Dx]/u;
/LTL-LLL[\uD83D\uDCA9\uD83D-\uD83D\uD83D\uD83D]/u;
/LTL-LLT[\uD83D\uDCA9\uD83D-\uD83D\uD83D\uDCA9]/u;
/LTL-LT[\uD83D\uDCA9\uD83D-\uD83D\uDCA9]/u;
/LTL-LTB[\uD83D\uDCA9\uD83D-\uD83D\uDCA9x]/u;
/LTL-LTL[\uD83D\uDCA9\uD83D-\uD83D\uDCA9\uD83D]/u;
/LTL-LTT[\uD83D\uDCA9\uD83D-\uD83D\uDCA9\uDCA9]/u;
/LTL-T[\uD83D\uDCA9\uD83D-\uDCA9]/u;
/LTL-TB[\uD83D\uDCA9\uD83D-\uDCA9x]/u;
/LTL-TL[\uD83D\uDCA9\uD83D-\uDCA9\uD83D]/u;
/LTL-TT[\uD83D\uDCA9\uD83D-\uDCA9\uDCA9]/u;
/LTL-TB[\uD83D\uDCA9\uD83D-\uDCA9x]/u;
/LTL-TBB[\uD83D\uDCA9\uD83D-\uDCA9xx]/u;
/LTL-TBL[\uD83D\uDCA9\uD83D-\uDCA9x\uD83D]/u;
/LTL-TBT[\uD83D\uDCA9\uD83D-\uDCA9x\uDCA9]/u;
/LTL-TL[\uD83D\uDCA9\uD83D-\uDCA9\uD83D]/u;
/LTL-TLB[\uD83D\uDCA9\uD83D-\uDCA9\uD83Dx]/u;
/LTL-TLL[\uD83D\uDCA9\uD83D-\uDCA9\uD83D\uD83D]/u;
/LTL-TLT[\uD83D\uDCA9\uD83D-\uDCA9\uD83D\uDCA9]/u;
/LTL-TT[\uD83D\uDCA9\uD83D-\uDCA9\uDCA9]/u;
/LTL-TTB[\uD83D\uDCA9\uD83D-\uDCA9\uDCA9x]/u;
/LTL-TTL[\uD83D\uDCA9\uD83D-\uDCA9\uDCA9\uD83D]/u;
/LTL-TTT[\uD83D\uDCA9\uD83D-\uDCA9\uDCA9\uDCA9]/u;
/LTT-LT[\uD83D\uDCA9\uDCA9-\uD83D\uDCA9]/u;
/LTT-LT[\uD83D\uDCA9\uDCA9-\uD83D\uDCA9]/u;
/LTT-LTB[\uD83D\uDCA9\uDCA9-\uD83D\uDCA9x]/u;
/LTT-LTL[\uD83D\uDCA9\uDCA9-\uD83D\uDCA9\uD83D]/u;
/LTT-LTT[\uD83D\uDCA9\uDCA9-\uD83D\uDCA9\uDCA9]/u;
/LTT-T[\uD83D\uDCA9\uDCA9-\uDCA9]/u;
/LTT-TB[\uD83D\uDCA9\uDCA9-\uDCA9x]/u;
/LTT-TL[\uD83D\uDCA9\uDCA9-\uDCA9\uD83D]/u;
/LTT-TT[\uD83D\uDCA9\uDCA9-\uDCA9\uDCA9]/u;
/LTT-TB[\uD83D\uDCA9\uDCA9-\uDCA9x]/u;
/LTT-TBB[\uD83D\uDCA9\uDCA9-\uDCA9xx]/u;
/LTT-TBL[\uD83D\uDCA9\uDCA9-\uDCA9x\uD83D]/u;
/LTT-TBT[\uD83D\uDCA9\uDCA9-\uDCA9x\uDCA9]/u;
/LTT-TL[\uD83D\uDCA9\uDCA9-\uDCA9\uD83D]/u;
/LTT-TLB[\uD83D\uDCA9\uDCA9-\uDCA9\uD83Dx]/u;
/LTT-TLL[\uD83D\uDCA9\uDCA9-\uDCA9\uD83D\uD83D]/u;
/LTT-TLT[\uD83D\uDCA9\uDCA9-\uDCA9\uD83D\uDCA9]/u;
/LTT-TT[\uD83D\uDCA9\uDCA9-\uDCA9\uDCA9]/u;
/LTT-TTB[\uD83D\uDCA9\uDCA9-\uDCA9\uDCA9x]/u;
/LTT-TTL[\uD83D\uDCA9\uDCA9-\uDCA9\uDCA9\uD83D]/u;
/LTT-TTT[\uD83D\uDCA9\uDCA9-\uDCA9\uDCA9\uDCA9]/u;
/TB-B[\uDCA9x-x]/u;
/TB-BB[\uDCA9x-xx]/u;
/TB-BL[\uDCA9x-x\uD83D]/u;
/TB-BT[\uDCA9x-x\uDCA9]/u;
/TB-BB[\uDCA9x-xx]/u;
/TB-BBB[\uDCA9x-xxx]/u;
/TB-BBL[\uDCA9x-xx\uD83D]/u;
/TB-BBT[\uDCA9x-xx\uDCA9]/u;
/TB-BL[\uDCA9x-x\uD83D]/u;
/TB-BLB[\uDCA9x-x\uD83Dx]/u;
/TB-BLL[\uDCA9x-x\uD83D\uD83D]/u;
/TB-BLT[\uDCA9x-x\uD83D\uDCA9]/u;
/TB-BT[\uDCA9x-x\uDCA9]/u;
/TB-BTB[\uDCA9x-x\uDCA9x]/u;
/TB-BTL[\uDCA9x-x\uDCA9\uD83D]/u;
/TB-BTT[\uDCA9x-x\uDCA9\uDCA9]/u;
/TB-L[\uDCA9x-\uD83D]/u;
/TB-LB[\uDCA9x-\uD83Dx]/u;
/TB-LL[\uDCA9x-\uD83D\uD83D]/u;
/TB-LT[\uDCA9x-\uD83D\uDCA9]/u;
/TB-LB[\uDCA9x-\uD83Dx]/u;
/TB-LBB[\uDCA9x-\uD83Dxx]/u;
/TB-LBL[\uDCA9x-\uD83Dx\uD83D]/u;
/TB-LBT[\uDCA9x-\uD83Dx\uDCA9]/u;
/TB-LL[\uDCA9x-\uD83D\uD83D]/u;
/TB-LLB[\uDCA9x-\uD83D\uD83Dx]/u;
/TB-LLL[\uDCA9x-\uD83D\uD83D\uD83D]/u;
/TB-LLT[\uDCA9x-\uD83D\uD83D\uDCA9]/u;
/TB-LT[\uDCA9x-\uD83D\uDCA9]/u;
/TB-LTB[\uDCA9x-\uD83D\uDCA9x]/u;
/TB-LTL[\uDCA9x-\uD83D\uDCA9\uD83D]/u;
/TB-LTT[\uDCA9x-\uD83D\uDCA9\uDCA9]/u;
/TB-T[\uDCA9x-\uDCA9]/u;
/TB-TB[\uDCA9x-\uDCA9x]/u;
/TB-TL[\uDCA9x-\uDCA9\uD83D]/u;
/TB-TT[\uDCA9x-\uDCA9\uDCA9]/u;
/TB-TB[\uDCA9x-\uDCA9x]/u;
/TB-TBB[\uDCA9x-\uDCA9xx]/u;
/TB-TBL[\uDCA9x-\uDCA9x\uD83D]/u;
/TB-TBT[\uDCA9x-\uDCA9x\uDCA9]/u;
/TB-TL[\uDCA9x-\uDCA9\uD83D]/u;
/TB-TLB[\uDCA9x-\uDCA9\uD83Dx]/u;
/TB-TLL[\uDCA9x-\uDCA9\uD83D\uD83D]/u;
/TB-TLT[\uDCA9x-\uDCA9\uD83D\uDCA9]/u;
/TB-TT[\uDCA9x-\uDCA9\uDCA9]/u;
/TB-TTB[\uDCA9x-\uDCA9\uDCA9x]/u;
/TB-TTL[\uDCA9x-\uDCA9\uDCA9\uD83D]/u;
/TB-TTT[\uDCA9x-\uDCA9\uDCA9\uDCA9]/u;
/TL-L[\uDCA9\uD83D-\uD83D]/u;
/TL-LB[\uDCA9\uD83D-\uD83Dx]/u;
/TL-LL[\uDCA9\uD83D-\uD83D\uD83D]/u;
/TL-LT[\uDCA9\uD83D-\uD83D\uDCA9]/u;
/TL-LB[\uDCA9\uD83D-\uD83Dx]/u;
/TL-LBB[\uDCA9\uD83D-\uD83Dxx]/u;
/TL-LBL[\uDCA9\uD83D-\uD83Dx\uD83D]/u;
/TL-LBT[\uDCA9\uD83D-\uD83Dx\uDCA9]/u;
/TL-LL[\uDCA9\uD83D-\uD83D\uD83D]/u;
/TL-LLB[\uDCA9\uD83D-\uD83D\uD83Dx]/u;
/TL-LLL[\uDCA9\uD83D-\uD83D\uD83D\uD83D]/u;
/TL-LLT[\uDCA9\uD83D-\uD83D\uD83D\uDCA9]/u;
/TL-LT[\uDCA9\uD83D-\uD83D\uDCA9]/u;
/TL-LTB[\uDCA9\uD83D-\uD83D\uDCA9x]/u;
/TL-LTL[\uDCA9\uD83D-\uD83D\uDCA9\uD83D]/u;
/TL-LTT[\uDCA9\uD83D-\uD83D\uDCA9\uDCA9]/u;
/TL-T[\uDCA9\uD83D-\uDCA9]/u;
/TL-TB[\uDCA9\uD83D-\uDCA9x]/u;
/TL-TL[\uDCA9\uD83D-\uDCA9\uD83D]/u;
/TL-TT[\uDCA9\uD83D-\uDCA9\uDCA9]/u;
/TL-TB[\uDCA9\uD83D-\uDCA9x]/u;
/TL-TBB[\uDCA9\uD83D-\uDCA9xx]/u;
/TL-TBL[\uDCA9\uD83D-\uDCA9x\uD83D]/u;
/TL-TBT[\uDCA9\uD83D-\uDCA9x\uDCA9]/u;
/TL-TL[\uDCA9\uD83D-\uDCA9\uD83D]/u;
/TL-TLB[\uDCA9\uD83D-\uDCA9\uD83Dx]/u;
/TL-TLL[\uDCA9\uD83D-\uDCA9\uD83D\uD83D]/u;
/TL-TLT[\uDCA9\uD83D-\uDCA9\uD83D\uDCA9]/u;
/TL-TT[\uDCA9\uD83D-\uDCA9\uDCA9]/u;
/TL-TTB[\uDCA9\uD83D-\uDCA9\uDCA9x]/u;
/TL-TTL[\uDCA9\uD83D-\uDCA9\uDCA9\uD83D]/u;
/TL-TTT[\uDCA9\uD83D-\uDCA9\uDCA9\uDCA9]/u;
/TT-LT[\uDCA9\uDCA9-\uD83D\uDCA9]/u;
/TT-LT[\uDCA9\uDCA9-\uD83D\uDCA9]/u;
/TT-LTB[\uDCA9\uDCA9-\uD83D\uDCA9x]/u;
/TT-LTL[\uDCA9\uDCA9-\uD83D\uDCA9\uD83D]/u;
/TT-LTT[\uDCA9\uDCA9-\uD83D\uDCA9\uDCA9]/u;
/TT-T[\uDCA9\uDCA9-\uDCA9]/u;
/TT-TB[\uDCA9\uDCA9-\uDCA9x]/u;
/TT-TL[\uDCA9\uDCA9-\uDCA9\uD83D]/u;
/TT-TT[\uDCA9\uDCA9-\uDCA9\uDCA9]/u;
/TT-TB[\uDCA9\uDCA9-\uDCA9x]/u;
/TT-TBB[\uDCA9\uDCA9-\uDCA9xx]/u;
/TT-TBL[\uDCA9\uDCA9-\uDCA9x\uD83D]/u;
/TT-TBT[\uDCA9\uDCA9-\uDCA9x\uDCA9]/u;
/TT-TL[\uDCA9\uDCA9-\uDCA9\uD83D]/u;
/TT-TLB[\uDCA9\uDCA9-\uDCA9\uD83Dx]/u;
/TT-TLL[\uDCA9\uDCA9-\uDCA9\uD83D\uD83D]/u;
/TT-TLT[\uDCA9\uDCA9-\uDCA9\uD83D\uDCA9]/u;
/TT-TT[\uDCA9\uDCA9-\uDCA9\uDCA9]/u;
/TT-TTB[\uDCA9\uDCA9-\uDCA9\uDCA9x]/u;
/TT-TTL[\uDCA9\uDCA9-\uDCA9\uDCA9\uD83D]/u;
/TT-TTT[\uDCA9\uDCA9-\uDCA9\uDCA9\uDCA9]/u;
/TBB-B[\uDCA9xx-x]/u;
/TBB-BB[\uDCA9xx-xx]/u;
/TBB-BL[\uDCA9xx-x\uD83D]/u;
/TBB-BT[\uDCA9xx-x\uDCA9]/u;
/TBB-BB[\uDCA9xx-xx]/u;
/TBB-BBB[\uDCA9xx-xxx]/u;
/TBB-BBL[\uDCA9xx-xx\uD83D]/u;
/TBB-BBT[\uDCA9xx-xx\uDCA9]/u;
/TBB-BL[\uDCA9xx-x\uD83D]/u;
/TBB-BLB[\uDCA9xx-x\uD83Dx]/u;
/TBB-BLL[\uDCA9xx-x\uD83D\uD83D]/u;
/TBB-BLT[\uDCA9xx-x\uD83D\uDCA9]/u;
/TBB-BT[\uDCA9xx-x\uDCA9]/u;
/TBB-BTB[\uDCA9xx-x\uDCA9x]/u;
/TBB-BTL[\uDCA9xx-x\uDCA9\uD83D]/u;
/TBB-BTT[\uDCA9xx-x\uDCA9\uDCA9]/u;
/TBB-L[\uDCA9xx-\uD83D]/u;
/TBB-LB[\uDCA9xx-\uD83Dx]/u;
/TBB-LL[\uDCA9xx-\uD83D\uD83D]/u;
/TBB-LT[\uDCA9xx-\uD83D\uDCA9]/u;
/TBB-LB[\uDCA9xx-\uD83Dx]/u;
/TBB-LBB[\uDCA9xx-\uD83Dxx]/u;
/TBB-LBL[\uDCA9xx-\uD83Dx\uD83D]/u;
/TBB-LBT[\uDCA9xx-\uD83Dx\uDCA9]/u;
/TBB-LL[\uDCA9xx-\uD83D\uD83D]/u;
/TBB-LLB[\uDCA9xx-\uD83D\uD83Dx]/u;
/TBB-LLL[\uDCA9xx-\uD83D\uD83D\uD83D]/u;
/TBB-LLT[\uDCA9xx-\uD83D\uD83D\uDCA9]/u;
/TBB-LT[\uDCA9xx-\uD83D\uDCA9]/u;
/TBB-LTB[\uDCA9xx-\uD83D\uDCA9x]/u;
/TBB-LTL[\uDCA9xx-\uD83D\uDCA9\uD83D]/u;
/TBB-LTT[\uDCA9xx-\uD83D\uDCA9\uDCA9]/u;
/TBB-T[\uDCA9xx-\uDCA9]/u;
/TBB-TB[\uDCA9xx-\uDCA9x]/u;
/TBB-TL[\uDCA9xx-\uDCA9\uD83D]/u;
/TBB-TT[\uDCA9xx-\uDCA9\uDCA9]/u;
/TBB-TB[\uDCA9xx-\uDCA9x]/u;
/TBB-TBB[\uDCA9xx-\uDCA9xx]/u;
/TBB-TBL[\uDCA9xx-\uDCA9x\uD83D]/u;
/TBB-TBT[\uDCA9xx-\uDCA9x\uDCA9]/u;
/TBB-TL[\uDCA9xx-\uDCA9\uD83D]/u;
/TBB-TLB[\uDCA9xx-\uDCA9\uD83Dx]/u;
/TBB-TLL[\uDCA9xx-\uDCA9\uD83D\uD83D]/u;
/TBB-TLT[\uDCA9xx-\uDCA9\uD83D\uDCA9]/u;
/TBB-TT[\uDCA9xx-\uDCA9\uDCA9]/u;
/TBB-TTB[\uDCA9xx-\uDCA9\uDCA9x]/u;
/TBB-TTL[\uDCA9xx-\uDCA9\uDCA9\uD83D]/u;
/TBB-TTT[\uDCA9xx-\uDCA9\uDCA9\uDCA9]/u;
/TBL-L[\uDCA9x\uD83D-\uD83D]/u;
/TBL-LB[\uDCA9x\uD83D-\uD83Dx]/u;
/TBL-LL[\uDCA9x\uD83D-\uD83D\uD83D]/u;
/TBL-LT[\uDCA9x\uD83D-\uD83D\uDCA9]/u;
/TBL-LB[\uDCA9x\uD83D-\uD83Dx]/u;
/TBL-LBB[\uDCA9x\uD83D-\uD83Dxx]/u;
/TBL-LBL[\uDCA9x\uD83D-\uD83Dx\uD83D]/u;
/TBL-LBT[\uDCA9x\uD83D-\uD83Dx\uDCA9]/u;
/TBL-LL[\uDCA9x\uD83D-\uD83D\uD83D]/u;
/TBL-LLB[\uDCA9x\uD83D-\uD83D\uD83Dx]/u;
/TBL-LLL[\uDCA9x\uD83D-\uD83D\uD83D\uD83D]/u;
/TBL-LLT[\uDCA9x\uD83D-\uD83D\uD83D\uDCA9]/u;
/TBL-LT[\uDCA9x\uD83D-\uD83D\uDCA9]/u;
/TBL-LTB[\uDCA9x\uD83D-\uD83D\uDCA9x]/u;
/TBL-LTL[\uDCA9x\uD83D-\uD83D\uDCA9\uD83D]/u;
/TBL-LTT[\uDCA9x\uD83D-\uD83D\uDCA9\uDCA9]/u;
/TBL-T[\uDCA9x\uD83D-\uDCA9]/u;
/TBL-TB[\uDCA9x\uD83D-\uDCA9x]/u;
/TBL-TL[\uDCA9x\uD83D-\uDCA9\uD83D]/u;
/TBL-TT[\uDCA9x\uD83D-\uDCA9\uDCA9]/u;
/TBL-TB[\uDCA9x\uD83D-\uDCA9x]/u;
/TBL-TBB[\uDCA9x\uD83D-\uDCA9xx]/u;
/TBL-TBL[\uDCA9x\uD83D-\uDCA9x\uD83D]/u;
/TBL-TBT[\uDCA9x\uD83D-\uDCA9x\uDCA9]/u;
/TBL-TL[\uDCA9x\uD83D-\uDCA9\uD83D]/u;
/TBL-TLB[\uDCA9x\uD83D-\uDCA9\uD83Dx]/u;
/TBL-TLL[\uDCA9x\uD83D-\uDCA9\uD83D\uD83D]/u;
/TBL-TLT[\uDCA9x\uD83D-\uDCA9\uD83D\uDCA9]/u;
/TBL-TT[\uDCA9x\uD83D-\uDCA9\uDCA9]/u;
/TBL-TTB[\uDCA9x\uD83D-\uDCA9\uDCA9x]/u;
/TBL-TTL[\uDCA9x\uD83D-\uDCA9\uDCA9\uD83D]/u;
/TBL-TTT[\uDCA9x\uD83D-\uDCA9\uDCA9\uDCA9]/u;
/TBT-LT[\uDCA9x\uDCA9-\uD83D\uDCA9]/u;
/TBT-LT[\uDCA9x\uDCA9-\uD83D\uDCA9]/u;
/TBT-LTB[\uDCA9x\uDCA9-\uD83D\uDCA9x]/u;
/TBT-LTL[\uDCA9x\uDCA9-\uD83D\uDCA9\uD83D]/u;
/TBT-LTT[\uDCA9x\uDCA9-\uD83D\uDCA9\uDCA9]/u;
/TBT-T[\uDCA9x\uDCA9-\uDCA9]/u;
/TBT-TB[\uDCA9x\uDCA9-\uDCA9x]/u;
/TBT-TL[\uDCA9x\uDCA9-\uDCA9\uD83D]/u;
/TBT-TT[\uDCA9x\uDCA9-\uDCA9\uDCA9]/u;
/TBT-TB[\uDCA9x\uDCA9-\uDCA9x]/u;
/TBT-TBB[\uDCA9x\uDCA9-\uDCA9xx]/u;
/TBT-TBL[\uDCA9x\uDCA9-\uDCA9x\uD83D]/u;
/TBT-TBT[\uDCA9x\uDCA9-\uDCA9x\uDCA9]/u;
/TBT-TL[\uDCA9x\uDCA9-\uDCA9\uD83D]/u;
/TBT-TLB[\uDCA9x\uDCA9-\uDCA9\uD83Dx]/u;
/TBT-TLL[\uDCA9x\uDCA9-\uDCA9\uD83D\uD83D]/u;
/TBT-TLT[\uDCA9x\uDCA9-\uDCA9\uD83D\uDCA9]/u;
/TBT-TT[\uDCA9x\uDCA9-\uDCA9\uDCA9]/u;
/TBT-TTB[\uDCA9x\uDCA9-\uDCA9\uDCA9x]/u;
/TBT-TTL[\uDCA9x\uDCA9-\uDCA9\uDCA9\uD83D]/u;
/TBT-TTT[\uDCA9x\uDCA9-\uDCA9\uDCA9\uDCA9]/u;
/TLB-B[\uDCA9\uD83Dx-x]/u;
/TLB-BB[\uDCA9\uD83Dx-xx]/u;
/TLB-BL[\uDCA9\uD83Dx-x\uD83D]/u;
/TLB-BT[\uDCA9\uD83Dx-x\uDCA9]/u;
/TLB-BB[\uDCA9\uD83Dx-xx]/u;
/TLB-BBB[\uDCA9\uD83Dx-xxx]/u;
/TLB-BBL[\uDCA9\uD83Dx-xx\uD83D]/u;
/TLB-BBT[\uDCA9\uD83Dx-xx\uDCA9]/u;
/TLB-BL[\uDCA9\uD83Dx-x\uD83D]/u;
/TLB-BLB[\uDCA9\uD83Dx-x\uD83Dx]/u;
/TLB-BLL[\uDCA9\uD83Dx-x\uD83D\uD83D]/u;
/TLB-BLT[\uDCA9\uD83Dx-x\uD83D\uDCA9]/u;
/TLB-BT[\uDCA9\uD83Dx-x\uDCA9]/u;
/TLB-BTB[\uDCA9\uD83Dx-x\uDCA9x]/u;
/TLB-BTL[\uDCA9\uD83Dx-x\uDCA9\uD83D]/u;
/TLB-BTT[\uDCA9\uD83Dx-x\uDCA9\uDCA9]/u;
/TLB-L[\uDCA9\uD83Dx-\uD83D]/u;
/TLB-LB[\uDCA9\uD83Dx-\uD83Dx]/u;
/TLB-LL[\uDCA9\uD83Dx-\uD83D\uD83D]/u;
/TLB-LT[\uDCA9\uD83Dx-\uD83D\uDCA9]/u;
/TLB-LB[\uDCA9\uD83Dx-\uD83Dx]/u;
/TLB-LBB[\uDCA9\uD83Dx-\uD83Dxx]/u;
/TLB-LBL[\uDCA9\uD83Dx-\uD83Dx\uD83D]/u;
/TLB-LBT[\uDCA9\uD83Dx-\uD83Dx\uDCA9]/u;
/TLB-LL[\uDCA9\uD83Dx-\uD83D\uD83D]/u;
/TLB-LLB[\uDCA9\uD83Dx-\uD83D\uD83Dx]/u;
/TLB-LLL[\uDCA9\uD83Dx-\uD83D\uD83D\uD83D]/u;
/TLB-LLT[\uDCA9\uD83Dx-\uD83D\uD83D\uDCA9]/u;
/TLB-LT[\uDCA9\uD83Dx-\uD83D\uDCA9]/u;
/TLB-LTB[\uDCA9\uD83Dx-\uD83D\uDCA9x]/u;
/TLB-LTL[\uDCA9\uD83Dx-\uD83D\uDCA9\uD83D]/u;
/TLB-LTT[\uDCA9\uD83Dx-\uD83D\uDCA9\uDCA9]/u;
/TLB-T[\uDCA9\uD83Dx-\uDCA9]/u;
/TLB-TB[\uDCA9\uD83Dx-\uDCA9x]/u;
/TLB-TL[\uDCA9\uD83Dx-\uDCA9\uD83D]/u;
/TLB-TT[\uDCA9\uD83Dx-\uDCA9\uDCA9]/u;
/TLB-TB[\uDCA9\uD83Dx-\uDCA9x]/u;
/TLB-TBB[\uDCA9\uD83Dx-\uDCA9xx]/u;
/TLB-TBL[\uDCA9\uD83Dx-\uDCA9x\uD83D]/u;
/TLB-TBT[\uDCA9\uD83Dx-\uDCA9x\uDCA9]/u;
/TLB-TL[\uDCA9\uD83Dx-\uDCA9\uD83D]/u;
/TLB-TLB[\uDCA9\uD83Dx-\uDCA9\uD83Dx]/u;
/TLB-TLL[\uDCA9\uD83Dx-\uDCA9\uD83D\uD83D]/u;
/TLB-TLT[\uDCA9\uD83Dx-\uDCA9\uD83D\uDCA9]/u;
/TLB-TT[\uDCA9\uD83Dx-\uDCA9\uDCA9]/u;
/TLB-TTB[\uDCA9\uD83Dx-\uDCA9\uDCA9x]/u;
/TLB-TTL[\uDCA9\uD83Dx-\uDCA9\uDCA9\uD83D]/u;
/TLB-TTT[\uDCA9\uD83Dx-\uDCA9\uDCA9\uDCA9]/u;
/TLL-L[\uDCA9\uD83D\uD83D-\uD83D]/u;
/TLL-LB[\uDCA9\uD83D\uD83D-\uD83Dx]/u;
/TLL-LL[\uDCA9\uD83D\uD83D-\uD83D\uD83D]/u;
/TLL-LT[\uDCA9\uD83D\uD83D-\uD83D\uDCA9]/u;
/TLL-LB[\uDCA9\uD83D\uD83D-\uD83Dx]/u;
/TLL-LBB[\uDCA9\uD83D\uD83D-\uD83Dxx]/u;
/TLL-LBL[\uDCA9\uD83D\uD83D-\uD83Dx\uD83D]/u;
/TLL-LBT[\uDCA9\uD83D\uD83D-\uD83Dx\uDCA9]/u;
/TLL-LL[\uDCA9\uD83D\uD83D-\uD83D\uD83D]/u;
/TLL-LLB[\uDCA9\uD83D\uD83D-\uD83D\uD83Dx]/u;
/TLL-LLL[\uDCA9\uD83D\uD83D-\uD83D\uD83D\uD83D]/u;
/TLL-LLT[\uDCA9\uD83D\uD83D-\uD83D\uD83D\uDCA9]/u;
/TLL-LT[\uDCA9\uD83D\uD83D-\uD83D\uDCA9]/u;
/TLL-LTB[\uDCA9\uD83D\uD83D-\uD83D\uDCA9x]/u;
/TLL-LTL[\uDCA9\uD83D\uD83D-\uD83D\uDCA9\uD83D]/u;
/TLL-LTT[\uDCA9\uD83D\uD83D-\uD83D\uDCA9\uDCA9]/u;
/TLL-T[\uDCA9\uD83D\uD83D-\uDCA9]/u;
/TLL-TB[\uDCA9\uD83D\uD83D-\uDCA9x]/u;
/TLL-TL[\uDCA9\uD83D\uD83D-\uDCA9\uD83D]/u;
/TLL-TT[\uDCA9\uD83D\uD83D-\uDCA9\uDCA9]/u;
/TLL-TB[\uDCA9\uD83D\uD83D-\uDCA9x]/u;
/TLL-TBB[\uDCA9\uD83D\uD83D-\uDCA9xx]/u;
/TLL-TBL[\uDCA9\uD83D\uD83D-\uDCA9x\uD83D]/u;
/TLL-TBT[\uDCA9\uD83D\uD83D-\uDCA9x\uDCA9]/u;
/TLL-TL[\uDCA9\uD83D\uD83D-\uDCA9\uD83D]/u;
/TLL-TLB[\uDCA9\uD83D\uD83D-\uDCA9\uD83Dx]/u;
/TLL-TLL[\uDCA9\uD83D\uD83D-\uDCA9\uD83D\uD83D]/u;
/TLL-TLT[\uDCA9\uD83D\uD83D-\uDCA9\uD83D\uDCA9]/u;
/TLL-TT[\uDCA9\uD83D\uD83D-\uDCA9\uDCA9]/u;
/TLL-TTB[\uDCA9\uD83D\uD83D-\uDCA9\uDCA9x]/u;
/TLL-TTL[\uDCA9\uD83D\uD83D-\uDCA9\uDCA9\uD83D]/u;
/TLL-TTT[\uDCA9\uD83D\uD83D-\uDCA9\uDCA9\uDCA9]/u;
/TLT-LT[\uDCA9\uD83D\uDCA9-\uD83D\uDCA9]/u;
/TLT-LT[\uDCA9\uD83D\uDCA9-\uD83D\uDCA9]/u;
/TLT-LTB[\uDCA9\uD83D\uDCA9-\uD83D\uDCA9x]/u;
/TLT-LTL[\uDCA9\uD83D\uDCA9-\uD83D\uDCA9\uD83D]/u;
/TLT-LTT[\uDCA9\uD83D\uDCA9-\uD83D\uDCA9\uDCA9]/u;
/TTB-B[\uDCA9\uDCA9x-x]/u;
/TTB-BB[\uDCA9\uDCA9x-xx]/u;
/TTB-BL[\uDCA9\uDCA9x-x\uD83D]/u;
/TTB-BT[\uDCA9\uDCA9x-x\uDCA9]/u;
/TTB-BB[\uDCA9\uDCA9x-xx]/u;
/TTB-BBB[\uDCA9\uDCA9x-xxx]/u;
/TTB-BBL[\uDCA9\uDCA9x-xx\uD83D]/u;
/TTB-BBT[\uDCA9\uDCA9x-xx\uDCA9]/u;
/TTB-BL[\uDCA9\uDCA9x-x\uD83D]/u;
/TTB-BLB[\uDCA9\uDCA9x-x\uD83Dx]/u;
/TTB-BLL[\uDCA9\uDCA9x-x\uD83D\uD83D]/u;
/TTB-BLT[\uDCA9\uDCA9x-x\uD83D\uDCA9]/u;
/TTB-BT[\uDCA9\uDCA9x-x\uDCA9]/u;
/TTB-BTB[\uDCA9\uDCA9x-x\uDCA9x]/u;
/TTB-BTL[\uDCA9\uDCA9x-x\uDCA9\uD83D]/u;
/TTB-BTT[\uDCA9\uDCA9x-x\uDCA9\uDCA9]/u;
/TTB-L[\uDCA9\uDCA9x-\uD83D]/u;
/TTB-LB[\uDCA9\uDCA9x-\uD83Dx]/u;
/TTB-LL[\uDCA9\uDCA9x-\uD83D\uD83D]/u;
/TTB-LT[\uDCA9\uDCA9x-\uD83D\uDCA9]/u;
/TTB-LB[\uDCA9\uDCA9x-\uD83Dx]/u;
/TTB-LBB[\uDCA9\uDCA9x-\uD83Dxx]/u;
/TTB-LBL[\uDCA9\uDCA9x-\uD83Dx\uD83D]/u;
/TTB-LBT[\uDCA9\uDCA9x-\uD83Dx\uDCA9]/u;
/TTB-LL[\uDCA9\uDCA9x-\uD83D\uD83D]/u;
/TTB-LLB[\uDCA9\uDCA9x-\uD83D\uD83Dx]/u;
/TTB-LLL[\uDCA9\uDCA9x-\uD83D\uD83D\uD83D]/u;
/TTB-LLT[\uDCA9\uDCA9x-\uD83D\uD83D\uDCA9]/u;
/TTB-LT[\uDCA9\uDCA9x-\uD83D\uDCA9]/u;
/TTB-LTB[\uDCA9\uDCA9x-\uD83D\uDCA9x]/u;
/TTB-LTL[\uDCA9\uDCA9x-\uD83D\uDCA9\uD83D]/u;
/TTB-LTT[\uDCA9\uDCA9x-\uD83D\uDCA9\uDCA9]/u;
/TTB-T[\uDCA9\uDCA9x-\uDCA9]/u;
/TTB-TB[\uDCA9\uDCA9x-\uDCA9x]/u;
/TTB-TL[\uDCA9\uDCA9x-\uDCA9\uD83D]/u;
/TTB-TT[\uDCA9\uDCA9x-\uDCA9\uDCA9]/u;
/TTB-TB[\uDCA9\uDCA9x-\uDCA9x]/u;
/TTB-TBB[\uDCA9\uDCA9x-\uDCA9xx]/u;
/TTB-TBL[\uDCA9\uDCA9x-\uDCA9x\uD83D]/u;
/TTB-TBT[\uDCA9\uDCA9x-\uDCA9x\uDCA9]/u;
/TTB-TL[\uDCA9\uDCA9x-\uDCA9\uD83D]/u;
/TTB-TLB[\uDCA9\uDCA9x-\uDCA9\uD83Dx]/u;
/TTB-TLL[\uDCA9\uDCA9x-\uDCA9\uD83D\uD83D]/u;
/TTB-TLT[\uDCA9\uDCA9x-\uDCA9\uD83D\uDCA9]/u;
/TTB-TT[\uDCA9\uDCA9x-\uDCA9\uDCA9]/u;
/TTB-TTB[\uDCA9\uDCA9x-\uDCA9\uDCA9x]/u;
/TTB-TTL[\uDCA9\uDCA9x-\uDCA9\uDCA9\uD83D]/u;
/TTB-TTT[\uDCA9\uDCA9x-\uDCA9\uDCA9\uDCA9]/u;
/TTL-L[\uDCA9\uDCA9\uD83D-\uD83D]/u;
/TTL-LB[\uDCA9\uDCA9\uD83D-\uD83Dx]/u;
/TTL-LL[\uDCA9\uDCA9\uD83D-\uD83D\uD83D]/u;
/TTL-LT[\uDCA9\uDCA9\uD83D-\uD83D\uDCA9]/u;
/TTL-LB[\uDCA9\uDCA9\uD83D-\uD83Dx]/u;
/TTL-LBB[\uDCA9\uDCA9\uD83D-\uD83Dxx]/u;
/TTL-LBL[\uDCA9\uDCA9\uD83D-\uD83Dx\uD83D]/u;
/TTL-LBT[\uDCA9\uDCA9\uD83D-\uD83Dx\uDCA9]/u;
/TTL-LL[\uDCA9\uDCA9\uD83D-\uD83D\uD83D]/u;
/TTL-LLB[\uDCA9\uDCA9\uD83D-\uD83D\uD83Dx]/u;
/TTL-LLL[\uDCA9\uDCA9\uD83D-\uD83D\uD83D\uD83D]/u;
/TTL-LLT[\uDCA9\uDCA9\uD83D-\uD83D\uD83D\uDCA9]/u;
/TTL-LT[\uDCA9\uDCA9\uD83D-\uD83D\uDCA9]/u;
/TTL-LTB[\uDCA9\uDCA9\uD83D-\uD83D\uDCA9x]/u;
/TTL-LTL[\uDCA9\uDCA9\uD83D-\uD83D\uDCA9\uD83D]/u;
/TTL-LTT[\uDCA9\uDCA9\uD83D-\uD83D\uDCA9\uDCA9]/u;
/TTL-T[\uDCA9\uDCA9\uD83D-\uDCA9]/u;
/TTL-TB[\uDCA9\uDCA9\uD83D-\uDCA9x]/u;
/TTL-TL[\uDCA9\uDCA9\uD83D-\uDCA9\uD83D]/u;
/TTL-TT[\uDCA9\uDCA9\uD83D-\uDCA9\uDCA9]/u;
/TTL-TB[\uDCA9\uDCA9\uD83D-\uDCA9x]/u;
/TTL-TBB[\uDCA9\uDCA9\uD83D-\uDCA9xx]/u;
/TTL-TBL[\uDCA9\uDCA9\uD83D-\uDCA9x\uD83D]/u;
/TTL-TBT[\uDCA9\uDCA9\uD83D-\uDCA9x\uDCA9]/u;
/TTL-TL[\uDCA9\uDCA9\uD83D-\uDCA9\uD83D]/u;
/TTL-TLB[\uDCA9\uDCA9\uD83D-\uDCA9\uD83Dx]/u;
/TTL-TLL[\uDCA9\uDCA9\uD83D-\uDCA9\uD83D\uD83D]/u;
/TTL-TLT[\uDCA9\uDCA9\uD83D-\uDCA9\uD83D\uDCA9]/u;
/TTL-TT[\uDCA9\uDCA9\uD83D-\uDCA9\uDCA9]/u;
/TTL-TTB[\uDCA9\uDCA9\uD83D-\uDCA9\uDCA9x]/u;
/TTL-TTL[\uDCA9\uDCA9\uD83D-\uDCA9\uDCA9\uD83D]/u;
/TTL-TTT[\uDCA9\uDCA9\uD83D-\uDCA9\uDCA9\uDCA9]/u;
/TTT-LT[\uDCA9\uDCA9\uDCA9-\uD83D\uDCA9]/u;
/TTT-LT[\uDCA9\uDCA9\uDCA9-\uD83D\uDCA9]/u;
/TTT-LTB[\uDCA9\uDCA9\uDCA9-\uD83D\uDCA9x]/u;
/TTT-LTL[\uDCA9\uDCA9\uDCA9-\uD83D\uDCA9\uD83D]/u;
/TTT-LTT[\uDCA9\uDCA9\uDCA9-\uD83D\uDCA9\uDCA9]/u;
/TTT-T[\uDCA9\uDCA9\uDCA9-\uDCA9]/u;
/TTT-TB[\uDCA9\uDCA9\uDCA9-\uDCA9x]/u;
/TTT-TL[\uDCA9\uDCA9\uDCA9-\uDCA9\uD83D]/u;
/TTT-TT[\uDCA9\uDCA9\uDCA9-\uDCA9\uDCA9]/u;
/TTT-TB[\uDCA9\uDCA9\uDCA9-\uDCA9x]/u;
/TTT-TBB[\uDCA9\uDCA9\uDCA9-\uDCA9xx]/u;
/TTT-TBL[\uDCA9\uDCA9\uDCA9-\uDCA9x\uD83D]/u;
/TTT-TBT[\uDCA9\uDCA9\uDCA9-\uDCA9x\uDCA9]/u;
/TTT-TL[\uDCA9\uDCA9\uDCA9-\uDCA9\uD83D]/u;
/TTT-TLB[\uDCA9\uDCA9\uDCA9-\uDCA9\uD83Dx]/u;
/TTT-TLL[\uDCA9\uDCA9\uDCA9-\uDCA9\uD83D\uD83D]/u;
/TTT-TLT[\uDCA9\uDCA9\uDCA9-\uDCA9\uD83D\uDCA9]/u;
/TTT-TT[\uDCA9\uDCA9\uDCA9-\uDCA9\uDCA9]/u;
/TTT-TTB[\uDCA9\uDCA9\uDCA9-\uDCA9\uDCA9x]/u;
/TTT-TTL[\uDCA9\uDCA9\uDCA9-\uDCA9\uDCA9\uD83D]/u;
/TTT-TTT[\uDCA9\uDCA9\uDCA9-\uDCA9\uDCA9\uDCA9]/u;
````

Produces same AST
